define(function (require, exports, module) {

	var INTERFACE = require('interface');
	var HTTP = require('http');
	var BUSINESS = require('business');
	var COMMAND = require('command');
	var MODULES = require('modules');
	var FILE = require('file');

	var vm = new Vue({
		el: '#vm',
		template: _g.getTemplate('Annex/annex-frame-v'),
		data: {
			param: api.pageParam.paramJson.param,
			dataJson: api.pageParam.paramJson.dataJson || [],
			items: [
				// {'type':'file',
				// 'url':'url',
				// 'name':'ddd'},
				// {'type':'picture',
				// 'url':'url',
				// 'name':'ddd'},
				// {'type':'audio',
				// 'url':'url',
				// 'name':'ddd',
				// 'speedTime':''},
			],
			itemId: '', // 用于保存需要删除元素标示
			data: '', //保存需要在页面间传递的参数
			isDetail: api.pageParam.paramJson.isDetail, // 单据是否为详情情况
			readOnly: api.pageParam.paramJson.readOnly || false,
		},
		watch: {
			'items': function (val, oldVal) { // 缺省图监听
				var self = this;
				if (val.length == 0) {
					$('#null').removeClass('uhide');
				} else {
					$('#null').addClass('uhide'); // 详情页数量更新
				}
			}
		},
		methods: {
			removeItem: function (item) {
				var index = this.items.indexOf(item);
				this.items.splice(index, 1);

			},
			uploadAnnex: function (paramJson) { // 上传文件
				var self = this;
				var fileName = paramJson.fileName; // 文件名称
				var fileType = paramJson.fileType; // 文件类型
				if(paramJson.voiceTime){
					var voiceTime = paramJson.voiceTime;
				}
				// var voiceTime = paramJson.voiceTime || 0; // 录音时长（毫秒）
				var filePath = paramJson.filePath; // 上传文件位置
				console.log(_g.j2s(paramJson));
				console.log('self.isDetail:' + self.isDetail);
				if (self.isDetail) { // 上传附件
					console.log('is detial');
					var data = '';
					if(voiceTime){
						data = {
							id: self.param.id,
							modId: self.param.modId,
							fileFileName: fileName + '.' + fileType, // 文件名+.文件格式
							voiceTime: voiceTime // 录音的时候voiceTime这个参数是大于0，如果是其它类型就等于0
						}
					}else{
						data = {
							id: self.param.id,
							modId: self.param.modId,
							fileFileName: fileName + '.' + fileType // 文件名+.文件格式
							// voiceTime: voiceTime // 录音的时候voiceTime这个参数是大于0，如果是其它类型就等于0
						}
					}
					
					HTTP.ajax({
						url: INTERFACE.annex['upload'].url,
						// data: {
						// 	id: self.param.id,
						// 	modId: self.param.modId,
						// 	fileFileName: fileName + '.' + fileType, // 文件名+.文件格式
						// 	voiceTime: voiceTime || 0 // 录音的时候voiceTime这个参数是大于0，如果是其它类型就等于0
						// },
						data:data,
						files: {
							file: filePath,
						},
						success: function (ret) {
							console.log('上传返回参数：' + _g.j2s(ret));
							self.items.unshift(ret.data.master); // 添加到视图
							api.hideProgress()
							_g.toastMsg({
								msg: ret.errMsg
							});
							api.sendEvent({ // 更新详情数量
								name: 'annex-num',
								extra: {
									'type': 'add'
								}
							});
							api.sendEvent({
								name: 'annex-reload' // 刷新列表
							});
						}
					});
				} else {
					console.log('元素序号：' + paramJson.itemIndex);
					var index = paramJson.itemIndex;
					if (index !== '') {
						if(voiceTime){
							self.items[index].voiceTime = voiceTime;
						}
						// self.items[index].filename = fileName;
						self.items[index].name = fileName;
						self.items[index].typename = fileType;
						self.items[index]["filepath"] = filePath;
						self.items[index].isAdd = 'true';
						console.log('编辑新增的元素：' + _g.j2s(self.items[paramJson.itemIndex]));
					} else {
						var param = {
							'name': fileName,
							'typename': fileType,
							'filepath': filePath,
							'isAdd': 'true', // 是否为原有的附件
						};
						if(voiceTime){
							param.voiceTime = voiceTime
						}
						self.items.unshift(param);
						console.log('添加元素：' + _g.j2s(self.items[self.items.length - 1]));
						_g.setLS('annex-list', self.items); // 添加到缓存
						console.log('----------看看缓存 + ', _g.getLS('annex-list'));
						api.sendEvent({ // 更新详情数量
							name: 'annex-num',
							extra: {
								'type': 'add'
							}
						});
					}
				}
			},
			editAnnex: function (paramJson) { // 编辑附件（修改名称）
				var self = this;
				var itemIndex = paramJson.itemIndex; // 视图元素序号
				console.log('编辑附件名称请求参数：' + _g.j2s(paramJson));
				HTTP.ajax({
					url: INTERFACE.annex['editName'].url,
					data: {
						id: self.param.id,
						itemno: self.items[itemIndex].itemno,
						modId: self.param.modId,
						filename: paramJson.fileName
					},
					success: function (ret) {
						console.log('编辑附件名称回调：' + _g.j2s(ret));
						self.items[itemIndex].name = paramJson.fileName; // 更新视图名称
						console.log('回调filename: ' + paramJson.fileName);
						_g.toastMsg({
							msg: ret.errMsg
						});
					}
				});
			},
			delAnnex: function (item) { // 删除附件
				var self = this;
				if (self.isDetail) {
					console.log('删除附件请求参数：' + _g.j2s(item));
					HTTP.ajax({
						url: INTERFACE.annex['del'].url,
						data: {
							id: self.param.id,
							itemno: item.itemno,
							modId: self.param.modId
						},
						success: function (ret) {
							console.log('删除附件回调：' + _g.j2s(ret));
							//							self.items.$remove(item); // 删除视图元素
							api.sendEvent({ // 更新详情数量
								name: 'annex-num',
								extra: {
									'type': 'reduce'
								}
							});
							api.sendEvent({
								name: 'annex-reload'
							});
							_g.toastMsg({
								msg: ret.errMsg
							});
						}
					});
				} else {
					self.removeItem(item);
					//					self.items.$remove(item); // 删除视图元素
					_g.setLS('annex-list', self.items); // 删除缓存（更新缓存）
					api.sendEvent({ // 更新详情数量
						name: 'annex-num',
						extra: {
							'type': 'reduce'
						}
					});
					api.sendEvent({
						name: 'annex-reload'
					});
				}
			},
			press: function (item) { // 响应长按事件
				var self = this;
				if (!self.readOnly) {
					_g.confirm({
						params: {
							title: '',
							msg: '是否删除该附件?',
							buttons: ['确定', '取消']
						},
						success: function (ret) {
							if (ret.buttonIndex == 1) {
								self.delAnnex(item);
							}
						}
					});
				}
			},
			addAnnex: function (buttonIndex) { // 附件添加按钮类型
				var self = this;
				switch (buttonIndex) {
					case 1: // 录音
						self.data = {
							title: '添加录音',
							text: '确定',
							isEdit:false,
						}
						_g.openWin({
							name: 'annex-audio',
							url: 'annex-audio',
							pageParam: {
								data: self.data
							}
						});
						break;
					case 2: // 拍照
						MODULES.apiPicture({
							sourceType: 'camera',
							success: function (ret) {
								console.log('拍照回调：' + _g.j2s(ret));
								var fileName = FILE.getFullNameByPath(ret.data);
								fileName = fileName.substring(0, fileName.lastIndexOf('.'));
								if (ret.data != '') {
									self.data = {
										title: '添加图片',
										text: '确定',
										fileName: fileName,
										fileUrl: ret.data,
										isEdit:false,
									};
									_g.showLoading({
										title: '正在处理'
									});
									setTimeout(function () {
										_g.hideProgress();
										_g.openWin({
											name: 'annex-pic',
											url: 'annex-pic',
											pageParam: {
												type: 'camera',
												data: self.data
											}
										});
									}, 2000);
								}
							}
						});
						break;
					case 3: // 文件
						if (api.systemType == 'ios') {
							MODULES.apiPicture({
								type: 'album',
								success: function (ret) {
									var fileName = FILE.getFullNameByPath(ret.data);
									fileName = fileName.substring(0, fileName.lastIndexOf('.'));
									if (ret.data != '') {
										self.data = {
											title: '添加图片',
											text: '确定',
											fileName: fileName,
											fileUrl: ret.data,
											isEdit:false,
										};
										_g.showLoading({
											title: '正在处理'
										});
										setTimeout(function () {
											_g.hideProgress();
											_g.openWin({
												name: 'annex-pic',
												url: 'annex-pic',
												pageParam: {
													type: 'album',
													data: self.data
												}
											});
										}, 2000);
									}
								}
							});
						} else {
							MODULES.fileBrowser({ // 浏览本地文件
								success: function (ret) {
									console.log('选择的文件回调：' + _g.j2s(ret));
									self.data = {
										title: '添加文件',
										text: '确定',
										fileName: FILE.getFullNameByPath(ret.url),
										fileUrl: ret.url,
									};
									_g.showLoading({
										title: '正在处理'
									});
									setTimeout(function () {
										_g.hideProgress();
										_g.openWin({
											name: 'annex-file',
											url: 'annex-file',
											pageParam: {
												data: self.data
											}
										});
									}, 1000);
								}
							});
						}
						break;
				}
			},
			showDetail: function (index, type) { // 打开文件
				var self = this;
				var isEdit = true; // 是否为原有的附件
				console.log('show me the item :' + _g.j2s(self.items[index]));
				console.log('isAdd：' + self.items[index].isAdd);
				if (self.items[index].isAdd) {
					isEdit = false;
				}
				console.log('isEdit:' + isEdit);
				// 获取附件地址
				var fileUrl = self.items[index].filepath || ''; // 本地附件地址
				if (api.pageParam.paramJson.isSign) {
					fileUrl = self.items[index].url;
				}
				if (isEdit && !api.pageParam.paramJson.isSign) {
					fileUrl = BUSINESS.getAnnexUrl({ // 生成文件url
						data: {
							id: self.param.id,
							modId: self.param.modId,
							itemno: self.items[index].itemno
						}
					});
				}
				
				console.log('文件地址：' + fileUrl);
				// 文件类型判断
				if (FILE.isPic(type)) { // 图片
					// 设置需要传递的参数
					console.log('come to pic here');
					
					if (isEdit && api.pageParam.paramJson.isSign) {
					// 外勤签到
						self.data = {
							title: '图片详情',
							text: '确定',
							file: self.items[index].filename + '.' + self.items[index].typename,
							fileName: self.items[index].filename,
							fileUrl: self.items[index].filepath,
							fileType: self.items[index].filetype,
							dataJson: self.items[index],
							isEdit: isEdit,
							itemIndex: index // 附件序号
						};
						
					}else{
						self.data = {
							title: '图片详情',
							text: '确定',
							file: (self.items[index].name || self.items[index].filename) + '.' + self.items[index].typename,
							fileName: self.items[index].filename || self.items[index].name,
							fileUrl: fileUrl,
							fileType: self.items[index].typename,
							dataJson: self.items[index],
							isEdit: isEdit,
							itemIndex: index // 附件序号
						};
					}
					
					console.log('prepare to openWin');
					_g.openWin({
						name: 'annex-pic',
						url: 'annex-pic',
						pageParam: {
							data: self.data,
							readOnly: self.readOnly
						}
					});
				} else if (FILE.isAudio(type)) { // 录音
					self.data = {
						title: '录音详情',
						text: '确定',
						file: (self.items[index].name || self.items[index].filename) + '.' + self.items[index].typename,
						fileName: self.items[index].filename || self.items[index].name,
						fileUrl: fileUrl,
						dataJson: self.items[index],
						isEdit: isEdit,
						itemIndex: index // 附件序号
					};
					_g.openWin({
						name: 'annex-audio',
						url: 'annex-audio',
						pageParam: {
							data: self.data,
							readOnly: self.readOnly
						}
					});
				} else if (FILE.isDoc(type)) { // 文档
					//传递参数
					self.data = {
						title: '文件详情',
						text: '确定',
						file: self.items[index].name + '.' + self.items[index].typename,
						fileName: self.items[index].name,
						fileUrl: fileUrl,
						fileType: self.items[index].typename,
						dataJson: self.items[index],
						isEdit: isEdit,
						itemIndex: index // 附件序号
					};
					_g.openWin({
						name: 'annex-file',
						url: 'annex-file',
						pageParam: {
							data: self.data,
							readOnly: self.readOnly
						}
					});
				}
			}
		},
		created: function () {
			var self = this;
			console.log('传递数据：' + _g.j2s(api.pageParam));

			if (self.isDetail) { // 详情
				if (api.pageParam.paramJson.isSign) { // 从外勤签到进入
					var file = api.pageParam.paramJson.dataJson;
					var _items = [];
					if (file.length != 0) {
						_.each(file, function (ele, index, list) {
						var filetype = ele.url.split('.');
							var _url = ele.url.replace(/\\/g, '/');
							_items.push({
								"id": ele.id,
								"filesize": ele.filesize,
								"filename": ele.guid,
								"filetype": filetype[filetype.length - 1],
								"typename": filetype[filetype.length - 1],
								"filepath": URLANNEX + '/' + _url,
								"isAdd": false
							});
						});
						self.items = _items;
					}
				} else {
					console.log('233: ' + JSON.stringify(self.param));
					self.param.pageSize = 10;
					self.param.start = 0;
					// self.param.data.pageSize = 10;
					COMMAND.init({ // 初始化
						url: INTERFACE.annex['list'].url,
						data: self.param,
						success: function (ret) {
							console.log('ret' + _g.j2s(ret));
							self.items = ret.data.detail1;
							console.log('self.items: ' + _g.j2s(self.items));
						}
					});

					_g.topLoading({ // 上拉加载
						success: function (ret) {
							COMMAND.next({
								success: function (ret) {
									console.log('ret' + _g.j2s(ret));
									_g.hideProgress();
									self.items = _.union(self.items, ret.data.detail1);
								}
							});
						}
					});

					_g.refresh({ // 下拉刷新
						success: function (ret) {
							COMMAND.refresh({
								success: function (ret) {
									_g.hideProgress();
									self.items = ret.data.detail1;
								}
							});
						}
					});

					_g.addEventListener({
						name: 'annex-reload',
						success: function (ret) {
							COMMAND.init({ // 初始化
								url: INTERFACE.annex['list'].url,
								data: self.param,
								success: function (ret) {
									_g.hideProgress();
									self.items = ret.data.detail1;
								}
							});
						}
					});
				}
			} else { // 新增
				var annexList = _g.getLS('annex-list') || [];
				self.items = annexList;
			}

			_g.addEventListener({ // 选择上传附件类型
				name: api.winName + '-add',
				success: function (ret) {
					_g.openButtons({
						buttons: ['录音', '拍照', '文件'],
						style: {
							fontNormalColor: '#333'
						}
					}, function (ret, err) {
						self.addAnnex(ret.buttonIndex);
					});
				}
			});

			_g.addEventListener({ //上传附件（事件）
				name: 'annex-upload',
				success: function (ret) {
					console.log('保存事件参数：' + _g.j2s(ret));

					self.uploadAnnex(ret.value.paramJson); // 文件位置，提交参数
				}
			});

			_g.addEventListener({ //编辑（修改附件名称）附件（事件）
				name: 'annex-edit',
				success: function (ret) {
					console.log('修改附件名称事件参数：' + _g.j2s(ret));
					self.editAnnex(ret.value.paramJson); // 附件名称
				}
			});
		}
	});
});