define(function(require, exports, module) {

	var BUSINESS = require('business');
	var FILE = require('file');
	var MODULES = require('modules');
	var PHOTOBROWSER = require('photoBrowser');

	var vm = new Vue({
		el: '#vm',
		data: {
			fileName: api.pageParam.data.fileName,
			fileUrl: api.pageParam.data.fileUrl,
			isEdit: api.pageParam.data.isEdit,
			itemIndex: api.pageParam.data.itemIndex, // 附件元素序号（编辑）
			readOnly: api.pageParam.readOnly || false,
			type: api.pageParam.type
		},
		methods: {
			shotPicture: function() { // 重新选择上传图片
				var self = this;
				MODULES.apiPicture({
					sourceType: self.type,
					success: function(ret) {
						if (ret.data != '') { // 更新文件和文件名
							self.fileUrl = ret.data;
							var fileName = FILE.getFullNameByPath(ret.data);
							self.fileName = fileName.substring(0, fileName.lastIndexOf('.'));
						}
					}
				});
			},
			pictureBrowser: function() { // 查看图片
				var self = this;
				_g.toastMsg({
					msg: '点击图片，可查看。请长按屏幕，退出图片浏览',
					duration: 800,
					location: 'middle',
				});
				PHOTOBROWSER.open({
					imgs: [self.fileUrl]
				});
			}
		},
		created: function() {
			var self = this;
			console.log('传递参数：' + JSON.stringify(api.pageParam));
			if (self.isEdit) { // 是否为编辑
				self.file = api.pageParam.data.file;
			}

			var btnLock = false;
			_g.addEventListener({ // 保存图片
				name: api.winName + '-save',
				success: function(ret) {
					if (!btnLock) { //将照片附件上传
						console.log(self.isEdit);
						if (self.fileName == '') {
							_g.toastMsg({
								msg: '请输入照片名称'
							});
							return;
						}
						if (self.isEdit) {
							api.sendEvent({
								name: 'annex-edit',
								extra: {
									paramJson: {
										fileName: self.fileName,
										itemIndex: self.itemIndex,
									}
								}
							});
							btnLock = true;
						} else {
							api.sendEvent({
								name: 'annex-upload',
								extra: {
									paramJson: {
										filePath: self.fileUrl,
										fileName: self.fileName,
										fileType: FILE.getTypeByPath(self.fileUrl),
										itemIndex: BUSINESS.unknownToEmpty(self.itemIndex),
									}
								}
							});
							btnLock = true;
						}
					}
					setTimeout(function() {
						api.closeWin(); 
					}, 500);
				}
			});
		},
	});
});
