define(function(require, exports, module) {

	var COMMAND = require('command');
	var STORAGE = require('storage');
	var BUSINESS = require('business-erp');

	var vm = new Vue({
		el: '#vm',
		template: _g.getTemplate('Business/product-choose-frame-v'),
		data: {
			eventName: api.pageParam.eventName,
			type: api.pageParam.type,
			items: [],
			index: '',
			activeItem: {}
		},
		methods: {
			init: function() { // 初始化
				var self = this;
				COMMAND.init({
					url: URLANNEX + '/common/goods/goodsList!doGetListData.action',
					data: {
						modId: 2403,
						modeid: BUSINESS.modeid[self.type],
						isH5: true
					},
					success: function(ret) {
						console.log(_g.j2s(ret))
						self.items = ret.resultData.ListData;
					}
				});
			},
			onTapChoose: function(item, index) { // 选中
				var self = this;
				console.log(_g.j2s(item))
				// _g.setLS('productItem', item);
				api.pageParam.data = item;
				api.pageParam.index = index;
				api.pageParam.goodMode = 'new';
				// api.sendEvent({
				// 	name: self.eventName,
				// 	extra: api.pageParam
				// });
				_g.openWin({
					name: 'product-detail',
					url: 'product-detail',
					pageParam: api.pageParam
				});
			},
			dealData: function(items) { // 处理返回值
				var self = this;
				_.each(items, function(element, index, list) {
					element.active = false;
				});
				return items;
			},
			setSearchParam: function(opts) { // 生成过滤条件
				var postData = {};
				var fieldType = ['ft_Str', 'ft_Str', 'ft_Str', 'ft_Str', 'ft_ListStr', 'ft_ListStr', 'ft_ListStr'];
				var id = ['355', '356', '357', '358', '360', '359', '361'];
				var index = ['', '', '', '', '', '5', '1'];
				var name = ['货品编码', '货品名称', '规格', '简称', '货品属性', '货品类别', '存货类型'];
				var operatertitle = ['包含', '包含', '包含', '包含子类', '包含子类', '包含', '包含', '包含'];
				for (var i = 0; i < 7; i++) {
					var num = String(i);
					postData['filterItems[' + num + '].fieldType'] = fieldType[i];
					postData['filterItems[' + num + '].id'] = id[i];
					postData['filterItems[' + num + '].index'] = index[i];
					postData['filterItems[' + num + '].name'] = name[i];
					postData['filterItems[' + num + '].operatertitle'] = operatertitle[i];
					postData['filterItems[' + num + '].value'] = opts.condition;
				}
				postData['filterisOR'] = 'true';
				postData['iMoneyHeadType'] = '0';
				postData['limit'] = '99999';
				postData['barcode'] = opts.condition;
				return postData;
			}
		},
		created: function() {
			console.log(_g.j2s(api.pageParam));
			var self = this;
			self.init();
		},
		mounted: function() {
			var self = this;

			_g.addEventListener({ // 搜索
				name: api.winName + '-search',
				success: function(ret) {
					var searchJson = self.setSearchParam({
						condition: ret.value.keyword
					});
					COMMAND.search({
						searchJson: searchJson,
						success: function(ret) {
							self.items = ret.resultData.ListData;
						}
					});
				}
			});

			_g.addEventListener({ // 扫描
				name: api.winName + '-scan',
				success: function(ret) {
					COMMAND.search({
						searchJson: {
							barcode: ret.value.content
						},
						success: function(ret) {
							self.items = ret.resultData.ListData;
						}
					});
				}
			});

			_g.addEventListener({ // 过滤
				name: api.winName + '-filter',
				success: function(ret) {
					var filterJson = self.setFilter({
						condition: ret.value.content
					});
					COMMAND.filter({
						filterJson: filterJson,
						success: function(ret) {
							self.items = ret.resultData.ListData;
						}
					});
				}
			});

			_g.topLoading({ // 上拉加载
				success: function(ret) {
					COMMAND.next({
						success: function(ret) {
						console.log(_g.j2s(ret))
							self.items = _.union(self.items, ret.listData);
						}
					});
				}
			});

			_g.refresh({ // 下拉刷新
				success: function(ret) {
					COMMAND.refresh({
						success: function(ret) {
							console.log(_g.j2s(ret))
							self.items = ret.resultData.ListData;
						}
					});
				}
			});
		}
	});
});
