define(function(require, exports, module) {

	_g.showLoading();

	var TIME = require('time');
	var BUSINESS = require('business-erp');
	var HTTP = require('http');

	var type = api.pageParam.type;
	var showStore = true; // 是否显示仓库、批号、生产日期、有效期至
	var showLargess = true; // 是否显示赠品按钮
	
	if (type == 'chance' || type == 'price') {
		api.pageParam.type = 'sbilling';
		showStore = false;
		if (type == 'chance') {
			showLargess = false;
		}
	}

	var vm = new Vue({
		el: '#vm',
		template: _g.getTemplate('Business/product-detail-erp-frame-v'),
		data: {
			showStore: showStore,
			showLargess: showLargess,
			edit: { // 编辑权限（局部）
				taxamt: true, // 税额
				taxrate: true, // 税率
				batchcode: false, // 条形码
				validdate: false, // 有效期至
				productdate: false, // 生产日期
				unitprice: true, // 单价
				goodsamt: true, // 货款
				amount: true, // 金额
				unitquantity: true, // 数量
				islargess: true // 赠品
			},
			batchcode: {
				showSelect: false
			},
			goods: {},
			newGoods: {
				is__detail__modify: 1,
				itemno: -1,
				storeid: 0,
				storecode: null,
				storename: null,
				storeshopid: '',
				goodsid: '',
				goodscode: '',
				goodsname: '',
				specs: '',
				goodskind: 0,
				costtype: 0,
				gcmid: 0,
				isbatch: 0,
				brandid: '',
				brandname: '',
				shortname: '',
				barcode: null,
				barcodeid: '',
				minpurchaseqty: '',
				storelist: '',
				goodstaxrate: null,
				guserdef1: '',
				guserdef2: '',
				guserdef3: '',
				guserdef4: '',
				guserdef5: '',
				guserdef6: '',
				guserdef7: '',
				guserdef8: '',
				guserdef9: '',
				guserdef10: '',
				unitid: '',
				unitname: '',
				unitrate: 0,
				unitrate1: 0,
				unitrate2: 0,
				unitrate3: 0,
				unitname1: '',
				unitname2: '',
				unitname3: '',
				baseunitname: '',
				bunitrate: 1,
				erate: 1,
				unitextname: '',
				quantity: 0,
				extqty: 0,
				unitquantity: 0,
				unitqty1: 0,
				unitqty2: 0,
				unitqty3: 0,
				price: 0,
				lcprice: 0,
				aprice: 0,
				disc: 100,
				discamt: 0,
				unitprice: 0,
				lcunitprice: 0,
				taxrate: 0,
				lctaxprice: 0,
				taxamt: 0,
				lctaxamt: 0,
				goodsamt: 0,
				lcgoodsamt: 0,
				amount: 0,
				lcamount: 0,
				islargess: 0,
				refercount: 0,
				referbilltype: null,
				referbillid: '',
				referbillcode: null,
				referbillitemno: null,
				referqty: 0,
				referextqty: 0,
				sumquantity: null,
				breferid: '',
				batchcode: null,
				productdate: null,
				validdate: 0,
				remark: null,
				userdef1: null,
				userdef2: null,
				userdef3: null,
				userdef4: null,
				userdef5: null,
				userdef6: null,
				userdef7: null,
				userdef8: null,
				userdef9: null,
				userdef10: null,
				userdef11: null,
				userdef12: null,
				userdef13: null,
				userdef14: null,
				userdef15: null,
				iscometrader: null,
				ioqty: 0,
				validdates: '0',
				origprice: 0,
				origtaxprice: 0,
				taxprice: 0
			},
			backupGoods: { // 备份数据(用于联动比较)
				goodsamt: '',
				taxamt: ''
			},
			showDelBtn: false,
			type: api.pageParam.type, // 单据类型
			mode: api.pageParam.mode, // 单据模式
			goodMode: api.pageParam.goodMode, // 货品模式(old:单据本身货品, add:新增, edit:编辑过, del:已删除)
			parWin: api.pageParam.winName,
			parFrame: api.pageParam.frameName,
			isEditer: api.pageParam.isEditer, // // 编辑权限（全局）
			isCheck: api.pageParam.isCheck, // 是否为审核状态
			billkind: api.pageParam.billkind, // 单据类型
			traderid: api.pageParam.traderid, // 供应商/客户id
			tradertaxrate: api.pageParam.tradertaxrate, // 供应商/客户税率
			isRetrun: api.pageParam.isRetrun,
			billdate: api.pageParam.billdate, // 日期
			notetype: api.pageParam.notetype, // 发票类型
			billtype: api.pageParam.billtype,
			isPurReturn: api.pageParam.isPurReturn, // 是否为采购退货（单据类型）
			vipid: api.pageParam.vipid, // 会员id
			canEditPrice: api.pageParam.canEditPrice // 是否能够修改货品单价
		},
		methods: {
			init: function() { // 初始化
				var self = this;
				if (self.goodMode == 'new') { // 判断如果是新增的话,就执行初始化货品明细编辑数据操作
					self.requestAdd(); // 获取货品详情
				} else { // 如果是编辑或者审核的话,则直接合并原有的数据,并且对原有字段进行转换
					var goods = _g.getLS('productItem') || '';
					self.goods = $.extend(self.newGoods, goods);
					self.render();
					self.refreshData();
					_g.hideProgress();
				}

				if (!self.isEditer || self.isCheck || self.goodMode == 'new') { // 是已审核状态 || 新增货品
					self.showDelBtn = false; // 隐藏删除按钮
				} else {
					self.showDelBtn = true; // 显示删除按钮
				}

				console.log(self.isCheck);
				if (self.isCheck) {
					self.edit.islargess = false; // 赠品按钮
				}
			},
			initData: function(goods) { // 新增货品明细的时候进行数据的初始化操作
				var self = this;
				var BillGoodsNumber = _g.getLS('billGoodsNumber');
				var iUnitID = 0;
				var sUnitName = '';
				var dUnitRate = 0;
				var sBarcode = null;
				var sBarcodeID = '';

				if (goods.unitid != undefined) {
					dUnitRate = goods.unitrate;
					iUnitID = goods.unitid;
					sUnitName = goods.unitname;
				} else {
					if (self.type.indexOf('p') != -1) { // 采购类单据
						dUnitRate = goods.prate;
						iUnitID = goods.punitid;
						sUnitName = goods.punitname;
						sBarcode = goods.pbarcode;
						sBarcodeID = goods.pbarcodeid;
					} else { // 销售类单据
						dUnitRate = goods.srate;
						iUnitID = goods.sunitid;
						sUnitName = goods.sunitname;
						sBarcode = goods.sbarcode;
						sBarcodeID = goods.sbarcodeid;
					}

					if (dUnitRate == null || dUnitRate == 0) {
						dUnitRate = goods.brate;
						iUnitID = goods.bunitid;
						sUnitName = goods.bunitname;
						sBarcode = goods.bbarcode;
						sBarcodeID = goods.bbarcodeid;
					}
				}
				self.goods.validdates = goods.validdates;
				self.goods.goodscode = goods.code;
				self.goods.goodsname = goods.name;
				self.goods.specs = goods.specs;
				self.goods.brandid = goods.brandid;
				self.goods.brandname = goods.brandname;
				self.goods.goodskind = goods.goodskind;
				self.goods.costtype = goods.costtype;
				self.goods.gcmid = goods.gcmid;
				self.goods.storelist = goods.storelist;
				self.goods.isbatch = goods.isbatch;
				self.goods.guserdef1 = goods.guserdef1;
				self.goods.guserdef2 = goods.guserdef2;
				self.goods.guserdef3 = goods.guserdef3;
				self.goods.guserdef4 = goods.guserdef4;
				self.goods.guserdef5 = goods.guserdef5;
				self.goods.guserdef6 = goods.guserdef6;
				self.goods.guserdef7 = goods.guserdef7;
				self.goods.guserdef8 = goods.guserdef8;
				self.goods.guserdef9 = goods.guserdef9;
				self.goods.guserdef10 = goods.guserdef10;
				self.goods.shortname = goods.shortname;
				self.goods.minpurchaseqty = goods.minpurchaseqty;
				self.goods.unitrate = dUnitRate;
				self.goods.unitname = sUnitName;
				self.goods.unitrate1 = goods.unitrate1;
				self.goods.unitrate2 = goods.unitrate2;
				self.goods.unitrate3 = goods.unitrate3;
				self.goods.unitname1 = goods.unitname1;
				self.goods.unitname2 = goods.unitname2;
				self.goods.unitname3 = goods.unitname3;
				self.goods.erate = goods.erate;
				self.goods.unitextname = goods.eunitname;
				self.goods.baseunitname = goods.bunitname;
				self.goods.goodstaxrate = goods.goodstaxrate;

				self.goods.unitquantity = 0;
				self.goods.unitqty1 = 0;
				self.goods.unitqty2 = 0;
				self.goods.unitqty3 = 0;

				self.goods.barcodeid = sBarcodeID;
				self.goods.barcode = sBarcode;
				self.goods.batchcode = null;
				self.goods.breferid = '';
				self.goods.productdate = null;
				self.goods.validdate = null;
				self.goods.islargess = 0;
				self.goods.unitid = iUnitID;
				self.goods.goodsid = goods.id;

				if (self.type.indexOf('s') != -1) {
					self.goods.margin = 0;
					self.goods.aprice = -1;
					self.goods.isallot = 0;
					self.goods.allotqty = 0;
					// self.goods.storeid','';
					self.goods.storecode = null;
					self.goods.storename = null;
					self.goods.storeshopid = '';
					self.goods.ioqty = 0;
					self.goods.margin = 0;
					self.goods.invoiceqty = 0;
					self.goods.invoiceamt = 0;
					self.goods.iscometrader = 0;
					self.goods.isallot = 0;
					self.goods.allotqty = 0;
					self.goods.point = 0;
					self.goods.tgcode = null;
					self.goods.tgname = null;
					self.goods.referbatchcode = null;
				} else {
					self.goods.appamt = 0;
					self.goods.lcappamt = 0;
				}

				self.countTaxRate(); // 计算税率

				if (goods.unitquantity == 0 || goods.unitquantity == null) {
					self.goods.unitquantity = BillGoodsNumber;
					self.goods.unitqty1 = 0;
					self.goods.unitqty2 = 0;
					self.goods.unitqty3 = 0;
					var iBaseQty = BillGoodsNumber; //从缓存中取
					if (self.billkind == '2') {
						iBaseQty = -1;
					}
					if (goods.unitrate == goods.unitrate1) {
						self.goods.unitqty1 = iBaseQty;
					} else if (goods.unitrate == goods.unitrate2) {
						self.goods.unitqty2 = iBaseQty;
					} else if (goods.unitrate == goods.unitrate3) {
						self.goods.unitqty3 = iBaseQty;
					}
				}
			},
			render: function() { // 页面数据填充
				var self = this;
				self.goods.unitprice = parseFloat(self.goods.unitprice || 0);
				self.goods.taxrate = parseFloat(self.goods.taxrate || 0).toFixed(2);
				self.goods.goodsamt = parseFloat(self.goods.goodsamt || 0).toFixed(2);
				self.goods.taxamt = parseFloat(self.goods.taxamt || 0).toFixed(2);
				self.goods.amount = parseFloat(self.goods.amount || 0).toFixed(2);
				self.goods.unitquantity = parseFloat(self.goods.unitquantity || 0);

				self.changeQty(self.goods.unitquantity);

				if (self.goods.islargess == 1) {
					self.isEditer = true;
					self.edit.unitquantity = false;
					self.edit.batchcode = false;
				}

				if (self.isCheck) { //如果是审核的话渲染完页面就直接停止
					return;
				}

				//税率为0时 禁止编辑税额
				if (self.goods.taxrate == 0) {
					self.edit.taxamt = false;
				}

				if (self.notetype == 1) {
					self.edit.taxrate = false;
					self.edit.taxamt = false;
				}

				if (self.type.indexOf('order') == -1) { // 开单类单据
					if (self.goods.costtype != 2) { //如果货品成本核算类型不是个别计价法 则禁止批号选择或者输入
						self.edit.batchcode = false;
						self.edit.validdate = false;
						self.edit.productdate = false;
					} else { // 如果是个别计价法的话 则允许批号操作
						self.edit.validdate = true;
						self.edit.productdate = true;
						if (self.type.indexOf('sbilling') != -1 || self.isPurReturn == 1) { // 销售开单的时候批号可选 采购退货批号可选 其他情况都是手工输入
							self.edit.batchcode = true;

							// self.edit.batchcode = false;
							self.batchcode.showSelect = true;
							
						} else { // 采购开单的时候批号可录 同时右箭头隐藏
							self.edit.batchcode = true;
							self.batchcode.showSelect = false;
						}
					}
				}
				_g.hideProgress();
			},
			requestAdd: function() {
				var self = this;
				self.goods = self.newGoods;
				HTTP.ajax({
					url: URLANNEX + '/lookupdm/lookupdata.action',
					data: {
						viewname: 'qrygoods',
						filter: "(code like '" + api.pageParam.data.code + "')",
						likeValue: '',
						pageSize: 9999,
						start: 0
					},
					success: function(ret) {
						console.log(_g.j2s(ret));
						var goods = ret.listData[0];
						self.initData(goods); // 新增货品明细的时候进行数据的初始化操作
						// self.goods = $.extend(self.newGoods, goods);
						console.log(_g.j2s(self.goods));
						self.render();
						self.getPrice(); // 获取价格
						if (_g.getLS('selfStoreGoods') != 1) { // 如果管理员没有货品默认仓库的权限时就不用默认仓库
							self.goods.storeid = '';
							self.goods.storename = '';
						}
					}
				})
			},
			changePrice: function(unitprice) { // 改变价格的时候触发的方法
				var self = this;
				self.goods.unitprice = unitprice;
				var PRICECHANGE = _g.getLS('priceChange'); //使用帐套缓存

				var origprice;
				var disc = self.goods.disc;
				var origtaxprice = self.goods.origtaxprice;
				var unitquantity = self.goods.unitquantity;
				var taxrate = self.goods.taxrate;

				if (PRICECHANGE == 0) {
					origprice = unitprice;
					origtaxprice = unitprice * (1 + taxrate / 100);
					if (unitprice > 0.000000001) {
						disc = unitprice / origprice * 100;
						self.goods.disc = disc;
					}
				} else {
					origprice = unitprice;
					origtaxprice = unitprice * (1 + taxrate / 100);
				}
				self.goods.origprice = origprice;
				self.goods.origtaxprice = origtaxprice;
				var taxrate = self.goods.taxrate;

				var taxprice = unitprice * (1 + taxrate / 100);
				self.goods.taxprice = taxprice;
				var lcunitprice = unitprice;
				self.goods.lcunitprice = lcunitprice;
				var lctaxprice = taxprice;
				self.goods.lctaxprice = lctaxprice;
				var goodsamt = unitprice * unitquantity;
				self.goods.goodsamt = goodsamt;
				var amount = taxprice * unitquantity;
				self.goods.amount = amount;

				var taxamt = amount - goodsamt;
				self.goods.taxamt = taxamt;
				var discamt = origtaxprice * (1 - disc / 100) * unitquantity;
				self.goods.discamt = discamt;
				var lcgoodsamt = goodsamt;
				self.goods.lcgoodsamt = lcgoodsamt;
				var lctaxamt = taxamt;
				self.goods.lctaxamt = lctaxamt;
				var lcdiscamt = discamt;
				self.goods.lcdiscamt = lcdiscamt;

				// 备份数据(用于联动比较)
				self.backupGoods.goodsamt = self.goods.goodsamt;
				self.backupGoods.taxamt = self.goods.taxamt;

				self.countPrice();
			},
			countPrice: function() { // 计算基本单位单价
				var self = this;
				var price;
				if (self.goods.quantity == 0 || self.goods.unitquantity == 0) {
					if (self.goods.unitrate == 1) {
						price = self.goods.unitprice;
					} else {
						price = self.goods.unitprice / self.goods.unitrate;
					}
				} else {
					if (self.goods.unitrate == 1) {
						price = self.goods.unitprice;
					} else {
						price = self.goods.unitquantity * self.goods.unitprice / self.goods.quantity;
					}
				}
				self.goods.price = parseFloat(price).toFixed(8);
			},
			countTaxRate: function() { // 计算税率
				var self = this;
				var goods = self.goods;
				var FTaxRate = 0;
				//如果是销售的话,默认使用货品中的税率,如果货品收率为0或者空,则使用帐套的税率
				if (self.notetype == '1') {
					FTaxRate = 0;
				} else {
					if (self.type.indexOf('s') != -1) {
						if (goods.goodstaxrate == null || goods.goodstaxrate == '')
							FTaxRate = _g.getLS('accsetTaxRate') || 0;
						else
							FTaxRate = goods.goodstaxrate || 0;
					} else {
						//如果是采购的话,默认使用供应商中的税率,如果供应商税率为0或者空,则手动输入
						if (self.tradertaxrate != '' && self.tradertaxrate != null)
							FTaxRate = self.tradertaxrate;
						else
							FTaxRate = 0;
					}
				}
				self.goods.taxrate = FTaxRate;
				self.changeTaxRate(FTaxRate); // 改变税率的时候触发的方法
			},
			refreshData: function() { // 统一刷新一次金额
				var self = this;
				var unitquantity = parseFloat(self.goods.unitquantity);
				var unitprice = parseFloat(self.goods.unitprice);
				var taxrate = parseFloat(self.goods.taxrate).toFixed(2);
				var goodsamt = parseFloat(self.goods.goodsamt).toFixed(2);
				var amount = parseFloat(self.goods.amount).toFixed(2);
				var taxamt = parseFloat(self.goods.taxamt).toFixed(2);
				var barcode = self.goods.barcode || '';

				if (self.countDotLength(unitquantity) > 8){
					unitquantity = parseFloat(unitquantity).toFixed(8);
				}

				if (self.countDotLength(unitprice) > 8){
					unitprice = parseFloat(unitprice).toFixed(8);
				}

				self.goods.unitquantity = unitquantity;
				self.goods.unitprice = unitprice;
				self.goods.taxrate = taxrate;
				self.goods.goodsamt = goodsamt;
				self.goods.amount = amount;
				self.goods.taxamt = taxamt;
				self.goods.barcode = barcode;
			},
			changeTaxRate: function(taxrate) { // 改变税率的时候触发的方法
				var self = this;
				if (taxrate == 0) { // 如果税率为0 禁止编辑税额
					self.edit.taxamt = false;
				} else {
					self.edit.taxamt = true;
				}

				// self.goods.taxrate = self.goods.taxrate;

				var origprice = self.goods.origprice; //获取原始价格
				var unitquantity = self.goods.unitquantity; //获取业务数量(在页面显示的数量)
				var unitprice = self.goods.unitprice; //获取业务单价(要显示的单价)
				var disc = self.goods.disc; //获取折扣

				var origtaxprice = origprice * (1 + taxrate / 100); //计算原始含税单价
				self.goods.origtaxprice = origtaxprice;
				var taxprice = unitprice * (1 + taxrate / 100); //含税单价(taxprice)=单价(unitprice)*(1+税率/100)
				self.goods.taxprice = taxprice;
				var lctaxprice = taxprice;
				self.goods.lctaxprice = lctaxprice;
				var amount = taxprice * unitquantity; //计算总额(需要显示)
				self.goods.amount = amount;
				var taxamt = unitquantity * (taxprice - unitprice); //计算税额(需要显示)
				self.goods.taxamt = taxamt;
				var goodsamt = amount - taxamt; //计算货品价格 不含税的
				self.goods.goodsamt = goodsamt;
				var discamt = origtaxprice * (1 - disc / 100) * unitquantity; //计算折扣
				self.goods.discamt = discamt;
				var lcgoodsamt = goodsamt; //lc开头的都是不需要显示的
				self.goods.lcgoodsamt = lcgoodsamt;
				var lctaxamt = taxamt;
				self.goods.lctaxamt = lctaxamt;
				var lcamount = goodsamt + taxamt;
				self.goods.lcamount = lcamount;
			},
			getPrice: function() { // 获取价格
				var self = this;
				var batrefid = 0,
					CVFLAG;
				if (self.type.indexOf('s') != -1) {
					batrefid = 0;
					CVFLAG = 2;
				} else {
					batrefid = self.getFieldValue('batrefid', 0);
					CVFLAG = 1;
				}
				HTTP.ajax({
					url: URLANNEX + '/common/bill/billpublic!doGetGoodsMultiPrice.action',
					data: {
						param: "{'CVFLAG':'" + CVFLAG + "','BILLTYPE':'" + self.billtype + "','GOODSID':'" + self.goods.goodsid + "','TRADERID':'" + self.traderid + "','BATREFID':'" + batrefid + "','STOREID':'" + self.getFieldValue('storeid', 0) + "','UNITID':'" + self.getFieldValue('unitid', 0) + "','MONEYID':'" + self.getFieldValue('moneyid', 0) + "','SALEDATE':'" + self.billdate + "','BILLKIND':'" + self.billkind + "','SHOPID':'" + _g.getLS('shopID') + "'}"
					},
					success: function(ret) {
						self.setPrice(ret.resultData.DefaultPrice);
					}
				});
			},
			setPrice: function(defaultPrice) { // 从价格接口获取价格之后的处理 在getPrice和unitname改变的时候会用到
				var self = this;
				if (_g.getLS('priceChoice') == '1') {
					var origtaxprice = defaultPrice;
					self.goods.origtaxprice = origtaxprice;
					var dTaxRate = self.goods.taxrate || 0;
					var dOrigTaxPrice = self.goods.origtaxprice || 0;
					var dDisc = BUSINESS.checkNull(self.goods.disc) == '' ? 100 : self.goods.disc;
					var unitprice = parseFloat(dOrigTaxPrice / (1 + dTaxRate / 100) * (dDisc / 100)).toFixed(8);
					self.goods.unitprice = unitprice;
					var origprice = parseFloat(dOrigTaxPrice / (1 + dTaxRate / 100)).toFixed(8);
					self.goods.origprice = origprice;
					var taxprice = parseFloat(dOrigTaxPrice * (dDisc / 100)).toFixed(8);
					self.goods.taxprice = taxprice;

					var unitquantity = self.goods.unitquantity;

					var lcunitprice = unitprice; // 单价=业务单价
					self.goods.lcunitprice = lcunitprice;
					var lctaxprice = taxprice; // 含税单价本=含税单价
					self.goods.lctaxprice = lctaxprice;
					var amount = taxprice * unitquantity; // 价税金额=含税单价*数量
					self.goods.amount = amount;
					var taxamt = unitquantity * (taxprice - unitprice); // 税额=数量*(含税单价-单价)
					self.goods.taxamt = taxamt;
					var goodsamt = amount - taxamt; // 货品金额=价税金额-税额
					self.goods.goodsamt = goodsamt;
					var discamt = origtaxprice * (1 - dDisc / 100) * unitquantity; // 折扣金额=原始单价(含税)*(1-折扣)*数量
					self.goods.discamt = discamt;
					var lcgoodsamt = goodsamt; // 货品金额本=货品金额
					self.goods.lcgoodsamt = lcgoodsamt;
					var lctaxamt = taxamt; // 税额本=税额
					self.goods.lctaxamt = lctaxamt;
					var lacmount = goodsamt + taxamt; // 价税金额=货品金额+税额
					self.goods.lacmount = lacmount;

					self.countPrice();
				} else {
					self.goods.unitprice = defaultPrice;
					self.changePrice(defaultPrice);
				}
				self.refreshData(); // 统一刷新一次金额
			},
			changeQty: function(num) { // 改变数量
				var self = this;
				var unitquantity = num;
				self.goods.unitquantity = unitquantity;
				var quantity = unitquantity * parseFloat(self.goods.unitrate);
				self.goods.quantity = quantity;
				var extqty;
				var erate = parseFloat(self.goods.erate);
				if (erate == 0) {
					extqty = 0;
				} else {
					extqty = quantity / erate;
				}
				var unitrate1 = parseFloat(self.goods.unitrate1);
				var unitrate2 = parseFloat(self.goods.unitrate2);
				var unitrate3 = parseFloat(self.goods.unitrate3);
				var unitqty1 = self.goods.unitqty1;
				var unitqty2 = self.goods.unitqty2;
				var unitqty3 = self.goods.unitqty3;

				if (unitrate2 == 0) {
					unitqty1 = unitquantity;
					unitqty2 = 0;
					unitqty3 = 0;
				} else {
					unitqty1 = parseInt(quantity / unitrate1);
					if (unitrate3 == 0) {
						unitqty2 = parseFloat((quantity - unitqty1 * unitrate1) / unitrate2).toFixed(8);
						unitqty3 = 0;
					} else {
						unitqty2 = parseInt((quantity - unitqty1 * unitrate1) / unitrate2);
						unitqty3 = parseFloat((quantity - unitqty1 * unitrate1 - unitqty2 * unitrate2) / unitrate3).toFixed(8);
					}
				}
				self.goods.unitqty1 = unitqty1;
				self.goods.unitqty2 = unitqty2;
				self.goods.unitqty3 = unitqty3;
				self.goods.extqty = parseFloat(extqty).toFixed(8); //辅助数量 保留八位;

				var taxrate = parseFloat(self.goods.taxrate || 0);
				var unitprice = parseFloat(self.goods.unitprice || 0);
				var origtaxprice = parseFloat(self.goods.origtaxprice);
				var disc = parseFloat(self.goods.disc);

				var taxprice = unitprice * (1 + taxrate / 100);
				self.goods.taxprice = taxprice;
				var amount = taxprice * unitquantity;
				self.goods.amount = amount;
				var taxamt = unitquantity * (taxprice - unitprice);
				self.goods.taxamt = taxamt;
				var goodsamt = amount - taxamt;
				self.goods.goodsamt = goodsamt;

				var discamt = origtaxprice * (1 - disc / 100) * unitquantity;
				self.goods.discamt = discamt;
				var lcgoodsamt = goodsamt;
				self.goods.lcgoodsamt = lcgoodsamt;
				var lctaxamt = taxamt;
				self.goods.lctaxamt = lctaxamt;
				var lcdiscamt = discamt;
				self.goods.lcdiscamt = lcdiscamt;

				self.countPrice(); // 计算基本单位单价
			},
			setStore: function(storeid, storecode, storename, storeshopid) { // 仓库更新
				var self = this;
				self.goods.storeid = storeid;
				self.goods.storecode = storecode;
				self.goods.storename = storename;
				self.goods.storeshopid = storeshopid;
			},
			getFieldValue: function(key, value) {
				var self = this;
				if (self.goods[key] == '' || self.goods[key] == null || self.goods[key] == undefined) {
					return value;
				} else {
					return self.goods[key];
				}
			},
			countDotLength: function(n) { // 计算小数点后有几位
				n = n.toString().split('.');
				if (n.length > 1) {
					return n[1].length;
				} else {
					return 0;
				}
			},
			changeBatchCode: function(data) { // 批号改变联动事件
				var self = this;
				var SelectedBatchID = data.id;
				var SelectedBatchCode = data.batchcode;
				var SelectedValidDate = data.validdate;
				var SelectedInprice = data.price;
				var SelectedProducedDate = data.produceddate;
				var SelectedStoreID = data.storeid;
				var SelectedStoreName = data.storename;
				var SelectedStoreCode = data.storecode;
				var SelectedStoreShopID = data.storeshopid;
				var SelectedLeftQry = data.leftqty;

				self.goods.batchcode = SelectedBatchCode; //批号
				self.goods.productdate = SelectedProducedDate; //生产日期
				self.goods.validdate = SelectedValidDate; //有效期

				self.goods.batchcode = SelectedBatchCode;
				self.goods.productdate = SelectedProducedDate;
				self.goods.validdate = SelectedValidDate;

				if (self.type.indexOf('p') != -1) { // 采购类
					if (self.billkind == '2') { //采购退货
						if (SelectedStoreID != self.goods.storeid) { // 更新仓库
							self.setStore(SelectedStoreID, SelectedStoreCode, SelectedStoreName, SelectedStoreShopID);
						}
						if (self.goods.unitprice == 0) {
							var IsLargess = self.goods.islargess;
							if (IsLargess == 0) {
								var _unitprice = SelectedInprice * self.goods.unitrate;
								self.changePrice(_unitprice);
							}
						}
						self.goods.breferid = SelectedBatchID;
					}
				} else { // 销售类单据
					if (self.billkind == 1) { //销售开单
						self.goods.breferid = SelectedBatchID;
						self.goods.aprice = parseFloat(SelectedInprice || 0).toFixed(8);
						if (SelectedStoreID != self.goods.storeid) { // 更新仓库
							self.setStore(SelectedStoreID, SelectedStoreCode, SelectedStoreName, SelectedStoreShopID);
						}
					} else if (self.billkind == 2) { //销售退货
						self.goods.aprice = parseFloat(SelectedInprice || 0).toFixed(8);
						if (SelectedStoreID != self.goods.storeid) { // 更新仓库
							self.setStore(SelectedStoreID, SelectedStoreCode, SelectedStoreName, SelectedStoreShopID);
						}
					}
				}
			},
			onTapDel: function(item, index) { // 删除
				var self = this;
				_g.confirm({
					params: {
						msg: '是否删除该货品?',
						buttons: ['确定', '取消']
					},
					success: function(ret) {
						if (ret.buttonIndex == 1) {
							api.sendEvent({
								name: 'goods-update',
								extra: {
									mode: 'del',
									goodMode: self.goodMode
								}
							});
							api.closeToWin({
								name: api.pageParam.parWin
							});
						}
					}
				})
			},
			openTapGetDate: function(key) { // 选择日期
				var self = this;
				var defaultDate = self.goods[key] || TIME.getDates().eDate;
				//选择日期的时候 根据有效天数计算有效日期
				TIME.getPickerDates(defaultDate, function(chooseDate) {
					self.goods[key] = chooseDate;
					var validdates = self.goods.validdates = 13;
					if (key == 'productdate' && validdates != '') {
						self.goods.validdate = TIME.countDate(self.goods.productdate, validdates);
					}
				});
			},
			onTapOpenBase: function(key) { // 选择基础资料
				var self = this;
				var url = '';
				var params = {};
				var title = '';
				switch (key) {
					case 'unitname': // 单位
						title = '单位';
						url = URLANNEX + '/lookupdm/lookupdata.action';
						params = {
							viewname: 'qrygoodsunit',
							filter: 'u.unittype=0 and u.goodsid=' + self.goods.goodsid,
							likeValue: '',
							pageSize: 9999,
							start: 0
						}
						break;
					case 'store': // 仓库
						title = '仓库';
						url = URLANNEX + '/lookupdm/lookupdata.action';
						var opID = _g.getLS('opID');
						var filter = "closed=0 "; //过滤条件
						if (_g.getLS('selfStoreGoods') == 1 && opID != 0) {
							filter += " and share like '%," + opID + ",%'";
						}
						if (opID > 0 && _g.getLS('shopAccount') == 1) {
							filter += " and shopid=" + _g.getLS('shopID');
						}
						params = {
							viewname: 'qrystore',
							likeValue: '',
							pageSize: 9999,
							start: 0,
							filter: filter
						}
						break;
					case 'batchcode': // 批号
						//获取仓库选择表
						var storeid = self.goods.storeid || 0;
						var storeshopid = self.goods.storeshopid;
						var unitid = self.goods.unitid;
						var goodsid = self.goods.goodsid;

						//从单据详情页面获取                            
						var traderid = self.traderid;
						var isreturn = self.isRetrun;
						var billdate = self.billdate;

						//有默认值
						var billkind = '';
						var billtype = '';
						var table = '';
						var shoptrader = 0;
						var storecanempty = true;

						//计算shoptrader
						var SHOPACCOUNT = _g.getLS('shopAccount');
						var SHOPID = _g.getLS('shopID'); //操作员分支机构ID
						var SHOPTRADER = _g.getLS('shopTrader');

						if (SHOPACCOUNT == "0") {
							if (SHOPID == 0) {
								shoptrader = 1;
							} else if (SHOPID > 0 && SHOPTRADER == '1') {
								shoptrader = 1;
							}
						}
						title = '批号';
						url = URLANNEX + '/common/bill/selectbatch!doGetGoodsBatch.action';
						params = {
							SHOPACCOUNT: _g.getLS('shopAccount'),
							param: "{'BILLTYPE':'','TABLE':'','BILLKIND':'','BILLDATE':'" + billdate +
								"','TRADERID':'0','STORESHOPID':'" + storeshopid + "','GOODSID':'" + goodsid + "','UNITID':'" + unitid +
								"','ISRETURN':'1','SHOPTRADER':'" + shoptrader + "','STORECANEMPTY':'" + storecanempty +
								"','STOREID':'" + storeid + "'}"
						}
						break;
				}
				_g.openWin({
					name: 'list-select',
					url: 'list-select',
					pageParam: {
						eventName: api.winName + '-list-select',
						billType: self.type,
						type: key,
						title: title,
						url: url,
						params: params
					}
				})
			},
			changeStore: function(data) { // 仓库改变事件
				var self = this;
				self.goods.storeid = data.id;
				self.goods.storeshopid = data.shopid;
				self.goods.storename = data.name;
				var goodsStoreLimit = _g.getLS('goodsStoreLimit');
				//获取选项中的值
				// $api.setStorage('goodsData', JSON.stringify(goodsData.getData()));
				if (goodsStoreLimit == '1') {
					var StoreID = 0,
						GoodsID = 0,
						ComeTrader = 0;
					var asReferBillCode = '';
					//获得编辑的仓库 id与货品id
					StoreID = self.goods.m_asStoreIDField;
					StoreID = StoreID ? StoreID : 0;
					GoodsID = self.goods.m_asGoodsIDField;
					GoodsID = GoodsID ? GoodsID : 0;
					if (typeof(self.goods.iscometrader) != 'undefined' && self.goods.iscometrader != null) {
						ComeTrader = self.goods.iscometrader;
					}
					if (typeof(self.goods.referbillcode) != 'undefined' && self.goods.referbillcode != null) {
						asReferBillCode = self.goods.referbillcode;
					}
					if (StoreID > 0 && GoodsID > 0 && asReferBillCode == '' && ComeTrader == 0) { //引用的明细不清空;供销货品不清空
						if (self.goods.goodskind <= 3) { //存货类货品才需要判断是否清除
							var storelist = self.goods.storelist;
							if (storelist.indexOf(',' + StoreID + ',') >= 0) {
								self.goods.goodsid = 0;
								self.goods.goodscode = '';
								self.goods.goodsname = '';
								self.goods.specs = '';
								self.goods.brandname = '';
								self.goods.unitid = 0;
								self.goods.unitname = '';
								self.goods.breferid = '';
								self.goods.referbilltype = null;
								self.goods.referbillid = '';
								self.goods.referitemno = null;
								self.goods.referbillcode = '';
							}
						}
					}
				}
				//如果是输入的话 则不会清空批号和生产日期等信息
				if (self.type.indexOf('sbilling') != -1 || self.isPurReturn == 1) {
					self.goods.batchcode = '';
					self.goods.productdate = '';
					self.goods.validdate = '';
				}
				self.refreshData();
			},
			changeUnitname: function(data) { // 单位改变事件
				var self = this;
				var dQuantity = 0;
				var dUnitRate = 0;
				var asUnitName = '',
					asBarCode = '',
					asBarCodeID = '';

				var _unitqty1 = self.goods.unitqty1;
				var _unitrate1 = self.goods.unitrate1;
				var _unitqty2 = self.goods.unitqty2;
				var _unitrate2 = self.goods.unitrate2;
				var _unitqty3 = self.goods.unitqty3;
				var _unitrate3 = self.goods.unitrate3;

				dQuantity = _unitrate1 * _unitrate1;
				if (parseFloat(_unitrate2) != 0) {
					dQuantity = dQuantity + _unitqty2 * _unitrate2;
					if (parseFloat(_unitrate3) != 0) {
						dQuantity = dQuantity + _unitqty3 * _unitrate3;
					}
				}

				var dUnitRate = data.rate;
				var asUnitName = data.name;
				var asBarCode = data.barcode;
				var asBarCodeID = data.barcodeid;
				var asUnitID = data.id;

				self.goods.unitname = asUnitName;
				self.goods.barcode = asBarCode;
				self.goods.barcodeid = asBarCodeID;
				self.goods.unitrate = dUnitRate;
				self.goods.unitid = asUnitID;

				var _dBaseQty = self.goods.quantity || 0;
				if (parseFloat(_dBaseQty) != 0)
					dQuantity = _dBaseQty;
				var _unitrate = self.goods.unitrate;
				var _islargess = self.goods.islargess;
				if (parseFloat(_unitrate) != 0) {
					if (_islargess == '0') {
						var _breferid = self.goods.breferid;
						var BatchID = (self.type.indexOf('s') != -1) ? 0 : self.getFieldValue('breferid', 0);
						var vipid = self.vipid ? self.vipid : 0;
						if (self.type.indexOf('s') != -1 && vipid != '0') {
							var TraderID = traderID ? traderID : 0;
							var GoodsID = self.goods.goodsid || 0;
							var UnitID = self.goods.unitid || 0;
							var StoreID = self.goods.storeid;
							var g_iShopID = _g.getLS('shopID');
							HTTP.ajax({
								url: URLANNEX + '/common/bill/billpublic!doGetVipGoodsPrice.action',
								data: {
									param: "{'TRADERID':'" + TraderID + "','GOODSID':'" + GoodsID + "','UNITID':'" + UnitID + "','STOREID':'" + StoreID + "','VIPID':'" + vipid + "','SHOPID':'" + g_iShopID + "'}"
								},
								success: function(ret) {
									var result = data1.resultData;
									self.setPrice(result.DefaultPrice);
									self.refreshData();
								}
							});
						} else {
							self.getPrice();
							self.refreshData();
						}
					}
					var unitquantity = dQuantity / _unitrate;
					self.changeQty(parseFloat(unitquantity).toFixed(8));
					self.refreshData();
				}
			},
			onChange: function(key) { // 改变事件
				var self = this;
				switch (key) {
					case 'unitprice': // 单价
						self.changePrice(self.goods.unitprice || 0);
						self.refreshData();
						break;
					case 'unitquantity': // 数量
						self.changeQty(self.goods.unitquantity);
						self.refreshData();
						break;
					case 'taxrate': // 税率
						self.changeTaxRate(self.goods.taxrate);
						self.refreshData();
						break;
					case 'taxamt': // 税额
						if (self.goods.taxrate == 0) { // 税率为0时 禁止编辑
							self.goods.taxamt = 0.00
							return;
						}
						var TAXAMTLIMIT = _g.getLS('taxAmtLimit'); //在缓存中获取
						var PRICECHANGE = 0;

						var taxamt = self.goods.taxamt;
						var oldTaxamt = self.backupGoods.taxamt;
						self.backupGoods.taxamt = taxamt;

						var amount = self.goods.amount;

						if (Math.abs(taxamt - oldTaxamt) > TAXAMTLIMIT) {
							//税额调整幅度在多少元之内不重算单价(<元)
							var unitquantity = self.goods.unitquantity;
							if (unitquantity == '0') {
								unitquantity = 1; //并且要触发业务数量改变
								self.changeQty(1);
							}
							var origprice = self.goods.origprice;
							var taxrate = self.goods.taxrate;
							var disc = self.goods.disc;
							var origtaxprice = self.goods.origtaxprice;

							var taxprice = (taxamt / (taxrate / 100)) * ((1 + taxrate / 100) / unitquantity);
							var unitprice = taxamt / (taxrate / 100) / unitquantity;
							if (PRICECHANGE == 0) {
								if (origtaxprice == 0) {
									origtaxprice = taxprice;
									origprice = unitprice;
									disc = taxprice / origprice * 100;
								}
							} else {
								origtaxprice = taxprice;
								origprice = unitprice;
							}
							self.goods.taxprice = taxprice;
							self.goods.unitprice = parseFloat(unitprice || 0).toFixed(8);
							self.goods.origtaxprice = origtaxprice;
							self.goods.origprice = origprice;
							self.goods.disc = disc;

							var lcunitprice = unitprice;
							self.goods.lcunitprice = lcunitprice;
							var lctaxprice = taxprice;
							self.goods.lctaxprice = lctaxprice;
							var goodsamt = unitprice * unitquantity;
							self.goods.goodsamt = goodsamt;
							var discamt = origtaxprice * (1 - disc / 100) * unitquantity;
							self.goods.discamt = discamt;
							amount = taxprice * unitquantity;
							self.goods.amount = amount;
						} else {
							amount = amount + taxamt - oldTaxamt;
							self.goods.amount = amount;
						}
						var lcgoodsamt = amount - taxamt;
						self.goods.lcgoodsamt = lcgoodsamt;
						var lctaxamt = taxamt;
						self.goods.lctaxamt = lctaxamt;
						var lcamount = lcgoodsamt + lctaxamt;
						self.goods.lcamount = lcamount;

						self.countPrice();
						self.refreshData();
						break;
					case 'goodsamt': // 货款
						var GOODSAMTLIMIT = _g.getLS('goodsAmtLimit'); //从帐套缓存中获取

						var unitquantity = self.goods.unitquantity;
						var goodsamt = self.goods.goodsamt;
						//旧货品数量
						var oldGoodsamt = self.backupGoods.goodsamt;
						self.backupGoods.goodsamt = goodsamt;
						console.log(oldGoodsamt);

						if (Math.abs(goodsamt - oldGoodsamt) > GOODSAMTLIMIT) {
							if (unitquantity == 0) {
								unitquantity = 1; //触发改变业务数量
								self.changeQty(1);
							}
							var origtaxprice = self.goods.origtaxprice;
							var origprice = self.goods.origprice;
							var disc = self.goods.disc;
							var taxrate = self.goods.taxrate;

							var unitprice = goodsamt / unitquantity;
							var taxprice = goodsamt * (1 + taxrate / 100) / unitquantity;

							if (self.goods.PRICECHANGE == '0') {
								if (origtaxprice == '0') {
									origtaxprice = taxprice;
									origprice = unitprice;
								}
								disc = taxprice / origprice * 100;
							} else {
								origtaxprice = taxprice;
								origprice = unitprice;
							}

							self.goods.origtaxprice = origtaxprice;
							self.goods.origprice = origprice;
							self.goods.disc = disc;
							self.goods.unitprice = parseFloat(unitprice).toFixed(8);
							self.goods.taxprice = taxprice;

							var taxamt = goodsamt * taxrate / 100;
							self.goods.taxamt = taxamt;
							var amount = taxprice * unitquantity;
							self.goods.amount = amount;

							var lcunitprice = unitprice;
							self.goods.lcunitprice = lcunitprice;
							var lctaxprice = taxprice;
							self.goods.lctaxprice = lctaxprice;
							var discamt = 0;
							self.goods.discamt = discamt;
						}
						self.countPrice();
						self.refreshData();
						break;
					case 'amount': // 金额
						var PRICECHANGE = 0; //需要从缓存获取
						var amount = self.goods.amount;
						var unitquantity = self.goods.unitquantity;
						var taxrate = self.goods.taxrate;
						if (unitquantity == 0) {
							unitquantity = 1; //触发业务数量改变
							self.changeQty(1);
						}
						//计算含税单价
						var taxprice = amount / unitquantity;
						self.goods.taxprice = taxprice;
						//计算业务单价
						var unitprice = amount / (1 + taxrate / 100) / unitquantity;
						self.goods.unitprice = parseFloat(unitprice).toFixed(8);
						//计算货品价格
						var goodsamt = unitprice * unitquantity;
						//计算税额
						var taxamt = goodsamt * taxrate / 100;
						self.goods.goodsamt = goodsamt;
						self.goods.taxamt = taxamt;

						var origtaxprice = self.goods.origtaxprice;
						var origprice = self.goods.origprice;
						var disc = self.goods.disc;

						if (PRICECHANGE == 0) {
							if (origtaxprice == 0) {
								origtaxprice = taxprice;
								origprice = unitprice;
								disc = amount / (origtaxprice * unitquantity) * 100
							}
						} else {
							origtaxprice = taxprice;
							origprice = unitprice;
						}
						self.goods.origtaxprice = origtaxprice;
						self.goods.origprice = origprice;
						self.goods.disc = disc;

						var lcunitprice = unitprice;
						self.goods.lcunitprice = lcunitprice;
						var lctaxprice = taxprice;
						self.goods.lctaxprice = lctaxprice;
						var discamt = origtaxprice * (1 - disc / 100) * unitquantity;
						self.goods.discamt = discamt;

						self.countPrice();
						self.refreshData();
						break;
				}
			},
			checkedIslargess: function() { // 赠品改变事件
				var self = this;
				if (self.goods.islargess == 1) {
					//取消赠品
					self.goods.islargess = 0;
					self.isEditer = true;
					self.isEditPrice();
					self.batchCodeType();
					var dTaxRate = 0;
					if (self.type.indexOf('p') != -1) { //采购类单据
						dTaxRate = self.tradertaxrate; //取供应商税率
					} else if (self.type.indexOf('s') != -1) { //销售类单据
						var FGRate = self.goods.goodstaxrate; //货品税率
						if (FGRate == null || FGRate == '') {
							dTaxRate = _g.getLS('accsetTaxRate');
						} else {
							dTaxRate = FGRate || 0;
						}
					}
					if (self.notetype == '1') {
						dTaxRate = 0;
					}
					if (dTaxRate == null) {
						dTaxRate = 0;
					}
					self.goods.taxrate = dTaxRate;
					self.getPrice();
				} else {
					self.goods.islargess = 1;
					if (parseInt(self.goods.goodskind) > 3) {
						self.goods.islargess = 0;
						return;
					}
					self.goods.unitprice = 0;
					self.goods.taxrate = 0;
					self.isEditer = false;
					self.batchCodeType();
				}
				self.changePrice(self.goods.unitprice);
				self.refreshData();
			},
			isEditPrice: function() { // 判断是否可以编辑单价
				var self = this;
				if (!self.canEditPrice) {
					self.edit.unitprice = false;
					self.edit.goodsamt = false;
					self.edit.amount = false;
					self.edit.taxamt = false;
				}
			},
			batchCodeType: function() { // 判断批号的输入类型
				var self = this;
				if (self.goods.costtype != '2') {
					self.edit.batchcode = false;
					self.edit.validdate = false; //有效期和生产日期只读
					self.edit.productdate = false;
				} else {
					self.edit.validdate = true; //有效期和生产日期只读
					self.edit.productdate = true;
					if (self.type.indexOf('sbilling') != -1 || self.isPurReturn == 1) {
						self.edit.batchcode = false; //销售开单和采购退货只选
					} else {
						self.edit.batchcode = true;
					}
				}
			},
			checkValid: function(json) {
				var self = this;
				for (key in json) {
					if (self.goods[key] === '') {
						_g.toastMsg({
							msg: '请输入' + json[key].title
						});
						return false;
					}
				}
				return true;
			}
		},
		created: function() {
			console.log(_g.j2s(api.pageParam));
			var self = this;
			self.init();
		},
		mounted: function() {
			var self = this;

			_g.addEventListener({
				name: api.winName + '-right',
				success: function(ret) {
					$('input').blur(); // 触发输入框改变事件
					// 判断是否有空值 合法性检验
					var checkBool = self.checkValid({
						quantity: {
							title: '数量'
						},
						unitprice: {
							title: '单价'
						},
						taxrate: {
							title: '税率'
						},
						goodsamt: {
							title: '货款'
						},
						taxamt: {
							title: '税额'
						},
						amount: {
							title: '金额'
						}
					});
					if (!checkBool) {
						return;
					}
					api.sendEvent({
						name: 'goods-update',
						extra: {
							mode: 'save',
							goodMode: self.goodMode,
							goods: self.goods
						}
					});
					api.closeToWin({
						name: api.pageParam.parWin
					});
				}
			});

			_g.addEventListener({
				name: api.winName + '-list-select',
				success: function(ret) {
					console.log(_g.j2s(ret));
					var type = ret.value.type
					var data = ret.value.data;
					switch (type) {
						case 'unitname': // 单位
							self.changeUnitname(data);
							break;
						case 'store': // 仓库
							self.changeStore(data);
							break;
						case 'batchcode': // 批号
							self.changeBatchCode(data);
							break;
					}
				}
			});
		}
	});
});
