define(function(require, exports, module) {

	// 销售机会（chance）：数量*单价=金额
	// 销售报价（price）：原价*折扣率=单价、数量*单价=货款、数量*单价*税率=税额、货款+税额=金额

	_g.showLoading();

	var HTTP = require('http');
	var BUSINESS = require('business');
	var MODULES = require('modules');

	var vm = new Vue({
		el: '#vm',
		template: _g.getTemplate('Business/product-detail-frame-v'),
		data: {
			type: api.pageParam.type || 'chance',
			mode: api.pageParam.mode || 'add',// 商品明细状态(old:单据本身商品, add:新增, edit:编辑过, del:已删除)
			isEditer: api.pageParam.isEditer || false,// 是否有权限编辑
			showDelBtn: api.pageParam.showDelBtn,// 是否显示删除按钮
			index: api.pageParam.index,
			goodMode: api.pageParam.goodMode, // 商品品模式(old:单据本身商品, add:新增, edit:编辑过, del:已删除)
			parWin: api.pageParam.winName,
			parFrame: api.pageParam.frameName,
			goods: {
				goodsname: '',//商品名称
				specs: '',//规格
				unitname: '',//单位
				barcode: '',//条形码
				quantity: 1,//数量
				oprice: 0,//原价
				disc: 0,//折扣率
				price: 0,//单价
				taxrate: 0,//税率
				taxamount: 0,//税额
				goodsamount: 0,//货款
				amount: 0,//金额
			}
		},
		watch: {},
		methods: {
			init: function() { // 初始化
				var self = this;
				var goods = _g.getLS('productItem') || '';
				self.initData(goods); // 初始化数据
			},
			initData: function(productItem){ // 初始化数据
				var self = this;
				if(productItem!==''){
					self.goods.goodsid = productItem.goodsid || productItem.id;// 商品id
					self.goods.goodsname = productItem.goodsname || productItem.name || '';//商品名称
					self.goods.specs = productItem.specs || '';//规格
					self.goods.unitname = productItem.unitname || '';//单位
					self.goods.barcode = productItem.barcode || '';//条形码
					self.goods.quantity = productItem.quantity || 1;//数量
					self.goods.oprice = productItem.oprice || productItem.cprice || 0;//原价
					self.goods.disc = productItem.disc || 100;//折扣率
					self.goods.price = productItem.price || productItem.sprice || 0;//单价
					console.log(productItem.taxrate);
					productItem.taxrate = BUSINESS.unknownToEmpty(productItem.taxrate);
					console.log(productItem.taxrate);
					console.log(productItem.taxrate === '');
					if(productItem.taxrate === ''){
						self.goods.taxrate = _g.getLS('TaxRate') || 0;//税率（登录的时候返回：optionList.TaxRate）
					}else{
						self.goods.taxrate = productItem.taxrate;
					}
					self.goods.taxamount = productItem.taxamount || 0;//税额
					self.goods.goodsamount = productItem.goodsamount || 0;//货款
					self.goods.amount = productItem.amount || 0;//金额

					self.goods.accsetid = productItem.accsetid;
					self.goods.itemno = productItem.itemno;//为商品明细id，新增时从-1开始 
					self.goods.id = productItem.id;//单据
					self.goods.discamount = productItem.discamount;//折扣
					self.goods.ispresent = productItem.ispresent;//是否为赠品 
					self.goods.referbillid = productItem.referbillid;//引用单据id
					self.goods.referbillitemno = productItem.referbillitemno;//引用单据商品明细id
					self.goods.referbilltype = productItem.referbilltype;//引用单据类型
					self.goods.remark = productItem.remark;//备注
					self.goods.mode = productItem.mode;
					self.mode = productItem.mode;

					if (self.goodMode == 'new') {
						switch(self.type){
							case 'chance':
								// 数量*单价=金额
								self.goods.amount = parseFloat((self.goods.price)*(self.goods.quantity)).toFixed(2)*100/100;
								break;
							case 'price':
								// 原价*折扣率=单价
								self.goods.price = parseFloat((self.goods.oprice)*((self.goods.disc)/100)).toFixed(8)*100/100;
								// 数量*单价=货款
								self.goods.goodsamount = parseFloat((self.goods.price)*(self.goods.quantity)).toFixed(8)*100/100;
								// 数量*单价*税率=税额
								self.goods.taxamount = parseFloat((self.goods.price)*(self.goods.quantity)*(Number(self.goods.taxrate)/100)).toFixed(8)*100/100;
								// 货款+税额=金额
								self.goods.amount = parseFloat((self.goods.goodsamount)+(self.goods.taxamount)).toFixed(2)*100/100;
								break;
							default:
						}
					}
				}
				_g.hideProgress();
				_g.rmLS('productItem');
			},
			scan: function(){ // 扫描商品条形码
				var self = this;
				MODULES.scan({
					success: function(ret) {
						if(ret.eventType=='success'){
							_g.showLoading({
								title: '识别中...'
							});
							// self.goods.barcode = ret.content;
							HTTP.ajax({
								url: _interface.base['dsgoods'].url,
								data: {
									'barcode': ret.content,
								},
								success: function(ret) {
									if(ret.errNo == 0){
										var listJson = ret.data.listJson;
										if(Array.isArray(listJson) && listJson.length>0){
											ret.data.listJson[0].isScan = true;
											self.setGood(ret.data.listJson[0]);
										}else{
						    			_g.toastMsg({
						    				msg: '该商品不存在'
						    			});
										}
									}else{
						    		_g.toastMsg({
						    			msg: '识别失败，请重试'
						    		});
									}
								},
								other: function(ret) {
									_g.toastMsg({
										msg: err.msg
									});
								},
								error: function(err) {
									_g.toastMsg({
										msg: err.msg
									});
								}
							});
						}
					}
				});
			},
			onTapChooseGoods: function(){ // 选择商品（商品名称）
				var self = this;
				api.pageParam.mode = self.mode;
				_g.openWin({
					name: 'product-choose',
					url: 'product-choose',
					pageParam: api.pageParam
				});
			},
			onTapDel: function(){ // 删除商品
				_g.confirm({
					params: {
				    msg: '是否删除该商品',
				    buttons: ['确定', '取消']
					},
					success: function(ret) {
						if(ret.buttonIndex == 1){
					    	api.sendEvent({
							    name: 'product-DEL'
							});
							// 记录被删除的商品
					    	api.sendEvent({
							    name: 'goods-del',
							    extra: {
							    	'delIndex': api.pageParam.index
							    }
							});
							api.closeToWin({name: 'product'});
						}
					}
				});
			},
			onChange: function(key){ // 输入框改变事件
				var self = this;
				if(self.type == 'price'){
					switch(key){
						case 'price': // 原价*折扣率=单价(单价反算折扣率)
							if(self.goods.oprice == 0){
								self.goods.disc = 0;
								return;
							}
							self.goods.disc = parseFloat((self.goods.price)/(self.goods.oprice)*100).toFixed(8)*100/100;
							break;
						case 'goodsamount': // 数量*单价=货款(货款反算单价)
							if(self.goods.quantity == 0){
								self.goods.price = 0;
								return;
							}
							self.goods.price = parseFloat((self.goods.goodsamount)/(self.goods.quantity)).toFixed(8)*100/100;
							break;
						case 'taxamount': // 数量*单价*税率=税额(税额反算税率)
							if(self.goods.quantity == 0 || self.goods.price == 0){
								self.goods.taxrate = 0;
								return;
							}
							self.goods.taxrate = parseFloat(((self.goods.taxamount)/((self.goods.quantity)*(self.goods.price)))*100).toFixed(8)*100/100;
							break;
					}
				}
			}
		},
		created: function() {
			console.log(_g.j2s(api.pageParam));
			var self = this;
			self.init();
		},
		mounted: function() {
			var self = this;

			_g.addEventListener({
				name: api.winName + '-right',
				success: function(ret) {
					$('input').blur(); // 触发输入框改变事件
					var bool = false;
					if(!/^[1-9]+(.[0-9]{0,8})?$/.test(self.goods.quantity) || self.goods.quantity <= 0){
						_g.toastMsg({
							msg:'数量不可为空或小于等于零！'
						});
						return;
					}
					switch(self.type){
						case 'chance':
							bool = true;
							break;
						case 'price':
							if(!/^[1-9]+(.[0-9]{0,8})?$/.test(self.goods.disc) || self.goods.disc < 0 || self.goods.disc >100){
								_g.toastMsg({
									msg:'折扣率不可小于0或大于100！'
								});
								return;
							}
							if(!/^[1-9]+(.[0-9]{0,8})?$/.test(self.goods.disc) || self.goods.taxrate < 0 || self.goods.taxrate >100){
								_g.toastMsg({
									msg:'税率不可小于0或大于100！'
								});
								return;
							}
							bool = true;
							break;
						case 'contract':
							if(!/^[1-9]+(.[0-9]{0,8})?$/.test(self.goods.disc) || self.goods.taxrate < 0 || self.goods.taxrate >100){
								_g.toastMsg({
									msg:'税率不可小于0或大于100！'
								});
								return;
							}
							bool = true;
							break;
					}
					if(!bool){
						return;
					}
					console.log(_g.j2s(self.goods));
					api.sendEvent({
						name: 'goods-update',
						extra: {
							mode: 'save',
							goodMode: self.goodMode,
							goods: self.goods
						}
					});
					api.closeToWin({
						name: api.pageParam.parWin
					});
				}
			});

			_g.addEventListener({
				name: api.winName + '-list-select',
				success: function(ret) {
					console.log(_g.j2s(ret));
					var type = ret.value.type
					var data = ret.value.data;
					switch (type) {
						case 'unitname': // 单位
							self.changeUnitname(data);
							break;
						case 'store': // 仓库
							self.changeStore(data);
							break;
						case 'batchcode': // 批号
							self.changeBatchCode(data);
							break;
					}
				}
			});
		}
	});

	
	var typeWatch = { // 保留小数：金额和税率两位，其它都是八位
		'chance': function(){
			vm.$watch(
				function() {
					return this.goods.price * this.goods.quantity
				},
				function(val, oldVal){
					console.log('数量*单价=金额');
					this.goods.amount = parseFloat(val).toFixed(2)*100/100; // 数量*单价=金额
				}
			);
			// vm.$watch('(goods.price)*(goods.quantity)', function(val, oldVal){
			// 	console.log(goods.price);
			// 	this.goods.amount = parseFloat(val).toFixed(2)*100/100; // 数量*单价=金额
			// });
		},
		'price': function(){
			vm.$watch(
				function() {
					return (this.goods.oprice * this.goods.disc)/100
				},
				function(val, oldVal){
					console.log('原价*折扣率=单价');
					this.goods.price = parseFloat(val).toFixed(8)*100/100; // 原价*折扣率=单价
				}
			);
			// vm.$watch('(goods.oprice)*((goods.disc)/100)', function(val, oldVal){
			// 	this.goods.price = parseFloat(val).toFixed(8)*100/100; // 原价*折扣率=单价
			// });

			vm.$watch(
				function() {
					return this.goods.quantity * this.goods.quantity
				},
				function(val, oldVal){
					console.log('数量*单价=货款');
					this.goods.goodsamount = parseFloat(val).toFixed(8)*100/100; // 数量*单价=货款
				}
			);
			// vm.$watch('(goods.quantity)*(goods.quantity)', function(val, oldVal){
			// 	this.goods.goodsamount = parseFloat(val).toFixed(8)*100/100; // 数量*单价=货款
			// });

			vm.$watch(
				function() {
					return this.goods.quantity * this.goods.price * this.goods.taxrate/100
				},
				function(val, oldVal){
					console.log('数量*单价*税率=税额');
					this.goods.taxamount = parseFloat(val).toFixed(8)*100/100; // 数量*单价*税率=税额
				}
			);
			// vm.$watch('((goods.quantity)*(goods.price))*(goods.taxrate/100)', function(val, oldVal){
			// 	this.goods.taxamount = parseFloat(val).toFixed(8)*100/100; // 数量*单价*税率=税额
			// });

			vm.$watch(
				function() {
					return this.goods.taxamount + this.goods.taxamount
				},
				function(val, oldVal){
					console.log('货款+税额=金额');
					this.goods.amount = parseFloat(val).toFixed(2)*100/100; // 货款+税额=金额
				}
			);
			// vm.$watch('(goods.taxamount)+(goods.taxamount)', function(val, oldVal){
			// 	this.goods.amount = parseFloat(val).toFixed(2)*100/100; // 货款+税额=金额
			// });
		}
	}
	typeWatch[vm.type](); // 设置表单监听
});
