define(function(require, exports, module) {

	var vm = new Vue({
		el: '#vm',
		template: _g.getTemplate('Business/product-frame-v'),
		data: {
			type: api.pageParam.type,
			index: '',//打开的商品序号
			items: [],
			amount: 0
		},
		methods: {
			init: function() { // 初始化
				var self = this;

				// 获取商品列表缓存
				var goods = _g.getLS('productJson') || {};
				console.log(_g.j2s(goods))
				
				// 设置商品列表
				self.items = goods.list || [];// 商品列表
				self.amount = goods.amount || 0;//合计

			},
			onTapOpen: function(item, index) { // 打开详情
				var self = this;
				self.index  = index;//记录打开的商品序号
				var goodsMode = self.items[index].mode || '';// 商品明细状态(old:单据本身商品, add:新增, edit:编辑过, del:已删除)
				// if(goodsMode == 'add'){
				// 	self.items[index].mode = 'edit';
				// }
				if(goodsMode == 'old'){
					self.items[index].mode = 'edit';
				}
				console.log('打开的商品数据：' + JSON.stringify(self.items[index]));
				_g.setLS('productItem', self.items[index]);
				api.pageParam.index = index;
				api.pageParam.showDelBtn = api.pageParam.isEditer;// 是否显示删除按钮
				api.pageParam.goodMode = 'edit';
				_g.openWin({
					name: 'product-detail',
					url: 'product-detail',
					pageParam: api.pageParam
				});
			},
			setGoodsLS: function() { // 缓存商品明细
				var self = this;
				var productJson = {
					list: self.items,
					amount: self.amount
				}
				_g.setLS('productJson', productJson);
			},
			countGoods: function() { // 统计新增或编辑过的商品明细数量
				var self = this;
				api.sendEvent({
					name: api.pageParam.parWin + '-goods-update'
				});
			},
			updateAmount: function() { // 更新合计
				var self = this;
				var amount = 0;
				_.each(self.items, function(ele, index, list){
					amount += Number(ele.amount);
				});
				self.amount = amount;
			}
		},
		created: function() {
			console.log(_g.j2s(api.pageParam));
			var self = this;
			self.init();
		},
		mounted: function() {
			var self = this;

			_g.addEventListener({
				name: 'goods-update',
				success: function(ret) {
					var mode = ret.value.mode;
					var goodMode = ret.value.goodMode; // 货品模式(old:单据本身商品, add:新增, edit:编辑过, del:已删除)
					var goods = ret.value.goods; // 商品数据
					switch(mode) {
						case 'save':
							if (goodMode == 'add') {
								self.items.push(goods); // 更新列表
							} else {
			    			self.items.splice(self.index, 1); // 移除旧数据
			    			self.items.push(goods); // 更新列表
							}
							break;
						case 'del':
							self.items.splice(self.index, 1); // 移除数据
							break;
					}
	    		self.updateAmount(); // 更新合计
					self.setGoodsLS(); // 缓存商品明细
					self.countGoods(); // 统计新增或编辑过的商品明细数量
				}
			});
		}
	});
});
