define(function(require, exports, module) {

	var COMMAND = require('command');
	var BUSINESS = require('business-erp');
	var TIME = require('time');

	var content = new Vue({
		el: '#content',
		template: _g.getTemplate('Business/work-frame-v'),
		data: {
			items: [],
			activeIndex: '',
			backup: {
				startdate: api.pageParam.param.startdate,
				enddate: api.pageParam.param.enddate
			}
		},
		methods: {
			init: function() { // 初始化
				var self = this;
				COMMAND.init({
					url: URLANNEX + '/ncrm/ssaleprice/ssalepriceselectChance!doGetChanceData.action',
					data: api.pageParam.param,
					method: 'post',
					success: function(ret) {
						self.items = self.dealData(ret.masterlist);
					}
				});
			},
			dealData: function(data) {
				return BUSINESS.addKeyValue({
					data: data,
					key: 'active',
					value: false
				});
			},
			onTapChoose: function(item, index) {
				var self = this;
				// if (item.active) {
				// 	return;
				// }
				// _.each(self.items, function(ele, index, list) {
				// 	ele.active = false;
				// });
				item.active = true;
				// self.activeIndex = index;

				Vue.set(self.items, index, item);
				api.sendEvent({
	              name:'sale-price-detail-select-work',
	              extra: {
	              	datas: self.items[index]
	              }
	            });
				setTimeout(function(){ _g.closeWin() }, 100)
			}
		},
		created: function() {
			console.log(_g.j2s(api.pageParam));
			var self = this;
			self.init(); // 初始化
		},
		mounted: function() {
			var self = this;

			_g.topLoading({ // 上拉加载
				success: function(ret) {
					COMMAND.next({
						success: function(ret) {
							self.items = _.union(self.items, self.dealData(ret.masterlist));
						}
					});
				}
			});

			_g.refresh({ // 下拉刷新
				success: function(ret) {
					COMMAND.refresh({
						success: function(ret) {
							api.pageParam.param.startdate = self.backup.startdate;
							api.pageParam.param.enddate = self.backup.enddate;
							self.items = self.dealData(ret.masterlist);
						}
					});
				}
			});

			var filterData = { // 过滤参数
				isReportOrProvider: true,
				filterName: 'selected-' + api.frameName,
				stage: {
					hasStage: true,
					startTime: TIME.getDates().sDate,
					endTime: TIME.getDates().eDate
				}
			}
			_g.setLS('selected-' + api.frameName, filterData);

			_g.addEventListener({ // 打开过滤页面
				name: api.winName + '-filter',
				success: function(ret) {
					_g.openWin({ // 打开过滤页面
						name:'filter',
						url:'../Common/filter',
						pageParam: _g.getLS('selected-'+api.frameName)
					})
				}
			});

			_g.addEventListener({ // 监听进行过滤操作
				name: 'selected-' + api.frameName + '-filterAction',
				success: function(ret) {
					var filterData = _g.getLS('selected-'+api.frameName);

					api.pageParam.param.startdate = filterData.stage.startTime;
					api.pageParam.param.enddate = filterData.stage.endTime;

					var filters = {
						startdate: filterData.stage.startTime, //开始时间
						enddate: filterData.stage.endTime //结束时间
					};

					COMMAND.filter({
						filterJson: filters,
						success: function(ret) {
							self.items = self.dealData(ret.masterlist);
						}
					});
				}
			});

			// _g.addEventListener({
			// 	name: api.winName + '-right',
			// 	success: function(ret) {
			// 		if (self.activeIndex !== '') {
			// 			api.pageParam.master = self.items[self.activeIndex]
			// 			api.sendEvent({
			//               name:'sale-price-detail-select-work',
			//               extra: {
			//               	datas: self.items[self.activeIndex]
			//               }
			//             });
			// 			setTimeout(function(){ _g.closeWin() }, 100)
			// 		}
			// 	}
			// })
		}
	});
});
