define(function (require, exports, module) {
	
	var COMMAND = require('command')
	var INTERFACE = require('interface')
	var MODULE = require('modules');
	var TIME = require('time')
	var stime = TIME.getDates().sDate
	var etime = TIME.getDates().eDate
	var content = new Vue({
		el: '#content',
		data: {
			paramData: {}
		},
		methods: {
			winSelect: function(item){
				var self = this;
				var _hasSearch = false;
				if (item.dataSource) {
					self.winSelectOfdata(item)
					return;
				}
				// console.log (INTERFACE.base[item.tag]['param'].hasOwnProperty('likeValue'));
				if ((INTERFACE.base[item.tag]['param']['likeValue'] == '') || item.hasSearch) {
					// item.hasSearch: 一般不会有该参数，只有在不是用“likeValue”进行搜索才需要传,并且传值也为true。
					_hasSearch = true;
				}
				var params = {
					isMultiSelect: item.isMultiSelect,
					title: item.title,
					tag: item.tag,
					frameName: api.frameName,
					showName: INTERFACE.base[item.tag]['showName'], //showName是数组（把要显示的内容拼接起来）
					hasSearch: _hasSearch,
					showScan: item.showScan,
					searchKeyword: item.searchKeyword,
					extraParams: {filter: item.filter}
				}
				if (item.otherParams) {
					//如有其他参数，则再加，暂时（旧单据过滤时的供应商、客户的过滤，待优化）
					$.extend(params.extraParams, item.otherParams);
				}
				_g.openWin({
					name:'list-select',
					url:'list-select',
					pageParam: params
				})
			},
			winSelectOfdata: function(item){ //新开窗口，并带有数据源
				var params = {
					isMultiSelect: item.isMultiSelect,
					title: item.title,
					tag: item.tag,
					hasSearch: item.hasSearch,
					frameName: api.frameName,
					showName: ['title'], //showName是数组（把要显示的内容拼接起来）
					dataSource: item.dataSource
				}
				_g.openWin({
					name:'list-select',
					url:'list-select',
					pageParam: params
				})
			},
			downSelect: function(item){
				var self = this
				MODULE.scrollSelect({
					isCitySelect: false,
					data: item.source,
					curActive: {
						index: item.selected.selectedIndex || 0
					},
					nextStep:function(ret){
						if(ret.eventType != 'cancel'){
							_.each(self.paramData.listItem, function(val, key){
								if(item.title == val.title){
									item.selected = ret.selectedInfo[0]
									return
								}
							})
							console.log(JSON.stringify(self.paramData.listItem))
						}
					}
				})
			},
			tapTimePicker: function(value, type, $index){
				var self = this
				if (value == '') {
					//无默认值
					value = TIME.getDates().eDate;
				}
				TIME.getPickerDates(value, function(selectedTime){
					if(type == 'stime'){
						// 开始时间
						Vue.set(self.paramData.stage, 'startTime', selectedTime)
					}else if(type == 'etime'){
						// 结束时间
						Vue.set(self.paramData.stage, 'endTime', selectedTime)
					}else if(type == 'time'){
						Vue.set(self.paramData.listItem[$index], 'selected', selectedTime)
					}	
				})
			},
			hasClient: function(winName, type, module) {
				var self = this
				if(self.paramData.listItem[0]['selectedStr'] == '不限' || self.paramData.listItem[0]['selected'].value == '不限') {
					_g.toastMsg({msg: '请选择'+type})
					return
				}
				//报表-客户流水, 资料-超期应收（天耀V30）
				if(winName == 'client-flow' || winName == 'outdate'){
					_g.closeWin({
						name: winName + '-win'
					})
				}
				_g.openWin({
					name: winName,
					url: '../' + module+ '/' + winName,
				})
			},
			openArea:function(){
				_g.openWin({
					name:name,
					url:'../Data/area',
					pageParam: {
						type:'filter',
						title:'地区选择'
					},
				})
			}
		},
		created: function() {
			var self = this;
			if(!api.pageParam.stage.hasOwnProperty('stageTit')){
				api.pageParam.stage.stageTit = '时间区间'; 
			}
			self.paramData = api.pageParam;
			console.log('listItem:'+_g.j2s(self.paramData.listItem))
			// 处理select-win的多选
			
			_.each(self.paramData.listItem, function(value, key){
				if(value.isMultiSelect) {
					if(!value.hasOwnProperty('selectedStr')) {
						value.selectedStr = '不限'
					}
				} else {
					value.isMultiSelect = false
				}
			})
		},
		mounted: function() {	

			var self = this
			_g.addEventListener({
				name: api.winName + '-save',
				success: function(ret) {
					if (self.paramData.stage.startTime > self.paramData.stage.endTime) {
						_g.toastMsg({ msg: '开始时间不能大于结束时间'})
						return
					}
					console.log(self.paramData.filterName);
					console.log(JSON.stringify(self.paramData));
					$api.setStorage(self.paramData.filterName, self.paramData) //新单据（盘点单、费用申请）没引入global.js,所以不能用_g.setLS，需引入api.js
					_g.setLS(self.paramData.filterName, self.paramData)

					switch(self.paramData.filterName){
						case 'selected-get-credit-frame': // 报表-应收账款
							self.hasClient('get-credit', '客户', 'Report')
						break;
						case 'selected-post-credit-frame': // 报表-应付账款
							self.hasClient('post-credit', '供应商', 'Report')
						break;
						case 'selected-client-flow-frame': // 报表-客户流水
							self.hasClient('client-flow', '客户', 'Report')
						break;
						case 'selected-outdate-frame': // 资料-超期应收
							self.hasClient('outdate', '客户', 'Data')
						break;
						default:
							console.log('event listener: ' + self.paramData.filterName);
							api.sendEvent({
								name: self.paramData.filterName + '-filterAction',
								extra: {}
							})
							setTimeout(function(){ _g.closeWin() }, 300)
					}
					
				}
			})
			//获取win-select的选中数据
			_g.addEventListener({
				name: api.frameName + '-get-winselected',
				success: function(ret) {
					_.each(self.paramData.listItem, function(val, key){
						if(ret.value.tag == val.tag){
							if(val.isMultiSelect) {
								// 多选
								if (ret.value.selectedData.length != 0) {
									var selected = []
									val.selected = ret.value.selectedData
									_.each(ret.value.selectedData, function(value, key){
										selected.push(value.showName)
									})
									val.selectedStr = selected.join('、')
									Vue.set(self.paramData.listItem, key, val)
								} else {
									val.selected = [{value: '不限'}]
									val.selectedStr = '不限'
									Vue.set(self.paramData.listItem, key, val)
								}
							} else {
								// 单选
								if (ret.value.selectedData.length != 0) {
									val.selected = ret.value.selectedData[0]
									val.selected.value = ret.value.selectedData[0]['showName']
								} else {
									val.selected = {value: '不限'}
								}
							}
						}
					})
				}
			})
			_g.addEventListener({
				name:'filter-area-select',
				success:function(ret){
					console.log('filter-area-select:'+_g.j2s(ret));
					_.each(self.paramData.listItem, function(val, key){
						if('area' == val.tag){
							val.selected = ret.value;
							val.selected.value = ret.value.selectName;
							return false;
						}
					})
				}
			})
		}

	});
});
