define(function(require, exports, module) {

	var vm = new Vue({
		el: '#vm',
		template: _g.getTemplate('Common/header/btns-layer-frame-v'),
		data: {
			btns: [],
			style: {
				isCenter: false,
				align: 'tx-r',
				width: 'wid-110',
				flex: 'ub-ae'
			}
		},
		computed: {
			// btnsSort: function() {
			// 	return _.sortBy(this.btns.filter(function (ele) {
			// 		return ele.title !== '打印'
			// 	}), 'sort')
			// }
			btnsSort: function() {
    		return _.sortBy(this.btns, 'sort')
			}
		},
		methods: {
			init: function() { // 初始化
				var self = this;

				_.each(self.btns, function(ele, index, list) {
					switch (ele.title) {
						case '保存':
							ele.icon = 'save';
							ele.sort = 0;
							break;
						case '提交':
							ele.icon = 'right';
							ele.sort = 1;
							break;
						case '撤回':
							ele.icon = 'revoke';
							ele.sort = 2;
							break;
						case '审核':
							ele.icon = 'check';
							ele.sort = 3;
							break;
						case '反审核':
							ele.icon = 'uncheck';
							ele.sort = 4;
							break;
						case '微信分享':
							ele.icon = 'wx';
							ele.sort = 5;
							break;
						case 'QQ分享':
							ele.icon = 'qq';
							ele.sort = 6;
							break;
						case '打印':
							ele.icon = 'print';
							ele.sort = 7;
							break;
						case '删除':
							ele.icon = 'del';
							ele.sort = 8;
							break;
						default:
							ele.icon = '';
					}
				});
			},
			onTapChoose: function(btn, index) { // 选中选项
				var self = this;
				api.sendEvent({
					name: api.winName + '-btns-layer-click',
					extra: {
						btn: btn,
						index: index
					}
				});
				self.onTapHide(); // 隐藏
			},
			onTapHide: function() { // 设置隐藏状态
				var self = this;
				api.sendEvent({
					name: api.frameName + '-state',
					extra: {
						state: 2 // 设置状态(0: 未打开, 1: 打开, 2: 隐藏)
					}
				});
				self.hide(); // 隐藏
			},
			hide: function() { // 隐藏
				api.setFrameAttr({
					name: api.frameName,
					hidden: true
				});
			}
		},
		created: function() {
			var self = this;
			console.log(_g.j2s(api.pageParam))
			self.btns = api.pageParam.btns;
			if (api.pageParam.location == 'center') {
				self.style.isCenter = true;
				self.style.align = 'tx-c';
				self.style.width = 'wid-90';
				self.style.flex = 'ub-ac';
			} else {
				self.init(); // 初始化按钮
			}
		},
		mounted: function() {
			var self = this;

			api.addEventListener({ // 监听图标更新
				name: api.winName + '-btns-layer-update'
			}, function(ret, err) {
				self.btns = ret.value.btns;
				self.init();
			});
		}
	});
});
