define(function(require, exports, module) {

	var vm = new Vue({
		el: '#vm',
		template: _g.getTemplate('Common/header/select-list-frame-v'),
		data: {
			items: [],
			activeItem: {}
		},
		methods: {
			init: function() { // 初始化
				var self = this;
				var tempItems = api.pageParam.data;
				_.each(tempItems, function(element, index, list) {
					if(index == 0) {
						self.activeItem = element;
						element.active = true;
					} else {
						element.active = false;
					}
				});
				self.items = tempItems;
			},
			onTapChoose: function(item, index) { // 选中选项
				var self = this;
				if (!item.active) {
					_.each(self.items, function(element, index, list) {
						element.active = false;
					});

					item.active = true;

					api.sendEvent({
						name: api.winName + '-select-data',
						extra: {
							data: item
						}
					});

					api.sendEvent({ // 清空搜索框
						name: api.winName + '-search-clear'
					})
				}
				self.onTapHide(); // 隐藏
			},
			onTapHide: function() { // 隐藏
				var self = this;
				api.sendEvent({
					name: api.frameName + '-state',
					extra: {
						state: 0 // 设置状态(0: 未打开, 1: 打开, 2: 隐藏)
					}
				});
				self.hide(); // 隐藏
			},
			hide: function() { // 隐藏
				api.setFrameAttr({
					name: api.frameName,
					hidden: true
				});
			}
		},
		created: function() {
			var self = this;
			self.init();
		},
		mounted: function() {
			var self = this;

			_g.addEventListener({ // 如果首页模块-审批单据列表中，头部标题有切换，则让“全部”选中
				name: api.winName + '-clear-typeChoose',
				success: function(ret) {
					_.each(self.items, function(element, index, list) {
						element.active = false;
					});
					self.items[0].active = true;
				}
			});
		}
	});
});
