define(function(require,exports,module){
	var _C = require('components');
	var COMMAND = require('command');
	var INTERFACE = require('interface');
	var getItemSelect = {
		frameName: api.frameName // 当前frame名
	};
	var getBaseIcon = {
		frameName: api.frameName // 当前frame名
	};
	var getBaseIcon = {
		icons: ['select'] //select为选择按钮
	};
	var list = new Vue({
		el:'#list',
		components:{
			'item-select': _C.getItemSelect(getItemSelect),
			'base-icon': _C.getBaseIcon(getBaseIcon)
		},
		data:{
			listData:[],	  //用于显示的列表数据
			params: {		  // 获取列表的参数
				pageSize: 15,
				likeValue: ''
			},
			isMultiSelect: api.pageParam.isMultiSelect || false,
			selectIndex: [], //选择的索引数组
			showNameArr: [],

			hasCode:false,
			likeValue: '',  //初始化时请求参数likeValue的值
			initFilterStr:'',	//初始化时请求参数filter的值
		},
		methods:{
			sortShowName: function(){
				var self = this
				//处理要显示的值
				if(api.pageParam.showName instanceof Array){
					// Array（数组）
					self.showNameArr = api.pageParam.showName
				}
			},
			selectIt:function(index){
				//选择
				var self = this;
				if(self.isMultiSelect){
					// 多选
					self.listData[index].selected = !self.listData[index].selected
					var i = _.indexOf(self.selectIndex, index)
					if(i < 0 && self.listData[index].selected == true) {
						//selectIndex中没有index,并且选中，则添加
						self.selectIndex.push(index)
					}else if(i > -1 && self.listData[index].selected == false) {
						//selectIndex中有index,并且不选中，则去除
						self.selectIndex = _.without(self.selectIndex, index)
					}
				}else{
					//单选
					self.selectIndex = [index];
					//选中即确定
					self.submit();
				}
			},
			ajax: function(){
				var self = this
				console.log(JSON.stringify(api.pageParam))
				var _data = $.extend({},
					INTERFACE['base'][api.pageParam.tag]['param'],
					api.pageParam.extraParams,
					self.params);
				if(api.pageParam.deleteParams){
					//如需要删除特定参数，需在 ajax前删除
					_.each(api.pageParam.deleteParams, function(val, key){
						delete _data[val];
					})
				}
				if (api.pageParam.tag == 'goodsType') {  //返回参数直接是数组，无errNo, errMsg等
					COMMAND.init({
						url: api.pageParam.url || INTERFACE['base'][api.pageParam.tag].url || INTERFACE.base.url,
						data: _data,
						hideProgress: true,
						method: api.pageParam.method || 'post',
						extraFunc:function(ret){
							_g.hideProgress();
							_.each(ret, function(val, key){
								val.selected = false;
								val.showName = '';
								// 把显示内容拼接起来
								_.each(self.showNameArr, function(showVal, key){
									val.showName = val.showName + '     ' + val[showVal]
								})
							})
							self.listData = ret
						}
					})
				} else{
					COMMAND.init({
						url: api.pageParam.url || INTERFACE['base'][api.pageParam.tag].url || INTERFACE.base.url,
						data: _data,
						hideProgress: true,
						method: api.pageParam.method || 'post',
						success:function(ret){
							_g.hideProgress();

							var listData =  ret.listData || ret.ListData;
							if (ret.resultData) {
								listData = ret.resultData.ListData;
							}
							if (ret.data) {
								listData = ret['data'][api.pageParam.retTag];
							}
							_.each(listData, function(val, key){
								val.selected = false;
								val.showName = '';
								// 把显示内容拼接起来
								_.each(self.showNameArr, function(showVal, key){
									val.showName = val.showName + '     ' + val[showVal]
								})
								// code是代码，搜索时，会根据hasCode判断传不同的SQL语句。
								if(val.code){
									self.hasCode = true;
								}
							})
							self.listData = listData
						}
					})
				}

			},
			submit: function(){
				// 整理选中数据，返回到上一页
				var self = this;
				var selectedData = [];
				if (self.selectIndex.length != 0) {
					_.each(self.selectIndex, function(val, key){
						selectedData.push(self.listData[val]);
					})
				}
				api.sendEvent({
					name: api.pageParam.frameName + '-get-winselected',
					extra: {
						tag: api.pageParam.tag,
						selectedData: selectedData
					}
				})
				// 关闭窗口
				setTimeout(function(){ _g.closeWin() }, 300);
			}
		},
		created:function(){
			var self = this
			if(api.pageParam.dataSource) {
				self.sortShowName()
				_.each(api.pageParam.dataSource, function(val, key){
					val.selected = false;
					val.showName = '';
					// 把显示内容拼接起来
					_.each(self.showNameArr, function(showVal, key){
						val.showName = val.showName + '     ' + val[showVal]
					})
				})
				self.listData = api.pageParam.dataSource 
				return;
			}
			//是否显示时间区间
			//过滤，initFilterStr在搜索filter时需用到。
			if(api.pageParam.extraParams && api.pageParam.extraParams.filter){
				self.initFilterStr = api.pageParam.extraParams.filter;
			} else{
				self.initFilterStr = '1=1';
			}
			if(api.pageParam.extraParams && api.pageParam.extraParams.likeValue){
				self.likeValue = api.pageParam.extraParams.likeValue;
			} else{
				self.likeValue = '';
			}
			self.sortShowName()
			self.ajax()
		},
		mounted:function(){
			var self = this
			// 上拉加载
			_g.topLoading({
				success:function(){
					if(api.pageParam.dataSource) {
						_g.refreshDone();
						return;
					}
					COMMAND.next({
						success: function(ret){
							var listData = ret.listData || ret.ListData;
							if (ret.resultData) {
								listData = ret.resultData.ListData;
							}
							if (ret.data) {
								listData = ret['data'][api.pageParam.retTag];
							}
							_.each(listData, function(val, key){
								val.selected = false
								val.showName = ''
								_.each(self.showNameArr, function(showVal, key){
									val.showName = val.showName + '  ' + val[showVal]
								})
							})
							self.listData = _.union(self.listData, listData)
						}
					})
				}
			})
			// 下拉刷新
			_g.refresh({
				success:function(){
					if(api.pageParam.dataSource) {
						_g.refreshDone();
						return;
					}
					if (api.pageParam.tag == 'oldGoods') {
						self.params = { 
							pageSize: 15,
							likeValue: ''
						}
						api.sendEvent({
							name: api.winName + '-search-clear'
						});
						self.ajax()
					}else{
						//用filter来搜索
						COMMAND.refresh({
							modify: {
								filter: self.initFilterStr,
								likeValue: self.likeValue
							},
							success: function(ret) {
								var listData = ret.listData || ret.ListData;
								if (ret.resultData) {
									listData = ret.resultData.ListData;
								}
								if (ret.data) {
									listData = ret['data'][api.pageParam.retTag];
								}
								_.each(listData, function(val, key){
									val.selected = false
									val.showName = ''
									_.each(self.showNameArr, function(showVal, key){
										val.showName = val.showName + '  ' + val[showVal]
									})
								})
								self.listData = listData
							}
						})
					}
					
				}
			})
			// 监听搜索内容的变化
			_g.addEventListener({
	  			name: api.winName + '-search',
	  			success: function(ret) {
	  				if(api.pageParam.dataSource) {
	  					_g.refreshDone();
	  					return;
	  				}
	  				console.log(JSON.stringify(ret))
	  				//设置参数里的关键字
					var keyword = ret.value.keyword;
					var _tag = api.pageParam.tag;
					var filterStr = '';

					//处理过滤参数（特殊的，比如旧单据的过滤货品）
					if (_tag == 'oldGoods') {
						api.sendEvent({
							name: _tag + '-set-filter',
							extra: {
								keyword: keyword
							}
						})
						//处理后，会在监听器'oldGoods-get-filter'中获得过滤参数，并进行搜索
					}else if (api.pageParam.searchKeyword) {
						//一般不会有searchKeyword这个参数，如果搜索时是用'likeValue'而非'filter',则需传
						self.params[api.pageParam.searchKeyword] = keyword;
		  				// 重新获取数据
						self.ajax()
					}else{
						if(self.hasCode){
							//hasCode表示列表数据中，是否含有‘code’字段。
							if(self.initFilterStr != '1=1'){
								filterStr = self.initFilterStr + " and (code like '%" + keyword + "%' or name like '%" + keyword + "%')";			
							}else{
								filterStr = "(code like '%" + keyword + "%' or name like '%" + keyword + "%')";
							}
						} else {
							if(self.initFilterStr != '1=1'){
								filterStr = self.initFilterStr + " and (name like '%" + keyword + "%')";
							}else{
								filterStr = "(name like '%" + keyword + "%')";
							}
						}
						
						if (_tag == 'employ' || _tag == 'payMethod' || _tag == 'project') {
							//旧单据里的字段
							filterStr = INTERFACE.oldBusinessSearch({
								tag: _tag, 
								keyword: keyword, 
								filterStr: filterStr
							})
						}
						if (_tag == 'oldUnit'){//结算单位
							filterStr = INTERFACE.oldBusinessSearch({
								tag: _tag, 
								keyword: keyword, 
								filterStr: self.initFilterStr,
								isShopid: api.pageParam.isShopid,
								shopid: api.pageParam.shopid
							})
							self.params.likeValue = keyword;
						}
						console.log(filterStr);
						self.params.filter = filterStr;
		  				// 重新获取数据
						self.ajax()
					}
	  			}	
	  		})
	  		_g.addEventListener({
				name: api.pageParam.tag + '-get-filter',
				success: function(ret) {
					if(api.pageParam.dataSource) return;
					//搜索的特殊处理，目前只有在旧单据billing-frame页面中有用到
					$.extend(self.params, ret.value.filterData);
					delete self.params.likeValue;
					// 重新获取数据
					self.ajax()
				}
			})
			//确定(多选)
			_g.addEventListener({
				name: api.winName + '-save',
				success: function(ret) {
					self.submit();
				}
			})


			//<item-select>组件里的item选中，
			_g.addEventListener({
				name: getItemSelect.frameName + '-selectIt',
				success: function(ret){
					self.selectIt(ret.value.index)
				}
			})
		}
	})
})