define(function(require,exports,module){
	var _C = require('components');
	var COMMAND = require('command');
	var INTERFACE = require('interface');
	var TIME = require('time');
	var stime = TIME.getDates().sDate;
	var etime = TIME.getDates().eDate;
	var _btns = [];
	if(api.pageParam.isMultiSelect) {
		_btns.push({
        	name: '确定',
        	event: api.winName + '-save'
      	})
	}
	console.log(JSON.stringify(api.pageParam))
	var header = new Vue({
		el:'#header',
		components:{
			baseheader:_C.getBaseHeader({
				title: api.pageParam.title,
        		showTitleSelect: false,
        		btns: _btns
			}),
			basesearchbar: _C.getBaseSearchBar({
		        showScan: api.pageParam.showScan || false, //是否有扫码
		        tips: '请输入'+ api.pageParam.title  //提示语
		    })
		},
		data:{
			keyword: '',
			showTime: api.pageParam.showTime || false,
			stime: '',
			etime: '',
			hasSearch: api.pageParam.hasSearch == undefined ? true : api.pageParam.hasSearch
		},
		created: function(){
			var self = this;
			self.stime = stime
			self.etime = etime
		},
		mounted: function(){
			_g.openFrame({
			    name: 'list-select',
			    url: 'list-select',
			    pageParam: api.pageParam
			})
			//搜索内容清空
			api.addEventListener({
			    name: 'list-select-clear'
			}, function(ret, err) {
			    self.keyword = '';
			});
			// 时间选择
			api.addEventListener({
				name:'openTimePicker'
			},function(ret, err){
				_basic.getPickerDates(ret.value.curTime, function(chooseDate){
					if(self.timeType == 'stime'){
						self.stime = chooseDate;
					}else{
						self.etime = chooseDate;
					}
					api.sendEvent({
						name:'select-time',
						extra: {
							stime: self.stime,
							etime: self.etime
						}
					})
				});
			});
		},
		methods: {
			changeSearch:function(changeData){
				var self = this;
				self.keyword = changeData[0];
				api.sendEvent({
					name: api.winName + '-search',
					extra: {
						keyword: changeData[0]
					}
				})
			},
			tapTimePicker:function(time,type){
				var self = this;
				self.timeType = type;
				api.sendEvent({
					name: 'openTimePicker',
					extra: {
						curTime: time
					}
				});
			}
		}
	});
	var Height;
	if(header.showTime){
		Height = 170;
	}else if(header.hasSearch){
		Height = 107;
	}else if((!header.hasSearch) && (!header.showTime)){
		Height = 68;
	}
	console.log('Height:'+Height);

});