define(function(require,exports,module){

	var command = require('command');
	var _interface = require('interface');

	var addressList = new Vue({
		el:'#addressList',
		template:_g.getTemplate('Data/address-frame-v'),
		data:{
			items:[
			],
			phoneNumber:'',
			itemId:''
		},
		mounted:function(){

			var that = this;
			_g.showLoading();
			_g.addEventListener({
        name:api.winName+'-add-address',
        success:function(ret){
        	_g.openWin({
						name: 'new-address',
						url: '../Data/new-address',
						pageParam:{
							type:'新增'
						},
					})
				}
      });

			//从客户详情里进入
			that.items = _g.getLS('recAddress') === undefined ? [] : _g.getLS('recAddress');
            
      _g.addEventListener({
      	name:'address_list_reload',
      	success:function(ret){
      		that.items = _g.getLS('recAddress');
      		that.showNull();
      	}
      });
      that.showNull();
      _g.hideProgress();
		},
		methods:{
			//进入地址编辑页面
			showDetail:function(curItem){
				var that = this;
				// _g.openWin('Client','new_address',{'type':'编辑','data':curItem});
				_g.openWin({
					name: 'new-address',
					url: '../Data/new-address',
					pageParam:{
						type:'编辑',
						data:curItem
					},
				})
			},
			//调用拨打号码
			call:function(ret,err){
				var that = this;
				if(ret.buttonIndex==1){
					_g.call(that.phoneNumber);
				}
			},
			//弹出对话框
			confirm:function(phoneNo){
				var that = this;
				that.phoneNumber = phoneNo;
				var params = {
					title:'号码:'+that.phoneNumber,
					buttons:['呼叫']
				};
				_g.openButtons(params,that.call);
			},
			//删除一条记录
			delItem:function(ret,err){
				var that = this;
				var deleteArr = _g.getLS('deleteAddress') == undefined ? [] : _g.getLS('deleteAddress');//保存所有删除的地址
	    	if(ret.buttonIndex==1){
					$.each(that.items,function(k,v){
						if(v.itemno == that.itemId){
							that.items.splice(k,1);
							deleteArr.push(v);
							_g.setLS('deleteAddress',deleteArr);
						}
					});
					_g.toastMsg({
						msg: '删除成功'
					});
					_g.setLS('recAddress',that.items);
					api.sendEvent({
						name:'address_list_reload',
						extra:{}
					});
					that.showNull();
	    	}
			},
			//响应长按事件
			press:function(itemNo){
				var that = this;
				that.itemId = itemNo;//目标对象下标值
				var params = {
					title: '',
			    msg: '是否删除该地址?',
			    buttons: ['确定', '取消']
				};
				_g.confirm({
					params: params,
			    success: that.delItem
				});
			},
			showNull:function(){
				var that=this;
				if(_.isEmpty(that.items)){
					$('#null').removeClass('uhide');
				}else{
					$('#null').addClass('uhide');
				}
			}
		}
		
	});
});