define(function(require,exports,module){
	var MAPS = require('maps');
	var command = require('command');
	var INTERFACE = require('interface');
	var modules = require('modules');
	var http = require('http');

	var client = new Vue({
		el:'#clientDetail',
		data:{
			client:{
				areaname:'',
				areaid:'',
				areacode:'',
				opname:'',
				opid:'',
				clienttypename: '',
				clienttypeid: '',
				sourcename: '',
				sourcetypeid: '',
				corpname: '',
				corptypeid: '',
				tradetypename:'',
				tradetypeid:'',
				statusname: '',
				statustypeid: '',
				levname:'',
				lev: '',
				clientid:api.pageParam.clientId,
        			checkStep:0,
				activityid:'',
				address: '',
				tradedate:'',
				tracedate:'',
				scamt:'',
				iscashtrader:0,//现金往来单位，1则灰置科目不能修改
			},
			isShow:false,
			annex:{
				len: 0,// 附件数量
				dataJson: [],// 附件数据
			},								
			dataDur:{
				len:0,  //数据权限数量
				data:[] //数据权限数据
			},								 
			transRecord:{
				len:0, ///移交历史数目
				data: [] //移交历史数据
			},
			contact:{
				len:0, ///联系人数目
				data: [] //联系人数据
			},							
			followRecord:{
				len:0,  //跟进记录数量
				data:[] //跟进记录数据
			},							 
			editAddress:[],
			deleteAddress : [],
			isSaved:false,
			recAddress:[],		//收货地址
			winSelectd: {
				'所有人': {
				}, 
				'往来类型': {
				},
				'来源': {
				},
				'地区': {
				},
				'行业': {
				},
				'客户状态': {
				},
				'客户等级': {
				},
			},
			curwinSelected: '',
			iscashtrader: 0,
			winselectParams: {  //new
				'所有人': {
					title: '所有人',
					tag: 'operator'
				},
				'往来类型': {
					title: '往来类型',
					tag: 'traderType'
				},
				'来源': {
					title: '来源',
					tag: 'source'
				},
				'地区': {
					title: '地区',
					tag: 'area'
				},
				'行业': {
					title: '行业',
					tag: 'corpType'
				},
				'客户状态': {
					title: '客户状态',
					tag: 'state'
				},
				'客户等级': {
					title: '客户等级',
					tag: 'level'
				},
				// '预收款科目': {
				// 	title: '预收款科目',
				// 	tag: 'subject'
				// },
				// '应收款科目': {
				// 	title: '应收款科目',
				// 	tag: 'subject'
				// }
			},
			mode: api.pageParam.mode,
			levList:[
				{selectedIndex:0,name:'一级',value:'1','sub':[{}],},
				{selectedIndex:1,name:'二级',value:'2','sub':[{}],},
				{selectedIndex:2,name:'三级',value:'3','sub':[{}],},
				{selectedIndex:3,name:'四级',value:'4','sub':[{}],},
				{selectedIndex:4,name:'五级',value:'5','sub':[{}],},
			]
		},
		methods:{
			openAnnex: function(){
				var self = this;
				// 打开附件
				var paramJson = {
					readOnly: false,
					isDetail: self.mode == 'edit' ? true : false,// 单据是否为详情情况
					param: {
						'id': api.pageParam.clientId,// 单据id
						'modId': 2402,// modId
					},
					// dataJson: self.annex.dataJson,// 附件数据
				}
				_g.openWin({
					name: 'annex',
					url: '../Annex/annex',
					pageParam:{
						paramJson:paramJson
					}
				})
			},
			updateAnnex: function(clientId, annexList) { // 上传附件列表
				for (var i = 0; i < annexList.length; i++) {
					http.ajax({
						url: INTERFACE.annex['upload'].url,
						data: {
							id: clientId,
							modId:'2402',
							fileFileName: annexList[i].filename + '.' + annexList[i].filetype, // 文件名+.文件格式
							voiceTime: annexList[i].voiceTime || 0,// 录音的时候voiceTime这个参数是大于0，如果是其它类型就等于0
						},
						files: {
							file: annexList[i].filepath,
						},
						success: function(ret) {
							api.hideProgress()
							console.log('上传附件返回参数：' + _g.j2s(ret));
							_g.toastMsg({
								msg: ret.errMsg
							});
							api.sendEvent({ // 更新详情数量
								name: 'annex-num',
								extra: {
									'type': 'add'
								}
							});
							api.sendEvent({
								name: 'annex-reload'  // 刷新列表
							});
						}
					});
				}
			},
			winSelect: function(title){
				var self = this
				self.curwinSelected = title
				var item = self.winselectParams[title]
				var params = {
					title: item.title,
					tag: item.tag,
					frameName: api.frameName,
					showName: INTERFACE.base[item.tag]['showName'],
					hasSearch: INTERFACE.base[item.tag]['param']['likeValue'] == undefined ? false : true
				}
				_g.openWin({
					name:'list-select',
					url:'../Common/list-select',
					pageParam: params
				})
			},
			//打开新页面
			openWin:function(name,url,data){
				//this.flag = data['type'];
				if(name == 'Annex'){
					var paramJson = {
						isDetail:this.isShow,// 单据是否为详情情况
						param: {
							'id': api.pageParam.clientId,// 单据id
							'modId': '2402',// 业务类型modId
						}
					}
					_g.openWin({
						name: 'annex',
						url: '../Annex/annex',
						pageParam:{
							paramJson:paramJson
						}
					})
				}else{
					console.log('data:'+_g.j2s(data));
					_g.openWin({
						name: name,
						url: url,
						pageParam:data
					})
				}
			},
			openLimit:function(){
				var OPENCRMPRIVILEGE = _g.getLS('OPENCRMPRIVILEGE');	//是否启用客户数据权限
				if(OPENCRMPRIVILEGE == 0){
					_g.toastMsg({
						msg:'你没有启用客户权限功能'
					})
				}else{
					_g.openWin({
						name:'limit',
						url:"../Data/limit",
						pageParam:{
							"type":"edit" , 
							"clientId": api.pageParam.clientId
						}
					});
				}
			},
			openArea:function(title,tag,name){
				_g.openWin({
					name:name,
					url:'../Data/area',
					pageParam: {
						type:'client',
						title:'地区选择'
					},
				})
			},
			//点击切换客户是否停用
			chooseStop:function(){
				var self=this;
				self.client.closed = self.client.closed == 1?0:1;
			},

			//获得附件
			getAnnex: function(followId) {
				var that = this;
				http.ajax({
					url: INTERFACE.annex.list.url,
					data: {
						id: api.pageParam.clientId,
						modId: 2402 
					},
					success: function(ret) {
						that.annex.len = ret.data.detail1.length;
					}
				});
			},

			//新增客户
			addAjax: function(){
				var self = this
		  	_g.showLoading({title: '正在加载'})
				http.ajax({
					url: URLANNEX+'/common/client/clientEdit!doGetAddnewData.action',
					data: INTERFACE.client.clients.add.param,
					method:'post',
					success:function(ret){
						//errNo为0时，操作成功
						_g.hideProgress()
						_.each(ret.master, function(val, key){
							if(val != null){
								self.client[key] = val 
							}
						})
						self.client['opid'] = _g.getLS('opID');
						self.client['opname'] = _g.getLS('opName');
						self.client['shopid'] = _g.getLS('shopID');
						self.client['shopname'] = _g.getLS('shopName');
					},
					other:function(ret){
						_g.hideProgress()
					},
					err:function(err){
						_g.hideProgress()
						_g.toastMsg({msg: err.msg})
					}
				})
			},
			detailAjax: function(){
				var self = this
				_g.showLoading({})
				http.ajax({
					url:URLANNEX+'/common/client/clientEdit!doGetEditData.action',
					data: $.extend(INTERFACE.client.clients.detail.param, {id: api.pageParam.clientId}),
					success:function(ret){
						//errNo为0时，操作成功
						_g.hideProgress()
						// self.annex.len = ret.data.fileCount
						// alert('fileCount:'+ret.data.fileCount)
						// alert('annex.len:'+self.annex.len)
						self.dataDur.len = ret.master.privcount  //数据权限数量
						self.transRecord.len = ret.master.transfercount //移交历史数量
						self.contact.len = ret.master.linkcount //联系人数量
						self.followRecord.len = ret.master.contcount //跟进记录数量
						self.client.opid = ret.master.opid  //所有人名称
						self.client.opname = ret.master.opname  //所有人id
						self.client.code = ret.master.code  //编号
						self.client.clientid = ret.master.clientid  //编号
						self.client.name = ret.master.name  //名称
						self.client.shortname = ret.master.shortname  //名称
						self.client.tradetypeid = ret.master.tradetypeid  //往来类型id
						self.client.tradetypename = ret.master.tradetypename //往来类型名称
						self.client.sourcetypeid = ret.master.sourcetypeid  //客户来源id
						self.client.sourcename = ret.master.sourcename //客户来源名称
						self.client.areaid = ret.master.areaid  //地区id
						self.client.areaname = ret.master.areaname //地区名称
						self.client.corptypeid = ret.master.corptypeid  //行业id
						self.client.corpname = ret.master.corpname //行业名称
						self.client.phone = ret.master.phone //电话
						self.client.mobilephone = ret.master.mobilephone //手机
						self.client.fax = ret.master.fax //传真
						self.client.address = ret.master.address //地址
						self.client.statustypeid = ret.master.statustypeid  
						self.client.statusname = ret.master.statusname
						self.client.lev = ret.master.lev  //等级id
						if (!(self.client.lev == null || self.client.lev == "")) {
							switch(self.client.lev) {
								case 1:
									self.client.levname = "一级";
									break;
								case 2:
									self.client.levname = "二级";
									break;
								case 3:
									self.client.levname = "三级";
									break;
								case 4:
									self.client.levname = "四级";
									break;
								case 5:
									self.client.levname = "五级";
									break;
								default:
									break;
							}
						}
						self.client.credit = ret.master.credit //信用额度
						self.client.memo = ret.master.memo //备注
						self.client.address = ret.master.address //收货地址
						self.client.shopid = ret.master.shopid  //机构id
						self.client.shopname = ret.master.shopname //机构名称
						self.client.tradedate = ret.master.tradedate //最近成交日期
						self.client.tracedate = ret.master.tracedate //最近跟进日期
						self.client.balance	 = ret.master.balance	//余额
						self.client.iscashtrader = ret.master.iscashtrader

						self.getAnnex();

						_.each(ret.master, function(val, key){
							if(val != null){
								self.client[key] = val
							}
						})
					},
					other:function(ret){
						_g.hideProgress()
					},
					err:function(err){
						_g.hideProgress()
						_g.toastMsg({msg: err.msg})
					}
				})
			},
			chooseLev:function(){
				var self=this;
				self.client.lev = self.client.lev == null ? 0 :  self.client.lev
				var curActive={index:self.client.lev , name:self.client.levname , sub:[{}] };
				//alert(JSON.stringify(self.typeList));
				modules.scrollSelect({
					isCitySelect: false,
					data:self.levList,
					curActive:curActive,
					nextStep:function(ret){
						if(ret.eventType=='ok'){
							console.log('selectedInfo:'+_g.j2s(ret.selectedInfo[0]));
							self.client.levname = ret.selectedInfo[0].name;
							self.client.lev = ret.selectedInfo[0].value;
						}
					}
				});
			},
			setStorages:function(arr){
				//设置缓存
				$.each(arr,function(key,value){
					_g.setLS(value.name,value.data);
				})
			},
			judge:function(){
				var self = this;
				if(isNaN(self.client.mobilephone)){
					_g.toastMsg({
						msg:'手机号码请输入全数字'
					})
				}
			}
		},
		created:function(){
			var self = this
			if(self.mode == 'add'){
				_g.showLoading({title: '正在定位'})
				MAPS.getLocation({
					success:function(ret){
						console.log('getLocation')
						console.log(_g.j2s(ret));
						MAPS.getAddress({
							lon:ret.lon,
							lat:ret.lat,
							success: function(ret){
								console.log('getAddress')
								_g.hideProgress()
								self.client.address = ret.address
							},
							error: function(err){
								_g.hideProgress()
								_g.showLoading({msg: '定位失败'})
							}
						})
					}
				})
				self.addAjax()
			} else {
				self.detailAjax()
			}
		},
		mounted:function(){
			var self = this;

			// 清除缓存
			_g.addEventListener({
				name: api.winName + '-closeWin',
				success: function(ret) {
					_g.rmLS('annex-list');
				}
			});

			//地区选择结果
			_g.addEventListener({
				name: 'client-area-select',
				success: function(ret) {
					console.log(_g.j2s(ret));
					self.client.areaid = ret.value.selectId;
					self.client.areacode = ret.value.selectCode;
					self.client.areaname = ret.value.selectName;
				}
			});

      /*
			通过ajax获取地址数据，然后缓存--->当地址数据有变化，缓存都做更新，--->提交客户数据时，把缓存的数据都赋给地址参数即可
			*/
			//保存按钮事件
	  	_g.addEventListener({
				name:api.winName + '-save',
				success: function(ret) {
					if(self.isSaved){
        		return;
        	}
        	if(self.client.opname== null || self.client.opname == ''){
        		_g.toastMsg({
        			msg:'请选择客户所有人'
        		});
        		return;
        	}
        	if(self.client.shortname == null || self.client.shortname == ''){
        		_g.toastMsg({
        			msg:'请输入客户名称'
        		});
        		return;
        	}
        	if(self.client.sourcename== '' || self.client.sourcename== null){
        		_g.toastMsg({
        			msg:'请选择来源'
        		});
        		return;
        	}
        	if(self.client.corpname== '' || self.client.corpname== null){
        		_g.toastMsg({
        			msg:'请选择行业'
        		});
        		return;
        	}
        	if(self.client.statusname== '' || self.client.statusname== null){
        		_g.toastMsg({
        			msg:'请选择客户状态'
        		});
        		return;
        	}
		var phreg = /^1[3|4|5|7|8][0-9]{9}$/;
		if (self.client.mobilephone !== '' && !phreg.test(self.client.mobilephone)) {
			_g.toastMsg({
				msg: '手机号码格式不正确'
			});
			return false;
		}
        	var url = URLANNEX+'/common/client/clientEdit!save.action';
        	var param = INTERFACE.client.clients.save.param;

        	$.each(self.client,function(key,value){
	    			if(value !== null && value !== ''){
	    				param['master.'+key] = value;
	    				console.log(param['master.'+key]);
	    			}
	    		});

        	param.checkStep = 0
        	param.iscashtrader = 0
        	param.modId = 2402
        	param['undefined'] = 'false';
        	param['master.phoneapply'] = 'T';
        	if (self.mode == 'add') {
						param.addnewFlag = 'true';
						// param['master.shopid'] = 0;
						param['master.checkperiod'] = 0;
						param['master.clientid'] = -999;
						param['master.sendday'] = 5;
						param['master.fixedcheck'] = 'F';
						param['master.isexpress'] = 'F';
					} else {
						param.addnewFlag = 'false';
						// param.master.clientid = api.pageParam.clientId;
					}


	    		//编辑日期设置为当前时间
					param['master.editdate'] = (new Date()).Format('yyyy-MM-dd hh:mm:ss');
      		// 处理收货地址
      		console.log(JSON.stringify(self.deleteAddress)+'**'+JSON.stringify(_g.getLS('editAddress')));
      		//删除
      		if(self.deleteAddress != undefined && self.deleteAddress.length != 0){
      			param['deletedetail1Count'] = self.deleteAddress.length;
      			// console.log('addd:' + JSON.stringify($api.getStorage('recAddress')));
        		$.each(self.deleteAddress,function(key,value){
        			$.each(value,function(k,v){
        				if(v != 'undefined' && v != null){
        					param['deletedetail1['+key+'].'+k] = v;
        				}
        			})
        		})
      		}
      		//新增编辑
      		if(self.editAddress != undefined && self.editAddress.length != 0){
      			param['detail1Count'] = self.editAddress.length;
      			// console.log('addd:' + JSON.stringify($api.getStorage('recAddress')));
        		$.each(self.editAddress,function(key,value){
        			$.each(value,function(k,v){
        				if(v != 'undefined' && v != null){
        					param['detail1['+key+'].'+k] = v;
        				}
        			})
        		})
      		}
        	//根据返回的code
					//alert('保存param:'+JSON.stringify(param));
					//return;
          
          _g.showLoading({
          	title:'正在保存'
          });

          http.ajax({
          	url:url,
          	data:param,
          	method : 'post',
          	success:function(ret){
          		if(ret.errNo == 0){
          			if (self.mode == 'add') {
									// 上传附件列表
									var clientId = ret.id; // 新增单据id
									var annexList = _g.getLS('annex-list') || '';
									if (annexList != '') {
										self.updateAnnex(clientId, annexList);
									}
								}

            		_g.hideProgress();
          			_g.toastMsg({
          				msg:'保存成功'
          			});
          			self.isSaved = true;
          			//self.rmStorages();
          			api.sendEvent({
          				name:'client-list-reload',
          				extra:{}
          			});
          			setTimeout(function(){_g.closeWin();},1000);
          		}else{
          			_g.hideProgress();
          			_g.toastMsg({
          				msg:ret.errMsg
          			});
          		}
          	},
          	error:function(err){
          		console.log('err:'+_g.j2s(err));
          	}
          });
        }
			});

			// 监听数据权限的改动，对数目进行更新
			_g.addEventListener({
				name:'client-limit-reload',
				success: function(ret) {
					self.dataDur.len = ret.value.len
				}
			});

			//联系人列表刷新
			_g.addEventListener({
      	name:'linker_list_reload',
      	success:function(ret){
      		if(ret.value.type == 'delete'){
	      		self.contact.len--;
	      	}else if(ret.value.type == 'add'){
	      		self.contact.len ++;
	      	}	
	      }
      });

    	//附件列表刷新
      _g.addEventListener({
        name:'annex_list_reload',
        success:function(ret){
        	self.annex = _g.getLS('annex');
        }	
      });

      //跟进记录列表刷新
      _g.addEventListener({
      	name:'client_followSum_reload',
      	success:function(ret){
      		self.followRecord.len=ret.value.len;
      	}
      });

      //附件更改后，通知改变附件数目
      _g.addEventListener({
      	name:'annex-num',
      	success:function(ret){
      		if(ret.value.type == 'add'){
						self.annex.len += 1;
					}else{
						self.annex.len -= 1;
					}
				}
      });

			//获取win-select的选中数据
			_g.addEventListener({
				name: api .frameName + '-get-winselected',
				success: function(ret) {
					var showName = ''
					var id = ''
					var opid = ''
					if (ret.value.selectedData.length != 0) {
						showName = ret.value.selectedData[0]['showName']
						id = ret.value.selectedData[0]['id']
						opid = ret.value.selectedData[0]['opid']
						self.winSelectd[self.curwinSelected] = ret.value.selectedData[0]


						if(ret.value.selectedData[0].tradetypeid){
							//往来类型
							Vue.set(self.client, 'tradetypename', showName)
							Vue.set(self.client, 'tradetypeid', ret.value.selectedData[0].tradetypeid)
						}

						
						console.log(_g.j2s(ret.value.selectedData[0]))
					} else{
						self.winSelectd[self.curwinSelected] = {}
					}
					
					switch(self.curwinSelected){
						case '所有人':
							Vue.set(self.client, 'opname', showName)
							Vue.set(self.client, 'opid', opid)
							console.log('opname:'+self.client.opname);
						break
						// case '往来类型':
						// 	Vue.set(self.client, 'tradetypename', showName)
						// 	Vue.set(self.client, 'tradetypeid', id)
						// 	console.log('tradetypename:'+self.client.tradetypename);
						// 	console.log('tradetypeid:'+self.client.tradetypeid);
						// break
						case '来源':
							Vue.set(self.client, 'sourcename', showName)
							Vue.set(self.client, 'sourcetypeid', id)
							console.log('sourcename:'+self.client.sourcename);
						break
						case '地区':
							Vue.set(self.client, 'areaname', showName)
							Vue.set(self.client, 'areaid', id)
							console.log('areaname:'+self.client.areaname);
						break
						case '行业':
							Vue.set(self.client, 'corpname', showName)
							Vue.set(self.client, 'corptypeid', id)
							console.log('corpname:'+self.client.corpname);
						break
						case '客户状态':
							Vue.set(self.client, 'statusname', showName)
							Vue.set(self.client, 'statustypeid', id)
							console.log('statusname:'+self.client.statusname);
						break
						case '客户等级':
							Vue.set(self.client, 'levname', showName)
							Vue.set(self.client, 'lev', id)
							console.log('levname:'+self.client.levname);
						break
						// case '预收款科目':
						// 	Vue.set(self.client, 'sursubname', showName)
						// 	Vue.set(self.client, 'sursubid', id)
						// 	console.log('sursubname:'+self.client.sursubname);
						// break
						// case '应收款科目':
						// 	Vue.set(self.client, 'balsubname', showName)
						// 	Vue.set(self.client, 'balsubid', id)
						// 	console.log('balsubname:'+self.client.balsubname);
						// break
						default:
						break
					}
				}
			})

		},
	})
})