define(function(require,exports,module){

	var _interface = require('interface');
	var modules = require('modules');
	var http = require('http');

	var limitDetail = new Vue({
		el:'#limitDetail',
		data:{
			item:{
				kind:'',
				kindname:'',
				membername:'',  //成员名
				member:'',		//成员id
				itemno:-1,
				id:-1,
				a00oldjsonvalue:''
			},
			membershow:true,
			postData_backup:{},  //用于删除操作的数据备份
			mode:api.pageParam.type,
			typeList:[
			
			]
		},
		created: function(){
			var self = this
			if(self.mode == 'edit') {
				self.item = api.pageParam.items[api.pageParam.index]

				if(self.item.kindname == '全公司'){
					self.membershow = false
				}
			}
			/*2.打开页面时，先获取成员类型和成员的数据（成员的数据会因为选了成员类型不同，获取的数据会有差异），--2.如果是编辑操作，则把指定的成员类型和成员显示*/
			self.getclientPriKind()
		},
		mounted:function(){
			var self = this
			
			//点击确定按钮
			_g.addEventListener({
        name:api.winName+'-save',
        success:function(ret){
        	if(self.item.kindname == '' && self.item.membername == ''){
						_g.toastMsg({msg: '请选择数据'})
						return
        	}
        	if(self.item.kindname !='全公司' && self.item.membername == ''){
	      		_g.toastMsg({msg: '请选择成员!'});
	      		return;
	      	}
	      	_g.showLoading({title: '正在保存'});
					if(self.mode == 'edit'){
	      		//编辑
	      		self.sortData({
							type: 'edit',
							callback: function(postData){
								self.submit(postData)
							}
						})	
	      	}else{
		      	//新增
						self.sortData({
							type: 'add',
							callback: function(postData){
								self.submit(postData)
							}
						})	
		      	
	        }
	      }
      });

			 //获取win-select的选中数据
      _g.addEventListener({
      	name:api.frameName + '-get-winselected',
      	success:function(ret){
      		self.item.membername = '';
	      	self.item.member = '';
	      	console.log('选定成员：'+_g.j2s(ret.value.selectedData));
	      	$.each(ret.value.selectedData,function(k,v){
	      		self.item.membername += v.name + ',';
	      		self.item.member += v.id + ',';
	      	})
	      	self.item.member = self.item.member.substring(0,self.item.member.length-1);
	      	self.item.membername = self.item.membername.substring(0,self.item.membername.length-1);
      	}
      })
		},
		methods:{
			sortMasterList: function(_masterList){
				var self = this
				var masterList = {}
				masterList.idStr = api.pageParam.clientId
				_.each(_masterList, function(item, index){
					_.each(item, function(value, key){
						if(value != null){
							masterList['masterList[' + index + '].' + key] = value
						}
						
					})
				})
				console.log('thiss:'+JSON.stringify(masterList))
				return masterList
			},
			sortData:function(opts){
				var self = this
				var postData = {}
				if(opts.type == 'delete') {
					//删除
					//1.整理好数据
						var curIndex = api.pageParam.index  // 当前所在的列表索引
						var delData = {
							'masterDelList[0]["a00oldjsonvalue"]': self.item.a00oldjsonvalue,
							'masterDelList[0]["id"]': api.pageParam.clientId,
							'masterDelList[0]["itemno"]': self.item.itemno,
							'masterDelList[0]["kind"]': self.item.kind,
							'masterDelList[0]["kindname"]': self.item.kindname,
							'masterDelList[0]["member"]': self.item.member,
							'masterDelList[0]["membername"]': self.item.membername
						}
						//2.移除在原来列表的位置,并且整理非删除的列表数据
						var _masterList = _.without(api.pageParam.items, self.item);
						//3.修改或新增的数据备份
						var masterList = self.sortMasterList(_masterList) 

						// 4.整合
						postData = $.extend(masterList, delData)
						opts.callback(postData)
				} else if(opts.type == 'add') {
					//增加
					var addData = {
						a00oldjsonvalue: '',
						id: api.pageParam.clientId,
						itemno: -1,
						kind: self.item.kind,
						kindname: self.item.kindname,
						member: self.item.member,
						membername: self.item.membername
					}
					var _items = api.pageParam.items
					_items.push(addData)
					// 整合
					postData = self.sortMasterList(_items)
					opts.callback(postData) 
				} else{
					//修改
					var _items = api.pageParam.items
					_.each(_items, function(value, key){
						if(key == api.pageParam.index) {
							_items[key] = self.item
							return
						}
					})
					// 整合
					postData = self.sortMasterList(_items) 
					opts.callback(postData) 
				}
			},
			submit: function(postData){
				var self = this
				http.ajax({
					url:URLANNEX + '/ncrm/clientpri/clientpriEdit!save.action',
					data:postData,
					success:function(ret){
						_g.hideProgress();
						_g.toastMsg({
							msg:'操作成功'
						});
						//通知客户详情页更新
						api.sendEvent({
              name:'limit-reload'
            });
						setTimeout( _g.closeWin(), 1100);
					},
					error:function(err){
						_g.hideProgress();
						_g.toastMsg({
							msg:err.msg
						});
					}
				});
			},
			getclientPriKind: function(){
				var self = this
				http.ajax({
					url:_interface['base']['url'],
					data:_interface['base']['clientPriKind']['param'],
					success:function(ret){
						if(ret.errNo == 0){
							$.each(ret.listData,function(key,value){
								self.typeList.push(
									{
										'name':value.name,
										'index':value.id,
										'sub':[{}]
									}
								)
							});
							_g.hideProgress();
						}else{
							_g.toastMsg(ret.errMsg);
						}
					}	
				});
			},
			openType:function(){
				var self=this;
				var curActive={index:0 , name:'' , sub:[{}] };
				$.each(self.typeList,function(key , val){
					if(val.name == self.item.kindname){ 
						curActive={index:val.index , name:val.name , sub:[{}] };
						return;
					}
				});
				//alert(JSON.stringify(self.typeList));
				modules.scrollSelect({
					isCitySelect: false,
					data:self.typeList,
					curActive:curActive,
					nextStep:function(ret){
						if(ret.eventType=='ok'){
							console.log('selectedInfo:'+_g.j2s(ret.selectedInfo[0]));
							var saveKindName = self.item.kindname;
							self.item.kindname = ret.selectedInfo[0].name;
							self.item.kind = ret.selectedInfo[0].index;
							if(self.item.kindname == '全公司'){
								self.membershow=false;
							}else{
								self.membershow=true;
							}
							if(saveKindName !== self.item.kindname || self.item.kindname == '全公司'){
								self.item.membername = '';
							}
						}
					}
				});
			},

			deletep:function(){
				var self=this;
				var params = {
					title: '提示',
			    msg: '是否删除该数据权限?',
			    buttons: ['确定', '取消']
				};

				_g.confirm({
					params:params,
					success:function(ret){
						if(ret){
							if(ret.buttonIndex == 1){
								_g.showLoading({
									title:'正在删除'
								});
								self.sortData({
									type: 'delete',
									callback: function(postData){
										self.submit(postData)
									}
								})								
							}
						}
					}
				});
			},
			openWin:function(typeId){
				if(this.item.kindname == ''){
					_g.toastMsg({
						msg:'请选择成员类型'
					});
				}else{
					_g.openWin({
						name:'list-select',
						url:'../Common/list-select',
						pageParam:{
							title: '成员',
							tag:'member',
							frameName: api.frameName,
							showName: _interface.base['member']['showName'],
							hasSearch: _interface.base['member']['param']['likeValue'] == undefined ? false : true,
							isMultiSelect:true,
							extraParams:{
								kind:this.item.kind,
							}
						}
					});
				}
			}
		}
	});
});