define(function(require,exports,module){

	var http = require('http');

	var limitList = new Vue({
		el:'#limitList',
		data:{
			listData:[]
		},
		methods:{
			openDetail:function(index){
				_g.openWin({
					name:'limit-detail',
					url:'../Data/limit-detail',
					pageParam:{
						'type':'edit',
						'index':index ,
						'clientId':api.pageParam.clientId , 
						'items':this.listData, 
						'dataDur':api.pageParam.dataDur
					}
				})
			},

			ajax:function(){
				var self = this
				http.ajax({
					url:URLANNEX + '/ncrm/clientpri/clientpriList!doGetClientPriList.action',
					data:{
						clientid: api.pageParam.clientId
					},
					method:'post',
					success:function(ret){
						self.listData=ret.rsData.ListData;
						//对client-frame.js里的列表进行刷新
						api.sendEvent({
	            name:'client-limit-reload',
	            extra:{
	            	len:self.listData.length
	            }
	          });
						_g.hideProgress();
					},
					error:function(err){
						_g.hideProgress();
						_g.toastMsg({
							msg:err.msg
						});
					}	
				});
			}
		},
		created: function(){
			var self = this;
			_g.showLoading({
				title:'正在加载'
			})
			self.ajax()
		},
		mounted:function(){
			var self = this;
			
			//接收数据权限的详情页的通知，对页面进行刷新
			_g.addEventListener({
        name:'limit-reload',
        success:function(){
        	self.ajax();
        }
      });
            
			_g.addEventListener({
        name:api.winName+'-addLimit',
        success:function(){
        	_g.openWin({
						name:'limit-detail',
						url:'../Data/limit-detail',
						pageParam:{
							'type':'add' ,
							'items':self.listData , 
							'clientId':api.pageParam.clientId , 
							'dataDur':api.pageParam.dataDur
						}
					})
        }
      });
		}
	});
})