define(function(require,exports,module){

	var modules = require('modules');
	var http = require('http');
	var _interface = require('interface');
	var TIME = require('time');
  var nDate = TIME.getDates().eDate;

	var linkerDetail = new Vue({
		el: '#linkerDetail',
		template:_g.getTemplate('Data/linker/linker-detail-frame-v'),
		data: {
			linker: {
				areaname:'',
				areaid:'',
				client:'', //客户名
				clientid:'',	//客户id
				code:'', //联系人编码
				name:'', //姓名
				sex:'', //性别
				department:'', //部门
				duty:'', //职务
				phone:'',//电话
				fax:'',//传真
				mobile:'',//手机
				email:'',//邮箱
				weixin:'',//微信
				qq:'',//QQ
				address:'',//地址
				picturl:'',//联系人头像
				birthday:'',
			},
			byear:'',
			bmonth:'',
			bday:'',

			oldpicturl:'',

			contactNumber:'',

			lrelationList:[],//公关关系
			isEdit:api.pageParam.type == 'edit' ? 'true' : 'false',
			isSaved : false,
			isAnnexUpload:true,
			clientEdit: api.pageParam.clientEdit,
			selectedTag:'',	//记录跳转到list-select页面的tag
		},
		methods: {
			scan:function(ret,err){
				if(ret.buttonIndex != 3){
    			type= ret.buttonIndex == 1 ?'camera' : 'album';	
    			console.log(type);
					modules.apiPicture(type , function(ret){
						console.log('识别图片：'+_g.j2s(ret));
						if(ret.data != ''){
							_g.showLoading({
								title:'正在识别'
							});
							var d=ret.base64Data.split('base64,')[1];
							var dataInfo={
				        	uid:"",
			            image: d,
			            lang: "chns",
			            color: "color"
				        };      
							$.ajax({
                type: "post",
                url: "http://api.hanvon.com/rt/ws/v1/ocr/bcard/recg?key=1733014a-f95a-4413-90d6-3184e15b1377&code=cf22e3bb-d41c-47e0-aa44-a92984f5829d",
                dataType: 'json',
                data: JSON.stringify(dataInfo),
                timeout: 15000,
                success: function (data, xhr) {
                	console.log('data:'+JSON.stringify(data));
                	if(data.code == 0){
										that.linker.name=data['name'][0] || '';  //姓名
										that.linker.phone=data['tel'][0] || '';   //电话
										that.linker.duty=data['title'][0] || '';   //职务
										that.linker.mobile=data['mobile'][0] || '';  //手机
										that.linker.email=data['email'][0] || '';  //邮箱
										that.linker.address=data['addr'][0] || '';   //地址
										that.linker.fax=data['fax'][0] || '';   //传真
										that.linker.department=data['dept'][0] || '';   //部门
						        _g.hideProgress();
					        }else{
					        	_g.toastMsg({
					        		msg:'识别失败，请检查图片内容是否清晰'
					        	});
					        }
                },
                error: function (xhr, type) {
                	_g.hideProgress();
                  _g.toastMsg({
                  	msg:'扫描失败，请重新扫描'
                  });
                }
	            });
						}
					},1000,1000);
				}
			},
			// 名片扫描
			scanCard: function(){
				var that = this;
				var type='';
				var params = {
					buttons:['拍照','相册']
				};
				_g.openButtons(params,that.scan);
			},
			// 选择客户
			selectClient: function(name,tag){
				var that = this;
				var filter = '(isclient=1 or acctrader =1) and Closed=0 and TraderID>0';
				var params={
					title:name,
					tag:tag,
					frameName:api.frameName,
					showName: _interface.base[tag]['showName'],
					hasSearch: _interface.base[tag]['param']['likeValue'] == undefined ? false : true,
					extraParams: {filter: filter}
				};
				that.selectedTag = tag;
				_g.openWin({
					name:'list-select',
					url:'../Common/list-select',
					pageParam: params
				})
			},
			// 选择头像
			selectPic: function(){
				var that=this;
				_g.openWin({
					name:'linker-pic',
					url:'../Data/linker-pic',
					pageParam:{
						'picturl': that.linker.picturl , 
						'isEdit':that.isEdit
					}
				})
			},
			rmStorages:function(){
				//关闭被本页面情况缓存
				_g.rmLS('lrelationList');
				_g.rmLS('picture');
				_g.rmLS('contact');
			},
			sortMaster: function (master) {
        var key = '';
        var json_data = {};
        for (var x in master) {
            key = 'master.' + x;
            json_data[key] = master[x];
            if (x == 'isActive' || json_data[key] == null) {
                delete json_data[key];
            }
        }
        return json_data;
    	},
	    //上传头像
	    uploadHead:function(picturl , id , callback){

	    	console.log('picturl:'+picturl)

	    	http.ajax({
					url:URLANNEX+'/basedata/picture/pictureEdit!upPicture.action',
					data:{
						id:id,
						isMobile:'true',
						modId:5033,			
					},
					files:{
						imgFile:picturl
					},
					success:function(ret){
						if(ret.errNo==0){
			    		_g.toastMsg({
			    			msg:'上传成功!'
			    		});
			    		callback(ret.data.url);
			    	}else if(ret.errNo==100  || ret.errNo==101){
			    		//需要重新登录
			    		_g.hideProgress();
			    		_g.closeToLogin(ret.errMsg);
			    	}else{
			    		_g.hideProgress();
			    		_g.toastMsg({
			    			msg:ret.errMsg
			    		});
			    	}
					},
					error:function(err){
						_g.hideProgress();
			    	_g.toastMsg({
			    		msg:err.msg
			    	});
					}
				});
			},
			saveLinker:function(newUrl , callback){
				var that=this;
				var param = that.sortMaster(that.linker);

				param['master.picturl'] = newUrl;

				console.log(param['master.picturl'])
				if(param['master.picturl'] == undefined){
					param['master.pictureext'] = '.undefined'
				}else{
					param['master.pictureext'] = '.'+param['master.picturl'].split('.')[1];
				}
				
				param.addnewFlag = that.isEdit == 'true' ? 'false' : 'true';
				param['master.sex'] = that.linker.sex ;
				param['master.ssex'] = that.linker.sex == 0 ? '女' :'男'  ;
				param['master.birthday'] = that.linker.birthday == null ? '' : that.linker.birthday ;
				param['master.billdate'] = (new Date()).Format('yyyy-MM-dd hh:mm:ss');
				param['master.opid'] = _g.getLS('employId');
				param['master.opname'] = _g.getLS('employName');
				param['master.isref'] = that.linker.isref == null ? 0 : that.linker.isref ;
				param['master.del'] = 1;	//修改和上传图片时为1，删除图片时为0
				param.start = 0;
				if(that.linker.name == null || that.linker.name == ''){
					_g.hideProgress();
					_g.toastMsg({
						msg:'请输入姓名!'
					});
					return;
				}
				if(that.linker.sex === null || that.linker.sex ===''){
					_g.hideProgress();
					_g.toastMsg({
						msg:'请选择性别!'
					});
					return;
				}
				if(that.linker.client == null || that.linker.client ==''){
					_g.hideProgress();
					_g.toastMsg({
						msg:'请选择客户!'
					});
					return;
				}
				if((that.linker.phone == null || that.linker.phone =='')&& (that.linker.fax == null || that.linker.fax =='')&&
					(that.linker.mobile == null || that.linker.mobile =='')&& (that.linker.email == null || that.linker.email =='')&& 
					(that.linker.weixin == null || that.linker.weixin =='')&& (that.linker.qq == null || that.linker.qq =='')){
					_g.hideProgress();
					_g.toastMsg({
						msg:'电话、传真、手机、邮箱、QQ、微信不可全空!'
					});
					return;
				}
//				if(isNaN(that.linker.mobile)){
//					_g.toastMsg({
//						msg:'手机号码请输入全数字'
//					})
//					return;
//				}
				var phreg = /^1[3|4|5|7|8][0-9]{9}$/;
				if ((that.linker.mobile !== '' || that.linker.mobile !== null) && !phreg.test(that.linker.mobile)) {
					_g.hideProgress();
					_g.toastMsg({
						msg: '手机号码格式不正确'
					});
					
					return false;
				}
				var reg = /^[A-Za-zd]+([-_.][A-Za-zd]+)*@([A-Za-zd]+[-.])+[A-Za-zd]{2,5}$/; 
				if(that.linker.email && !reg.test(that.linker.email)){
					_g.hideProgress();
					_g.toastMsg({
						msg:'请输入格式正确的邮箱地址'
					})
					return;
				}
				console.log('save linker:'+_g.j2s(param));
				//return;
				http.ajax({
					url:_interface['client']['linker']['save']['url'],
					data:param,
					success:function(ret){
						console.log('保存联系人：'+_g.j2s(ret));
						if(ret.errNo == 0){
							callback(ret);
							//that.isSaved = true;
						}else if(ret.errNo==100  || ret.errNo==101){
				    		//需要重新登录
				    		_g.hideProgress();
				    		_g.closeToLogin(ret.errMsg);
			    	}else{
							_g.hideProgress();
							_g.toastMsg({
								msg:errMsg
							});
						}
					},
					error:function(err){
						_g.hideProgress();
						_g.toastMsg({
							msg:err.msg
						});
					}
				})
			},

			//调用拨打号码
			call:function(ret,err){
				var that = this;
				if(ret.buttonIndex==1){
					_g.call({
						number:that.contactNumber
					});
				}
			},
			// 拨打电话
			confirm:function(phone){
				var that = this;
				that.contactNumber = phone == null ? '' : phone;
				if(that.phone != ''){
					var params = {
						title:'号码:'+that.contactNumber,
						buttons:['呼叫']
					};
					_g.openButtons(params,that.call);
				}else{
					_g.toastMsg({
						msg:'暂无号码'
					});
				}
			},
			selectDate:function(){
				var that = this;
				api.openPicker({
				    type: 'date',
				    date: nDate,
				    title: '选择日期'
				}, function(ret, err) {
				    if (ret) {
				        that.byear = ret.year;
				        that.bmonth = ret.month > 0 && ret.month <= 9 ? '0'+ret.month : ret.month;
				        that.bday = ret.day > 0 && ret.day <= 9 ? '0'+ret.day : ret.day;
				        that.linker.birthday = that.byear+'-'+that.bmonth+'-'+that.bday;
				    } else {
				        alert(JSON.stringify(err));
				    }
				});
			},
			judgeMobile:function(){
				var self = this;
				if(isNaN(self.linker.mobile)){
					_g.toastMsg({
						msg:'手机号码请输入全数字'
					})
				}
			},
			judgeMail:function(){
				var that = this;
				var reg = /^[A-Za-zd]+([-_.][A-Za-zd]+)*@([A-Za-zd]+[-.])+[A-Za-zd]{2,5}$/; 
				if(that.linker.email && !reg.test(that.linker.email)){
					_g.toastMsg({
						msg:'请输入格式正确的邮箱地址'
					})
				}
			}
		},
		mounted: function(){
			var that = this;
			var tipMsg = that.isEdit ? '编辑成功!' :'新增成功!';
			if(api.pageParam.type !== 'add'){
				//编辑
				_g.showLoading();
				var url = _interface.client.linker.edit.url;
				console.log('url:'+url);
				var data = {
					id:api.pageParam.linkerId
				}
				http.ajax({
					url:url,
					data:data,
					success:function(ret){
						console.log('detail:'+JSON.stringify(ret));
						that.linker = ret.master;

						that.oldpicturl = URLANNEX + '/'+ that.linker.picturl;
						
						_g.setLS('picture',that.linker.picturl);
						_g.hideProgress();
					},
					error:function(err){
						_g.hideProgress();
						_g.toastMsg({
							msg:err.msg
						});
					}
				});
			}else{
				//新增
				http.ajax({
					url:_interface.client.linker.add.url,
					data:{},
					success:function(ret){
						console.log('addLinker:'+_g.j2s(ret));
						var retObj = ret.master;
						$.each(retObj,function(key,value){
							Vue.set(that.linker,key,value);
						});
						that.linker.shopid=_g.getLS('shopID');
						that.linker.shopname=_g.getLS('shopName');
						that.oldpicturl = URLANNEX + '/'+ that.linker.picturl;

						console.log('that.clientEdit:'+that.clientEdit)
						if(!that.clientEdit){
							that.linker.client=api.pageParam.clientName;
							that.linker.clientid=api.pageParam.clientId;
						}
					},
					error:function(err){
						_g.toastMsg({
							msg:err.msg
						});
					}
				})
			}

			//获取list-select的选中数据
			_g.addEventListener({
				name: api.frameName + '-get-winselected',
				success: function(ret) {
					console.log('selected-client:'+_g.j2s(ret));
					that.linker.client = ret.value.selectedData[0]['name'];
					that.linker.clientid = ret.value.selectedData[0]['clientid'];
				}
			})

		  //确定
			_g.addEventListener({
				name: api.winName + '-save',
				success:function(ret,err){
					_g.showLoading({
						title:'正在保存'
					});

					console.log('isEdit:'+that.isEdit);
					console.log('oldpicturl:'+that.oldpicturl);
					console.log('linker.picturl:'+that.linker.picturl);
					var newpicturl = URLANNEX +'/' + that.linker.picturl;

					if(that.isEdit == 'true' && newpicturl != that.oldpicturl){
						//编辑状态下,并且头像有编辑过，先上传头像
						that.uploadHead(that.linker.picturl , api.pageParam.linkerId, function(newUrl){
							//保存联系人
							that.saveLinker(newUrl , function(ret){
								reloadList('edit',newUrl);
							});
						});
					}else if(that.isEdit == 'true' &&  newpicturl == that.oldpicturl){
						//编辑状态下,并且头像没有编辑
						//保存联系人
						that.saveLinker(that.linker.picturl , function(ret){
							reloadList('edit');
						});
					}else  if(that.isEdit == 'false'){
						//新增状态下，先保存联系人，再上传
						that.saveLinker('' , function(ret){
							//进行图片上传
							if(that.linker.picturl!=''){
								console.log('that.linker.picturl:'+that.linker.picturl);
								that.uploadHead(that.linker.picturl , ret.id , function(newUrl){
									reloadList('add');
								});
							}else{
								reloadList('add');
							}
						});
					}
				}
			});
			
			function reloadList(type){
				_g.hideProgress();
				_g.toastMsg({
					msg:'保存成功'});
				//通知列表更新
				api.sendEvent({
					name:'linker_list_reload',
					extra:{ type : type}
				});
				setTimeout(function(){_g.closeWin();},800);
			}
			//联系人头像有更新
			_g.addEventListener({
				name:'get-headPic',
				success:function(ret){
					that.linker.picturl = ret.value.imgFile;
					console.log('get-headPic:'+that.linker.picturl);
					that.isAnnexUpload=!ret.value.hasURLANNEX;//不需上传附件
				}
			});

		}
	});
});