define(function(require,exports,module){

	var command = require('command');
	var _interface = require('interface');
	var _storage = require('storage');
	var http = require('http');

	var linkerList = new Vue({
		el: '#linkerList',
		template: _g.getTemplate('Data/linker/linker-frame-v'),
		data: {
			activeIndex: '',
			items: [],
			item:{},
			phone:'',
    		linkerParams:{
    			searchKey: '',
				pageSize: '10',
				start: 0,
				isMobile: 'true',
				isH5:'true',
				modId:5033
	    	},
	    	params:{},
		},
		watch:{
			'items':function(val, oldVal){
				if(_.isEmpty(val)){
					$('#null').removeClass('uhide');
				}else{
					$('#null').addClass('uhide');
				}
			}
		},
		mounted: function(){
			var that = this;
			
			console.log('客户详情跳转：'+_g.j2s(api.pageParam));
			if(api.pageParam.type == '联系人'){
				//客户详情进入联系人列表
				$.extend(that.params , {'clientid' : api.pageParam.clientId});
			}		

			that.ajax();

			// 下拉刷新
			_g.refresh({
				success:function(ret){
					command.refresh({
						success:function(ret){
							$.each(ret.resultData.ListData,function(k,v){
								v.isActive=false;
								v.picturl = URLANNEX + '/' + v.picturl;
							});	
							that.items = ret.resultData.ListData;
						}
					})
				}
			});
			// 上拉加载
			_g.topLoading({
				success:function(ret){
					command.next({
						success:function(ret){
							$.each(ret.resultData.ListData,function(k,v){
								v.isActive=false;
								v.picturl = URLANNEX + '/' + v.picturl;
							});	
							that.items = _.union(that.items , ret.resultData.ListData);
						}
					})
				}
			});
    		//添加联系人
			_g.addEventListener({
				name: api.winName + '-add',
				success:function(ret){
					console.log('type:'+api.pageParam.type);
					console.log(_g.j2s(api.pageParam))
					if(api.pageParam.type == '联系人'){
						_g.openWin({
							name:'linker-detail',
							url:'../Data/linker-detail',
							pageParam:{
								type: 'add', 
								linkerId: '' , 
								clientEdit : false , 
								clientId:api.pageParam.clientId , 
								clientName:api.pageParam.clientName
							}
						})
					}else{
						_g.openWin({
							name:'linker-detail',
							url:'../Data/linker-detail',
							pageParam:{
								type: 'add', 
								linkerId: '' , 
								clientEdit : false
							}
						})
					}
				}
			});

			var sex = [
				{selectedIndex:0,name:'不限',value:'不限',sub:[{}]},
				{selectedIndex:1,name:'男',value:'男',sub:[{}]},
				{selectedIndex:2,name:'女',value:'女',sub:[{}]},
			];
			
	  		// 过滤
			if(!_g.getLS('selected-'+api.frameName)) {
				// 刚进入列表
				var filterData = {
					filterName: 'selected-' + api.frameName,
					stage: {
						hasStage: false,
					},
					listItem:[{
						type:'input', title:'编号',selected:'',
					},{
						type:'input', title:'姓名',selected:'',
					},{
						type:'select-box', 
						title:'性别',
						source:sex,
						selected: {
							selectedIndex:0,
							name:'不限',
							value:'不限',
							sub:[{}]
						},
					},{
						type:'input', title:'职务',selected:'',
					},{
						type:'input', title:'部门',selected:'',
					},{
						type:'input', title:'归属客户',selected:'',
					},{
						type:'input', title:'地址',selected:'',
					}]
				}
				_g.setLS('selected-'+api.frameName, filterData)
			};

			_g.addEventListener({
				name: api.winName + '-filter',
				success: function(ret) {
					_g.openWin({
						name:'filter',
						url:'../Common/filter',
						pageParam: _g.getLS('selected-'+api.frameName)
					})
				}
			});

			// 监听进行过滤操作
			_g.addEventListener({
				name: 'selected-' + api.frameName + '-filterAction',
				success: function(ret) {
					//获取过滤数据
					var selectedData = _g.getLS('selected-'+api.frameName);
					var len = 0;
					that.params = {};
		     	_.each(selectedData.listItem, function(val, key){
		     		if(!(val.selected.value == '不限' || val.selected.value == '')){
		     			switch(val.title){
			     			case '编号':
			     				if(val.selected){
			     					that.params["filterItems["+len+"].fieldType"]='ft_Str';
										that.params["filterItems["+len+"].id"]='1';
										that.params["filterItems["+len+"].index"]='';
										that.params["filterItems["+len+"].name"]='编号';
										that.params["filterItems["+len+"].operatertitle"]='等于';
										that.params["filterItems["+len+"].value"]=val.selected;
										len++;
			     				}
			     			break
			     			case '姓名':
			     				if(val.selected){
			     					that.params["filterItems["+len+"].fieldType"]='ft_Str';
										that.params["filterItems["+len+"].id"]='2';
										that.params["filterItems["+len+"].index"]='';
										that.params["filterItems["+len+"].name"]='姓名';
										that.params["filterItems["+len+"].operatertitle"]='等于';
										that.params["filterItems["+len+"].value"]=val.selected;
										len++;
			     				}
			     			break
			     			case '性别':
			     				that.params["filterItems["+len+"].fieldType"]='ft_ListNum';
									that.params["filterItems["+len+"].id"]='3';
									that.params["filterItems["+len+"].index"]='1';
									that.params["filterItems["+len+"].name"]='性别';
									that.params["filterItems["+len+"].operatertitle"]='等于';
									that.params["filterItems["+len+"].value"]=val.selected.value;
									len++;
			     			break
			     			case '职务':
			     				if(val.selected){
			     					that.params["filterItems["+len+"].fieldType"]='ft_Str';
										that.params["filterItems["+len+"].id"]='4';
										that.params["filterItems["+len+"].index"]='';
										that.params["filterItems["+len+"].name"]='职务';
										that.params["filterItems["+len+"].operatertitle"]='等于';
										that.params["filterItems["+len+"].value"]=val.selected;
										len++;
			     				}
			     			break
			     			case '部门':
			     				if(val.selected){
			     					that.params["filterItems["+len+"].fieldType"]='ft_Str';
										that.params["filterItems["+len+"].id"]='5';
										that.params["filterItems["+len+"].index"]='';
										that.params["filterItems["+len+"].name"]='部门';
										that.params["filterItems["+len+"].operatertitle"]='等于';
										that.params["filterItems["+len+"].value"]=val.selected;
										len++;
			     				}
			     			break
			     			case '归属客户':
			     				if(val.selected){
			     					that.params["filterItems["+len+"].fieldType"]='ft_Str';
										that.params["filterItems["+len+"].id"]='6';
										that.params["filterItems["+len+"].index"]='';
										that.params["filterItems["+len+"].name"]='归属客户';
										that.params["filterItems["+len+"].operatertitle"]='等于';
										that.params["filterItems["+len+"].value"]=val.selected;
										len++;
			     				}
			     			break
			     			case '地址':
			     				if(val.selected){
			     					that.params["filterItems["+len+"].fieldType"]='ft_Str';
										that.params["filterItems["+len+"].id"]='11';
										that.params["filterItems["+len+"].index"]='';
										that.params["filterItems["+len+"].name"]='地址';
										that.params["filterItems["+len+"].operatertitle"]='包含';
										that.params["filterItems["+len+"].value"]=val.selected;
										len++;
			     				}
			     			break
			     			default:
			     			break
			     		}
		     		}
		     	})

					// 重新获取数据
					that.ajax()
				}
			});
			
			//输入框筛选
      		_g.addEventListener({ // 搜索
				name: api.winName + '-search',
				success: function(ret){
					command.search({
						searchJson: {
							searchKey: ret.value.keyword
						},
						success: function(ret) {
							$.each(ret.resultData.ListData,function(k,v){
								v.isActive=false;
								v.picturl = URLANNEX + '/' + v.picturl;
							});	
							that.items = ret.resultData.ListData;
						}
					});
				}
			});


			//监听点击返回按钮后，清除缓存的过滤数据
			_g.addEventListener({
				name: api.winName + '-closeWin',
				success: function(ret) {
					_g.clearFilterLS(api.frameName)
				}
			})

		      //监听需要刷新
		      _g.addEventListener({
		        name:'linker_list_reload',
		        success:function(ret){
							that.ajax();
		        }
		      });
		      _g.addEventListener({
		      	name:api.winName + '-clearStorage',
		      	success:function(ret){
		      		_g.rmLS('contact');
		      	}
		      })
		},
		methods: {

			ajax:function(){
				var that = this;
				that.items = [];
				var _params = $.extend({}, that.linkerParams, that.params);
				//初始化
				command.init({
					url:_interface.client.linker.list.url,
					data: _params,
					method: 'post',
					success:function(ret){
						console.log('ret:'+JSON.stringify(ret));
						$.each(ret.resultData.ListData,function(k,v){
							v.isActive=false;
							v.picturl = URLANNEX + '/' + v.picturl;
							console.log('pictureurl:'+v.picturl);
							// that.item = {};
							// $.each(v,function(key,value){
							// 	Vue.set(that.item,key,value);
							// });
							// that.items.push(that.item);
						});	
						that.items = ret.resultData.ListData;
					}
				})

			},

			// 打开详情
			openDetail: function(linkerId){
				if(api.pageParam.type == '联系人'){
					_g.openWin({
						name:'linker-detail',
						url:'../Data/linker-detail',
						pageParam:{
							'type': 'edit', 
							'linkerId': linkerId , 
							clientEdit : false
						}
					})
				}else{
					_g.openWin({
						name:'linker-detail',
						url:'../Data/linker-detail',
						pageParam:{
							'type': 'edit', 
							'linkerId': linkerId , 
							clientEdit : true
						}
					})
				}
				
			},
			//滑动显示电话和短信按钮
			swipeLeft: function(_item){
				var that = this;
				console.log('left:'+_item.isActive);

				if(!_item.isActive){
					that.activeIndex = that.items.indexOf(_item);
					console.log(_item.isActive+'此时已经左滑');
					$.each(that.items,function(k,v){
						$('#'+k+'phone').removeClass('moveToLeft');
						$('#'+k).removeClass('swipe-actions-right');
						v.isActive = false;
					});	
					$('#'+that.activeIndex +'phone').addClass('moveToLeft');
					$('#'+that.activeIndex).addClass('swipe-actions-right');
					_item.isActive = true;
				}else{
					that.activeIndex = '';
					console.log(_item.isActive+'此时复原');
					$.each(that.items,function(k,v){
						$('#'+k+'phone').removeClass('moveToLeft');
						$('#'+k).removeClass('swipe-actions-right');
						v.isActive = false;
					});	
				}
			},
			swipeRight:function(){
				var that = this;
				// alert('swipeRight');
				$.each(that.items,function(k,v){
					$('#'+k+'phone').removeClass('moveToLeft');
					$('#'+k).removeClass('swipe-actions-right');
					v.isActive = false;
				});	
			},
			//调用拨打号码
			call:function(ret,err){
				var that = this;
				if(ret.buttonIndex==1){
					_g.call({
						number:that.phone
					});
				}
			},
			// 拨打电话
			confirm:function(phone){
				var that = this;
				that.phone = phone == null ? '' : phone;
				if(that.phone != ''){
					var params = {
						title:'号码:'+that.phone,
						buttons:['呼叫']
					};
					_g.openButtons(params,that.call);
				}else{
					_g.toastMsg({
						msg:'暂无号码'
					});
				}
			},
			
			// 发送短信
			sms: function(phone){
				api.sms({
				    numbers: [phone],
				    text: ''
				}, function(ret, err) {
				    if (ret && ret.status) {
				        console.log(_g.j2s(ret));
				    } else {
				        console.log(_g.j2s(err));
				    }
				});
			},
			delLinker:function(id){
				var that = this;
				var params = {
					title: '提示',
			    msg: '确定删除该联系人?',
			    buttons: ['确定', '取消']
				};
				_g.confirm({
					params:params,
					success:function(ret){
						if(ret.buttonIndex == 1){
							var param = {};
							param = {
								url : _interface.client.linker.delete.url,
								data:{
									id:id,
									checkStep: 0,
									isH5:'true',
									modId:5033
								}
							}
							console.log(_g.j2s(param));
							http.ajax({
								url:param.url,
								data:param.data,
								success:function(ret){
									console.log('deleteResult:'+_g.j2s(ret))
									if(ret.errNo == 0){
										_g.toastMsg({
											msg:'删除成功!'
										});
										api.sendEvent({
											name:'linker_list_reload',
											extra:{ type :'delete'}
										})
									}else{
										_g.toastMsg({
											msg:ret.errMsg
										});
									}
								}	
							});
						}
					}
				})
			},
			
		},
	});
});