define(function(require,exports,module){

	var _interface = require('interface');
	var command = require('command');
	var time = require('time');
	var maps = require('maps');

	var list = new Vue({
		el:'#list',
		data:{
			items:[],
			curAddress:{
				address:'',
				lat:'',
				lon:'',
			},
			params:{
				address:'',
			},

		},
		watch:{
			'items':function(value,newValue){
				if(value.length == 0){
					$('#null').removeClass('uhide');
				}else{
					$('#null').addClass('uhide');
				}
			}
		},
		mounted:function(){
			var that = this;
			var param = _interface.client.near.param;

			console.log('param:'+_g.j2s(param));
			console.log('location_frame:'+_g.j2s(api.pageParam));

			//获取当前的位置
			that.curAddress.address = api.pageParam.address;
			that.curAddress.lon = api.pageParam.lon;
			that.curAddress.lat = api.pageParam.lat;

			that.params.address = that.curAddress.address;

			var params = $.extend({},param,that.params);
			console.log('that.params:'+_g.j2s(params));
				
			command.init({
				url:_interface.client.near.url,
				data:params,
				method:'post',
				success:function(ret){
					if(ret.errNo == 0){
						that.items = [];
						if(ret.clientclassList.length !=0){
							$.each(ret.clientclassList , function(k,v){
								if(v.tracedate != null){
									v.tracedate=time.sortdate(v.tracedate);
								}
								if(v.address){
									that.items.push(v);
								}
							});

							that.items = that.opItems(that.items);
							$.each(that.items,function(k,v){
								if(k == 'distance'){
									console.log(v);
								}
							})
						}
					}
				}
			});

			_g.topLoading({
				success: function(ret) {
					command.next({
						success: function(ret) {
							if(ret.errNo == 0){
								if(ret.clientclassList.length !=0){
									$.each(ret.clientclassList , function(k,v){
										if(v.tracedate != null && v.address){
											v.tracedate=time.sortdate(v.tracedate);
											that.items = _.union(that.items , [v]);
										}
									});
									
									that.opItems(that.items);
								}
							}
						}
					});
				}
			});

			_g.refresh({
				success: function(ret) {
					command.refresh({
						success: function(ret) {
							if(ret.errNo == 0){
								that.items = [];
								if(ret.clientclassList.length !=0){
									$.each(ret.clientclassList , function(k,v){
										if(v.tracedate != null){
											v.tracedate=time.sortdate(v.tracedate);
										}
										if(v.address){
											that.items.push(v);
										}
									});
									that.opItems(that.items);
								}
							}
						}
					});
				}
			});
		},
		methods:{
			//跳转客户详情
			showClient:function(clientid){
				_g.openWin({
					name:'detail',
					url:'../Data/detail',
					pageParam:{
						title:'客户详情',
						isShow:true,
						clientId:clientid
					}
				})
			},
			opItems:function(dataJson){
				//统一处理item 获取坐标和计算距离等
				var that = this;
				$.each(dataJson,function(key,value){	
					//获取地址对应的坐标
					Vue.set(value,'lat','');
					Vue.set(value,'lon','');
					Vue.set(value,'distance','');
					//通过地址获得对应的坐标值
					//
					console.log('opItems-address:'+value.address);
					maps.getCoordsFromName({
						city:'',
						address:value.address,
						success:function(ret){
							value.lat = ret.lat;
							value.lon = ret.lon;

							console.log('opItems-lat:'+value.lat);
							console.log('opItems-lon:'+value.lon);

							var points = {
								'start':{'lat':that.curAddress.lat,'lon':that.curAddress.lon},
								'end':{'lat':value.lat,'lon':value.lon}
							}
							//计算与当前坐标点距离
							maps.getDistance({
								params:points,
								success:function(ret){
									value.distance = (ret.distance / 1000).toFixed(1);
								}
							});
						}						
					});
				});
				return dataJson;
			}	
		}
	});
});