define(function(require,exports,module){

	var modules = require('modules');
	var _interface = require('interface');
	var http = require('http');

	var newAddress = new Vue({
		el:'#newAddress',
		template:_g.getTemplate('Data/new-address-frame-v'),
		data:{
			item:{
				id:'',
				address:'',
				contact:'',
				phone:'',
				itemno:'',
				areaid:'',			//地区id
				areaname:'',		//地区名称
  			areashow:0,		//地区show
			}
		},
		mounted:function(){
			var that = this;
			if(api.pageParam.type=='编辑'){
				_g.showLoading();
				var sAddress = api.pageParam.data;
				that.item.areaid = sAddress.areaid;
				that.item.areaname = sAddress.areaname;
				that.item.address = sAddress.address;
				that.item.contact = sAddress.contact;
				that.item.phone = sAddress.phone;
				that.item.itemno = sAddress.itemno;
				_g.hideProgress();
			}
			//地址编辑好，点击确定按钮
			_g.addEventListener({
        name:api.winName+'-save-address',
        success:function(ret){
        	if(that.item.pro==''||that.item.address==''){
      			_g.toastMsg({
      				msg:'请编辑信息再提交'
      			});
      		}else{
      			//缓存地址信息，刷新地址列表页
        		_g.showLoading({
        			title:'提交数据中'
        		});
        		var recAddress = _g.getLS('recAddress') == undefined ? [] : _g.getLS('recAddress');//获取从地址列表传递的地址
	      		var editArr = _g.getLS('editAddress') == undefined ? [] : _g.getLS('editAddress');

	        	if(api.pageParam.type=='编辑'){
	        		$.each(recAddress,function(k,v){
	        			if(api.pageParam.data.areaid === v.areaid){
	        				recAddress.splice(k,1);
	        			}
	        		});
	        		$.each(editArr,function(k,v){
	        			if(api.pageParam.data.areaid === v.areaid){
	        				_index = k;
	        				editArr.splice(k,1);
	        			}
	        		});

	        	}else{
	        		_g.toastMsg({
	        			msg:'添加成功!'
	        		});
        			that.item.itemno = recAddress.length + 1;
	        	}
	        	that.item.id = 1;
        		that.item.isdefault = 0;
        		editArr.push(that.item);
	      		_g.setLS('editAddress',editArr);
	        	recAddress.push(that.item);			//合并新增,编辑的地址并设置到缓存中
	        	_g.hideProgress();
	        	_g.setLS('recAddress',recAddress);
	        	api.sendEvent({
	        		name:'address_list_reload',
	        		extra:{}
	        	});
	        	setTimeout(function(){_g.closeWin();},500);
      		}
        }
      });
      _g.addEventListener({
      	name: 'new-address-select-area',
      	success:function(ret){
      		that.item.areaname = ret.value.area.name;
      		that.item.areaid = ret.value.area.id
      	}
      }); 

      // _g.rmLS('area');
			//获取地区列表
			if(!_g.getLS('area')){
				http.ajax({
					url:_interface.base.url,
					data: {
						'filter': '1=1',
						'likeValue': '',
						'viewname': 'qryArea'
					},
					success:function(ret){
						$.each(ret.listData,function(index,item){
							console.log(index+':'+_g.j2s(item));
							item.index=index;
							item.show=index+1;
						});
						console.log('areaLS:'+_g.j2s(ret.listData));
						_g.setLS('area',ret.listData);

					}
				});
			};

		},
		methods:{
			select:function(name,type,storageName){
				var that=this;
				if(_g.getLS(storageName)){
					modules.openActionSelector({
						index:[that['item'][name+'show']],
						dataSource:_g.getLS(storageName),
						col:1,
						nextStep:function(ret){
							if(ret.eventType=='ok'){
				    		var data=ret.selectedInfo[0];
				    		that['item'][name+'name']=data.name;
				    		that['item'][name+'id']=data.id;
				    		that['item'][name+'show']=data.show;
				    	}
						}
					});
				}else{
					_g.toastMsg({
						msg:'没有数据提供选择！'
					});
				}
			},
		}
	});
});