define(function(require,exports,module){

	var command = require('command');
	var _interface = require('interface');
	var http = require('http');
	var time = require('time');
	var BLE = require('ble/blePrinter');
	var outdateList = new Vue({
		el:'#outdateList',
		template:_g.getTemplate('Data/outdate-frame-v'),
		data:{
			items:[
			],
			params:{
				clientid: 0,
			},
		},
		watch:{
			'items':function(val, oldVal){
				if(_.isEmpty(val)){
					$('#null').removeClass('uhide');
				}else{
					$('#null').addClass('uhide');
				}
			}
		},
		methods:{
			ajax:function(){
				var self = this;
				var param = {};

				if(self.params.clientid != 0){
					param.clientid = self.params.clientid
				}
				command.init({ // 初始化
					url: URLANNEX +'/ncrm/crmreport/crmreport!doGetReportData.action',
					data: $.extend({
						modId:2421,
					}, param),
					method: 'post',
					success: function(ret) {
						console.log(_g.j2s(ret));
						self.items = ret.resultData.ReportData;
					}
				});
			},

			showDetail:function(id,billtype){
				var self = this;

				var name = '',
						type = '',
						url = '';
				
				if(billtype == '销售机会'){
					name = 'sale-chance-detail';
					type = 'chance';
					url = '../Business/'+name;
				}else if(billtype == '销售报价'){
					name = 'sale-price-detail';
					type = 'price';
					url = '../Business/'+name;
				}else if(billtype == '采购订单'){
					name = 'pur-order-edit';
					type = 'pur-order';
					url = '../oldBusiness/pur-order-edit'
				}else if(billtype == '采购收货'){
					name = 'pur-gain-edit';
					type = 'pur-gain';
					url = '../oldBusiness/pur-gain-edit'
				}else if(billtype == '现款采购'){
					name = 'cash-pur-edit';
					type = 'cash-pur';
					url = '../oldBusiness/cash-pur-edit'
				}else if(billtype == '采购退货'){
					name = 'pur-return-edit';
					type = 'pur-return';
					url = '../oldBusiness/pur-return-edit'
				}else if(billtype == '销售订单'){
					name = 'sale-order-edit';
					type = 'sale-order';
					url = '../oldBusiness/sale-order-edit'
				}else if(billtype == '销售发货'){
					name = 'sale-del-edit';
					type = 'sale-del';
					url = '../oldBusiness/sale-del-edit'
				}else if(billtype == '现款销售'){
					name = 'cash-sale-edit';
					type = 'cash-sale';
					url = '../oldBusiness/cash-sale-edit'
				}else if(billtype == '销售退货'){
					name = 'sale-return-edit';
					type = 'sale-return';
					url = '../oldBusiness/sale-return-edit'
				}

				if(billtype == '销售机会' || billtype == '销售报价'){
					_g.openWin({
						name: name,
						url: url,
						pageParam: {
							type: type,
							mode: 'edit',
							id: id
						}
					})
				}
				if(billtype == '采购订单' || billtype == '采购收货' || billtype == '现款采购' || billtype == '采购退货'|| billtype == '销售订单' || billtype == '销售发货' || billtype == '现款销售' || billtype == '销售退货'){
					_g.openWin({
						name: name,
						url: url,
						pageParam: {
							type: type,
							mode: 'edit',
							billid: id
						}
					})
				}
			}
		},
		created:function(){
			var self = this;
			if(_g.getLS('selected-'+api.frameName)) {
				var filterData = _g.getLS('selected-'+api.frameName)
				console.log('outdate init:'+_g.j2s(filterData.listItem))
				
				console.log('clientname:'+ filterData.listItem[0]['selected']['name'])
				self.params.clientid = filterData.listItem[0]['selected']['clientid']
				self.ajax()
			}
		},
		mounted:function(){
			var self = this;

			//上拉加载
		  _g.topLoading({
				success: function(ret) {
					command.next({
						success: function(ret) {
							self.items = _.union(self.items , ret.resultData.ReportData);
						}
					});
				}
			});
  		//下拉刷新
      _g.refresh({
				success: function(ret) {
					command.refresh({
						success: function(ret) {
							self.items = ret.resultData.ReportData;
						}
					});
				}
			});

			// 过滤
			_g.addEventListener({
				name: api.winName + '-filter',
				success: function(ret) {
					// 打开过滤页面
					_g.openWin({
						name:'filter',
						url:'../Common/filter',
						pageParam: _g.getLS('selected-'+api.frameName)
					})
				}
			})

			_g.closeWin({
				name: 'filter-win'
			})

   //    var filterData = {
   //    	filterName: 'selected-' + api.frameName,
   //    	stage: {
			// 		hasStage:false
			// 	},
			// 	listItem:[{
			// 		type:'select-win',title:'客户',tag:'trader',selected:{value:'不限'}
			// 	}]
   //    };
   //    _g.setLS('selected-'+api.frameName, filterData);

   //    _g.addEventListener({
			// 	name: api.winName + '-filter',
			// 	success: function(ret) {
			// 		_g.openWin({
			// 			name:'filter',
			// 			url:'../Common/filter',
			// 			pageParam: _g.getLS('selected-'+api.frameName)
			// 		})
			// 	}
			// });

      // 监听进行过滤操作
			// _g.addEventListener({
			// 	name: 'selected-' + api.frameName + '-filterAction',
			// 	success: function(ret) {
			// 		//获取过滤数据
			// 		var filterData = _g.getLS('selected-'+api.frameName)

			// 		self.params={};
		 //     	_.each(filterData.listItem, function(val, key){
		 //     		if(!(val.selected.value == '不限' || val.selected.value == '')){
		 //     			console.log(_g.j2s(val.selected));
			//      		switch(val.title){
			//      			case '客户':
			//      				self.params.clientid = Number(val.selected.clientid) || 0;
			//      			break
			//      			default:
			//      			break
			//      		}
			//      	}
		 //     	})

			// 		// 重新获取数据
			// 		self.ajax()
			// 	}
			// });


			//监听点击返回按钮后，清除缓存的过滤数据
			_g.addEventListener({
				name: api.winName + '-closeWin',
				success: function(ret) {
					_g.clearFilterLS(api.frameName)
				}
			})


      //监听需要刷新本页面的事件
      _g.addEventListener({
        name:'outdate_list_reload',
        success:function(ret){
        	command.refresh({
        		success:function(ret){
							self.items = ret.resultData.ReportData;
        		}
					});
        }
      });
      
      //蓝牙打印
			_g.addEventListener({
				name: api.winName + '-print',
				success: function(ret) {
					var printData = {}
					var content = []
					_.each(self.items, function(val, key){
						content.push({title: '客户名称', value: val.shortname})
						content.push({title: '单据类型', value: val.billtype})
						content.push({title: '单号', value: val.code})
						content.push({title: '收款日期', value: val.duedate})
						content.push({title: '未结算金额', value: val.dueamt})
					})
					printData.content = content

					BLE.setData({
						data:printData.content
					});
					BLE.printEvent();
				}
			})
		},
		
	});
});