define(function(require,exports,module){

	var command = require('command');
	var _interface = require('interface');
	var http = require('http');

	var codeList = new Vue({
		el:'#codeList',
		data:{
			items:[
			],
			isMultiSelect: false,
			selectIndex: [], //选择的索引数组
			toggleAddCode:false,
			goodsid:'',
			unitid:'',
			code:'',
			newCodeArr:[],	//保存新增的条形码，并返回给上级
			newBarcodeid:-9999,
			deleteCount:0,	//条形码的删除条数
			deleteCodes:[],	//删除的条形码数组
		},
		watch:{
			'items':function(val, oldVal){
				if(_.isEmpty(val)){
					$('#null').removeClass('uhide');
				}else{
					$('#null').addClass('uhide');
				}
			}
		},
		created:function(){
			var that = this;
			that.toggleAddCode = false;
			that.items = api.pageParam.unitCode;
			that.goodsid = api.pageParam.goodsid;
			that.unitid = api.pageParam.unitid;

			_.each(that.items,function(v, k){
				v.selected = false;
				if(v.barcode == api.pageParam.selectedCode){
					v.selected = true;
				}
			});
		},
		mounted:function(){
			var that = this;

      //监听需要刷新本页面的事件
      _g.addEventListener({
        name:'code_list_reload',
        success:function(ret){
        	command.refresh({
        		success:function(ret){
							that.items = ret.resultData.ListData;
        		}
					});
        }
      });

      //确定
			_g.addEventListener({
				name: api.winName + '-save',
				success: function(ret) {
					var selectedData = [];
					if (that.selectIndex.length != 0) {
						_.each(that.selectIndex, function(val, key){
							selectedData.push(that.items[val])
						})
					}else{
						_.each(that.items,function(v, k){
							if(v.selected == true){
								selectedData.push(v);
							}
						});
					}

					console.log('deleteCount:'+_g.j2s(that.deleteCount))
					console.log('deleteCodes:'+_g.j2s(that.deleteCodes))

					api.sendEvent({
						name: 'codeSelected',
						extra: {
							selectedData: selectedData,	//被选中的条形码
							newCodeArr:that.newCodeArr,	//新增的条形码数组
							deleteCount:that.deleteCount,	//条形码的删除条数
							deleteCodes:that.deleteCodes,	//删除的条形码数组
							unitCode:that.items	//被处理后的条形码数组
						}
					})
					setTimeout(function(){ _g.closeWin() }, 300)
				}
			});
		},
		methods:{
			selectIt:function(index){
				var that = this;
				if(that.isMultiSelect){
					// 多选
					that.items[index].selected = !that.items[index].selected
					var i = _.indexOf(that.selectIndex, index)
					if(i < 0 && that.items[index].selected == true) {
						//selectIndex中没有index,并且选中，则添加
						that.selectIndex.push(index)
					}else if(i > -1 && that.items[index].selected == false) {
						//selectIndex中有index,并且不选中，则去除
						that.selectIndex = _.without(that.selectIndex, index)
					}
				}else{
					//单选
					_.each(that.items,function(v, k){
						if(k == index){
							v.selected = true;
						}else{
							v.selected = false;
						}
					});
					that.selectIndex = [index];
				}
			},
			deleteIt:function(index){
				var that = this;
				console.log('删除条形码下标：'+index);
				console.log(_g.j2s(that.items[index]));
				var params = {
					title: '提示',
			    msg: '确定删除该条形码?',
			    buttons: ['确定', '取消']
				};
				_g.confirm({
					params:params,
					success:function(ret){
						if(ret.buttonIndex == 1){
							that.deleteCount ++;
							that.deleteCodes.push(that.items[index]);
							$.each(that.newCodeArr,function(key,value){
								if(value.barcodeid == that.items[index].barcodeid){
									that.newCodeArr.splice(key,1);
								}
							})
							that.items.splice(index,1);
							
						}
					}
				});
			},
			toggleAdd:function(){
				var that = this;
				that.toggleAddCode = !that.toggleAddCode;
				api.sendEvent({
					name: 'toggleAddContent',
					extra: {
						toggleAddCode :that.toggleAddCode,
					}
				});
			},
			addCode:function(){
				var that = this;
				var newCode = {};
				newCode.a00oldjsonvalue = null;
				newCode.barcode = that.code;
				newCode.barcodeid = that.newBarcodeid;
				that.newBarcodeid ++;
				console.log(that.newBarcodeid);
				newCode.goodsid = that.goodsid;
				newCode.unitid=that.unitid;
				newCode.selected = false;
				console.log('newCode:'+_g.j2s(newCode));
				if(that.items.length == 0){
					newCode.selected = true;
				}
				that.items.push(newCode);
				that.newCodeArr.push(newCode);
				that.code='';
				that.toggleAdd();
			},
			onTapScan: function () { //扫描
				var self = this;
				var MODULES = require('modules');
				MODULES.scan({
					success: function (ret) {
						self.code = ret.content;
					},
					error: function (err) {
						_g.toastMsg({
							msg: '扫描失败，请重试！'
						});
					}
				});
			},
		}
		
	});
});