define(function(require,exports,module){

	var command = require('command');
	var _interface = require('interface');
	var modules = require('modules');
	var http = require('http');
	var QQ = require('qq');
	var wx = require('wx');

	var proDetail = new Vue({
		el:'#proDetail',
		template:_g.getTemplate('Data/pro/pro-detail-frame-v'),
		data:{
			detail1:[],	//单位信息
			onhanddetail:[],
			deletedDetail1Count:0,
			deletedDetail1:[],
			master:{
  			a00OldJsonValue:{}, 
  			affixinfoid:'', 
  			code:'',   			//编号
  			name:'',			//名称
  			specs:'',			//规格
  			gcmid:'',      //存货类型
  			gcmname:'',		
  			costingtypename:'',		 //成本核算
  			inf_costingtypeid:'',
  			goodstypeid:'',      //货品类别
  			goodstypename:'',
  			batchctrl:0,	  //批号管理
  			pictureUrl:'',
  			unit:'',
  			sprice:'',
  			isRefenced:'',
  		},
  		winSelectd: { 
				'存货类型': {
				},
				'成本核算': {
				}
			},
			curwinSelected: '',
			winselectParams: {  //new
				'存货类型': {
					title: '存货类型',
					tag: 'gcm'
				},
				'成本核算': {
					title: '成本核算',
					tag: 'costType'
				}
			},
			postData:{},
			oldpicturl:'',
			isEdit:api.pageParam.type=='编辑' ? true : false,
			// isReferenced:'',
			isKind:true,	//单位信息是否可用
			baseRate:true,//存储单位修改页面返回是否“满足基本单位的比率必须为1”的结果
			isInOrder:true,//存储单位修改页面返回是否“满足单位的比率按从大到小顺序输入”的结果

			goodsId:'',
			canSelectCost:false,
		},
		mounted:function(){
			var that = this;
			_g.showLoading({
				title:'正在加载'
			});

			that.goodsId=api.pageParam.dataId;
			var suffix;
			if(that.isEdit){
				suffix='/common/goods/goodsEdit!doGetEditData.action';
				that.canSelectCost = true;
			}else{
				suffix="/common/goods/goodsEdit!doGetAddnewData.action";
			}

			http.ajax({
				url:URLANNEX+ suffix,
				method:'post',
				data:{
					id:that.goodsId,
					modId:13
				},
				success:function(ret){
					if(ret.errMsg){
						_g.hideProgress();
						_g.toastMsg({
							msg:ret.errMsg
						});
					}else{
						//把获取的数据做处理
						if(that.isEdit){
							var iKindId = ret.master.kind;
							if(iKindId > 3 && iKindId <= 8 || iKindId < 1 || iKindId == 9){	//单位信息不可用
								that.isKind = false;
							}
						}else{
							that.postData['master.a00OldJsonValue']=ret.master.a00OldJsonValue;
						}

						that.detail1=ret.detail1;	//单位信息
						that.onhanddetail=ret.onhanddetail;

						that.postData=that.sort(ret.master,'master');

						that.master.affixinfoid=ret.master.affixinfoid || ''; //编号
						that.master.code=ret.master.code; //编号
						that.master.name=ret.master.name; //名称
						that.master.specs=ret.master.specs; //规格
						that.master.gcmname=ret.master.gcmname; //存货类型
						that.master.gcmid=ret.master.gcmid;
						that.master.costingtypename=ret.master.costingtypename; //成本核算
						that.master.inf_costingtypeid=ret.master.inf_costingtypeid;
						that.master.goodstypename=ret.master.goodstypename; //货品类别
						that.master.goodstypeid=ret.master.goodstypeid;
						that.master.batchctrl=ret.master.batchctrl; //批号管理
						that.master.pictureUrl = URLANNEX + '/' + ret.master.pictureUrl;
						that.master.unit = ret.master.unit;
						that.master.sprice = ret.master.sprice;
						that.master.isRefenced = ret.master.isRefenced;

						that.oldpicturl = that.master.pictureUrl;
						
						_g.hideProgress();

					}
				},
				error:function(err){
					_g.hideProgress();
					_g.toastMsg({
						msg:err.msg
					});
				}
			})

			//单位信息和条形码的修改返回结果
			_g.addEventListener({
				name:'unit-frame-change-save',
				success:function(ret){
					that.detail1 = ret.value.unitItems;
					that.baseRate = ret.value.baseRate;
					that.isInOrder = ret.value.isInOrder;

					that.deletedDetail1Count = ret.value.unitDeleteCount;
					that.deletedDetail1 = ret.value.unitDeleteItems;
				}
			})

			// 分享 第二阶段
			_g.addEventListener({
				name: api.winName + '-share',
				success:function(ret){

					var sprice = '';
				    $.each(that.detail1, function(key, value){
				    	console.log('detail1:'+_g.j2s(value));
						  if(value.unittype == 0){
						  	sprice = value.sprice;
						  }
						})
					var shareContent ={};
					shareContent.name = that.master.name == null ? '' :that.master.name;
					shareContent.specs=that.master.specs == null ? '' :that.master.specs;
					shareContent.unit=that.master.unit == null ? '' :that.master.unit;
					shareContent.sprice=sprice;
					shareContent.pictureUrl= that.master.pictureUrl.indexOf('null') > -1 ? '' :that.master.pictureUrl;
					_g.openWin({
						name: 'pro-intro',
						url: '../Data/pro-intro',
						pageParam:{
							item:shareContent
						},
					})
				}
			})

			//分享第一阶段
			// 监听btn-layer-click
			// _g.addEventListener({
			// 	name: api.winName + '-btns-layer-click',
			// 	success: function (ret) {
			// 		switch (ret.value.index) {
			// 			case 1:
			// 				var textJson = {
			// 					title: '',
			// 					content: {}
			// 				};
			// 				textJson.title = '货品信息';
			// 				textJson['content']['货品名称'] = that.master.name == null ? '' : that.master.name;
			// 				textJson['content']['规格'] = that.master.specs == null ? '' : that.master.specs;
			// 				textJson['content']['销售单位'] = that.master.unit == null ? '' : that.master.unit;
			// 				textJson['content']['参考售价'] = that.master.sprice == null ? '' : that.master.sprice;

			// 				QQ.shareText({
			// 					textJson: textJson,
			// 					success: function (ret) {
			// 						_g.toastMsg({
			// 							msg: '分享成功'
			// 						});
			// 					},
			// 					error: function (err) {
			// 						_g.toastMsg({
			// 							msg: err.msg
			// 						});
			// 					}
			// 				});
			// 				break;
			// 			case 0:
			// 				api.actionSheet({
			// 					title: '请选择分享方式',
			// 					cancelTitle: '取消分享',
			// 					buttons: ['分享到朋友圈', '分享给微信好友']
			// 				}, function (ret, err) {
			// 					var index = ret.buttonIndex;
			// 					var target = '';
			// 					if (index == 1) {
			// 						target = 'wxTimeline';
			// 					} else if(index == 2){
			// 						target = 'wxSession';
			// 					}else{
			// 						return;
			// 					}
			// 					var textJson = {
			// 						'事项': '货品信息',
			// 						'货品名称': that.master.name == null ? '' : that.master.name,
			// 						'规格': that.master.specs == null ? '' : that.master.specs,
			// 						'销售单位': that.master.unit == null ? '' : that.master.unit,
			// 						'参考售价': that.master.sprice == null ? '' : that.master.sprice,
			// 					}

			// 					var str = '';
			// 					_.each(textJson, function(val, key){
			// 						str = str + key + ':' + val + '\r\n'
			// 					})
								
			// 					var clipBoard = api.require('clipBoard');
			// 					var mobShare = api.require('mobShare');
			// 					if(that.master.pictureUrl.indexOf("null") > -1) {
			// 						//有“null”,则没有图片
			// 		   	 			mobShare.shareTo({
			// 						    target: target,
			// 						    title: '货品信息',
			// 						    text: str
			// 							}, function(ret, err) {
			// 						    if (ret.status) {
			// 						        _g.toastMsg({msg: '分享成功'})
			// 						    }
			// 							});
			// 					}else{
			// 					 if (target == 'wxSession'){
			// 					 	//有图，好友
			// 					 	clipBoard.set({
			// 						    value: str
			// 						}, function(ret, err) {
			// 					    if (ret) {
			// 				    		_g.toastMsg({msg: '请把分享数据粘贴在微信中的输入框'})
			// 				        setTimeout(function(){
			// 				        	mobShare.shareTo({
			// 								    target: target,
			// 								    title: '货品信息',
			// 								    text: str,
			// 								    imgPaths: [that.master.pictureUrl]
			// 									}, function(ret, err) {
			// 								    if (ret.status) {
			// 								      _g.toastMsg({msg: '分享成功'})
			// 								    }
			// 									});
			// 					      },600)
			// 					    }
			// 						});
			// 					 }else {
			// 					 	//有图，朋友圈
			// 					 	api.download({
			// 					    url: that.master.pictureUrl,
			// 					    report: true,
			// 					    cache: true,
			// 					    allowResume: true
			// 						}, function(ret, err) {
			// 					    if (ret.state == 1) {
			// 				        //下载成功
			// 				        realPath = ret.savePath;
			// 				        var share = api.require('sharePics');
			// 				        var array = new Array();
			// 				        array.push(realPath);
							
			// 				        var param = {
			// 				            title: str,
			// 				            list: array
			// 				        };
								
			// 					      share.shareToTimeLine(param);
			// 					    }
			// 						})
			// 					 }
			// 					}
			// 				});
			// 				break;
			// 		}
			// 	}
			// });
			
			//货品类别选择结果
			_g.addEventListener({
				name: 'goodsType-area-select',
				success: function(ret) {
					console.log(_g.j2s(ret));
					Vue.set(that.master, 'goodstypename', ret.value.selectName)
					Vue.set(that.master, 'goodstypeid', ret.value.selectId)
				}
			}); 
		

			//货品编辑好，点击确定按钮
			_g.addEventListener({
        name:api.winName+'-save',
        success:function(ret){
 					//更新供应商信息，刷新列表
      		_g.showLoading({
      			title:'提交数据中'
      		});

      		console.log(that.baseRate);
      		console.log(that.isInOrder);
      		if(!that.baseRate){ _g.toastMsg({ msg:'基本单位的比率必须为1'});_g.hideProgress(); return;}
      		if(!that.isInOrder){ _g.toastMsg({ msg:'单位的比率请按从大到小的顺序输入'});_g.hideProgress(); return;}

      		var newpicturl = that.master.pictureUrl;
      		console.log('newpicturl:'+newpicturl);
      		console.log('oldpicturl:'+that.oldpicturl);

      		if(that.isEdit && newpicturl != that.oldpicturl){
      			console.log('edit1');
						//编辑状态下,并且图片有编辑过，先上传图片
						that.uploadPic(newpicturl , that.goodsId, function(newUrl,picId){
							//保存货品
							that.savePro(newUrl ,picId, function(ret){
								that.reloadList();
							});
						});
					}else if(that.isEdit &&  newpicturl == that.oldpicturl){
						console.log('edit2');
						//编辑状态下,并且图片没有编辑
						//保存货品
						that.savePro(newpicturl ,that.master.affixinfoid, function(ret){
							that.reloadList();
						});

					}else if(!that.isEdit){
						console.log('add');
						//新增状态下，先保存货品，再上传
						that.savePro('' ,'', function(ret){
							console.log('savenewpro:'+ ret.id)
							//进行图片上传
							if(newpicturl!='' && newpicturl.indexOf('null') < 0){
								//二次保存
								that.goodsId = ret.id;
								that.uploadPic(newpicturl , that.goodsId , function(newUrl){
									that.reloadList();
								});
								
								
							}else{
								that.reloadList();
							}
						});
					}
        }
      });

			//获取win-select的选中数据
			_g.addEventListener({
				name: api .frameName + '-get-winselected',
				success: function(ret) {
					// var showName = ''
					// var id = ''
					if (ret.value.selectedData.length != 0) {
						console.log(_g.j2s(ret.value.selectedData[0]))
						// name = ret.value.selectedData[0]['showName']
						// id = ret.value.selectedData[0]['id']
						that.winSelectd[that.curwinSelected] = ret.value.selectedData[0]
					} else{
						that.winSelectd[that.curwinSelected] = {}
					}
					
					switch(that.curwinSelected){
						case '存货类型':
							Vue.set(that.master, 'gcmname', ret.value.selectedData[0]['name'])
							Vue.set(that.master, 'gcmid', ret.value.selectedData[0]['gcmid'])
							Vue.set(that.master, 'kind', ret.value.selectedData[0]['kind'])
							if(that.master.gcmid && that.master.kind < 4){
								that.canSelectCost = true;
							}
							if(that.master.kind >= 4){
								that.master.batchctrl = 'F';
							}
						break
						case '成本核算':
							Vue.set(that.master, 'costingtypename', ret.value.selectedData[0]['name'])
							Vue.set(that.master, 'inf_costingtypeid', ret.value.selectedData[0]['inf_costingtypeid'])
						break
						default:
						break
					}
				}
			})
		},
		methods:{
			sort: function (master,type) {
        var key = '';
        var json_data = {};
        for (var x in master) {
            key = type+'.' + x;
            json_data[key] = master[x];
            if (json_data[key] == null) {
                delete json_data[key];
            }
        }
        return json_data;
	    },
			winSelect: function(title){
				var that = this
				that.curwinSelected = title
				var item = that.winselectParams[title]
				var params = {
					title: item.title,
					tag: item.tag,
					frameName: api.frameName,
					showName: _interface.base[item.tag]['showName'],
					hasSearch: _interface.base[item.tag]['param']['likeValue'] == undefined ? false : true
				}
				_g.openWin({
					name:'list-select',
					url:'../Common/list-select',
					pageParam: params
				})
			},
			openUnit:function(){
				var that = this;
				_g.openWin({
					name:'unit',
					url:'../Data/unit',
					pageParam:{
						detail1:that.detail1,	//基本单位
						detail3:that.detail3,	//条形码
						goodsid:api.pageParam.dataId,
						isRefenced:that.master.isRefenced,
						isEdit:that.isEdit
					}
				})
			},
			selectPic:function(){
				var that = this;
				_g.openButtons({
					cancelTitle: '取消',
					buttons: ['相册', '拍照']
				}, function (ret, err) {
					var index = ret.buttonIndex;
					switch (index) {
						case 1:
							modules.apiPicture({
								sourceType: 'library',
								success: function (ret) {
									if (ret.data != '') {
										console.log('library:'+ret.data);
										that.master.pictureUrl = ret.data;
									}
								}
							});
							break;
						case 2:
							modules.apiPicture({
								sourceType: 'camera',
								success: function (ret) {
									if (ret.data != '') {
										console.log('camera:'+ret.data);
										that.master.pictureUrl = ret.data;
									}
								}
							})
							break;
					}
				});
			},
			//上传图片
	    uploadPic:function(picturl , goodsid , callback){
	    	var that = this;
	 			var id = '';
	 			console.log('that.master.affixinfoid:'+that.master.affixinfoid)
	    	if(that.master.affixinfoid && that.master.affixinfoid != null){
	    		console.log('not null')
	    		id = that.master.affixinfoid;
	    	}else{
	    		console.log('null')
	    		id = -9999;
	    	}

	    	var param = {
	    		id:id,
	    		goodsid:goodsid,
					isMobile:'true',
					modId:13,	
	    	}

	    	http.ajax({
					url:URLANNEX+'/basedata/picture/pictureEdit!upGoodsPicture.action',
					data:param,
					files:{
						imgFile:picturl
					},
					success:function(ret){
						if(ret.errNo==0){
							_g.hideProgress();
							_g.toastMsg({
			    			msg:'上传成功!'
			    		});
			    		callback(ret.data.url,ret.id);
			    	}else if(ret.errNo==100  || ret.errNo==101){
			    		//需要重新登录
			    		_g.hideProgress();
			    		_g.closeToLogin(ret.errMsg);
			    	}else{
			    		_g.hideProgress();
			    		_g.toastMsg({
			    			msg:ret.errMsg
			    		});
			    	}
					},
					error:function(err){
						_g.hideProgress();
			    	_g.toastMsg({
			    		msg:err.msg
			    	});
					}
				});
			},
			savePro:function(newUrl ,picId, callback){
				var that=this;

				that.postData['master.pictureUrl']=newUrl;
				that.postData['master.affixinfoid']=picId;
				that.postData.addnewFlag = that.isEdit ? 'false' : 'true';

				that.postData['master.phoneapply']='T';
				that.postData['master.code']=that.master.code;
				that.postData['master.name']=that.master.name ==null ? "" : that.master.name;
				that.postData['master.specs']=that.master.specs==null ? '' : that.master.specs;
				that.postData['master.batchctrl']=that.master.batchctrl==null ? 'F' : that.master.batchctrl; //批号管理
				that.postData['master.gcmid']=that.master.gcmid==null ? '' : that.master.gcmid;
				that.postData['master.gcmname']=that.master.gcmname==null ? '' : that.master.gcmname;
				that.postData['master.inf_costingtypeid']=that.master.inf_costingtypeid==null ? '' : that.master.inf_costingtypeid;
				that.postData['master.costingtypename']=that.master.costingtypename==null ? '' : that.master.costingtypename;
				that.postData['master.goodstypeid']=that.master.goodstypeid==null ? '' : that.master.goodstypeid;
				that.postData['master.goodstypename']=that.master.goodstypename==null ? '' : that.master.goodstypename;
				that.postData['master.kind']=that.master.kind==null ? '' : that.master.kind;

				that.postData.checkStep=0;

				if(that.postData['master.code']==''){ _g.toastMsg({ msg:'编号不能为空'}); _g.hideProgress(); return;}
				if(that.postData['master.name']==''){ _g.toastMsg({ msg:'名称不能为空'});_g.hideProgress(); return;}

				$.each(that.detail1,function(k,v){
					$.extend(that.postData,that.sort(v,'detail1['+k+']'));
					if(v.unittype == 0){
						that.postData['master.barcode']=v.barcode ==null ? "" : v.barcode;
						that.postData['master.goodsid']=v.goodsid ==null ? "" : v.goodsid;
						that.postData['master.lprice1']=v.lprice1 ==null ? "" : v.lprice1;
						that.postData['master.lprice2']=v.lprice2 ==null ? "" : v.lprice2;
						that.postData['master.lprice3']=v.lprice3 ==null ? "" : v.lprice3;
						that.postData['master.lprice4']=v.lprice4 ==null ? "" : v.lprice4;
						that.postData['master.lprice5']=v.lprice5 ==null ? "" : v.lprice5;
						that.postData['master.maxpprice']=v.maxpprice ==null ? "" : v.maxpprice;
						that.postData['master.minsprice']=v.minsprice ==null ? "" : v.minsprice;
						that.postData['master.pprice']=v.pprice ==null ? "" : v.pprice;
						that.postData['master.rate']=v.rate ==null ? "" : v.rate;
						that.postData['master.sprice']=v.sprice ==null ? "" : v.sprice;
						that.postData['master.lprice5']=v.lprice5 ==null ? "" : v.lprice5;
						that.postData['master.upflag']=v.upflag ==null ? "" : v.upflag;
						that.postData['master.vipprice']=v.vipprice ==null ? "" : v.vipprice;
					}
				})

				$.each(that.onhanddetail,function(k,v){
					$.extend(that.postData,that.sort(v,'onhanddetail['+k+']'));
				})
				
				if(that.deletedDetail1Count > 0){
					$.each(that.deletedDetail1,function(k,v){
						$.extend(that.postData,that.sort(v,'deletedDetail1['+k+']'));
					})
					that.postData['deletedDetail1Count']=that.deletedDetail1Count;
				}
				if(that.postData['master.affixinfoid'] == null) {
					delete that.postData['master.affixinfoid']
				}
				if(that.postData['master.pictureUrl'].indexOf('null') > -1) {
					delete that.postData['master.pictureUrl']
				}
  			_g.showLoading({
  				title:'正在保存'
  			});

  			console.log('final:'+_g.j2s(that.postData));

  			that.checkAjax(that.postData,callback);
   			
			},
			reloadList:function(){
				_g.hideProgress();
				_g.toastMsg({
					msg:'保存成功'});
				//通知列表更新
				api.sendEvent({
					name:'pro_list_reload',
				});
				setTimeout(function(){_g.closeWin();},800);
			},
			openGoodsType:function(title,tag,name){
				_g.openWin({
					name:name,
					url:'../Data/area',
					pageParam: {
						type:'goodsType',
						title:'货品类别'
					},
				})
			},
			checkAjax:function(postData,callback){
				var that = this;
				_g.showLoading({})
				http.ajax({
  				url:URLANNEX+'/common/goods/goodsEdit!save.action',
  				method:'post',
  				data:postData,
  				success:function(ret){
  					
  					_g.hideProgress();
    				if(ret.errNo==0){
    					callback(ret);
    				}else{
    					_g.toastMsg({
    						msg:ret.errMsg
    					});
    				}
    			},
    			other:function(ret){
						if(Number(ret.errNo) != 0 && Number(ret.errNo) != 1 && Number(ret.errNo) > 0){
							var errNo = Number(ret.errNo)
							_g.confirm({
								params: {
									title:'货品保存',
									msg: ret.errMsg,
									buttons: ['是', '否']
								},
								success: function(ret){
									if (ret.buttonIndex == 1) {
										postData.checkStep = errNo + 1;
										console.log('postData.checkStep:'+postData.checkStep)
										that.checkAjax(postData,callback)
									}
								}
							})
						} else if (ret.errNo == 1 && ret.errMsg != '') {
							_g.toastMsg({msg: ret.errMsg})
						}
					},
    			error:function(err){
						_g.hideProgress();
						_g.toastMsg({
							msg:err.msg
						});
    			}
				});
			}
		},
	});
});