define(function(require,exports,module){

	var command = require('command');
	var _interface = require('interface');
	var http = require('http');

	var proList = new Vue({
		el:'#proList',
		template:_g.getTemplate('Data/pro/pro-frame-v'),
		data:{
			items:[
			],
			proParams:{
				pageSize:'20',
				start:'0',
				modId:'13',
				condition_txf:'',
				filterItemRelation:'全部或者',
			},
			params: {
			},
		},
		watch:{
			'items':function(val, oldVal){
				if(_.isEmpty(val)){
					$('#null').removeClass('uhide');
				}else{
					$('#null').addClass('uhide');
				}
			}
		},
		mounted:function(){
			var that = this;
			that.ajax()

			//上拉加载
			 _g.topLoading({
				success: function(ret) {
					command.next({
						success: function(ret) {
							console.log(_g.j2s(ret));
							$.each(ret.listData,function(k,v){
								v.pictureUrl = URLANNEX + '/' + v.pictureUrl;
							});	
							that.items = _.union(that.items , ret.listData);
						}
					});
				}
			});
  			//下拉刷新
     		_g.refresh({
				success: function(ret) {
					command.refresh({
						modify: {filterItemRelation: '全部或者'},
						deleted: {filterStr: 'filterItems'},
						success: function(ret) {
							console.log(_g.j2s(ret));
							$.each(ret.listData,function(k,v){
								v.pictureUrl = URLANNEX + '/' + v.pictureUrl;
							});	
							that.items = ret.listData;
						}
					});
				}
			});
     		//新增货品
			_g.addEventListener({
		        name:api.winName+'-add',
		        success:function(ret){
		        	_g.openWin({
						name: 'pro-detail',
						url: '../Data/pro-detail',
						pageParam:{
							type:'新增'
						},
					})
				}
      		});

      		//监听需要刷新本页面的事件
      		_g.addEventListener({
       			name:'pro_list_reload',
        		success:function(ret){
					that.ajax();
        		}
     		});


			var fieldtype=['ft_Str','ft_ListStr','ft_Str','ft_Str','ft_Level','ft_ListNum'];
			var fieldid=['13010','13020','13030','13040','13050','13060'];
			var itemno=['0','1','2','3','4','5'];
			var fieldlabel=['货品编码','货品名称','货品规格','货品简称','货品类别','货品属性'];
			var operate=['包含','包含','包含','包含','等于(包含子级)','包含'];

		    _g.addEventListener({
		        name:api.winName + '-search',
		        success:function(ret){
		        	console.log('keyword:'+ret.value.keyword);
		        	if (ret.value.type == 'input') {
						for(var i=0;i<6;i++){
							var num=String(i);
							that.params["filterItems["+num+"].displayvalue"]=ret.value.keyword;
							that.params["filterItems["+num+"].fieldid"]=fieldid[i];
							that.params["filterItems["+num+"].fieldlabel"]=fieldlabel[i];
							that.params["filterItems["+num+"].fieldtype"]=fieldtype[i];
							that.params["filterItems["+num+"].itemno"]=itemno[i];
							that.params["filterItems["+num+"].operate"]=operate[i];
							that.params["filterItems["+num+"].realvalue"]=ret.value.keyword;
						}
		        	}else{
		        		that.params = {},
						that.params={
							"filterItemRelation":'全部并且',
							"filterItems[0].displayvalue":ret.value.keyword,
							"filterItems[0].fieldid":13150,
							"filterItems[0].fieldlabel":'货品条码',
							"filterItems[0].fieldtype":'ft_Str',
							"filterItems[0].itemno":0,
							"filterItems[0].operate":'包含',
							"filterItems[0].realvalue":ret.value.keyword,
							start:0,
							pageSize:20,
							condition_txf:"",
						};
		        	}
					console.log('searchparams:'+_g.j2s(that.params));

					// 重新获取数据
					that.ajax()
				}
        	});

	        // 过滤
	  		if(!_g.getLS('selected-'+api.frameName)) {
	  			// 刚进入列表
	  			var filterData = {
	  				filterName: 'selected-' + api.frameName,
						stage: {
							hasStage: false,
						},
						listItem:[{
							type:'input', title:'货品编号',selected:'',
						},{
							type:'input', title:'货品名称',selected:'',
						},{
							type:'input', title:'规格',selected:'',
						},{
							type:'input', title:'简称',selected:'',
						},{
							type:'select-win', title:'货品类别', tag: 'goodsType', selected: {value: '不限'},
						}]
					}
					_g.setLS('selected-'+api.frameName, filterData);

					console.log('selected-'+api.frameName+':'+_g.j2s(_g.getLS('selected-'+api.frameName)))
	  		};

  			_g.addEventListener({
				name: api.winName + '-filter',
				success: function(ret) {
					_g.openWin({
						name:'filter',
						url:'../Common/filter',
						pageParam: _g.getLS('selected-'+api.frameName)
					})
				}
			});

			// 监听进行过滤操作
			_g.addEventListener({
				name: 'selected-' + api.frameName + '-filterAction',
				success: function(ret) {
					//获取过滤数据
					var selectedData = _g.getLS('selected-'+api.frameName);
					console.log('selectedData:'+_g.j2s(selectedData));

					var len = 0;
					that.params = {}
		     	_.each(selectedData.listItem, function(val, key){
		     		if(!(val.selected.value == '不限' || val.selected.value == '')){
		     			console.log(_g.j2s(val.selected));
		     			switch(val.title){
			     			case '货品编号':
			     				if(val.selected){
										that.params["filterItems["+len+"].displayvalue"]=val.selected;
										that.params["filterItems["+len+"].fieldid"]='13010';
										that.params["filterItems["+len+"].fieldlabel"]='货品编码';
										that.params["filterItems["+len+"].fieldtype"]='ft_Str';
										that.params["filterItems["+len+"].itemno"]='0';
										that.params["filterItems["+len+"].operate"]='等于';
										that.params["filterItems["+len+"].realvalue"]=val.selected;
										len++;
			     				}
			     			break
			     			case '货品名称':
			     				if(val.selected != ''){
										that.params["filterItems["+len+"].displayvalue"]=val.selected;
										that.params["filterItems["+len+"].fieldid"]='13020';
										that.params["filterItems["+len+"].fieldlabel"]='货品名称';
										that.params["filterItems["+len+"].fieldtype"]='ft_ListStr';
										that.params["filterItems["+len+"].itemno"]='1';
										that.params["filterItems["+len+"].operate"]='等于';
										that.params["filterItems["+len+"].realvalue"]=val.selected;
										len++;
			     				}
			     			break
			     			case '规格':
			     				if(val.selected != ''){
										that.params["filterItems["+len+"].displayvalue"]=val.selected;
										that.params["filterItems["+len+"].fieldid"]='13030';
										that.params["filterItems["+len+"].fieldlabel"]='货品规格';
										that.params["filterItems["+len+"].fieldtype"]='ft_Str';
										that.params["filterItems["+len+"].itemno"]='2';
										that.params["filterItems["+len+"].operate"]='等于';
										that.params["filterItems["+len+"].realvalue"]=val.selected;
										len++;
			     				}
			     			break
			     			case '简称':
			     				if(val.selected != ''){
										that.params["filterItems["+len+"].displayvalue"]=val.selected;
										that.params["filterItems["+len+"].fieldid"]='13040';
										that.params["filterItems["+len+"].fieldlabel"]='货品简称';
										that.params["filterItems["+len+"].fieldtype"]='ft_Str';
										that.params["filterItems["+len+"].itemno"]='3';
										that.params["filterItems["+len+"].operate"]='等于';
										that.params["filterItems["+len+"].realvalue"]=val.selected;
										len++;
			     				}
			     			break
			     			case '货品类别':
									that.params["filterItems["+len+"].displayvalue"]=val.selected.text;
									that.params["filterItems["+len+"].fieldid"]='13050';
									that.params["filterItems["+len+"].fieldlabel"]='货品类别';
									that.params["filterItems["+len+"].fieldtype"]='ft_Level';
									that.params["filterItems["+len+"].itemno"]='4';
									that.params["filterItems["+len+"].operate"]='等于(包含子级)';
									that.params["filterItems["+len+"].realvalue"]=val.selected.lcode;
									len++
			     			break
			     			default:
			     			break
			     		}
		     		}
		     	})

					// 重新获取数据
					that.ajax()
				}
			});

			//监听点击返回按钮后，清除缓存的过滤数据
			_g.addEventListener({
				name: api.winName + '-closeWin',
				success: function(ret) {
					_g.clearFilterLS(api.frameName)
				}
			});

		},
		methods:{
			ajax:function(){
				var that = this;
				var params = $.extend({}, that.proParams, that.params);
				command.init({ // 初始化
					url: URLANNEX +'/common/goods/goodsList!doGetListData.action',
					data: params,
					method: 'post',
					success: function(ret) {
						console.log(_g.j2s(ret));
						$.each(ret.listData,function(k,v){
							v.pictureUrl = URLANNEX + '/' + v.pictureUrl;
						});	
						that.items = ret.listData;
					}
				});
			},
			//货品详情页
			showDetail:function(dataId){
				var that = this;
				_g.openWin({
					name: 'pro-detail',
					url: '../Data/pro-detail',
					pageParam:{
						type:'编辑',
						dataId:dataId
					},
				})
			},

			//删除货品
			deletePro:function(id){
				var that = this;
				var params = {
					title: '提示',
			    msg: '是否删除该货品?',
			    buttons: ['确定', '取消']
				};

				_g.confirm({
					params:params,
					success:function(ret){
						if(ret.buttonIndex == 1){
							http.ajax({
								url:URLANNEX+'/common/goods/goodsEdit!delete.action',
								data:{
									id:id
								},
								success: function(ret){
									_g.hideProgress();
									_g.toastMsg({
										msg:'删除成功!'
									});
									api.sendEvent({
										name:'pro_list_reload',
										extra:{}
									});
								},
								error:function(err){
									_g.hideProgress();
									_g.toastMsg({
										msg:err.msg
									});
								}	
							})
						}
					}
				})
			},
		}
		
	});
});