define(function(require,exports,module){

	var command = require('command');
	var _interface = require('interface');
	var modules = require('modules');
	var http = require('http');
	var photoBrowser = require('photoBrowser');
	var FILE = require('file');
	var QQ = require('qq');
	var wx = require('wx');

	var proIntro = new Vue({
		el:'#proIntro',
		template:_g.getTemplate('Data/pro/pro-intro-frame-v'),
		data:{
			item:{},
			picArr:[],
			// broswerImgs: [], //照片浏览器要查看的照片数组，只存路径，格式为数组
			// selectImgs: [] ,//选择好的图片
			selectedPic:[],
		},
		mounted:function(){
			var that = this;

			console.log(_g.j2s(api.pageParam.item));
			
			that.item = api.pageParam.item;

			_.each(that.item,function(v,k){
				console.log(k+':'+v);
				if(k == 'pictureUrl' && v.indexOf('null') < 0){
					// v = URLANNEX + '/' + v,
					console.log('pro-intro-frame.js pictureUrl:'+_g.j2s(v));
					var pic = {};
					pic.pictureUrl = v;
					pic.selected = false;
					that.picArr.push(pic);
				}
			})
			

			// 监听btn-layer-click
			_g.addEventListener({
				name: api.winName + '-btns-layer-click',
				success: function (ret) {
					switch (ret.value.index) {
						case 1:
							var textJson = {
								title: '',
								content: {}
							};
							textJson.title = '货品信息';
							textJson['content']['货品名称'] = that.item.name == null ? '' : that.item.name;
							textJson['content']['规格'] = that.item.specs == null ? '' : that.item.specs;
							textJson['content']['销售单位'] = that.item.unit == null ? '' : that.item.unit;
							textJson['content']['参考售价'] = that.item.sprice == null ? '' : that.item.sprice;

							QQ.shareText({
								textJson: textJson,
								success: function (ret) {
									_g.toastMsg({
										msg: '分享成功'
									});
								},
								error: function (err) {
									_g.toastMsg({
										msg: err.msg
									});
								}
							});
							break;
						case 0:
							api.actionSheet({
								title: '请选择分享方式',
								cancelTitle: '取消分享',
								buttons: ['分享到朋友圈', '分享给微信好友']
							}, function (ret, err) {
								var index = ret.buttonIndex;
								var target = '';
								if (index == 1) {
									target = 'wxTimeline';
								} else if(index == 2){
									target = 'wxSession';
								}else{
									return;
								}
								var textJson = {
									'事项': '货品信息',
									'货品名称': that.item.name == null ? '' : that.item.name,
									'规格': that.item.specs == null ? '' : that.item.specs,
									'销售单位': that.item.unit == null ? '' : that.item.unit,
									'参考售价': that.item.sprice == null ? '' : that.item.sprice,
								}
								
								console.log(_g.j2s(that.selectedPic));

								var num = 0;
								if(that.selectedPic.length>0){
									$.each(that.selectedPic,function(key,value){
										console.log(key+':'+value);
										if(value.indexOf('http://') > -1){	//货品详情的图片，先下载
											api.download({
												url: value,
												report: true,
												cache: true,
												allowResume: true
											}, function(ret, err) {
												if (ret.state == 1) {
													console.log('download success');
													console.log('save paths: ' + JSON.stringify(ret.savePath));
													that.selectedPic.splice(key,1,ret.savePath);
													num++;
													if(num == that.selectedPic.length) {
														that.share(textJson,target);
													}

												} 
											});
										}else{
											num++;
											if(num == that.selectedPic.length) {
												that.share(textJson,target);
											}
										}
									})
								}else{
									that.share(textJson,target);
								}
									
							});
							break;

					}
				}
			});
			
		},
		methods:{
			selectIt:function(item){
				var that = this;

				console.log('pro-intro-frame.js before that.selectedPic.length:'+that.selectedPic.length);

				item.selected = !item.selected;
				if(!item.selected){
					$.each(that.selectedPic,function(k,v){
						if(v == item.pictureUrl){
							that.selectedPic.splice(k,1);
						}
					})
				}else{
					that.selectedPic.push(item.pictureUrl);
				}
				console.log('pro-intro-frame.js after that.selectedPic.length:'+that.selectedPic.length)
			},
			updatePic: function () {
				var that = this;

				var newPic ={};

				_g.openButtons({
					cancelTitle: '取消',
					buttons: ['相册', '拍照']
				}, function (ret, err) {
					var index = ret.buttonIndex;
					switch (index) {
						case 1:
							modules.apiPicture({
								sourceType: 'library',
								success: function (ret) {
									if (ret.data != '') {
										// var picName = FILE.getFullNameByPath(ret.data);
										// var picType = FILE.getTypeByPath(ret.data);
										// var index = that.selectImgs.length;
										// that.broswerImgs.push(ret.data);
										// that.selectImgs.push({
										// 	savePath: ret.data,
										// 	saveName: picName,
										// 	'hasUploadPic': true
										// });
										console.log('pro-intro-img.js ret.data:'+ret.data)
										newPic.pictureUrl = ret.data;
										newPic.selected = false;
										that.picArr.push(newPic);
									}
								}
							});
							break;
						case 2:
							modules.apiPicture({
								sourceType: 'camera',
								success: function (ret) {
									if (ret.data != '') {
										// var picName = FILE.getFullNameByPath(ret.data);
										// var index = that.selectImgs.length;
										// that.broswerImgs.push(ret.data);
										// that.selectImgs.push({
										// 	savePath: ret.data,
										// 	saveName: picName,
										// 	'hasUploadPic': true
										// });
										console.log('pro-intro-img.js ret.data:'+ret.data)
										newPic.pictureUrl =  ret.data;
										newPic.selected = false;
										that.picArr.push(newPic);
									}
								}
							})
							break;
					}
				});
			},

			share:function(textJson,target){
				var that = this;
				wx.shareToWx({
					textJson: textJson,
					type: target,
					imgArr:that.selectedPic,
					success: function (ret) {
						_g.toastMsg({
							msg: '分享成功'
						});
					},
					error: function (err) {
						_g.toastMsg({
							msg: '分享失败'
						});
					}
				});
			}
		}
	});
});