define(function(require,exports,module){

	var command = require('command');
	var _interface = require('interface');
	var modules = require('modules');
	var http = require('http');

	var unitDetail = new Vue({
		el:'#unitDetail',
		template:_g.getTemplate('Data/pro/unit-detail-frame-v'),
		data:{
			master:{
  			a00oldjsonvalue:{},  
  			unittype:'',   			//基本单位
  			unitid:0,
  			unitname:'',			//单位名称
  			rate:'',			//比率
  			barcode:'',      //条形码
  			pprice:'',			//参考进价
  			sprice:'',		  //参考售价
  			vipprice:'',    //会员价
  			lprice1:'',      //一级批发价
  			lprice2:'',      //二级批发价
  			lprice3:'',      //三级批发价
  			lprice4:'',      //四级批发价
  			lprice5:'',      //五级批发价
  		},
  		goodsid:'',

  		isadd:api.pageParam.type=="添加" ? true : false,
  		isRefenced:api.pageParam.isRefenced,
  		isEdit:'',//货品是新增，还是编辑，用于判断新增单位时的基本单位字段的值
  		
		},
		mounted:function(){
			var that = this;

			that.goodsid = api.pageParam.goodsid;
			that.isEdit = api.pageParam.isEdit;

			if(api.pageParam.type=="编辑"){
				var item = api.pageParam.item;
				that.master.a00oldjsonvalue = item.a00oldjsonvalue;
				that.master.barcode=item.barcode; 
				that.master.goodsid=item.goodsid; 
				that.master.lprice1=item.lprice1;
				that.master.lprice2=item.lprice2;
				that.master.lprice3=item.lprice3;
				that.master.lprice4=item.lprice4;
				that.master.lprice5=item.lprice5;
				that.master.maxpprice=item.maxpprice;
				that.master.minsprice=item.minsprice;
				that.master.pprice=item.pprice;
				that.master.rate=item.rate;
				that.master.sprice=item.sprice; 
				that.master.unitid=item.unitid;
				that.master.unitname=item.unitname;  
				that.master.unittype=item.unittype;
				that.master.upflag=item.upflag;
				that.master.vipprice=item.vipprice;
			}else{
				that.master.a00oldjsonvalue = '';
				that.master.barcode=''; 
				that.master.goodsid=that.goodsid; 
				that.master.lprice1=0;
				that.master.lprice2=0;
				that.master.lprice3=0;
				that.master.lprice4=0;
				that.master.lprice5=0;
				that.master.maxpprice=0;
				that.master.minsprice=0;
				that.master.pprice=0;
				that.master.rate=1;
				that.master.sprice=0; 
				that.master.unitid=-1;
				that.master.unitname='';  
				that.master.unittype= that.isEdit ? -1 : 0;
				that.master.upflag=0;
				that.master.vipprice=0;
			}

			//单位信息编辑好，点击确定按钮
			_g.addEventListener({
        name:api.winName+'-save',
        success:function(ret){

 					var postData={};
 					postData['barcode']=that.master.barcode==null ? '' : that.master.barcode;
 					postData['goodsid']=that.master.goodsid==null ? '' : that.master.goodsid;
					postData['lprice4']=that.master.lprice4==null ? '' : that.master.lprice4;
					postData['lprice5']=that.master.lprice5==null ? '' : that.master.lprice5;
					postData['lprice1']=that.master.lprice1==null ? '' : that.master.lprice1;
					postData['lprice2']=that.master.lprice2==null ? '' : that.master.lprice2;
					postData['lprice3']=that.master.lprice3==null ? '' : that.master.lprice3;
					postData['lprice4']=that.master.lprice4==null ? '' : that.master.lprice4;
					postData['lprice5']=that.master.lprice5==null ? '' : that.master.lprice5;
					postData['maxpprice']=that.master.maxpprice==null ? '' : that.master.maxpprice;
					postData['minsprice']=that.master.minsprice==null ? '' : that.master.minsprice;
					postData['pprice']=that.master.pprice==null ? '' : that.master.pprice;
					postData['rate']=that.master.rate==null ? '' : that.master.rate;
					postData['sprice']=that.master.sprice==null ? '' : that.master.sprice;
					postData['unittype']=that.master.unittype;
					postData['unitid']=that.master.unitid;
					postData['unitname']=that.master.unitname ==null ? "" : that.master.unitname;
					postData['upflag']=that.master.upflag==null ? '' : that.master.upflag;
					postData['vipprice']=that.master.vipprice==null ? '' : that.master.vipprice;

					
					if(postData['master.unitname']==''){ _g.toastMsg({ msg:'名称不能为空'});_g.hideProgress(); return;}

					var baseRate='';	//返回是否“满足基本单位的比率必须为1”的结果
					if(postData['unittype'] == 0 && postData['rate'] != 1){
						baseRate = false;
					}else{
						baseRate = true;
					}

					var baseUnitId ='';	//标记设为基本单位的单位id
					if(that.master.unittype == 0){
						baseUnitId = that.master.unitid
					}

					api.sendEvent({
						name: 'unit-detail-change-save',
						extra: {
							unitData:postData,
							isadd:that.isadd,
							baseRate:baseRate,
							baseUnitId:baseUnitId,
						}
					})
					setTimeout(function(){ _g.closeWin() }, 300)
     		
        }
      });
      
		},
		methods:{
		}
	});
});