define(function(require,exports,module){

	var command = require('command');
	var _interface = require('interface');
	var http = require('http');

	var unitList = new Vue({
		el:'#unitList',
		template:_g.getTemplate('Data/pro/unit-frame-v'),
		data:{
			unitItems:[],
			goodsid:'',
			params:{			
			},
			newUnitid:-10000,

			editIndex:-1,
			isadd:false,
			isRefenced:'',
			isEdit:'',	//货品是新增，还是编辑，用于判断新增单位时的基本单位字段的值


			baseRate:'',	//存储单位修改页面返回是否“满足基本单位的比率必须为1”的结果
			baseUnitId:'',	//存储基本单位的单位id

			deleteCount:0,	//删除的单位数量
			deleteUnits:[],	//删除的单位数组
		},
		watch:{
			'items':function(val, oldVal){
				if(_.isEmpty(val)){
					$('#null').removeClass('uhide');
				}else{
					$('#null').addClass('uhide');
				}
			}
		},
		created:function(){
			var that = this;
			that.unitItems = api.pageParam.detail1;
			that.goodsid = api.pageParam.goodsid;
			that.isRefenced = api.pageParam.isRefenced;
			that.isEdit = api.pageParam.isEdit;

			// if(!api.pageParam.isEdit){
  	// 		that.newUnitid ++;
  	// 	}
		},
		mounted:function(){
			var that = this;

      _g.addEventListener({
      	name:'unit-detail-change-save',
      	success:function(ret){
      		console.log('unit-detail-change-save:'+_g.j2s(ret.value));
      		that.isadd = ret.value.isadd;
      		that.baseRate = ret.value.baseRate;
      		that.baseUnitId = ret.value.baseUnitId;

      		console.log('that.baseUnitId:'+that.baseUnitId);
      		console.log('that.isadd:'+that.isadd)
      		if(that.isadd == true){	//添加单位信息
      			console.log(_g.j2s(ret.value));
      			that.unitItems.push(ret.value.unitData);

      		}else if(that.editIndex > -1 ){	//编辑单位信息

      			that.unitItems[that.editIndex].unittype = ret.value.unitData.unittype;
	      		that.unitItems[that.editIndex].unitid = ret.value.unitData.unitid;
	      		that.unitItems[that.editIndex].unitname = ret.value.unitData.unitname;
	      		that.unitItems[that.editIndex].barcode = ret.value.unitData.barcode;
	      		that.unitItems[that.editIndex].rate = ret.value.unitData.rate;
	      		that.unitItems[that.editIndex].pprice = ret.value.unitData.pprice;
	      		that.unitItems[that.editIndex].sprice = ret.value.unitData.sprice;
	      		that.unitItems[that.editIndex].vipprice = ret.value.unitData.vipprice;
	      		that.unitItems[that.editIndex].lprice1 = ret.value.unitData.lprice1;
	      		that.unitItems[that.editIndex].lprice2 = ret.value.unitData.lprice2;
	      		that.unitItems[that.editIndex].lprice3 = ret.value.unitData.lprice3;
	      		that.unitItems[that.editIndex].lprice4 = ret.value.unitData.lprice4;
	      		that.unitItems[that.editIndex].lprice5 = ret.value.unitData.lprice5;
      		}
   
      		if(that.baseUnitId){	//设置各单位的基本单位
      			$.each(that.unitItems,function(key,value){
      				console.log(_g.j2s(value));
      				value.unittype = -1;
      				if(value.unitid == that.baseUnitId){
      					value.unittype = 0;
      				}
      			})
      		}
      		
      	}
      });

      _g.addEventListener({
      	name:api.winName + '-save',
      	success:function(ret){
      		var length = that.unitItems.length;
      		var isInOrder = true;	//返回是否“满足单位的比率按从大到小顺序输入”的结果
      		for(var i = 0; i <length-1;i++){
      			for(var j = i+1;j <length;j++){
      				if(that.unitItems[i].rate<that.unitItems[j].rate){
      					isInOrder = false;
      					break;
      				}
      			}
      		}

      		api.sendEvent({
						name: 'unit-frame-change-save',
						extra: {
							unitItems :that.unitItems,
							baseRate :that.baseRate,
							isInOrder:isInOrder,

							unitDeleteCount:that.deleteCount,
							unitDeleteItems:that.deleteUnits,

						}
					});
					setTimeout(function(){ _g.closeWin(); },1000);
      	}
      })
		},
		methods:{
			editUnit:function(item,index){
				var that = this;

				that.editIndex = index;
				_g.openWin({
					name: 'unit-detail',
					url: '../Data/unit-detail',
					pageParam:{
						type:'编辑',
						item:item,
						goodsid:that.goodsid,
						isRefenced:that.isRefenced,
					},
				}) 
			},
			addUnit:function(){
				var that = this;

				that.newUnitid++;
				that.editIndex = -1;
				_g.openWin({
					name: 'unit-detail',
					url: '../Data/unit-detail',
					pageParam:{
						type:'添加',
						goodsid:that.goodsid,
						isRefenced:that.isRefenced,
						newUnitid:that.newUnitid,
						isEdit:that.isEdit
					},
				}) 
			},
			deleteUnit:function(index){
				var that = this;

				var params = {
					title: '提示',
			    msg: '是否删除该单位?',
			    buttons: ['确定', '取消']
				};

				_g.confirm({
					params:params,
					success:function(ret){
						if(ret.buttonIndex == 1){
							that.deleteCount++;
							that.deleteUnits.push(that.unitItems[index]);
							that.unitItems.splice(index,1);
						}
					}
				})
			}
		}
		
	});
});