define(function(require,exports,module){

	var command = require('command');
	var _interface = require('interface');
	var modules = require('modules');
	var http = require('http');

	var newProvider = new Vue({
		el:'#providerDetail',
		template:_g.getTemplate('Data/provider/provider-detail-frame-v'),
		data:{
			master:{
  			a00oldjsonvalue:{},  
  			code:'',   			//编号
  			closed:'F', 			//是否停用，0/1
  			credit:0,
  			name:'',			//名称
  			shortname:'',
  			areaid:'',			//地区id
  			areacode:'',
  			areaname:'',		//地区名称
  			iscashtrader:0,     //现金往来单位
  			acctrader:0,		//核算客户
  			lev:'',				//客户等级id
  			mobilephone:'',			//手机
  			phone:'',			//电话
  			fax:'',				//传真
  			traderid:'',         //客户id
  			tradetypeid:'',          //往来类型id
  			tradetypename:'',		 //往来类型名称
  			tradetypeshow:0,        //往来类型show
  			empid:'',			//业务员id
  			empshow:0,		//业务员show
  			empname:'',		//业务员名称
  			memo:'',
  			taxrate:'',
  		},
  		annex:{
				len: 0,// 附件数量
				dataJson: [],// 附件数据
			},	
  		'undefined':1,
  		addnewFlag:'true',		//true: 新增   false：编辑
  		iscashtrader:0,         //1为现金往来单位，0为否
  		acctrader:0,			//核算客户
  		checkStep:0,
  		selectedTag:'',	//记录跳转到list-select页面的tag
  		selectedName:'',//记录跳转到list-select页面的name

  		mode:api.pageParam.mode,

		},
		mounted:function(){
			_g.showLoading({
				title:'正在加载'
			});
			var that = this;
			var sub=[];
	    sub.push({});

			var id = api.pageParam.dataId;
			var suffix;
			if(api.pageParam.type=='编辑'){
				suffix='/common/vendor/vendorEdit!doGetEditData.action';
			}else{
				suffix="/common/vendor/vendorEdit!doGetAddnewData.action";
			}

			var postData={};

			http.ajax({
				url:URLANNEX+ suffix,
				method:'post',
				data:{id:id},
				success:function(ret){
					if(ret.errMsg){
						_g.hideProgress();
						_g.toastMsg({
							msg:ret.errMsg
						});
					}else{
						if(api.pageParam.type=='编辑'){
							that.getAnnex();
						}else{
							postData['master.a00oldjsonvalue']=ret.master.a00oldjsonvalue;
							postData['master.shopid']=_g.getLS('shopID');
							postData['master.shopname']=_g.getLS('shopName');
							postData['master.traderid']=ret.master.traderid;
							postData['master.phoneapply']='T';
							postData['master.credit']=0;
							postData['master.moneyid']=0;
						}

						postData=that.sortMaster(ret.master);
						that.master.code=ret.master.code; //编号
						that.master.name=ret.master.name; //名称
						that.master.shortname=ret.master.shortname; //名称
						that.master.tradetypename=ret.master.tradetypename; //往来类型
						that.master.tradetypeid=ret.master.tradetypeid;
						that.master.tradetypeshow=ret.master.tradetypeid;
						that.master.areaid=ret.master.areaid;
						that.master.areaname=ret.master.areaname; //地区
						that.master.areacode=ret.master.areacode;
						that.master.phone=ret.master.phone; //电话
						that.master.mobilephone=ret.master.mobilephone; //手机
						that.master.fax=ret.master.fax; //传真
						that.master.address=ret.master.address; //地址
						that.master.empid=ret.master.empid;
						that.master.empname=ret.master.empname; //业务员
						that.master.empshow=ret.master.empid;
						that.master.credit=ret.master.credit; //信用额度
						that.master.balance=ret.master.balance; //余额
						that.master.memo=ret.master.memo; //备注
						that.master.shopid = ret.master.shopid  //机构id
						that.master.shopname = ret.master.shopname //机构名称

						that.master.closed = ret.master.closed === null ? 'F' : ret.master.closed;
						
						_g.hideProgress();
					}
				},
				error:function(err){
					_g.hideProgress();
					_g.toastMsg({
						msg:err.msg
					});
				}
			})

			// 清除缓存
			_g.addEventListener({
				name: api.winName + '-closeWin',
				success: function(ret) {
					_g.rmLS('annex-list');
				}
			});


			//地区选择结果
			_g.addEventListener({
				name: 'provider-area-select',
				success: function(ret) {
					console.log(_g.j2s(ret));
					that.master.areaid = ret.value.selectId;
					that.master.areacode = ret.value.selectCode;
					that.master.areaname = ret.value.selectName;
				}
			});

			//获取win-select的选中数据
			_g.addEventListener({
				name: api.frameName + '-get-winselected',
				success: function(ret) {
					if (ret.value.selectedData.length != 0) {
						console.log('get-select:'+_g.j2s(ret.value.selectedData[0]))

						//往来类型
						if(ret.value.selectedData[0].tradetypeid){
							that.master.tradetypeid = ret.value.selectedData[0].tradetypeid;
							that.master.tradetypename = ret.value.selectedData[0].showName;
							that.master.tradetypeshow = ret.value.selectedData[0].tradetypeid;
						}else if(ret.value.selectedData[0].empid){
							//业务员
							that.master.empid = ret.value.selectedData[0].empid;
							that.master.empname = ret.value.selectedData[0].name;
							that.master.empshow = ret.value.selectedData[0].empid;
						}else{
							that['master'][that.selectedName+'id']=ret.value.selectedData[0]['id'];
					    that['master'][that.selectedName+'name']=ret.value.selectedData[0]['showName'];
					    that['master'][that.selectedName+'show']=ret.value.selectedData[0]['id'];
						}
						
					} 
				}
			})

			//监听附件数量的更改
			_g.addEventListener({
      	name:'annex-num',
      	success:function(ret){
      		if(ret.value.type == 'add'){
						that.annex.len += 1;
					}else{
						that.annex.len -= 1;
					}
      	}
      });

			//供应商编辑好，点击确定按钮
			_g.addEventListener({
        name:api.winName+'-save',
        success:function(ret){
 					//更新供应商信息，刷新列表
      		_g.showLoading({
      			title:'提交数据中'
      		});

      		postData['master.closed']=that.master.closed;
					postData['master.code']=that.master.code ==null ? "" : that.master.code;
					postData['master.shortname']=that.master.shortname ==null ? "" : that.master.shortname;
					postData['master.phone']=that.master.phone==null ? '' : that.master.phone;
					postData['master.mobilephone']=that.master.mobilephone==null ? '' : that.master.mobilephone;
					postData['master.fax']=that.master.fax==null ? '' : that.master.fax;
					postData['master.address']=that.master.address==null ? '' : that.master.address;
					postData['master.credit']=that.master.credit==null ? '' : that.master.credit;	//信用额度
					postData['master.memo']=that.master.memo ==null ? "" : that.master.memo;
					postData['master.areaid']=that.master.areaid ==null ? "" : that.master.areaid;
					postData['master.areacode']=that.master.areacode ==null ? "" : that.master.areacode;
					postData['master.areaname']=that.master.areaname ==null ? "" : that.master.areaname;
				

					postData.iscashtrader=that.master.iscashtrader;
					postData.acctrader=that.master.acctrader;
					if(postData['master.code']==''){ _g.toastMsg({ msg:'编号不能为空'}); _g.hideProgress(); return;}
					if(postData['master.shortname']==''){ _g.toastMsg({ msg:'名称不能为空'});_g.hideProgress(); return;}

					if(that.master.tradetypeshow==null || that.master.tradetypeshow==0){
						postData['master.tradetypeid']='';
					}else{
						postData['master.tradetypeid']=that.master.tradetypeid;
					}

					if(that.master.empshow==null || that.master.empshow==0){
						postData['master.empid']='';
					}else{
						postData['master.empid']=that.master.empid;
					}
					
					postData['master.phoneapply'] = 'T';
					postData['undefined']='false';

					if(that.mode =='edit'){
	    				that.addnewFlag='false';
	    		}else{
	  				that.addnewFlag = 'true';
						postData['master.checkperiod'] = 0;
						postData['master.clientid'] = -999;
						postData['master.sendday'] = 5;
						postData['master.fixedcheck'] = 'F';
						postData['master.isexpress'] = 'F';
						postData['master.shopid']=_g.getLS('shopID');
						postData['master.shopname']=_g.getLS('shopName');
	  			}

	  			postData.addnewFlag=that.addnewFlag;
	  			postData.checkStep=that.checkStep;
	  			postData.detail1Count = 0;
				
	  			_g.showLoading({
	  				title:'正在保存'
	  			});

     			http.ajax({
    				url:URLANNEX+'/common/vendor/vendorEdit!save.action',
    				method:'post',
    				data:postData,
    				success:function(ret){
    					if(ret.errNo==0){
	    					// alert(ret.id);
	    					if (that.mode == 'add') {
									// 上传附件列表
									var providerId = ret.id; // 新增单据id
									var annexList = _g.getLS('annex-list') || '';
									if (annexList != '') {
										that.updateAnnex(providerId, annexList);
									}
								}

		  					_g.hideProgress();
	    					_g.toastMsg({
	    						msg:"保存成功！"
	    					});

	    					api.sendEvent({name:'provider_list_reload'});
	    				}else{
	    					_g.toastMsg({
	    						msg:ret.errMsg
	    					});
	    				}
	    				setTimeout(function(){ _g.closeWin(); },1000);
	    			},
	    			error:function(err){
							_g.hideProgress();
							_g.toastMsg({
								msg:err.msg
							});
	    			}
					});
        }
      });

		},
		methods:{
			sortMaster: function (master, type) {
		        var key = '';
		        var json_data = {};
		        for (var x in master) {
		            key = 'master.' + x;
		            json_data[key] = master[x];
		            if (json_data[key] == null) {
		                delete json_data[key];
		            }
		        }
		        return json_data;
			},
	    
			winSelect:function(title,tag,name){
				var that = this;
				var	filter ='';
				if(tag == 'employ'){
					filter = "IsOperate='T' and SIGN='T' and shopid ="+ _g.getLS('shopID') ;
				}
				 
				var params = {
					title: title,
					tag:tag,
					frameName: api.frameName,
					showName: _interface.base[tag]['showName'],
					hasSearch: _interface.base[tag]['param']['likeValue'] == undefined ? false : true,
					extraParams: {filter: filter}
				}
				that.selectedTag = tag;
				that.selectedName = name;
				_g.openWin({
					name:'list-select',
					url:'../Common/list-select',
					pageParam: params
				})
			},
			openArea:function(title,tag,name){
				_g.openWin({
					name:name,
					url:'../Data/area',
					pageParam: {
						type:'provider',
						title:'地区选择'
					},
				})
			},
			
  		openAnnex: function(){
				var that = this;
				// 打开附件
				// 
				var paramJson = {
					readOnly: false,
					isDetail: that.mode == 'edit' ? true : false,// 单据是否为详情情况
					param: {
						'id': api.pageParam.dataId,
						'modId': 2450,// modId
					},
					// dataJson: self.annex.dataJson,// 附件数据
				}
				_g.openWin({
					name: 'annex',
					url: '../Annex/annex',
					pageParam:{
						paramJson:paramJson
					}
				})
			},

			updateAnnex: function(providerId, annexList) { // 上传附件列表
				for (var i = 0; i < annexList.length; i++) {
					http.ajax({
						url: _interface.annex['upload'].url,
						data: {
							id: providerId,
							modId:'2450',
							fileFileName: annexList[i].filename + '.' + annexList[i].filetype, // 文件名+.文件格式
							voiceTime: annexList[i].voiceTime || 0,// 录音的时候voiceTime这个参数是大于0，如果是其它类型就等于0
						},
						files: {
							file: annexList[i].filepath,
						},
						success: function(ret) {
							api.hideProgress()
							console.log('上传附件返回参数：' + _g.j2s(ret));
							_g.toastMsg({
								msg: ret.errMsg
							});
							api.sendEvent({ // 更新详情数量
								name: 'annex-num',
								extra: {
									'type': 'add'
								}
							});
							api.sendEvent({
								name: 'annex-reload'  // 刷新列表
							});
						}
					});
				}
			},

			//获得附件
			getAnnex: function() {
				var that = this;
				http.ajax({
					url: _interface.annex.list.url,
					data: {
						'id': api.pageParam.dataId,
						'modId': 2450 
					},
					success: function(ret) {
						that.annex.len = ret.data.detail1.length;
					}
				});
			},

		}
	});
});