define(function(require,exports,module){

	var command = require('command');
	var _interface = require('interface');
	var http = require('http');

	var providerList = new Vue({
		el:'#providerList',
		template:_g.getTemplate('Data/provider/provider-frame-v'),
		data:{
			items:[
			],
			phoneNumber:'',
			itemId:'',
			providerParams:{
				pageSize:'20',
				start:'0',
				modId:'2450',
				isH5:'true',
				condition_txf:'',
				filterItemRelation:'全部或者',
			},
			params:{
			},
		},
		watch:{
			'items':function(val, oldVal){
				if(_.isEmpty(val)){
					$('#null').removeClass('uhide');
				}else{
					$('#null').addClass('uhide');
				}
			}
		},
		created:function(){
			var that = this;
			that.ajax()
		},
		mounted:function(){
			var that = this;

			//下拉刷新
		  _g.topLoading({
				success: function(ret) {
					command.next({
						success: function(ret) {
							that.items = that.items.concat(ret.vendorclassList);
						}
					});
				}
			});
  		//上拉加载
      _g.refresh({
				success: function(ret) {
					command.refresh({
						modify: {filterItemRelation: '全部或者'},
						deleted: {filterStr: 'filterItems'},
						success: function(ret) {
							that.items=ret.vendorclassList;
						}
					});
				}
			});

      // 过滤
  		if(!_g.getLS('selected-'+api.frameName)) {
  			// 刚进入列表
  			var filterData = {
  				filterName: 'selected-' + api.frameName,
					stage: {
						hasStage: false,
					},
					listItem:[{
						type:'input', title:'单位编号',selected:'',
					},{
						type:'input', title:'单位名称',selected:'',
					},
					{
						title:'地区', tag: 'area', selected: {value: '不限'}
					},{
						type:'select-win', title:'往来类型', tag: 'traderType', selected: {value: '不限'},
					}]
				}
				_g.setLS('selected-'+api.frameName, filterData)
  		};

			_g.addEventListener({
				name: api.winName + '-filter',
				success: function(ret) {
					_g.openWin({
						name:'filter',
						url:'../Common/filter',
						pageParam: _g.getLS('selected-'+api.frameName)
					})
				}
			});

			// 监听进行过滤操作
			_g.addEventListener({
				name: 'selected-' + api.frameName + '-filterAction',
				success: function(ret) {
					//获取过滤数据
					var selectedData = _g.getLS('selected-'+api.frameName)

					var len =0;
					that.params={};
		     	_.each(selectedData.listItem, function(val, key){
		     		if(!(val.selected.value == '不限' || val.selected.value == '')){
		     			switch(val.title){
			     			case '单位编号':
			     				if(val.selected){
			     					that.params["filterItems["+len+"].displayvalue"]=val.selected;
										that.params["filterItems["+len+"].fieldid"]='3000';
										that.params["filterItems["+len+"].fieldlabel"]='供应商编码';
										that.params["filterItems["+len+"].fieldtype"]='ft_Str';
										that.params["filterItems["+len+"].itemno"]=len;
										that.params["filterItems["+len+"].operate"]='等于';
										that.params["filterItems["+len+"].realvalue"]=val.selected;
										len++;
			     				}
			     			break
			     			case '单位名称':		  
			     				if(val.selected){
										that.params["filterItems["+len+"].displayvalue"]=val.selected;
										that.params["filterItems["+len+"].fieldid"]='3010';
										that.params["filterItems["+len+"].fieldlabel"]='供应商名称';
										that.params["filterItems["+len+"].fieldtype"]='ft_ListStr';
										that.params["filterItems["+len+"].itemno"]=len;
										that.params["filterItems["+len+"].operate"]='等于';
										that.params["filterItems["+len+"].realvalue"]=val.selected;
										len++;
			     				}
			     			break
			     			case '地区':
									that.params["filterItems["+len+"].displayvalue"]=val.selected.selectName;
									that.params["filterItems["+len+"].fieldid"]='3020';
									that.params["filterItems["+len+"].fieldlabel"]='所在地区';
									that.params["filterItems["+len+"].fieldtype"]='ft_Level';
									that.params["filterItems["+len+"].itemno"]=len;
									that.params["filterItems["+len+"].operate"]='等于(包含子级)';
									that.params["filterItems["+len+"].realvalue"]=val.selected.selectCode;
									len++;
			     			break
			     			case '往来类型':
			     				that.params["filterItems["+len+"].displayvalue"]=val.selected.value;
									that.params["filterItems["+len+"].fieldid"]='3040';
									that.params["filterItems["+len+"].fieldlabel"]='往来类型';
									that.params["filterItems["+len+"].fieldtype"]='ft_Level';
									that.params["filterItems["+len+"].itemno"]=len;
									that.params["filterItems["+len+"].operate"]='等于(包含子级)';
									that.params["filterItems["+len+"].realvalue"]=val.selected.lcode;
									len++;
			     			break
			     			default:
			     			break
			     		}
		     		}
		     	})
					// 重新获取数据
					that.ajax()
				}
			});

			//监听点击返回按钮后，清除缓存的过滤数据
			_g.addEventListener({
				name: api.winName + '-closeWin',
				success: function(ret) {
					_g.clearFilterLS(api.frameName)
				}
			});

			_g.addEventListener({
        name:api.winName+'-add',
        success:function(ret){
        	_g.openWin({
						name: 'provider-detail',
						url: '../Data/provider-detail',
						pageParam:{
							type:'新增',
							mode:'add',
						},
					})
				}
      });


			var fieldType=['ft_Str','ft_ListStr','ft_Level','ft_Level','ft_ListStr','ft_ListStr','ft_ListStr'];
			var fieldid=['3000','3010','3020','3040','3150','3090','1822100'];
			var itemno=['0','1','2','3','4','5','6'];
			var fieldlabel=['供应商编码','供应商名称','地区','往来类型','联系人','业务员','分支机构'];
			var operate=['包含','包含','等于(包含子级)','等于(包含子级)','包含','包含','包含'];

      _g.addEventListener({
        name:api.winName + '-search',
        success:function(ret){
        	console.log('keyword:'+ret.value.keyword);

        	for(var i=0;i<7;i++){
						var num=String(i);

						that.params["filterItems["+num+"].displayvalue"]=ret.value.keyword;
						that.params["filterItems["+num+"].fieldid"]=fieldid[i];
						that.params["filterItems["+num+"].fieldlabel"]=fieldlabel[i];
						that.params["filterItems["+num+"].fieldtype"]=fieldType[i];
						that.params["filterItems["+num+"].itemno"]=itemno[i];
						that.params["filterItems["+num+"].operate"]=operate[i];
						that.params["filterItems["+num+"].realvalue"]=ret.value.keyword;
					}
					console.log('searchparams:'+_g.j2s(that.params));

					// 重新获取数据
					that.ajax()
				}
      });

      //监听需要刷新本页面的事件
      _g.addEventListener({
        name:'provider_list_reload',
        success:function(ret){
        	command.refresh({
        		success:function(ret){
							that.items = ret.vendorclassList;
        		}
					});
        }
      });
		},
		methods:{
			ajax:function(){
				var that = this;
				var params = $.extend({}, that.providerParams, that.params);
				command.init({ // 初始化
					url: URLANNEX +'/common/vendor/vendorList!doGetListData.action',
					data: params,
					method: 'post',
					success: function(ret) {
						console.log(_g.j2s(ret));
						that.items = ret.vendorclassList;
					}
				});
			},
			// sort:function(len,item){
			// 	var result={};
			// 	result['filterItems['+len+'].fieldType']='ft_Str';
			// 	result['filterItems['+len+'].id']=item.id;
			// 	result['filterItems['+len+'].index']='';
			// 	result['filterItems['+len+'].name']=item.name;
			// 	result['filterItems['+len+'].operatertitle']='等于';
			// 	result['filterItems['+len+'].value']=item.post;
			// 	return result;
			// },
			//进入地址编辑页面
			showDetail:function(dataId){
				var that = this;
				_g.openWin({
					name: 'provider-detail',
					url: '../Data/provider-detail',
					pageParam:{
						type:'编辑',
						dataId:dataId,
						mode:'edit',
					},
				})
			},
			//调用拨打号码
			call:function(ret,err){
				var that = this;
				if(ret.buttonIndex==1){
					_g.call({
						number:that.phoneNumber
					});
				}
			},
			//弹出对话框
			confirm:function(phoneNo){
				var that = this;
				that.phoneNumber = phoneNo;
				that.phoneNumber = phoneNo == null ? '' : phoneNo;
				if(that.phone != ''){
					var params = {
						title:'号码:'+that.phoneNumber,
						buttons:['呼叫']
					};
					_g.openButtons(params,that.call);
				}else{
					_g.toastMsg({
						msg:'暂无号码'
					});
				}
			},

			//删除一条记录
			delItem:function(ret){
				var that = this;
				if(ret.buttonIndex!=1){
	    		_g.showLoading({
	    			title:'正在删除'
	    		});
	    		http.ajax({
						url:URLANNEX+'/common/vendor/vendorEdit!delete.action',
						data:{"id":that.itemId},
						method:'post',
						success:function(ret){
							if(ret.errNo==0){
	    					_g.toastMsg({
	    						msg:"删除成功！"
	    					});
	    					//重新刷新客户列表页
	    					api.sendEvent({name:'provider_list_reload'});
	    				}else{
	    					_g.toastMsg({
	    						msg:ret.errMsg
	    					});
	    				}
						},
						error:function(err){
							_g.hideProgress();
							_g.toastMsg({
								msg:err.msg
							});
						}
					});	
		    }
			},
			//响应长按事件
			press:function(traderid){
				var that = this;
				that.itemId = traderid;//目标对象下标值
				var params = {
					title: '',
			    msg: '是否删除该供应商?',
			    buttons: ['取消', '确定']
				};
				console.log('dataId:'+that.itemId);
				_g.confirm({
					params: params,
			    success: that.delItem
				});
			},
		}
		
	});
});