define(function (require, exports, module) {
	var mobShare = api.require('mobShare');
	var expressFrame = new Vue({
		el: '#expressFrame',
		data: {
			express:{
				'name': '',//公司名称
				'value': '',//公司名称code
			},
			expressInfo:[],//快递信息
			code:''  //快递单 号
		},
		
		methods:{
			choose:function(title){
				//	选择公司名称
				var self=this;
				var title ;
				_g.openWin({
					name: 'choose',
					url: '../Home/choose',
					pageParam:{
						title:title, 
						data:CODE
					},
				})
			},
			query:function(){
				var self=this;
				if(self.code == ''){
					_g.toastMsg({msg: '请输入快递单号'});
					return;
				}
				if(self.express.name == ''){
					_g.toastMsg({msg: '请选择物流公司名'});
					return;
				}
				_g.showLoading({msg: '正在查询'});
				var AppKey="5784ce86-0276-4bab-9540-1b0e04a7b875";
				var _RequestData=_expressCode._RequestData({'LogisticCode':self.code,'ShipperCode':self.express.value});
				var _DataSign=_expressCode.encrypt({'LogisticCode':self.code,'ShipperCode':self.express.value} , AppKey);
				api.ajax({
				    url: 'http://api.kdniao.cc/Ebusiness/EbusinessOrderHandle.aspx',
				    method: 'post',
				    dataType:'json',
				    data: {
			        values: {
		            'RequestData':_RequestData,
		            'DataSign':_DataSign,
		            'DataType':2,
		            'EBusinessID':'1270837',
		            'RequestType':'1002'
			        }
				    }
				}, function(ret, err) {
				    if (ret) {
				    	//判断ret.Traces.length!=0,则有物流信息
				        if(ret.Traces.length != 0){
				        	$.each(ret.Traces , function(key , val){
				        		self.expressInfo.unshift(val);
				        	});
				        	api.hideProgress();
				        }else{
				        	self.expressInfo=[];
				        	api.hideProgress();
				        	_g.toastMsg({msg: ret.Reason});
				        }
				    } else {
				    	self.expressInfo=[];
				    	api.hideProgress();
				    	_g.toastMsg({msg: err.msg});
				    }
				});
			},
			sendToWX:function(type,textJson){
				var text='';
				if(type=='content'){
					text=textJson.title+'\r\n\r\n';
					$.each(textJson.content,function(key,val){
						text=text+key+": "+val+'\r\n';
					});
				}else if(type=='photo'){
					text=textJson.url;
				}else{
					text=textJson.title;
				}
				var target1 = ''
				api.actionSheet({
					cancelTitle: '取消',
					buttons: ['分享给好友', '分享到朋友圈']
				}, function(ret, err) {
					if(ret.buttonIndex == 1){
						target1 = 'wxSession'
					}else if(ret.buttonIndex == 2){
						target1 = 'wxTimeline'
					}
					mobShare.shareTo({
				    target: target1,
				    text: text,
					}, function(ret, err) {
				    if (ret.status) {
				      _g.toastMsg({
								msg: '分享成功'
							});
				    }
					});
				})
			}
		},
		created: function(){
			var self=this;
			//公司名称
			api.addEventListener({
        name:'公司名称-get'
      },function(ret,err){
      	self.express.name=ret.value.selected.name;
      	self.express.value=ret.value.selected.value;
      });
      //查询
      api.addEventListener({
        name:api.winName+'-save'
      },function(ret,err){
      	self.query();
      });
      //微信操作
			api.addEventListener({
				name: api.winName+'-wx'
			},function(ret,err){
			
				if(self.expressInfo.length == 0){
					_g.toastMsg({
						msg: '无物流信息，不能分享'
					});
					return
				}
				var textJson={};
				var expressInfo='';
				$.each(self.expressInfo , function(key , val){
					expressInfo=expressInfo+'\r\n\r\n'+val.AcceptStation+'\r\n'+val.AcceptTime;
				});
				textJson.title='物流状态';
				textJson.content={
					'公司名称':self.express.name,
					'快递单号':self.code,
					'物流情况':expressInfo,
				};
				 self.sendToWX('content',textJson);
			});
		}
	});
});
