define(function(require, exports, module) {
	var _C = require('components');
	var index = new Vue({
		el: '#Home',
		components: {
			searchbar: _C.getSearchBar({
				tips: '名称/单号',
				showScan: false, // 显示二维码扫描按钮
				showSelect: true, // 显示小下拉选择框
				isDistribute: false, // 显示长下拉选择框
				showSearchbar: true,
				selectList: {
					url: 'html/Common/header/select-list',
					title: '销售机会',
					data: [
						{ name: '销售机会', active: true },
						{ name: '销售报价', active: false },
						{ name: '销售订单', active: false },
						{ name: '销售发货', active: false },
						{ name: '现款销售', active: false },
						{ name: '销售退货', active: false },
						{ name: '采购订单', active: false },
						{ name: '采购收货', active: false },
						{ name: '现款采购', active: false },
						{ name: '采购退货', active: false }
					]
				},
				isHome: true, //是否是一级页面的选择框
				type: ''
			})
		},
		data: {
			'opcode': api.pageParam.opcode,
			'isActive': [true, false, false, false, false],
			'framesInfo': [ //[name,posY,height,firstOpen]
				{ 'home_frame': ['home_frame', 0, 400, true] },
				{ 'data_frame': ['data_frame', 0, 400, true] },
				{ 'business_frame': ['business_frame', 0, 400, true] },
				{ 'report_frame': ['report_frame', 0, 400, true] },
				{ 'set_frame': ['set_frame', 0, 400, true] }
			],
			ty: true,
			billingType: '销售机会',
			keyword: ''
		},
		methods: {
			switchframe: function(index, frameName) {
				var self = this;
				//1.切换底部tab,对应按钮样式变化,并且头部也要变化
				var bool = self.isActive[index];
				if (!bool) {
					this.isActive = [false, false, false, false, false];
					this.isActive[index] = true;
				}
				//2.切换到对应的fame
				self.hideAllframe();
				var frameName = self['framesInfo'][index][frameName][0];
				var firstOpen = self['framesInfo'][index][frameName][3];

				if (!firstOpen) {
					self.showframe(frameName); //显示frame
				} else {
					//打开frame
					_g.fixStatusBar('header');
					var h = $('#header').height();
					if (frameName == 'home_frame') h = h + 44; //加上搜索框的高度44
					self['framesInfo'][index][frameName][1] = h; //设置posY
					self['framesInfo'][index][frameName][2] = api.winHeight - h - $('.module-footer-t5').height(); //设置height
					var posY = self['framesInfo'][index][frameName][1];
					var height = self['framesInfo'][index][frameName][2];
					self.openframeinstance(frameName, posY, height);
					firstOpen = false;
				}
				console.log(JSON.stringify(self.isActive))
			},
			openframeinstance: function(frame, posY, height) {
				//把首页模块的“CRM”的标志显示
				//alert(frame);
				if (frame == 'home_frame') $('#iconTit').removeClass('uhide');
				api.openFrame({
					name: frame,
					url: api.wgtRootDir + '/html/Home/' + frame + '.html',
					rect: {
						x: 0,
						y: posY,
						w: 'auto',
						h: height
					},
//					pageParam: {name: marginTop + footerPos.h},
					bounces: false,
					vScrollBarEnabled: true,
					hScrollBarEnabled: false,
					delay: 200
				});
			},
			showframe: function(frameName) {
				api.setFrameAttr({
					name: frameName,
					hidden: true
				});
				//把首页模块的“CRM”的标志显示
				if (frameName == 'home') $('#iconTit').removeClass('uhide');
			},
			hideAllframe: function() {
				$.each(['home_frame', 'data_frame', 'business_frame', 'report_frame', 'set_frame'], function(index, item) {
					api.setFrameAttr({
						name: item,
						hidden: true
					});
				});
				//把首页模块的“CRM”的标志去掉
				$('#iconTit').addClass('uhide');
			},
			//搜索框内容改变后，子组件用dispatch通知父组件，并让父组件的数据更新
			changeSearch: function(changeData) {
				var that = this;
				var node = '';
				//_basic.openModuleWin('Index','check',{keyword: that.keyword , typeName:changeData[2]});
				that.keyword = changeData[0];
				if (changeData[2] == '已审单据') {
					node = 3;
				} else if (changeData[2] == '待审单据') {
					node = 2;
				} else {
					node = 4;
				}
				api.openWin({
					name: 'check',
					url: './html/Index/check.html',
					pageParam: { keyword: changeData[0], typeName: changeData[2], node: node },
					animation: { type: 'reveal', subType: 'from_right', duration: 500 },
					reload: true
				});

			},
			NewPrint: function(){
				var BLE = require('ble/blePrinter');
				api.addEventListener({ // 连接
					name: 'new-printer-connect'
				}, function(ret, err) {
					console.log('new printer connect :'+_g.j2s(ret.value))
					var data = ret.value.data;
					var uuid = ret.value.uuid;
					BLE.setUUID({
						uuid: uuid
					});
					BLE.isConnect({
						success: function(ret) {
							console.log('isConnect')
							BLE.print({
								data: data
							});
						},
						error: function(err) {
							if (api.systemType == 'android') {
								BLE.autoConnect({});
								setTimeout(function() {
									BLE.print({
										data: data
									});
								}, 5000);
							} else {
								BLE.autoConnect({
									success: function(ret) {
										BLE.print({
											data: data
										});
									}
								});
							}
						}
					});
				});
	
				api.addEventListener({ // 打印
					name: 'printer-print'
				}, function(ret, err) {
					var data = ret.value.data;
					var uuid = ret.value.uuid;
					BLE.setUUID({
						uuid: uuid
					});
					BLE.print({
						data: data
					});
				});
	
				api.addEventListener({ // 停止扫描
					name: 'printer-stopScan'
				}, function(ret, err) {
					BLE.stopScan();
				});
			},
			oldPrint: function(){
				var bleEvent = new BleEvent();
		 		// 连接(旧单据)
				api.addEventListener({
	            name:'old-printer-connect'
	        },function(ret,err){
		        var str = ret.value.str;
		        var uuid = ret.value.uuid;
			    bleEvent.setBleAddr(uuid);
		        bleEvent.isConnect(function(){
					bleEvent.printData(str);
		        },function(){
			        if(api.systemType == 'android'){
								bleEvent.autoConnect(function(){});
			        	setTimeout(function(){
									bleEvent.printData(str);
					      }, 5000);
			        }else{
								bleEvent.autoConnect(function(){
									// _basic.toastMsg('开始打印', 6000);
						      console.log(JSON.stringify(str));
						      // bleEvent.setBleAddr(uuid);
									bleEvent.printData(str);
								});
			        }
		        });
	        });
				// 打印(旧单据)
				api.addEventListener({
	        name:'printer-print'
	      },function(ret,err){
	      	var str = ret.value.str;
	      	var uuid = ret.value.uuid;
	      	console.log(JSON.stringify(str));
	      	bleEvent.setBleAddr(uuid);
					bleEvent.printData(str);
	      });
				// 停止扫描
				api.addEventListener({
	        name:'printer-stopScan'
	      },function(ret,err){
					bleEvent.stopScan();
	      });
			}


		},
		created: function() {
			var self = this;
			_g.exitApp();
			if (api.systemType == 'ios') {
				document.getElementById("aa").style.top = '65px';
			} else if (api.systemType == 'android') {
				document.getElementById("aa").style.top = '71px';
			}
			if (_g.getLS('isTY') == 2) {
				self.ty = false;
			}
			self.switchframe(0, 'home_frame'); //统一入口

			self.oldPrint() //旧单据打印
			self.NewPrint() //新单据打印（包括销售机会，销售报价，报表）
		},
		mounted: function() {
			var self = this
			// 搜索框下拉列表的选中
			_g.addEventListener({
				name: api.winName + '-search-select-data',
				success: function(ret) {
					console.log(_g.j2s(ret));
					self.billingType = ret.value.name
				}
			})
			// 点击搜索图标
			_g.addEventListener({
				name: api.winName + '-search',
				success: function(ret) {
					self.keyword = ret.value.keyword
					var win = ''
					var param = { 'keyword': self.keyword, 'filterValue': self.keyword }
					switch (self.billingType) {
						case '销售机会':
							win = 'sale-chance'
							break
						case '销售报价':
							win = 'sale-price'
							break
						case '采购订单':
							win = 'pur-order'
							break
						case '采购收货':
							win = 'pur-gain'
							break
						case '现款采购':
							win = 'cash-pur'
							break
						case '采购退货':
							win = 'pur-return'
							break
						case '销售订单':
							win = 'sale-order'
							break
						case '销售发货':
							win = 'sale-del'
							break
						case '现款销售':
							win = 'cash-sale'
							break
						case '销售退货':
							win = 'sale-return'
							break
						default:
							break
					}
					if(self.billingType == '销售报价' || self.billingType == '销售机会'){
						_g.openWin({
							name: win,
							url: './html/Business/' + win,
							pageParam: param
						})
					}else{
						_g.openWin({
							name: win,
							url: './html/oldBusiness/' + win,
							pageParam: param
						})
					}
				}
			});
		}
	});
});
