define(function (require, exports, module) {
	var _C=require('components');
	var rateFrame = new Vue({
		el: '#rateFrame',
		data: {
			'tradeSum':0.00,
			'ownSum': '',//
			'tradeM': '',//
			'tradeC': '',//
			'ownM': '',		//持币名
			'ownC': ''		//持币代码
		},
		
		methods:{
			choose:function(title){
				//	选择物流公司
				var self=this;
				var title ;
				_basic.openModuleWin('Home','choose',{title:title , data:rateList});
			},
			//清空
			clear:function(){
				var self=this;
				self.tradeSum=0;
				self.ownSum=0;
			},
			//计算
			calculate:function(){
				var self=this;
				if(self.ownSum == 0 || self.ownSum == ''){
					_basic.toastMsg('请输入兑换金额');
					return;
				}
				if(self.ownM == ''){
					_basic.toastMsg('请选择持有货币');
					return;
				}
				if(self.tradeM == ''){
					_basic.toastMsg('请选择兑换货币');
					return;
				}
				_basic.showLoading('正在计算');
				api.ajax({
				    url: 'http://op.juhe.cn/onebox/exchange/currency',
				    method: 'get',
				    dataType:'json',
				    timeout:15,
				    data: {
				        values: {
				        	key:'2b0ad4bbf9ac2d4d408f5c0488ac3e75',
				        	from:self.ownC,
				        	to:self.tradeC
				        }
				    },
				},function(ret, err){
				    if (ret) {
				    	if(ret.error_code == 0){
				    		var rate=ret.result[0]['result'];
				    		self.tradeSum=(self.ownSum * rate).toFixed(4);
				    		api.hideProgress();
				    		console.log(JSON.stringify(ret.result));
				    	}
				    }else{
				    	api.hideProgress();
				    	_basic.toastMsg(err.msg);
				    }
				})
			},
			sendToWX:function(type,textJson){
				var text='';
				if(type=='content'){
					text=textJson.title+'\r\n\r\n';
					$.each(textJson.content,function(key,val){
						text=text+key+": "+val+'\r\n';
					});
				}else if(type=='photo'){
					text=textJson.url;
				}else{
					text=textJson.title;
				}
				var target1 = ''
				api.actionSheet({
					cancelTitle: '取消',
					buttons: ['分享给好友', '分享到朋友圈']
				}, function(ret, err) {
					if(ret.buttonIndex == 1){
						target1 = 'wxSession'
					}else if(ret.buttonIndex == 2){
						target1 = 'wxTimeline'
					}
					mobShare.shareTo({
				    target: target1,
				    text: text,
					}, function(ret, err) {
				    if (ret.status) {
				      _g.toastMsg({
								msg: '分享成功'
							});
				    }
					});
				})
			}
		},
		created: function(){
			var self=this;
			//持有货币
			api.addEventListener({
        name:'持有货币-get'
      },function(ret,err){
      	self.ownM=ret.value.selected.name;
      	self.ownC=ret.value.selected.code;
      });
      //兑换货币
      api.addEventListener({
        name:'兑换货币-get'
      },function(ret,err){
      	self.tradeM=ret.value.selected.name;
      	self.tradeC=ret.value.selected.code;
      });
      //微信操作
			api.addEventListener({
				name: api.winName+'-wx'
			},function(ret,err){
				var textJson={};
				textJson.title='汇率查询';
				textJson.content={
					'兑换金额':self.ownSum,
					'持有货币':self.ownM,
					'兑换货币':self.tradeM,
					'兑换结果':self.tradeSum
				};
				if(self.ownSum == ''){
					_g.toastMsg({
						msg: '无查询信息，不能分享'
					});
					return
				}
				self.sendToWX('content',textJson);
				
			});
		}
	});
});
