define(function (require, exports, module) {
	var _C = require("components");
	var wx = require('wx');
	var http = require('http');
	var INTERFACE = require('interface');
	var COMMAND = require('command');
	var RECORD = require('record');
	var TIME = require('time');
	var photoBrowser = require('photoBrowser');
	var MODULES = require('modules');
	var FILE = require('file');
	var QQ = require('qq');
	var wx = require('wx');

	//加载富文本编辑器
	var addFrame = new Vue({
		el: '#addFrame',
		data: {
			'layerBtns': [{
					title: '微信分享',
				},
				{
					title: 'QQ分享'
				}
			],
			'daily': {
				'dailyType': '', //日志类型名称
				'dailyTypeId': '', //日志类型id
				'dailyDate': (new Date()).Format('yyyy-MM-dd'), //日期
				'dailyEmployee': '', //员工
				'dailyEmployeeId': '', //员工id
				'dailyTheme': '', //日志主题
				'dailyContent': '', //日志内容
				'imgUrl': '',
				'recordUrl': [],
				'shareList': []
			},
			'dailyType': {},
			'sharerNameArr': [], //共享人名称
			'sharerIdArr': [], //共享人id
			'shareStr': '', //选中的共享人字符串
			'repeatSave': false, //是否重复保存
			'depts': [], //	获取的部门数据
			'sourceTag': {
				'日志类型': {
					listName: 'dailytype',
					unlimit: false,
					name: ['name'],
					submitArr: ['kindname', 'id']
				}
			},
			dailyType: []
		},
		components: {
			'btns-layer': _C.getBtnsLayer({
			    'height': api.frameHeight
			}),
			'record': _C.getRecord(),
			'chatbox': _C.getChatBox({
				content: '',
				placeholder: '请输入100字内的备注'
			}),
		},
		methods: {
			sharer: function (module, win) {
				var self = this;
				_g.openWin({
					name: win,
					url: '../' + module + '/' + win,
					pageParam: {
						sharerNameArr: self.sharerNameArr,
						sharerIdArr: self.sharerIdArr,
						depts: self.depts
					}
				});
			},
			chooseDailyType: function () {
				var self = this;
				MODULES.scrollSelect({
					isCitySelect: false,
					curActive: {
						index: self.daily.type,
						name: self.daily.typename
					},
					data: self.dailytype,
					nextStep: function (ret) {
						if (ret.eventType == 'ok') {
							self.daily.dailyType = ret.selectedInfo[0].name;
							self.daily.dailyTypeId = ret.selectedInfo[0].id;
						}
					}
				});
			},
			getDate: function () {
				var self = this;
				TIME.getPickerDates(self.daily.dailyDate, function (chooseDate) {
					self.daily.dailyDate = chooseDate;
				});
			},
			closeCurrentWin: function(){
				setTimeout(function(){api.closeWin();}, 500)
			},
			//内容处理为带表情的内容
			dealTohtml: function (str, callback) {
				var content = str;
				var emojiArr = content.match(/(?:\[)([^\[\]]*)(?:\])/g);
				if (Array.isArray(emojiArr) && emojiArr.length > 0) {
					api.ajax({
						url: '../../res/img/emotion/emotion.json',
						method: 'get',
					}, function (ret, err) {
						if (ret) {
							var data = ret;
							for (var i = 0; i < data.length; i++) {
								for (var j = 0; k < emojiArr.length; j++) {
									if (data[i].text == emojiArr[j]) {
										content = content.replace(emojiArr[j], '<img src="../../res/img/emotion/' + ret[i].name + '.png">');
									}
								}
							}
							callback(content);
						}
					});
				}
			},
			save: function () {
				var self = this;
				var annex = _.union(self.daily.recordUrl, uploadImg.selectImgs);
				var postData = {};

				//新增
				postData['addnewFlag'] = 'true';
				postData['billId'] = '-9999';
				postData['checkStep'] = "";
				postData['master.a00OldJsonValue'] = '';
				postData['master.billdate'] = self.daily.dailyDate;
				//				postData['master.billid'] = '';
				postData['master.empid'] = self.daily.dailyEmployeeId;
				postData['master.content'] = "";
				postData['master.opid'] = _g.getLS('opID');
				//	old     	postData['master.empname']=self.daily.dailyEmployee;
				//				postData['master.employee'] = '';  // it should be default
				
				postData['master.sharelistname'] = self.sharerNameArr.join(',') || '';
				postData['master.sharename'] = self.sharerNameArr.join(',') || '';
				if(self.sharerIdArr.length == 0){
					postData['master.sharelist'] = '';
				}  else if(self.sharerIdArr.length == 1){
					postData['master.sharelist'] = self.sharerIdArr[0] + '#';
				} else {
					postData['master.sharelist'] = self.sharerIdArr.join('#')+ '#';
				}
				postData['master.share'] = postData['master.sharelist'] 
					
				postData['startIndex'] = "0";
				postData['undefined'] = "0";
				postData['modid'] = 5035;
				postData['master.type'] = self.daily.dailyTypeId;
				if (self.daily.dailyType == '') {
					_g.toastMsg({
						msg: '日志类型不能为空'
					});
					return;
				} else {
					postData['master.typename'] = self.daily.dailyType;
				}

				if (self.daily.dailyTheme == '') {
					_g.toastMsg({
						msg: '主题不能为空'
					});
					return;
				} else {
					postData['master.name'] = self.daily.dailyTheme;
				}
				// var chatbox = addFrame.$refs.chatbox;
				// addFrame.daily.dailyContent = chatbox.content;//日志内容

				if (self.daily.dailyContent == '') {
					_g.toastMsg({
						msg: '内容不能为空'
					});
					return;
				} else {
					postData['master.description'] = self.daily.dailyContent;
				}
				console.log('---------------给老子看看参数-------------------------');
				console.log(JSON.stringify(postData));
				_g.showLoading('正在加载');
				http.ajax({
					url: INTERFACE.index.daily.save.url,
					data: postData,
					success: function (ret) {
						//						self.repeatSave=true;
						console.log('看有没有附件对应的id');
						console.log(JSON.stringify(ret));
						var annex = _.union(self.daily.recordUrl, uploadImg.selectImgs);
						if (annex.length != 0) {
							$.each(annex, function (index, val) {
								http.ajax({
									url: INTERFACE.annex.upload.url,
									data: {
										'fileFileName': val.saveName,
										'id': ret.billId,
										'modId': 5035,
										'voiceTime': val.voiceTime || 0
									},
									files: {
										file: val.savePath
									},
									success: function (ret) {
										console.log('------------annex-----------------------');
										console.log(JSON.stringify(ret));
										if (annex.length == index + 1) {
											_g.hideProgress();
											if (self.sharerNameArr.length != 0) {
												self.reloadList('share');
											} else {
												self.reloadList('my');
											}
											_g.toastMsg({
												msg: '保存成功'
											});
											self.closeCurrentWin()
											self.repeatSave = true;
											
											console.log('repeat save');
											console.log(self.repeatSave);
										}
									},
									other: function (ret) {
										_g.toastMsg({
											msg: val.saveName + ret.errMsg
										});
									},
									error: function (err) {
										_g.hideProgress();
										_g.toastMsg({
											msg: err.msg
										});
									}
								});
							});
						} else {
							_g.hideProgress();
							self.repeatSave = true;
							if (self.sharerNameArr.length != 0) {
								self.reloadList('share');
								self.reloadList('my');
							} else {
								self.reloadList('my');
							}
							_g.toastMsg({
								msg: '保存成功'
							}); //无附件情况下
							self.closeCurrentWin()
						}
					},
					error: function (err) {
						_g.hideProgress();
						_g.toastMsg(err.msg);
					}
				});
			},
			reloadList: function (type) {
				var eventName = type == 'share' ? 'share-frame-reload' : 'my-frame-reload';
				api.sendEvent({
					name: eventName
				});
			}
		},
		mounted: function () {
			var self = this;

			COMMAND.init({
				url: INTERFACE.index.daily.add.url,
				data: {
					modid: 5035,
					isH5: 'true'
				},
				success: function (ret) {
					self.daily.dailyEmployeeId = ret.master.empid || _g.getLS('opID');
					self.daily.dailyEmployee = ret.master.employee || _g.getLS('opName');
					var filterInfo = [];
					var filterTit = ['日志类型'];
					$.each(filterTit, function (key, value) {
						filterInfo.push(self.sourceTag[value]);
					});
					// undefined会报错
					//					STORAGE.init(filterInfo,function(){
					//					});
				},
				other: function (err) {
					console.log('fucking error');
				},
				error: function (err) {
					console.log('fucking errorr');
				}
			});

			// 获取log type [{dailyty:'日志'...},{...},...]
			http.ajax({
				url: INTERFACE.base.url,
				data: INTERFACE.base.logkind.param,
				success: function (ret) {
					self.dailytype = ret.listData;
				},
				other: function (ret) {
					console.log('request logkind error: ' + JSON.stringify(ret));
				},
				error: function (err) {
					console.log('request logkind ajax error: ' + JSON.stringify(err));
				}
			});

			//提前把部门的数据获取
			http.ajax({
				url: URLANNEX + '/oa/archives/archivesEdit!doGetOpGroup.action',
				data: {},
				success: function (ret) {
					console.log('共享人组数据');
					console.log(JSON.stringify(ret));
					$.each(ret.resultData.opGroupList, function (key, val) {
						val.name = val.groupname;
						// val.type = val.groupname;
						val.selected = false;
						self.depts.push(val);
					});
					console.log('let me seesee whats in the depts');
					console.log(JSON.stringify(self.depts));
				}
			});

			//			var postData = {};
			//			postData['addnewFlag'] = 'true';
			//			postData['billId'] = -9999;
			//			postData['checkStep'] = "";
			//			postData['master.a00oldjsonvalue'] = "";
			//			postData['master.billdate'] = '2017-03-16';
			//			postData['master.billid'] = '';
			//			postData['master.content'] = '';
			//			postData['master.description'] = 'this is desc';
			//			postData['master.empid'] = 0;
			////			postData['master.employee'] = ''; default
			////			postData['master.id'] = '';
			////			postData['master.itemno'] = '';
			//			postData['master.name'] = 'arteezy';
			////			postData['master.opdate'] = "";
			////			postData['master.opid'] = "0";
			////			postData['opname'] = "";  default
			//			postData['master.sharelist'] = "";
			//			postData['master.sharelistname'] = "";
			//			postData['master.type'] = "0";
			//			postData['master.typename'] = "日志";
			//			postData['startIndex'] = "0";
			//			postData['undefined'] = "0";
			//			postData['modid'] = 5035;
			//			
			//		
			//			http.ajax({
			//				url: INTERFACE.index.daily.save.url,
			//				data: postData,
			//				success: function(ret) {
			//					console.log('success');
			//				},
			//				other: function(ret) {
			//					console.log('print: ' + JSON.stringify(ret));
			//				},
			//				error: function(ret) {
			//					console.log('error');
			//				}
			//			});
			//			
			// 微信 qq分享
			_g.addEventListener({
				name: api.winName + '-btns-layer-selected',
				success: function (ret) {
					console.log('repeat save: ' + self.repeatSave);
					console.log(JSON.stringify(ret));
					// {"value":{"btn":{"title":"微信分享","icon":""},"index":0}}
					switch (ret.value.selected.title) {
						case '微信分享':
							if (!self.repeatSave) {
								_g.toastMsg({
									msg: '请先保存日志，再操作'
								});
							} else {
								api.actionSheet({
									title: '请选择分享方式',
									cancelTitle: '取消分享',
									buttons: ['分享到朋友圈', '分享给微信好友']
								}, function (ret, err) {
									var index = ret.buttonIndex;
									var target = '';
									if (index == 1) {
										target = 'wxTimeline';
									} else if(index == 2){
										target = 'wxSession';
									} else {
										return;
									}
									var textJson = {
										'事项': '新增日志',
										'日志类型名': self.daily.dailyType,
										'创建日期': self.daily.dailyDate,
										'员工': self.daily.dailyEmployee,
										'日志主题': self.daily.dailyTheme,
										'日志内容': self.daily.dailyContent
									}
									wx.shareToWx({
										textJson: textJson,
										type: target,
										success: function (ret) {
											_g.toastMsg({
												msg: '分享成功'
											});
										},
										error: function (err) {
											_g.toastMsg({
												msg: '分享失败'
											});
										}
									});
								});
							}
							break;
						case 'QQ分享':
							if (!self.repeatSave) {
								_g.toastMsg({
									msg: '请先保存日志，再操作'
								});
								return;
							}
							var textJson = {
								title: '',
								content: {}
							};
							textJson.title = '新增日志';
							textJson['content']['日志类型名'] = self.daily.dailyType;
							textJson['content']['创建日期'] = self.daily.dailyDate;
							textJson['content']['员工'] = self.daily.dailyEmployee;
							textJson['content']['日志主题'] = self.daily.dailyTheme;
							textJson['content']['日志内容'] = self.daily.dailyContent;
							QQ.shareText({
								textJson: textJson,
								success: function (ret) {
									_g.toastMsg({
										msg: '分享成功'
									});
								},
								error: function (err) {
									_g.toastMsg({
										msg: err.msg
									});
								}
							});
							break;
					}
				}
			});
			// 点击保存
			_g.addEventListener({
				name: api.winName + '-right',
				success: function (ret) {
					self.save();
				}
			});
			//更多按钮点击
			_g.addEventListener({
				name: api.winName + '-more',
				success: function (ret) {
					api.sendEvent({
	                    name: api.winName + '-btns-layer',
	                    extra: {
	                        type: 'change'  //操作类型
	                    }
	                });
				}
			});
			// 获取录音数据
			_g.addEventListener({
				name: api.winName + '-get-record',
				success: function (ret) {
					//					console.log('record: ' + JSON.stringify(ret.value[0]));
					self.daily.recordUrl = ret.value.rec;
				}
			});

			// 测试分享
			//			_g.addEventListener({
			//				name: api.winName + '-send',
			//				success: function(ret) {
			//				
			//				}
			//			});

			_g.hideProgress();
		}
	});
	var uploadImg = new Vue({
		el: '#uploadImg',
		template: _g.getTemplate('Index/uploadImg-v'),
		data: {
			'broswerImgs': [], //照片浏览器要查看的照片数组，只存路径，格式为数组
			'selectImgs': [] //选择好的图片
		},
		methods: {
			//上传图片
			updatePic: function () {
				var self = this;
				_g.openButtons({
					cancelTitle: '取消',
					buttons: ['相册', '拍照']
				}, function (ret, err) {
					var index = ret.buttonIndex;
					switch (index) {
						case 1:
							MODULES.apiPicture({
								sourceType: 'library',
								success: function (ret) {
									if (ret.data != '') {
										var picName = FILE.getFullNameByPath(ret.data);
										var picType = FILE.getTypeByPath(ret.data);
										var index = uploadImg.selectImgs.length;
										uploadImg.broswerImgs.push(ret.data);
										uploadImg.selectImgs.push({
											savePath: ret.data,
											saveName: picName,
											'hasUploadPic': true
										});
										//										console.log(JSON.stringify(ret));
										//											console.log('url: ' + ret.data);
										//											self.send(ret.data);
									}
								}
							});
							break;
						case 2:
							MODULES.apiPicture({
								sourceType: 'camera',
								success: function (ret) {
									if (ret.data != '') {
										var picName = FILE.getFullNameByPath(ret.data);
										var index = uploadImg.selectImgs.length;
										uploadImg.broswerImgs.push(ret.data);
										uploadImg.selectImgs.push({
											savePath: ret.data,
											saveName: picName,
											'hasUploadPic': true
										});
									}
								}
							})
							break;
					}
				});
			},

			//			send: function(url) {
			//				var share = api.require('sharePics');
			//				var arr = [url,url];
			//				var param = {
			//					title: 'test',
			//					list: arr
			//				};
			//				share.shareToTimeLine(param);
			//			},

			detailPic: function (index) {
				//查看图片
				_g.toastMsg({
					msg: '请长按或点击屏幕，退出图片浏览',
					duration: 800,
					location: 'middle'
				});
				setTimeout(function () {
					photoBrowser.open({
						imgs: uploadImg.broswerImgs,
						index: index,
						success: function (ret) {
							if (ret.eventType == 'longPress' || ret.eventType == 'click') {
								photoBrowser.close();
							}
						},
						error: function (err) {
							console.log('fucking error');
						}
					});
					//					_basic.photoBrowser(uploadImg.broswerImgs,index); 
				}, 1000);
			},
			delUpdatePic: function (img) {
				//删除图片
				var that = this;
				var params = {
					title: '',
					msg: '是否删除该照片?',
					buttons: ['确定', '取消']
				};
				_g.confirm({
					params: params,
					success: function (ret) {
						if (ret.buttonIndex == 1) {
							that.selectImgs = _.without(that.selectImgs, img);
							that.browserImgs = _.without(that.browserImgs, img.savepath);
						}
					}
				});
			},
		},
	});

	//获取共享人列表返回的数据
	api.addEventListener({
		name: 'sharer-select'
	}, function (ret, err) {
		addFrame.sharerNameArr = ret.value.shareName;
		addFrame.sharerIdArr = ret.value.shareId;
		addFrame.shareStr = ret.value.shareName.join(',');
	});
});