define(function (require, exports, module) {
	var http = require('http');
	var INTERFACE = require('interface');
	var COMMAND = require('command');
	var TIME = require('time')
	var stime = TIME.getDates().sDate
	var etime = TIME.getDates().eDate
	var content = new Vue({
		el: '#content',
		data: {
			listData: [],
			params: {
				billtype: api.pageParam.billKind[0]['id'], // 单据类型
				billstate: 0,	// 单据状态,待审核为0，反审核为1
				billcode: '',
				isMybill: 0,
				traderid: '',
				opid: '',
				sdate: stime,
	      beginDate: stime,
	      endDate: etime,
	      edate: etime,
	      filterisOR:'true',
			},
			checkData: []
		},
		components: {
			
		},
		methods: {
			remove: function(billcode){
				var self = this
				var index = _.findIndex(self.listData, {
					billcode: billcode
				})
				self.listData = _.without(self.listData, self.listData[index])
			},
			ajax: function(){
				var self = this
				INTERFACE.index.check.getList.param.ipurpose = self.params.billstate
				var params = $.extend(INTERFACE.index.check.getList.param, self.params)
				// console.log(JSON.stringify(params))
				COMMAND.init({
					url: INTERFACE.index.check.getList.url,
					data: params,
					success:function(ret){
						self.listData = ret.resultData.ListData
					}
				})
			},
			detail: function(item){
				var self = this
				var param = {mode: 'edit', isDetail:true}
				var win = ''
				switch(item.billname){
					case '销售订单':
						win = 'order-detail'
						param.type = 'sorder'
						param.id = item.billid
						param.item = item
						self.openWin({win: win, param:param})
					break
					case '销售开单':
						win = 'billing-detail'
						param.type = 'sbilling'
						param.id = item.billid
						param.item = item
						self.openWin({win: win, param:param})
					break
					case '采购订单':
						win = 'order-detail'
						param.type = 'porder'
						param.id = item.billid
						param.item = item
						self.openWin({win: win, param:param})
					break
					case '采购开单':
						win = 'billing-detail'
						param.type = 'pbilling'
						param.id = item.billid
						param.item = item
						self.openWin({win: win, param:param})
					break
					case '销售报价':
						win = 'sale-price-detail'
						param.id = item.billid
						param.item = item
						self.openWin({win: win, param:param})
					break
					case '销售机会':
						win = 'sale-chance-detail'
						param.id = item.billid
						param.item = item
						self.openWin({win: win, param:param})
					break
					default:
						_g.toastMsg({msg: '没有该类型单据的详情'})
					break
				}
			},
			openWin: function(opts){
				var self = this
				_g.openWin({
					name: opts.win,
					url:'../Business/' + opts.win,
					pageParam:$.extend(opts.param, {mode: 'edit'})
				})
			},
			choose: function(item, index){
				var self = this
				if (item.selected){
					Vue.set(self.listData[index], 'selected', false)
				} else {
					Vue.set(self.listData[index], 'selected', true)
				}
				
			},
			checkAjax: function(postData){
				var self = this
				_g.showLoading({})
				http.ajax({
					url: INTERFACE.index.check.checkOperation.url,
					data: postData,
					success:function(ret){
						//errNo为0时，操作成功
						_g.hideProgress()
						_g.toastMsg({msg: postData.param.billcode + '单据操作成功'})
						self.remove(postData.param.billcode)
					},
					other:function(ret){
						if(Number(ret.errNo) == 500){
							_g.confirm({
								params: {
									title: item.billcode,
									msg: ret.errMsg,
									buttons: ['是', '否']
								},
								success: function(ret){
									if (ret.buttonIndex == 1) {
										postData.param.checkStep = '500'
										self.checkAjax(postData)
									}
								}
							})
						} else if (ret.errNo == 1 && ret.errMsg != '') {
							_g.toastMsg({msg: ret.errMsg})
						} else if(ret.errNo == 2) {
							//errNo为2时，操作也成功
							_g.hideProgress()
							_g.toastMsg({msg: postData.param.billcode + '单据操作成功'})
							self.remove(postData.param.billcode)
						}
					},
					err:function(err){
						_g.toastMsg({msg: err.msg})
					}
				})
			},
			checkPower: function(postData){
				var self = this
				var ZEROONHAND = _g.getLS('ZEROONHAND');
				_g.showLoading({})
				http.ajax({
					url: URLANNEX + '/common/bill/billpublic!doGetCheckZero.action',
					data: {
						param: {
							'billtype': postData.param.billtype, 
							'billid': postData.param.billid,
							'flag': postData.param.billstate == '0' ? '1' : '-1'
						}
					},
					success: function(ret){
						_g.hideProgress();
						if(ret.resultData.checkzero.length > 0 && ZEROONHAND == '0'){
							// 前台只给一个提示“存在货品库存不足/超出上限下限”，不操作
							_g.toastMsg({msg: '存在货品库存不足/超出上限下限!'})
						} else if (ret.resultData.checkzero.length > 0 && ZEROONHAND == '1') {
							// 前台要给一个选项 “存在货品库存不足/超出上限下限是否忽略？” [忽略] [否] 
							_g.confirm({
								params: {
									title: '系统提示：',
									msg: '存在货品库存不足/超出上限下限是否忽略？',
									buttons: ['忽略', '否']
								},
								success: function(ret) {
									// 忽略则继续请求数据
									if (ret.buttonIndex == 1) {
										self.checkAjax(postData)
									}
								}
							})
						} else if(ret.resultData.checkzero.length == 0) {
							// 忽略则继续请求数据
							self.checkAjax(postData)
						}
					},
					other: function(other){
						_g.hideProgress();
						_g.toastMsg({msg: other.errMsg})
					},
					error: function(err){
						_g.hideProgress();
						_g.toastMsg({msg: err.msg})
					}
				})
			},
			tostring: function(str){
				var strV = String(str)
				if(str == null) {
					strV = 'null'
				}else if(str == undefined) {
					strV = 'undefined'
				} else if (typeof(str) == 'number') {
					strV = ""+str
				}
				return strV
			},
			check: function(){
				//审核
				var self = this
				_.each(self.checkData, function(item, key){
					var postData = {
						billstate: item.billstate,
						param: {
							billid: self.tostring(item.billid), 
							billdate: self.tostring(item.billdate),
							billkind: self.tostring(item.billkind),
							billname: self.tostring(item.billname),
							billstate: self.tostring(item.billstate),
							billtype: self.tostring(item.billtype),
							checkorid: self.tostring(item.checkorid),
							checkor: self.tostring(item.checkor),
							departmentid: self.tostring(item.departmentid),
							depname: self.tostring(item.depname),
							empid: self.tostring(item.empid),
							empname: self.tostring(item.empname),
							opid: self.tostring(item.opid),
							shopid: self.tostring(item.shopid),
							shopname: self.tostring(item.shopname),
							tablename: self.tostring(item.tablename),
							billcode: self.tostring(item.billcode),
							checkStep: self.tostring(0)
						}
					}
					if (postData.param.billtype == '4' || postData.param.billtype == '14'){
						/*如果是采购开单，销售开单，检查库存与权限是否满足*/
						self.checkPower(postData)
					} else {
						self.checkAjax(postData)
					}
				})
				
			},
			clearKeyword: function(){
				var self = this
				self.params.billcode = ''
				self.params.traderid = ''
				self.params.opid = ''
				api.sendEvent({
					name: api.winName + '-clear',
					extra: {}
				})
			},
			sortCheck: function(){
				var self = this
				self.checkData = []
				_.each(self.listData, function(value, key){
					if(value.selected) {
						self.checkData.push(value)
					}
				})
			}
		},
		created: function(){
			this.ajax()
		},
		mounted: function(){
			var self = this
			// 上拉加载
			_g.topLoading({
				success:function(){
					COMMAND.next({
						success: function(ret){
						self.listData = _.union(self.listData, ret.resultData.ListData)
						}
					})
				}
			})
			// 下拉刷新
			_g.refresh({
				
				success:function(){
					//设置参数里的关键字
					self.params.billcode = ''
					self.params.traderid = ''
					self.params.opid = ''
					api.sendEvent({
						name: api.winName + '-search-clear',
						extra: {}
					});
					COMMAND.refresh({
						success: function(ret) {
							self.listData = ret.resultData.ListData
						}
					})
				}
			})
			// 监听搜索内容的变化
			_g.addEventListener({
  			name: api.winName + '-search',
  			success: function(ret) {
  				console.log(JSON.stringify(ret))
  				//设置参数里的关键字
					self.params.billcode = ret.value.keyword
					self.params.traderid = ret.value.keyword
					self.params.opid = ret.value.keyword
  				// 重新获取数据
					self.ajax()
  			}	
  		})
  		// 切换审核与反审核数据
  		_g.addEventListener({
  			name: api.winName + '-btns-layer-click',
  			success: function(ret) {
  				// alert(JSON.stringify(ret));
  				// 处理头部右边的按钮
  				var index;
  				if (ret.value.btn.title == '已审核') {
  					index = 1
  					self.params.billstate = 1
  					self.params.isMybill = 0
  				} else if(ret.value.btn.title == '待审核'){
  					index = 0
  					self.params.billstate = 0
  					self.params.isMybill = 0
  				}else {
  					index = 2
  					self.params.billstate = 0
  					self.params.isMybill = 1
  				}
  				api.sendEvent({
						name: api.winName + '-btns-bubble',
						extra: {
							index: index
						}
					})
					// 清空关键字
					self.clearKeyword()
					// 单据类型恢复第一个
					api.sendEvent({
						name: api.winName + '-clear-typeChoose',
						extra: {
							title: api.pageParam.billKind[0]['name']
						}
					})
					self.params.billtype = api.pageParam.billKind[0]['id']
					// 重新获取数据
					self.ajax()
  			}	
  		});
  		// 审核
  		_g.addEventListener({
  			name: api.winName + '-check',
  			success: function(ret) {
  				self.sortCheck()
  				if(self.checkData.length != 0){
  					self.check()
  				} else {
  					_g.toastMsg({msg: '请选择单据'})
  				}
  			}	
  		})
  		// 反审核
  		_g.addEventListener({
  			name: api.winName + '-uncheck',
  			success: function(ret) {
  				self.sortCheck()
  				if(self.checkData.length != 0){
  					self.check()
  				} else {
  					_g.toastMsg({msg: '请选择单据'})
  				}
  			}	
  		})
  		// 搜索框下拉列表的选中
  		_g.addEventListener({
  			name: api.winName + '-select-data',
  			success: function(ret) {
  				// 清空关键字
  				self.clearKeyword()
  				// 设置billtype
  				self.params.billtype = ret.value.data.id
  				// 重新获取数据
					self.ajax()
  			}	
  		})
  		// 过滤
  		if(!_g.getLS('selected-'+api.frameName)) {
  			// 刚进入列表
  			var filterData = {
  				filterName: 'selected-' + api.frameName,
					stage: {
						hasStage: true,
						startTime: stime,
						endTime: etime
					},
					listItem:[]
				}
				_g.setLS('selected-'+api.frameName, filterData)
  		}
  		// 监听点击了过滤按钮
  		_g.addEventListener({
				name: api.winName + '-filter',
				success: function(ret) {
					// 打开过滤页面
					_g.openWin({
						name:'filter',
						url:'../Common/filter',
						pageParam: _g.getLS('selected-'+api.frameName)
					})
				}
			})
			// 监听进行过滤操作
			_g.addEventListener({
				name: 'selected-' + api.frameName + '-filterAction',
				success: function(ret) {
					//获取过滤数据
					var filterData = _g.getLS('selected-'+api.frameName)
					self.params.sdate = filterData.stage.startTime
		      self.params.beginDate = filterData.stage.startTime
		      self.params.endDate = filterData.stage.endTime
		      self.params.edate = filterData.stage.endTime
					// 重新获取数据
					self.ajax()
				}
			})
			//监听点击返回按钮后，清除缓存的过滤数据
			_g.addEventListener({
				name: api.winName + '-closeWin',
				success: function(ret) {
					_g.clearFilterLS(api.frameName)
				}
			})
		}

	})
})	
