define(function(require, exports, module) {

  var COMMAND = require('command');
  var INTERFACE = require('interface');
	var TIME = require('time');
	var stime = TIME.getDates().sDate;
	var etime = TIME.getDates().eDate;
  
  
  var list = new Vue({
    el: '#chooseBillList',
    data:{
    	items: [],
    	params:{
    	},
    	referbillcode:'',
    	referbillid:'',
    },
    watch: {
      "items": function(val, oldVal) {
        if (val.length === 0) {
          $('#null').removeClass('uhide');
        } else {
          $('#null').addClass('uhide');
        }
      }
    },
    created:function(){
    	var self = this;
			self.ajax();
    },
    methods: {
    	ajax:function(){
    		var self = this;
				// init
				COMMAND.init({
					url: INTERFACE.base.bill.url,
					method: 'post',
					data: $.extend(INTERFACE.base.bill.param, self.params,{billType:api.pageParam.billType, modId: 5034}),
					success: function(ret) {	
		    		_.each(ret.data.detail1,function(v, k){
							v.selected = false;
						});
						self.items = ret.data.detail1;

		    		console.log('self.items:'+_g.j2s(self.items))
					}
				});
    	},

    	selectIt:function(index){
    		var self = this;

    		_.each(self.items,function(v, k){
					if(k == index){
    				v.selected = true;
    				Vue.set(self.items, k, v)
    				self.referbillcode = v.billcode;
    				self.referbillid = v.id;
    			}else{
    				v.selected = false;
    			}
				});

    		console.log('after selected items:'+_g.j2s(self.items))

    		$.each(self.items,function(key,value){
    			console.log(key+':'+value.selected)
    		})
    	}
    },
		mounted: function() {
			var self = this;
			
			_g.refresh({ // 下拉刷新
				success: function(ret) {
					COMMAND.refresh({
						success: function(ret) {
							self.items = ret.data.detail1;
						}
					});
				}
			});
			
			_g.topLoading({ // 上拉加载
				success: function(ret) {
					COMMAND.next({
						success: function(ret) {
							console.log('next');
							self.items = self.items.concat(ret.data.detail1);
						}
					});
				}
			});
			
			_g.addEventListener({ // 搜索
				name: api.winName + '-search',
				success: function(ret){
					COMMAND.search({
						searchJson: {
							searchKey: ret.value.keyword
						},
						success: function(ret) {
							self.items = ret.data.detail1;
						}
					});
				}
			});

			//监听过滤事件
			var filterData = {
      	filterName: 'selected-' + api.frameName,
      	stage: {
					hasStage: true,
					startTime: stime,
					endTime: etime
				},
				listItem:[{
					type:'select-win',title:'客户',tag:'trader',selected:{value:'不限'}
				}]
      };
      _g.setLS('selected-'+api.frameName, filterData);

      _g.addEventListener({
				name: api.winName + '-filter',
				success: function(ret) {
					_g.openWin({
						name:'filter',
						url:'../Common/filter',
						pageParam: _g.getLS('selected-'+api.frameName)
					})
				}
			});

			// 监听进行过滤操作
			_g.addEventListener({
				name: 'selected-' + api.frameName + '-filterAction',
				success: function(ret) {
					//获取过滤数据
					var filterData = _g.getLS('selected-'+api.frameName)

					self.params={};
		     	_.each(filterData.listItem, function(val, key){
		     		if(!(val.selected.value == '不限' || val.selected.value == '')){
		     			console.log(_g.j2s(val.selected));
			     		switch(val.title){
			     			case '客户':
			     				self.params.traderid = Number(val.selected.id) || 0;
			     			break
			     			default:
			     			break
			     		}
			     	}
		     	})

		     	self.params.beginDate = filterData.stage.startTime;
		     	self.params.endDate = filterData.stage.endTime;

					// 重新获取数据
					self.ajax()
				}
			});

			//监听点击返回按钮后，清除缓存的过滤数据
			_g.addEventListener({
				name: api.winName + '-closeWin',
				success: function(ret) {
					_g.clearFilterLS(api.frameName)
				}
			})

			_g.addEventListener({
				name: api.winName + '-right',
				success: function(ret) {
					api.sendEvent({
						name: 'choose-bill-return',
						extra: {
							//返回的数据	 给日程新增/编辑页 schedules-detail-frame.js
							//
							referbillcode:self.referbillcode,
							referbillid:self.referbillid
						}
					})
					setTimeout(function(){ _g.closeWin() }, 300)
				}
			});

		}
  });
});