define(function(require, exports, module) {
  var _C = require('components');

  var header = new Vue({
    el: '#header',
    components: {
      baseheader: _C.getBaseHeader({
        title: '协作日程',
        showTitleSelect: false,
        btns: [
      		{
            icon: 'add',
            event: api.winName + '-add'
          },
          {
            icon: 'filter',
            event: api.winName + '-filter',
            frames: ['unreply', 'reply'],
          },                 
        ]
      }),
      searchbar: _C.getSearchBar({
				tips: '主题等关键字',
				type: ''
			}),
			tabbar: _C.getTabBar({
				tabs: [
					{
						title: '不需回复',
						active: true
					},
					{
						title: '需要回复',
						active: false
					},
				],
				eventName: api.winName + '-change-tab'
			})
    },
    methods: {},
    mounted: function() {
    	var self = this;
    	
    	_g.openFrame({
          name: 'unreply',
          url: '../Index/unreply',
          pageParam: api.pageParam
      });
    	
    
    	// 监听tab切换
    	_g.addEventListener({
				name: api.winName + '-change-tab',
				success: function(ret) {
					console.log(ret.value.index);
					var frameName = ''
					switch (ret.value.index) {
						case 0: _g.openFrame({
					                name: 'unreply',
					                url: '../Index/unreply',
					                pageParam: api.pageParam
					            });
											frameName = 'unreply';
					            break;
					    case 1: _g.openFrame({
					                name: 'reply',
					                url: '../Index/reply',
					                pageParam: api.pageParam
					            });
					    				frameName = 'reply';
					            break;    
					}
					api.sendEvent({
						name: 'schedules-currentFrame',
						extra: {
							frameName: frameName
						}
					});
				}
			});
    }
  });
});