define(function (require, exports, module) {
	var _C = require("components");
	var http = require('http');
	var INTERFACE = require('interface');
	var TIME = require('time');
	var MODULES = require('modules');
	var QQ = require('qq');
	var wx = require('wx');

	var dailyDetail = new Vue({
		el: '#dailyDetail',
		components: {
			'btns-layer': _C.getBtnsLayer({
			    'height': api.frameHeight
			}),
			"instruct": _C.getInstruct({
				'fixToBottom': api.pageParam.isOperator == true ? false : true
			}),
			"chatbox": _C.getChatBox({
				content: '',
				placeholder: '请输入100字内的备注'
			})
		},
		data: {
			'layerBtns': [{
				title: '微信分享'
			},{
				title: 'QQ分享'
			}],
			'triangleActive': true, //批示列表展开/收起	
			'daily': {
				'a00OldJsonValue': '', // 旧值
				'type': '', // 日志id
				'typename': '', //日志类型
				'billdate': '', //2015-12-12
				'employee': '', //员工
				'empid': '', //员工id
				'name': '', //主题
				'description': '', //内容。。。
				'annexSum': 0 //附件个数
			},
			'billId': 0,
			'sharerNameArr': [], //共享人名称
			'sharerIdArr': [], //共享人id
			'shareStr': '', //选中的共享人字符串
			'depts': [], //	获取的部门数据
			'mode': 'sharer', //模式是：operator , sharer 
			'itemsNum': 0, //批示数量
			'hideDelMode': false, //是否显示删除批示模式蒙版
			'delBtnIndex': 0,
			dailytype: []
		},
		methods: {
			sharer: function (module, win) {
				var self = this;
				_g.openWin({
					name: win,
					url: '../' + module + '/' + win,
					pageParam: {
						sharerNameArr: self.sharerNameArr,
						sharerIdArr: self.sharerIdArr,
						depts: self.depts
					}
				});
			},
			toggleInstruction: function () {
				//批示列表展开/收起
				this.$refs.instructChild.page.isList = this.triangleActive;
				this.triangleActive = !this.triangleActive;
			},
			offDelMode: function () {
				//关闭删除模式
				this.hideDelMode = true;
				this.$refs.instructChild.items[this.delBtnIndex].hideDelBtn = true;
			},
			chooseDailyType: function () {
				var self = this;
				MODULES.scrollSelect({
					isCitySelect: false,
					curActive: {
						index: self.daily.type,
						name: self.daily.typename
					},
					data: self.dailytype,
					nextStep: function (ret) {
						if (ret.eventType == 'ok') {
							self.daily.typename = ret.selectedInfo[0].name;
							self.daily.type = ret.selectedInfo[0].id;
						}
					}
				});
			},
			getDate: function () {
				var self = this;
				TIME.getPickerDates(self.daily.billdate, function (chooseDate) {
					self.daily.billdate = chooseDate;
				});
			},
			openAnnex: function (key) {
				var self = this;
				if (self.daily.annexSum != 0) {
					// 打开附件

					var paramJson = {
						'readOnly': self.mode != 'operator' ? true : false,
						'isDetail': true, // 单据是否为详情情况
						'param': {
							'id': api.pageParam.dailyId, // 日志id
							'modId': 5035, // modId
						}
					}
					_g.openWin({
						name: 'annex',
						url: '../Annex/annex',
						pageParam: {
							paramJson: paramJson
						}
					});
				} else {
					var paramJson = {
						'readOnly': true,
						'isDetail': true, // 单据是否为详情情况
						'param': {
							'id': api.pageParam.dailyId, // 日志id
							'modId': 5035, // modId
						}
					}
					if (self.mode == 'operator') {
						paramJson.readOnly = false;
						_g.openWin({
							name: 'annex',
							url: '../Annex/annex',
							pageParam: {
								paramJson: paramJson
							}
						});
					} else {
						_g.toastMsg({
							msg: '无附件可查看'
						});
					}
				}
			},
			dealTohtml: function (str, callback) {
				var content = str;
				console.log('content-------: ' + content);
				var emojiArr = content.match(/(?:\[)([^\[\]]*)(?:\])/g);
				console.log('emojiArr: ' + JSON.stringify(emojiArr));
				if (Array.isArray(emojiArr) && emojiArr.length > 0) {
					console.log('into loop----------------------------');
					$.ajax({
						url: '../../res/img/emotion/emotion.json',
						type: 'get',
						dataType: 'json',
						success: function (ret) {
							var data = ret;
							for (var i = 0; i < data.length; i++) {
								for (var j = 0; j < emojiArr.length; j++) {
									if (data[i].text == emojiArr[j]) {
										content = content.replace(emojiArr[j], '<img src="../../res/img/emotion/' + ret[i].name + '.png">');

									}
								}
							}
							console.log('content is ' + content);
							callback(content);
						}
					});
				} else {
					callback(content);
				}
			},
			sortdate: function (date) {
				if (date.indexOf(' ') > -1) {
					return date.split(' ')[0];
				} else {
					return date;
				}
			},
			sortMaster: function (master) {
				var key = '';
				var json_data = {};
				for (var x in master) {
					key = 'master.' + x;
					json_data[key] = master[x];
				}
				return json_data;
			},
			clickDelete: function () {
				_g.confirm({
					params: {
						title: '提示',
						msg: '是否删除日志?',
						buttons: ['确定', '取消']
					},
					success: function (ret) {
						if (ret) {
							if (ret.buttonIndex == 1) {
								http.ajax({
									url: INTERFACE.index.daily.del.url,
									data: {
										billId: api.pageParam.dailyId,
										listid: 0,
										isH5: 'true',
										modid: 160
									},
									success: function (ret) {
										_g.hideProgress();
										_g.toastMsg({
											msg: '删除成功'
										});
										api.sendEvent({
											name: api.pageParam.type + '-reload'
											// api.pageParam.type === 'my-frame'
										});
										setTimeout(function () {
											api.closeWin()
										}, 800);
									},
									error: function (err) {
										_g.hideProgress();
										_g.toastMsg({
											msg: err.errMsg
										});
									}
								});
							}
						}
					},
				});
			}
		},
		mounted: function () {
			var self = this;
			_g.showLoading();
			var detailRet;
			var annexRet;
			var postData = {};

			self.mode = api.pageParam.isOperator == true ? "operator" : "sharer";
			console.log('mode: ' + self.mode);
			http.ajax({
				url: INTERFACE.index.daily.detail.url,
				data: {
					billId: api.pageParam.dailyId,
					modid: 160,
					isH5: 'true'
				},
				success: function (ret) {
					ret.master.billdate = self.sortdate(ret.master.billdate);
					detailRet = ret;
					if (ret.master.sharelistname != '') {
						self.shareStr = ret.master.sharelistname;
						self.sharerNameArr = self.shareStr.split(',');
						self.sharerIdArr = ret.master.sharelist.split(',');
					}
					self.daily.a00OldJsonValue = detailRet.master.a00OldJsonValue;
					self.daily.type = detailRet.master.type;
					self.daily.typename = detailRet.master.typename;
					self.daily.billdate = detailRet.master.billdate;
					self.billId = detailRet.billId;
					self.daily.employee = detailRet.master.employee;
					self.daily.empid = detailRet.master.empid;
					self.daily.name = detailRet.master.name;
					self.daily.description = detailRet.master.description;
					// if (self.mode == 'operator') {
					// 	var chatbox = dailyDetail.$refs.chatbox;
					// 	self.daily.description = chatbox.content = detailRet.master.description;
					// } else {
					// 	self.dealTohtml(detailRet.master.description, function (str) {
					// 		self.daily.description = str;
					// 	});
					// }
				},
				other: function (ret) {
					console.log('errrrrrrrrrrrrrrrror');
				}
			});

			// 获取log type [{dailyty:'日志'...},{...},...]
			http.ajax({
				url: INTERFACE.base.url,
				data: INTERFACE.base.logkind.param,
				success: function (ret) {
					self.dailytype = ret.listData;
				},
				other: function (ret) {
					console.log('request logkind error: ' + JSON.stringify(ret));
				},
				error: function (err) {
					console.log('request logkind ajax error: ' + JSON.stringify(err));
				}
			});

			// 获取annex-count
			http.ajax({
				url: INTERFACE.annex.list.url,
				data: {
					id: api.pageParam.dailyId,
					modId: 5035,
					start: 0
				},
				success: function (ret) {
					self.daily.annexSum = ret.data.detail1.length;
				}
			})


			// 获取点评列表
			api.sendEvent({
				name: 'instruct-list',
				extra: {
					paramJson: {
						id: api.pageParam.dailyId,
						modId: 160
					}
				}
			});

			// 点击保存按钮
			_g.addEventListener({
				name: api.winName + '-right',
				success: function (ret) {
					postData['addnewFlag'] = 'false';
					postData['billId'] = self.billId;
					postData['checkStep'] = "";
					postData['startIndex'] = 0;
					postData['undefined'] = 0;
					postData['modid'] = 160;
					postData['master.a00OldJsonValue'] = self.daily.a00OldJsonValue;
					postData['master.type'] = self.daily.type;
					postData['master.typename'] = self.daily.typename;
					postData['master.billdate'] = self.daily.billdate;
					postData['master.billid'] = self.billId;
					postData['master.name'] = self.daily.name;
					postData['master.content'] = "";
					postData['master.empid'] = self.daily.empid;
					postData['master.employee'] = self.daily.employee;
					postData['master.sharelistname'] = self.sharerNameArr.join(',') || '';
					postData['master.sharename'] = self.sharerNameArr.join(',') || '';
					if(self.sharerIdArr.length == 0){
						postData['master.sharelist'] = '';
					}  else if(self.sharerIdArr.length == 1){
						postData['master.sharelist'] = self.sharerIdArr[0] + '#';
					} else {
						postData['master.sharelist'] = self.sharerIdArr.join('#')+ '#';
					}
					postData['master.share'] = postData['master.sharelist'] 
					// fuck 
					postData['master.id'] = '';
					postData['master.itemno'] = '';
					postData['master.opdate'] = '';
					postData['master.opid'] = _g.getLS('opID');
					postData['master.opname'] = '';
					// end
					if (postData['master.description'] == '') {
						_g.toastMsg({
							msg: '内容不能为空'
						});
						return;
					} else {
						// var chatbox = dailyDetail.$refs.chatbox;
						// self.daily.description = postData['master.description'] = chatbox.content;
						postData['master.description'] = self.daily.description;
					}
					if (postData["master.typename"] == '') {
						_g.toastMsg({
							msg: '日志类型不能为空'
						});
						return;
					}
					if (postData['master.name'] == '') {
						_g.toastMsg({
							msg: '主题不能为空'
						});
						return;
					}
					console.log(JSON.stringify(postData));
					_g.showLoading('正在保存');
					http.ajax({
						url: INTERFACE.index.daily.save.url,
						data: postData,
						success: function (ret) {
							_g.hideProgress();
							_g.toastMsg({
								msg: '保存成功'
							});
							api.sendEvent({
								name: 'my-frame-reload'
							});
						},
						error: function (err) {
							_g.hideProgress();
							_g.toastMsg({
								msg: err.msg
							});
						}
					});

				}
			});
			//点击头部更多按钮
			_g.addEventListener({
			    name: api.winName + '-more',
			    success: function (ret) {
			        api.sendEvent({
			            name: api.winName + '-btns-layer',
			            extra: {
			                type: 'change'  //操作类型
			            }
			         });
			    }
			});
			// 监听btn-layer-click
			_g.addEventListener({
				name: api.winName + '-btns-layer-selected',
				success: function (ret) {
					console.log('show me the ret');
					console.log(JSON.stringify(ret));
					switch (ret.value.selected.title) {
						case 'QQ分享':
							var textJson = {
								title: '',
								content: {}
							};
							textJson.title = '日志详情';
							textJson['content']['日志类型名'] = self.daily.typename;
							textJson['content']['创建日期'] = self.daily.billdate;
							textJson['content']['员工'] = self.daily.employee;
							textJson['content']['日志主题'] = self.daily.name;
							textJson['content']['日志内容'] = self.daily.description;
							QQ.shareText({
								textJson: textJson,
								success: function (ret) {
									_g.toastMsg({
										msg: '分享成功'
									});
								},
								error: function (err) {
									_g.toastMsg({
										msg: err.msg
									});
								}
							});
							break;
						case '微信分享':
							api.actionSheet({
								title: '请选择分享方式',
								cancelTitle: '取消分享',
								buttons: ['分享到朋友圈', '分享给微信好友']
							}, function (ret, err) {
								var index = ret.buttonIndex;
								var target = '';
								if (index == 1) {
									target = 'wxTimeline';
								} else if (index == 2){
									target = 'wxSession';
								} else {
									return;
								}
								var textJson = {
									'事项': '日志详情',
									'日志类型名': self.daily.typename,
									'创建日期': self.daily.billdate,
									'员工': self.daily.employee,
									'日志主题': self.daily.name,
									'日志内容': self.daily.description
								}
								wx.shareToWx({
									textJson: textJson,
									type: target,
									success: function (ret) {
										_g.toastMsg({
											msg: '分享成功'
										});
									},
									error: function (err) {
										_g.toastMsg({
											msg: '分享失败'
										});
									}
								});
							});
							break;
					}
				}
			});
			//监听附件数量的更改
			api.addEventListener({
				name: 'annex-num'
			}, function (ret) {
				if (ret.value.type == 'add') {
					self.daily.annexSum += 1;
				} else {
					self.daily.annexSum -= 1;
				}
			});

			// 提前获取部门的数据
			http.ajax({
				url: INTERFACE.base.shareShop.url,
				data: INTERFACE.base.shareShop.param,
				success: function (ret) {
					console.log('共享人组数据');
					console.log(JSON.stringify(ret));
					$.each(ret.resultData.opGroupList, function (key, val) {
						val.name = val.groupname;
						// val.type = val.name;
						val.selected = false;
						self.depts.push(val);
					});
					console.log('let me seesee whats in the depts');
					console.log(JSON.stringify(self.depts));
				}
			});

			//获取共享联系人列表返回的数据
			_g.addEventListener({
				name: 'sharer-select',
				success: function (ret) {
					console.log('返回联系人数据');
					console.log(JSON.stringify(ret));
					self.sharerNameArr = ret.value.shareName;
					self.sharerIdArr = ret.value.shareId;
					self.shareStr = ret.value.shareName.join(',')
				}
			});
		}
	});
});