define(function (require, exports, module) {

	var HTTP = require('http');
	var INTERFACE = require('interface');
	var TIME = require('time');
	var QQ = require('qq');
	var wx = require('wx');

	var _C = require('components');
	var detail_list = new Vue({
		el: '#detail_list',
		components: {
			'instruct': _C.getInstruct({
				'fixToBottom': api.pageParam.isOperator == true ? false : true
			}),
			'btns-layer': _C.getBtnsLayer({
				'height': api.frameHeight
			})
		},
		data: {
			layerBtns: [{
				title: '微信分享'
			}, {
				title: 'QQ分享'
			}],
			item: {
				"followMsg": {
					clientname: '',
					referbilltypename: ''
				},
				"followAnnex": {
					len: 0, // 附件数量
					dataJson: [], // 附件数据
				},
				"instruction": [ //批示
				],
				billId: '', // 客户跟进id
			},
			isShow: false, //标示是否显示批示按钮
			from: api.pageParam.from || 'default',
			isDetail: api.pageParam.isShow, //表示详情 新建
			canEditDateCode: true, //是否能编辑日期及编号
			itemId: '', //标示删除的下标值
			mapping: {
				'dsclient': 'client', //客户
				'dscontact': 'contact', //联系人
				'dscalltype': 'contacttype', //跟进方式
				'dsbilltype': 'billtype', //业务类型
				'followbill': 'referbillcode', //跟进单据
				'follower': 'emp'
			},
			flag: '',
			referbillcode: '',
			clientRead: false, //表示是否能选择客户
			hideDelMode: true, //是否显示删除模式蒙版
			triangleActive: true, //批示列表展开/收起	
			isSaved: false, //是否进行过保存
			retId: '',
			det: api.pageParam.title == '新建跟进' ? false : true,

			saveBillId:'',
		},
		methods: {
			showContent: function () {
				this.isShow = !this.isShow;
			},
			//选择时间
			timePicker: function (date, type) {
				var that = this;
				if(that.canEditDateCode){
					TIME.getPickerDates(date, function (chooseDate) {		
						
						var dataJson = {
							billType: '155',
							billDate: chooseDate,
							oldBillDate: that.item.followMsg.billdate,
							oldBillCode: that.item.followMsg.billcode
						}
						that.item.followMsg[type] = chooseDate; // 注释ajax之后的替代品
					});
				}
			},

			//删除跟进
			delFollow: function () {
				//alert(api.pageParam.clientid);return;
				var that = this;

				_g.confirm({
					params: {
						title: '提示',
						msg: '确定删除该跟进记录?',
						buttons: ['确定', '取消']
					},
					success: function (ret) {
						if (ret.buttonIndex == 1) {
							if (typeof api.pageParam.clientid !== 'undefined') {
								param = {
									url: INTERFACE.client.follow.delete.url,
									data: {
										billId: that.saveBillId,
										isH5: true,
										modId: 155,
										listid: '',
										clientId: ''
									}
								}
							} else {
								param = {
									url: INTERFACE.client.follow.delete.url,
									data: {
										billId: that.saveBillId,
										isH5: true,
										modId: 155,
										listid: ''
									}
								}
							}
							HTTP.ajax({
								url: param.url,
								data: param.data,
								success: function (ret) {
									_g.toastMsg({
										msg: '删除成功'
									});
									api.sendEvent({
										name: 'follow-list-reload'
									});
									_g.closeWin();
								},
								other: function (ret) {
									console.log('delete error in follow-detail-frame.js');
								},
								error: function (error) {
									_g.toastMsg({
										msg: error.errMsg
									});
								}
							});
						}
					}
				});
			},
			//打开新页面
			openWin: function (win, winName, data) {
				var that = this;
				that.flag = data.type;
				if(api.pageParam.from == 'bussiness'){
					return;
				}
				if (data.tag == 'bill') {
					console.log(that.item.followMsg.tradername)
					console.log('3:' + that.item.followMsg.referbilltypename)
					//判断是否选择了客户和业务类型
					if (that.item.followMsg.tradername == null) {
						_g.toastMsg({
							msg: '请选择客户!'
						});
						return;
					} else if (that.item.followMsg.referbilltypename == null) {
						_g.toastMsg({
							msg: '请选择业务类型!'
						});
						return;
					}
					_g.openWin({
						name: winName,
						url: '../' + win + '/' + winName,
						pageParam: data
					});
				} else if (win == 'Annex') {
					var paramJson = {
						isDetail: true, // 单据是否为详情情况
						param: {
							'id': api.pageParam.id, // 单据id
							'modId': 155,//'10109', // 业务类型modId
						}
					}
					_g.openWin({
						name: 'annex',
						url: '../Annex/annex',
						pageParam: paramJson
					});
				} else if (data.tag == 'contcat') {
					//判断是否选择了客户
					if (that.item.followMsg.tradername == null) {
						_g.toastMsg({
							msg: '请选择客户!'
						});
						return;
					}
					_g.openWin({
						name: winName,
						url: '../' + win + '/' + winName,
						pageParam: data
					});
				}
				else {
					_g.openWin({
						name: winName,
						url: '../' + win + '/' + winName,
						pageParam: data
					});
				}
			},
			//获得附件
			getAnnex: function (followId) {
				var that = this;
				HTTP.ajax({
					url: INTERFACE.annex.list.url,
					data: {
						id: followId,
						modId: 155
					},
					success: function (ret) {
						that.item.followAnnex.len = ret.data.detail1.length;
					}
				});
			},
			toggleInstruction: function () {
				//批示列表展开/收起
				this.$refs.instructList.isHide = this.triangleActive;
				this.triangleActive = !this.triangleActive;
			},
			offDelMode: function () {
				//关闭删除模式
				this.hideDelMode = true;
				this.$refs.instructList.items[this.delBtnIndex].hideDelBtn = true;
			},
			setDefault: function (json) {
				console.log(JSON.stringify(json));
				api.sendEvent({
					name: 'list-select',
					extra: {
						'listJson': [{
							id: json.id,
							code: json.code,
							name: json.name
						}]
					}
				});
			},
			openAnnex: function () {
				var self = this;
				var paramJson = {
					readOnly: false,
					isDetail: api.pageParam.isShow,
					param: {
						'id': api.pageParam.followId,
						modId: 155
					}
				};
				if(api.pageParam.from == 'bussiness'){
					paramJson.readOnly = true
				}
				_g.openWin({
					name: 'Annex',
					url: '../Annex/annex',
					pageParam: {
						paramJson: paramJson
					}
				});
			},

			// 编辑保存
			editEvent: function (followId) {
				var that = this;
				var param1 = {
					addnewFlag: 'false',
					billId: followId,
					checkStep: 0,
					isH5: 'true',
					modId: 155,
					startIndex: '',
					undefined: ''
				};

				$.each(that.item.followMsg, function (key, value) {
					if (key.indexOf('userdef') == -1) {
						param1['master.' + key] = value;
					}
					if (value == null) {
						if (key.indexOf('userdef') == -1) {
							param1['master.' + key] = '';
						}
					}
				});
				_g.showLoading({
					text: '正在保存'
				});
				HTTP.ajax({
					url: INTERFACE.client.follow.save.url,
					data: param1,
					success: function (ret) {
						_g.hideProgress();
						_g.toastMsg({
							msg: '保存成功'
						});
						api.sendEvent({
							name: 'follow-list-reload'
						});
					},
					other: function (ret) {
						_g.hideProgress();
						if(ret.errNo == 500){
							_g.confirm({
								params: {
									title: '',
									msg: '单据编号已占用,是否自动修改',
									buttons: ['确定', '取消']
								},
								success: function(ret){
									if(ret.buttonIndex == 1){
										_g.showLoading({
											text: '正在保存'
										});
										param1['checkStep'] = 500
										HTTP.ajax({
											url: INTERFACE.client.follow.save.url,
											data: param1,
											success: function (ret) {
												_g.hideProgress();
												_g.toastMsg({
													msg: '保存成功'
												});
												api.sendEvent({
													name: 'follow-list-reload'
												});
											},
											error: function (err) {
												_g.hideProgress();
												_g.toastMsg({
													msg: err.errMsg
												});
											}
										})
									}
								}
							})
						}else{
							_g.toastMsg({
								msg: ret.errMsg
							});
						}
					},
					error: function (err) {
						_g.hideProgress();
						_g.toastMsg({
							msg: err.errMsg
						});
					}
				});
			},
			addEvent: function () {
				var that = this;
				var param2 = {
					addnewFlag: 'true',
					billId: that.item.billId,
					checkStep: 0,
					isH5: 'true',
					modId: 155,
					startIndex: '',
					undefined: ''
				}
				_g.showLoading({
					text: '正在保存'
				});
				$.each(that.item.followMsg, function (key, value) {
					//				if(key.indexOf('userdef') == -1 && value != null){
					//					param2['master.'+key] = value;
					//				}
					if (key.indexOf('userdef') == -1) {
						param2['master.' + key] = value;
					}
					if (value === null && key.indexOf('userdef') == -1) {
						param2['master.' + key] = '';
					}
				});
				param2['master.billstate'] = 0; // 初始化要传0
				param2['master.empname'] = _g.getLS('opName');
				param2['master.empid'] = _g.getLS('opID');
				param2['master.shopid'] = _g.getLS('shopID');

				console.log('参数2：' + JSON.stringify(param2));
				//return;
				HTTP.ajax({
					url: INTERFACE.client.follow.save.url,
					data: param2,
					success: function (ret) {
						_g.hideProgress();
						_g.toastMsg({
							msg: '保存成功，可进行微信分享'
						});
						api.sendEvent({
							name: 'follow-list-reload'
						});
						that.isDetail = true;
						that.isSaved = true;
						that.item.followMsg.billid = ret.billId;

						that.saveBillId = ret.billId;
						that.detailEvent(that.saveBillId);
					},
					other: function (ret) {
						_g.hideProgress();
						if(ret.errNo == 500){
							_g.confirm({
								params: {
									title: '',
									msg: '单据编号已占用,是否自动修改',
									buttons: ['确定', '取消']
								},
								success: function(ret){
									if(ret.buttonIndex == 1){
										_g.showLoading({
											text: '正在保存'
										});
										param2['checkStep'] = 500
										HTTP.ajax({
											url: INTERFACE.client.follow.save.url,
											data: param2,
											success: function (ret) {
												_g.hideProgress();
												_g.toastMsg({
													msg: '保存成功'
												});
												api.sendEvent({
													name: 'follow-list-reload'
												});
											},
											error: function (err) {
												_g.hideProgress();
												_g.toastMsg({
													msg: err.errMsg
												});
											}
										})
									}
								}
							})
						}else{
							_g.toastMsg({
								msg: ret.errMsg
							});
						}
					}
				});


			},
			// 查看详情
			detailEvent: function (followId) {
				var that = this;
				HTTP.ajax({
					url: INTERFACE.client.follow.edit.url,
					data: {
						billId: followId,
						isH5: 'true',
						modId: 155
					},
					success: function (ret) {
						that.item.followMsg = ret.master;
						that.item.followMsg.billdate = TIME.sortdate(that.item.followMsg.billdate);
						that.canEditDateCode = ret.resultData.canEditDateCode
						// if (that.item.followMsg.nextdate=='' || that.item.followMsg.nextdate == null) {
						// 	that.item.followMsg.nextdate=(new Date()).Format("yyyy-MM-dd");
						// }
						//对业务的销售机会进来的记录页，，要设置默认的业务类型和单据
						if (!(api.pageParam.bparam == undefined || api.pageParam.bparam == '')) {
							that.flag = 'dsbilltype'; //业务类型
							that.setDefault(api.pageParam.bparam.dsbilltype);
							setTimeout(function () {
								that.flag = 'followBill'; //单据
								that.setDefault(api.pageParam.bparam.followBill);
							}, 800);
						}
						JsonValue = ret.master.a00oldjsonvalue;
						that.getAnnex(followId);
						//						$api.setStorage('annex',that.item.followAnnex.dataJson);
						_g.hideProgress();

						//获取批示
						api.sendEvent({
							name: 'instruct-list',
							extra: {
								paramJson: {
									'id': followId,
									'modId': 155
								}
							}
						});
					}
				});

				
			},
			//提交数据进行的非空检测
			checkSubmit: function () {
				var that = this;
				var reg = /^\s+$/g;
				if (that.item.followMsg.billcode == null || reg.test(that.item.followMsg.billcode)) {
					_g.toastMsg({
						msg: '请输入编码!'
					});
					return false;
				}
				if (that.item.followMsg.name == null || reg.test(that.item.followMsg.name)) {
					_g.toastMsg({
						msg: '请输入主题!'
					});
					return false;
				}
				if (that.item.followMsg.tradername == null || reg.test(that.item.followMsg.tradername)) {
					_g.toastMsg({
						msg: '请选择客户!'
					});
					return false;
				}
				if (that.item.followMsg.contactname == "" || that.item.followMsg.contactname == null || reg.test(that.item.followMsg.contactname)) {
					_g.toastMsg({
						msg: '请选择联系人!'
					});
					return false;
				}
				if (that.item.followMsg.contacttypename == null || reg.test(that.item.followMsg.contacttypename)) {
					_g.toastMsg({
						msg: '请选择跟进方式!'
					});
					return false;
				}
				return true;
			}
		},
		mounted: function () {
			console.log('api.pageParam:'+JSON.stringify(api.pageParam));
			var that = this;
			var JsonValue = '';
			that.isShow = api.pageParam.isShow;
			that.clientRead = api.pageParam.clientName != undefined ? true : false;
			var param = {};
			if (that.isShow) {
				//跟进详情
				_g.showLoading();
				var followId = api.pageParam.followId;
				that.item.billId = followId;
				var clientId = api.pageParam.clientId;
				that.isSaved = true;

				that.saveBillId = api.pageParam.followId;	//保存时的billId
				that.detailEvent(followId);
				api.hideProgress();
				if(api.pageParam.from == 'bussiness'){
					// api.sendEvent({
					// 	name: api.winName + '-btns-update',
					// 	extra: {
					// 		btns: [{
					// 			icon: 'more',
					// 			event: api.winName + '-more',
					// 			frame: {
					// 				pageParam: {
					// 					btns: [{
					// 							title: '微信分享',
					// 						},
					// 						{
					// 							title: 'QQ分享'
					// 						}
					// 					]
					// 				}
					// 			}
					// 		}]
					// 	}
					// })
				}
			} else {
				_g.showLoading('正在获取数据');
				//新建跟进
				HTTP.ajax({
					url: INTERFACE.client.follow.add.url,
					data: {
						isH5: 'true',
						modId: 155
					},
					success: function (ret) {
						console.log('ret: ' + JSON.stringify(ret));
						that.item.followMsg = ret.master;
						that.item.billId = ret.billId;
						if(api.pageParam.clientName){
							that.item.followMsg.tradername = api.pageParam.clientName
						}
						that.item.followMsg.empname = _g.getLS('opName');
						that.canEditDateCode = ret.resultData.canEditDateCode
					}
				});
			}


			// save detail
			_g.addEventListener({
				name: api.winName + '-right',
				success: function (ret) {
					console.log('isDetail: ' + that.isDetail);
					console.log('isSave: ' + that.isSaved);
					if (that.isDetail) {
						if (!that.checkSubmit()) {
							console.log('suck in checkSubmit');
							return;
						}
						console.log('edit:'+that.saveBillId);
						that.editEvent(that.saveBillId);
						return;
					} else {
						if (!that.checkSubmit()) {
							return;
						}
					}
					if (that.isSaved) {
						_g.toastMsg({
							msg: '保存成功，可进行微信分享'
						});
						return;
					} else {
						console.log('add');
						that.addEvent();
					}
				}
			});
			// 打开头部 下拉按钮组
			_g.addEventListener({
				name: api.winName + '-more',
				success: function (ret) {
					api.sendEvent({
	                    name: api.winName + '-btns-layer',
	                    extra: {
	                        type: 'change'  //切换layer的显示
	                    }
	                });
				}
			});
			// 头部下拉按钮组选中(新的)
			_g.addEventListener({
				name: api.winName + '-btns-layer-selected',
				success: function (ret) {
					var item = ret.value.selected;
					if (!that.isSaved) {
						_g.toastMsg({
							msg: '请先保存'
						});
						return;
					}
					switch(item.title){
						case '微信分享':
							// send to wx
							api.actionSheet({
								title: '请选择分享方式',
								cancelTitle: '取消分享',
								buttons: ['分享到朋友圈', '分享给微信好友']
							}, function (ret, err) {
								var index = ret.buttonIndex;
								var target = '';
								if (index == 1) {
									target = 'wxTimeline'
								} else if(index == 2) {
									target = 'wxSession'
								} else {
									return;
								}
								var textJson = {
									'事项': '客户跟进记录',
									' ': ' ',
									'编号': that.item.followMsg.billcode == null ? '' : that.item.followMsg.billcode,
									'跟进日期': that.item.followMsg.billdate == null ? '' : that.item.followMsg.billdate,
									'跟进主题': that.item.followMsg.name == null ? '' : that.item.followMsg.name,
									'客户': that.item.followMsg.tradername == null ? '' : that.item.followMsg.tradername,
									'联系人': that.item.followMsg.contactname == null ? '' : that.item.followMsg.contactname,
									'跟进方式': that.item.followMsg.contacttypename == null ? '' : that.item.followMsg.contacttypename,
									'跟进业务类型': that.item.followMsg.referbilltypename == null ? '' : that.item.followMsg.referbilltypename,
									'跟进单据': that.item.followMsg.referbillcode == null ? '' : that.item.followMsg.referbillcode,
									'跟进描述': that.item.followMsg.remark == null ? '' : that.item.followMsg.remark,
									'地址': that.item.followMsg.address == null ? '' : that.item.followMsg.address,
									'跟进人': that.item.followMsg.empname == null ? '' : that.item.followMsg.empname,
									'下次跟进日期': that.item.followMsg.nextdate == null ? '' : that.item.followMsg.nextdate
								}
								wx.shareToWx({
									textJson: textJson,
									type: target,
									success: function (ret) {
										_g.toastMsg({
											msg: '分享成功'
										});
									},
									error: function (ret) {
										msg: '分享失败'
									}
								});
							});
						break;
						case 'QQ分享':
							var textJson = {};
							textJson.title = '客户跟进记录';
							textJson.content = {
							
								'编号': that.item.followMsg.billcode == null ? '' : that.item.followMsg.billcode,
								'跟进日期': that.item.followMsg.billdate == null ? '' : that.item.followMsg.billdate,
								'跟进主题': that.item.followMsg.name == null ? '' : that.item.followMsg.name,
								'客户': that.item.followMsg.tradername == null ? '' : that.item.followMsg.tradername,
								'联系人': that.item.followMsg.contactname == null ? '' : that.item.followMsg.contactname,
								'跟进方式': that.item.followMsg.contacttypename == null ? '' : that.item.followMsg.contacttypename,
								'跟进业务类型': that.item.followMsg.referbilltypename == null ? '' : that.item.followMsg.referbilltypename,
								'跟进单据': that.item.followMsg.referbillcode == null ? '' : that.item.followMsg.referbillcode,
								'跟进描述': that.item.followMsg.remark == null ? '' : that.item.followMsg.remark,
								'地址': that.item.followMsg.address == null ? '' : that.item.followMsg.address,
								'跟进人': that.item.followMsg.empname == null ? '' : that.item.followMsg.empname,
								'下次跟进日期': that.item.followMsg.nextdate == null ? '' : that.item.followMsg.nextdate
							};
							QQ.shareText({
								textJson: textJson,
								success: function (ret) {
									_g.toastMsg({
										msg: '分享成功'
									});
								},
								error: function (ret) {
									_g.toastMsg({
										msg: err.msg
									});
								}
							});
						break;
						default:
						break;
					}
				}
			});
			// btn-layer （旧的）
			_g.addEventListener({
				name: api.winName + '-btns-layer-click',
				success: function (ret) {
					switch (ret.value.index) {
						case 0:
							// send to wx
							if (!that.isSaved) {
								_g.toastMsg({
									msg: '请先保存'
								});
								return;
							}
							api.actionSheet({
								title: '请选择分享方式',
								cancelTitle: '取消分享',
								buttons: ['分享到朋友圈', '分享给微信好友']
							}, function (ret, err) {
								var index = ret.buttonIndex;
								var target = '';
								if (index == 1) {
									target = 'wxTimeline'
								} else if(index == 2) {
									target = 'wxSession'
								} else {
									return;
								}
								var textJson = {
									'事项': '客户跟进记录',
									' ': ' ',
									'编号': that.item.followMsg.billcode == null ? '' : that.item.followMsg.billcode,
									'跟进日期': that.item.followMsg.billdate == null ? '' : that.item.followMsg.billdate,
									'跟进主题': that.item.followMsg.name == null ? '' : that.item.followMsg.name,
									'客户': that.item.followMsg.tradername == null ? '' : that.item.followMsg.tradername,
									'联系人': that.item.followMsg.contactname == null ? '' : that.item.followMsg.contactname,
									'跟进方式': that.item.followMsg.contacttypename == null ? '' : that.item.followMsg.contacttypename,
									'跟进业务类型': that.item.followMsg.referbilltypename == null ? '' : that.item.followMsg.referbilltypename,
									'跟进单据': that.item.followMsg.referbillcode == null ? '' : that.item.followMsg.referbillcode,
									'跟进描述': that.item.followMsg.remark == null ? '' : that.item.followMsg.remark,
									'地址': that.item.followMsg.address == null ? '' : that.item.followMsg.address,
									'跟进人': that.item.followMsg.empname == null ? '' : that.item.followMsg.empname,
									'下次跟进日期': that.item.followMsg.nextdate == null ? '' : that.item.followMsg.nextdate
								}
								wx.shareToWx({
									textJson: textJson,
									type: target,
									success: function (ret) {
										_g.toastMsg({
											msg: '分享成功'
										});
									},
									error: function (ret) {
										msg: '分享失败'
									}
								});
							});
							break;
						case 1:
							if (!that.isSaved) {
								_g.toastMsg({
									msg: '请先保存'
								});
								return;
							}
							var textJson = {};
							textJson.title = '客户跟进记录';
							textJson.content = {
							
								'编号': that.item.followMsg.billcode == null ? '' : that.item.followMsg.billcode,
								'跟进日期': that.item.followMsg.billdate == null ? '' : that.item.followMsg.billdate,
								'跟进主题': that.item.followMsg.name == null ? '' : that.item.followMsg.name,
								'客户': that.item.followMsg.tradername == null ? '' : that.item.followMsg.tradername,
								'联系人': that.item.followMsg.contactname == null ? '' : that.item.followMsg.contactname,
								'跟进方式': that.item.followMsg.contacttypename == null ? '' : that.item.followMsg.contacttypename,
								'跟进业务类型': that.item.followMsg.referbilltypename == null ? '' : that.item.followMsg.referbilltypename,
								'跟进单据': that.item.followMsg.referbillcode == null ? '' : that.item.followMsg.referbillcode,
								'跟进描述': that.item.followMsg.remark == null ? '' : that.item.followMsg.remark,
								'地址': that.item.followMsg.address == null ? '' : that.item.followMsg.address,
								'跟进人': that.item.followMsg.empname == null ? '' : that.item.followMsg.empname,
								'下次跟进日期': that.item.followMsg.nextdate == null ? '' : that.item.followMsg.nextdate
							};
							QQ.shareText({
								textJson: textJson,
								success: function (ret) {
									_g.toastMsg({
										msg: '分享成功'
									});
								},
								error: function (ret) {
									_g.toastMsg({
										msg: err.msg
									});
								}
							});
					}
				}
			});



			/**
			 * 附件统计数量统计事件
			 */
			_g.addEventListener({
				name: 'annex-num',
				success: function (ret) {
					if (ret.value.type == 'add') {
						that.item.followAnnex.len += 1;
					} else {
						that.item.followAnnex.len -= 1;
					}
				}
			});

			//获取win-select的选中数据
			_g.addEventListener({
				name: api.frameName + '-get-winselected',
				success: function (ret) {
					console.log('get-winselected');
					console.log(JSON.stringify(ret));
					if (ret.value.tag == 'trader') {
						if (ret.value.selectedData.length > 0) {
							var pre = that.item.followMsg.tradername;
							var current = ret.value.selectedData[0].name;
							that.item.followMsg.tradername = ret.value.selectedData[0].showName;
							that.item.followMsg.traderid = ret.value.selectedData[0].clientid;
							if (pre != current) {
								that.item.followMsg.referbillcode = '';
								that.item.followMsg.referbillid = 0;

								that.item.followMsg.contactname = '';
								that.item.followMsg.contactid = 0;
							}
						} else {
							that.item.followMsg.tradername = '';
							that.item.followMsg.traderid = 0;
						}
					} else if (ret.value.tag == 'contcat') {
						if (ret.value.selectedData.length > 0) {
							that.item.followMsg.contactname = ret.value.selectedData[0].showName;
							that.item.followMsg.contactid = ret.value.selectedData[0].id;
						} else {
							that.item.followMsg.contactname = '';
							that.item.followMsg.contactid = 0;
						}
					} else if (ret.value.tag == 'CRkind') {
						if (ret.value.selectedData.length > 0) {
							that.item.followMsg.contacttypename = ret.value.selectedData[0].showName;
							that.item.followMsg.contacttype = ret.value.selectedData[0].id;
						} else {
							that.item.followMsg.contacttypename = '';
							that.item.followMsg.contacttype = 0;
						}
					} else if (ret.value.tag == 'billType') {
						if (ret.value.selectedData.length > 0) {
							var pre = that.item.followMsg.referbilltypename;
							var current = ret.value.selectedData[0].showName;
							that.item.followMsg.referbilltypename = ret.value.selectedData[0].showName;
							that.item.followMsg.referbilltype = ret.value.selectedData[0].id;
							if (pre != current) {
								that.item.followMsg.referbillcode = '';
								that.item.followMsg.referbillid = 0;
							}
						} else {
							that.item.followMsg.referbilltypename = '';
							that.item.followMsg.referbilltype = 0;
						}
					} else if (ret.value.tag == 'bill') {
						if (ret.value.selectedData.length > 0) {
							that.item.followMsg.referbillcode = ret.value.selectedData[0].showName;
							that.item.followMsg.referbillid = ret.value.selectedData[0].id;
						} else {
							that.item.followMsg.referbillcode = '';
							that.item.followMsg.referbillid = 0;
						}
					} else if (ret.value.tag == 'operator') {
						if (ret.value.selectedData.length > 0) {
							that.item.followMsg.empname = ret.value.selectedData[0].showName;
							that.item.followMsg.empid = ret.value.selectedData[0].id;
						} else {
							that.item.followMsg.empname = '';
							that.item.followMsg.empid = 0;
						}
					}
				}
			});

			api.addEventListener({
				name: api.winName + '-clearStorage'
			}, function (ret) {
				that.rmStorages();
			})
		}
	});
});