define(function(require,exports,module){
	var COMMAND = require('command');
	var INTERFACE  = require('interface');
	var TIME = require('time');
	var stime = TIME.getDates().sDate;
	var etime = TIME.getDates().eDate;
	

	var record = new Vue({
		el:'#recordList',
		data:{
			title: api.pageParam.title,
			items:[],
			filter: {
				isH5: 'true',
				pageSize: '',
				start: 0,
				startdate: '',
				endDate: '',
				clientId: api.pageParam.clientid
			},
			sourceTag:{
				'联系人':{
        			listName:'dscontact',
					unlimit:false,
					name:['name','code'],
					submitArr:['name','code']
        		},
        		'客户':{//客户
        			listName:'dsclient',
					unlimit:false,
					name:['name','code'],
					submitArr:['name','code']
        		}
        	},
        	cJson:{		//过滤条件
        		'clientName':'',//归属客户名称
        		'code':'',		//客户编码
        		'contactName':'',	//职务
        		'name':''		//主题 
        	}
		},
		watch:{
			'items':function(val, oldVal){
				if(_.isEmpty(val)){
					$('#null').removeClass('uhide');
				}else{
					$.each(val , function(k , v){
		            	if(v.billdate !=null){
		            		v.billdate=TIME.sortdate(v.billdate);
		            	}
		            	if(v.nextdate !=null){
		            		v.nextdate=TIME.sortdate(v.nextdate);
		            	}
	            	});
					$('#null').addClass('uhide');
				}
			}
		},
		methods:{
			showDetail:function(billid,clientId,id){
				var bparam='';
				if(api.pageParam.bparam){
					bparam=api.pageParam.bparam;
				}
				_g.openWin({
					name: 'follow-detail',
					url: '../Index/follow-detail',
					pageParam: {
						from: api.pageParam.from,
						followId:billid,
						clientId:clientId,
						id:id,
						isIcon:true,
						weChat:'-toWeChat',
						text:'确定',
						textEventName:'-follow-detail',
						title:'跟进详情',
						bparam:bparam,
						isShow:true
					}
				});
			}
		},
		created: function(){
			var that = this;
			var param = {};
			if(api.pageParam.from == 'bussiness'){
				api.sendEvent({
					name: api.winName + '-btns-update',
					extra: {
						btns: []
					}
				})
			}
			if(typeof api.pageParam.clientid !== 'undefined'){
				//客户详情进入
				param = {
					url : INTERFACE.client.follow.list.url,
					data:{
						isH5: 'true',
						pageSize: '',
						start: 0,
						startdate: '',
						endDate: '',
						modId: 155,
						clientid: api.pageParam.clientid
					}
				}
			}else{
				if (api.pageParam.referbillid) {
					INTERFACE.client.follow.list.param.referbillid = api.pageParam.referbillid
				}
				param = {
					url : INTERFACE.client.follow.list.url,
					data: INTERFACE.client.follow.list.param
				}
			}
			COMMAND.init({
				url: param.url,
				data: param.data,
				method: 'post',
				success: function(ret) {
					console.log(JSON.stringify(ret));
					that.items = ret.resultData.ListData;
				},
				other: function(ret) {
					console.log('other');
					console.log(JSON.stringify(ret));
				},
				error: function(ret) {
					console.log('error');
					console.log(JSON.stringift(ret));
				}
			});
		},
		mounted:function(){
			var that = this;

			_g.topLoading({ // 上拉加载
				success: function(ret) {
					COMMAND.next({
						success: function(ret) {
							console.log('next');
							that.items = that.items.concat(ret.resultData.ListData);
						}
					});
				}
			});
			
			_g.refresh({ // 下拉刷新
				success: function(ret) {
					COMMAND.refresh({
						success: function(ret) {
							console.log('refresh')
							that.items = ret.resultData.ListData;
						}
					});
				}
			});
			// 新增跟进
			_g.addEventListener({
				name: api.winName + '-add',
				success: function(ret) {
					var bparam = '';
					if (api.pageParam.bparam) {
						bparam = api.pageParam.bparam;
					}
					_g.openWin({
						name: 'follow-detail',
						url: '../Index/follow-detail',
						pageParam: {
							isIcon: true,
							title: '新建跟进',
							isShow: false,
							weChat: '-toWeChat',
							save: '-save',
							clientId: api.pageParam.id, 
							bparam: bparam , 
							clientName:api.pageParam.clientName
						}
					});
				}
			});
				
				
			// 过滤
			if (!_g.getLS('selected-' + api.frameNae)) {
				var filterData = {
					filterName: 'selected-' + api.winName,
					stage: {
						hasStage: true,
						startTime: stime,
						endTime: etime
					},
					listItem: [
						{
							type: 'input', title: '单号'
						},
						{
							type: 'input', title: '跟进主题'
						},
						{
							type: 'select-win', 
							title: '客户', 
							tag: 'trader', 
							selected: {value: '不限'}, 
							extraParams: {filter: '(isclient=1 or acctrader =1) and Closed=0 and TraderID>0'}
						},

						{
							type: 'input', title: '联系人'
						},
						{
							type: 'select-win', title: '跟进方式', tag: 'CRkind', selected: {value: '不限'}
						},
						{
							type: 'select-win', title: '跟进业务类型', tag: 'billType', selected: {value: '不限'}
						},
						{
							type: 'select-win', title: '跟进人', tag: 'followOperator', selected: {value: '不限'}
						}
					]
				}
				_g.setLS('selected-' + api.winName, filterData);
			}
				
			_g.addEventListener({
				name: api.winName + '-filter',
				success: function(ret) {
					console.log('-filter');
					_g.openWin({
						name:'filter',
						url:'../Common/filter',
						pageParam: _g.getLS('selected-' + api.winName)
					});
				}	
			});
			//获取过滤条件
			_g.addEventListener({
				name: 'selected-' + api.winName + '-filterAction',
				success: function(ret) {
					console.log('filter save:'+ JSON.stringify(_g.getLS('selected-' + api.winName)));
					//搜索框的内容清空
			        api.sendEvent({
			            name: api.winName + '-search-clear',
			        })
					var filterData = _g.getLS('selected-' + api.winName);
					
					var postData = {
						isH5: 'true',
						start: 0,
						modId: 155,
						startdate: filterData.stage.startTime,
						endDate: filterData.stage.endTime
					};
					var filterIndex = 0;
					
					if (filterData.listItem[0].selected != undefined) {
						postData["filterItems[" + filterIndex + "].fieldType"] = 'ft_Str';
						postData["filterItems[" + filterIndex + "].id"] = 1;
						postData["filterItems[" + filterIndex + "].index"] = '';
						postData["filterItems[" + filterIndex + "].name"] = '单号';
						postData["filterItems[" + filterIndex + "].operatertitle"] = '包含';
						postData["filterItems[" + filterIndex + "].value"] = filterData.listItem[0].selected;
						filterIndex++;
					}
					
					if (filterData.listItem[1].selected != undefined) {
						postData["filterItems[" + filterIndex + "].fieldType"] = 'ft_Str';
						postData["filterItems[" + filterIndex + "].id"] = 3;
						postData["filterItems[" + filterIndex + "].index"] = '';
						postData["filterItems[" + filterIndex + "].name"] = '跟进主题';
						postData["filterItems[" + filterIndex + "].operatertitle"] = '等于';
						postData["filterItems[" + filterIndex + "].value"] = filterData.listItem[1].selected;
						filterIndex++;							
					}				
					
					if (filterData.listItem[2].selected.showName != undefined) {
						postData["filterItems[" + filterIndex + "].fieldType"] = 'ft_ListStr';
						postData["filterItems[" + filterIndex + "].id"] = 4;
						postData["filterItems[" + filterIndex + "].index"] = 103;
						postData["filterItems[" + filterIndex + "].name"] = '客户';
						postData["filterItems[" + filterIndex + "].operatertitle"] = '等于';
						postData["filterItems[" + filterIndex + "].value"] = filterData.listItem[2].selected.name;
						filterIndex++;
					}
					
					if (filterData.listItem[3].selected != undefined) {
						postData["filterItems[" + filterIndex + "].fieldType"] = 'ft_Str';
						postData["filterItems[" + filterIndex + "].id"] = 5;
						postData["filterItems[" + filterIndex + "].index"] = '';
						postData["filterItems[" + filterIndex + "].name"] = '联系人';
						postData["filterItems[" + filterIndex + "].operatertitle"] = '包含';
						postData["filterItems[" + filterIndex + "].value"] = filterData.listItem[3].selected;
						filterIndex++;
					}
					
					if (filterData.listItem[4].selected.showName != undefined) {
						postData["filterItems[" + filterIndex + "].fieldType"] = 'ft_Str';
						postData["filterItems[" + filterIndex + "].id"] = 6;
						postData["filterItems[" + filterIndex + "].name"] = '跟进方式';
						postData["filterItems[" + filterIndex + "].operatertitle"] = '等于';
						postData["filterItems[" + filterIndex + "].value"] = filterData.listItem[4].selected.name;
						filterIndex++;
					}
					
					if (filterData.listItem[5].selected.showName != undefined) {
						postData["filterItems[" + filterIndex + "].fieldType"] = 'ft_ListStr';
						postData["filterItems[" + filterIndex + "].id"] = 7;
						postData["filterItems[" + filterIndex + "].index"] = 1;
						postData["filterItems[" + filterIndex + "].name"] = '跟进业务类型';
						postData["filterItems[" + filterIndex + "].operatertitle"] = '等于';
						postData["filterItems[" + filterIndex + "].value"] = filterData.listItem[5].selected.name;
						filterIndex++;
					}
					
					if (filterData.listItem[6].selected.showName != undefined) {
						postData["filterItems[" + filterIndex + "].fieldType"] = 'ft_ListStr';
						postData["filterItems[" + filterIndex + "].id"] = 10;
						postData["filterItems[" + filterIndex + "].index"] = 1;
						postData["filterItems[" + filterIndex + "].name"] = '跟进人';
						postData["filterItems[" + filterIndex + "].operatertitle"] = '等于';
						postData["filterItems[" + filterIndex + "].value"] = filterData.listItem[6].selected.opname;
						filterIndex++;
					}
					COMMAND.init({
						url: INTERFACE.client.follow.list.url,
						data: postData,
						method: 'post',
						success: function(ret) {
						    // 重新赋值
							that.items = ret.resultData.ListData;
						}
					});
				}
			});
				
			// 监听关闭页面 清除缓存
			_g.addEventListener({
				name: api.winName + '-closeWin',
				success: function(ret) {
					_g.clearFilterLS(api.frameName)
				}
			});

			//监听需要刷新本页面的事件 ，这个是？？？
			_g.addEventListener({
				name: 'follow-list-reload',
				success: function(ret) {
					COMMAND.refresh({
						success: function(ret) {
							console.log('follow-list-reload refresh');
							that.items = ret.resultData.ListData;
							api.sendEvent({
								name: 'client-followSum-reload',
								extra: {
									len: that.items.length
								}
							});
						}
					});
				}
			});
			
			// 输入框搜索
			_g.addEventListener({ // 模糊搜索
				name: api.winName + '-search',
				success: function(ret){
					console.log('来到了搜索');
					COMMAND.search({
						searchJson: {
							searchKey: ret.value.keyword
						},
						success: function(ret) {
							that.items = ret.resultData.ListData;
						},
						other: function(ret) {
							console.log('other');
						},
						error: function(err) {
							console.log('errrrrrrrrrrrrrrrrrr');
						}
					});
				}
			});
		}
	});
});