define(function(require, exports, module) {

    var COMMAND = require('command');
    var INTERFACE = require('interface');
  	var TIME = require('time');
	var stime = TIME.getDates().sDate;
	var etime = TIME.getDates().eDate;
    
    
    var list = new Vue({
        el: '#dailylist',
        data:{
        	currentFrame: 'my-frame',
            uhide: true, 
            items: [],
            sourceTag:{
				'员工':{//员工
        			listName:'worker',
					unlimit:true,
					name:['name'],
					submitArr:['name']
        		},
			},	//数据源参数
	        filter: {
	        	isH5:'true',
            	pageSize:20,
            	start:0,
            	modid: 5035,
            	beginDate: '',
            	endDate: '',
            	returnIntShow: 1,
            	searchKey: '',
		    }
        },
        watch: {
            "items": function(val, oldVal) {
                if (val.length === 0) {
                    $('#null').removeClass('uhide');
                } else {
                    $('#null').addClass('uhide');
                }
            }
        },
        created: function() {
        	var that = this;
    		COMMAND.init({
    			url: INTERFACE.index.daily.list.url,
    			method: 'post',
    			data: {
    				isH5:'true',
					pageSize:20,
					start:0,
					modid: 5035,
					beginDate: '',
					endDate: '',
					returnIntShow: 1,
    			},
    			success: function(ret) {
    				if (ret.errNo === 0) {
                        if (ret.resultData) {
                            that.items = that.dealPhoto(ret.resultData.ListData);
                        } else {
                            that.items = [];
                        }
                    } else {
                        if (ret.errMsg.indexOf('请重新登陆') > 0 || ret.errMsg.indexOf('请重新登录') > 0) {
                            _g.toast(ret.errMsg);
                            setTimeout(function() {
                                api.closeToWin({
                                    name: 'index-win'
                                });
                            }, 1000);
                        } else {
                            _g.toast(ret.errMsg);
                        }
                    }
    				// that.items = that.dealPhoto(ret.resultData.ListData);
    			}
    		});
        },
        methods: {
            dealPhoto: function(obj){
				$.each(obj,function(key ,val){
					if(val.pictureurl == null){
						val.pictureurl = '../../res/img/head.jpg';
					}else{
						val.pictureurl = URLANNEX + '/' + val.pictureurl;
					}
				});
				return obj;
			},
			openDetail: function(dailyId , empid){
				//打开日志详情
				var isOperator=_g.getLS('opId') == empid ? true :false;
				_g.openWin({
					name: 'detail',
					url: '../Index/detail',
					pageParam: {
						'dailyId': dailyId , 
						'type':'my-frame', 
						'isOperator':isOperator
					}
				});
			}
        },
		mounted: function() {
        	var that = this;
        	console.log('mounted: ' + JSON.stringify(api.pageParam));
        	_g.addEventListener({ // 搜索
				name: api.winName + '-search',
				success: function(ret){
					COMMAND.search({
						searchJson: {
							searchKey: ret.value.keyword
						},
						success: function(ret) {
							console.log('search result');
							console.log(JSON.stringify(ret));
							that.items = that.dealPhoto(ret.resultData.ListData);
						}
					});
				}
			});
			
			_g.addEventListener({
				name: 'my-frame-reload',
				success: function(ret) {
					COMMAND.init({
						url: INTERFACE.index.daily.list.url,
						method: 'post',
						data:  {
		                 	isH5:'true',
		                    pageSize:20,
		                    start:0,
		                    modid: 5035,
		                    beginDate: '',
		                    endDate: '',
		                    returnIntShow: 1
		                },
						success:function(ret){
							console.log(JSON.stringify(ret));
							that.items = that.dealPhoto(ret.resultData.ListData);
							console.log(JSON.stringify(that.items));
						}
					});
				}
			});
			
			// 过滤
			if (!_g.getLS('selected-' + api.frameName)) {
				var filterData = {
					filterName: 'selected-' + api.frameName,
					stage: {
						hasStage: true,
						startTime: stime,
						endTime: etime
					},
					listItem:[
							// 现在还没有
						{
							type:'input', title:'主题'
						},
						{
							type: 'select-win', title: '日志类型', tag: 'logkind', selected: {value: '不限'}
						}
					]
				}
				_g.setLS('selected-'+api.frameName, filterData);
				console.log('---------- ' + JSON.stringify(filterData));
			}
			//监听tab栏的切换
            _g.addEventListener({
                name: api.winName + '-change-tab',
                success: function(ret) {
                    if (ret.value.index == 0) {
                        that.currentFrame = 'my-frame';
                    } else {
                        that.currentFrame = 'share-frame';
                    }
                }
            });
			// 监听过滤按钮的点击
			_g.addEventListener({
				name: api.winName + '-filter',
				success: function(ret) {
					console.log('-filter');
					if (that.currentFrame == 'my-frame') {
					_g.openWin({
						name:'filter',
						url:'../Common/filter',
						pageParam: _g.getLS('selected-' + api.frameName)
					});
					}
				}	
			});
			
			_g.addEventListener({
				name: 'selected-' + api.frameName + '-filterAction',
				success: function(ret) {
					console.log('filter save');
					//搜索框的内容清空
                    api.sendEvent({
                        name: api.winName + '-search-clear',
                    })
					var filterData = _g.getLS('selected-' + api.frameName);
					console.log('--------------' + JSON.stringify(filterData));
					var postData = {
                        isH5: 'true',
                        pageSize: 20,
                        start: 0,
                        modid: 5035,
                        beginDate: filterData.stage.startTime,
                        endDate: filterData.stage.endTime,
                        returnIntShow: 1,
                    }
                    var index = 0
                    $.each(filterData.listItem, function(key, val) {
                        if (val.title == '主题') {
                            if (val.selected && val.selected != ' ') {
                                postData['filterItems[' + index + '].fieldType'] = 'ft_Str'
                                postData['filterItems[' + index + '].id'] = 4
                                postData['filterItems[' + index + '].index'] = ''
                                postData['filterItems[' + index + '].name'] = '主题'
                                postData['filterItems[' + index + '].operatertitle'] = '等于'
                                postData['filterItems[' + index + '].value'] = val.selected
                                index++
                            }
                        } else {
                            if (val.selected.value != '不限') {
                                postData['filterItems[' + index + '].fieldType'] = 'ft_ListStr'
                                postData['filterItems[' + index + '].id'] = 1
                                postData['filterItems[' + index + '].name'] = '类型'
                                postData['filterItems[' + index + '].operatertitle'] = '等于'
                                postData['filterItems[' + index + '].value'] = val.selected.name
                            }
                            index++
                        }
                    });



					// var postData = {};
					
					// if (filterData.listItem[1].selected.name == undefined && filterData.listItem[0].selected == undefined) {
					// 	postData = {
					// 		isH5:'true',
					// 		pageSize:20,
					// 		start:0,
					// 		modid: 5035,
					// 		beginDate: filterData.stage.startTime,
					// 		endDate: filterData.stage.endTime,
					// 		returnIntShow: 1,
					// 	}
					// } else if (filterData.listItem[1].selected.name == undefined) {
					// 	postData = {
					// 		isH5:'true',
					// 		pageSize:20,
					// 		start:0,
					// 		modid: 5035,
					// 		beginDate: filterData.stage.startTime,
					// 		endDate: filterData.stage.endTime,
					// 		returnIntShow: 1,
					// 		'filterItems[0].fieldType': 'ft_Str',
					// 		'filterItems[0].id': 4,
					// 		'filterItems[0].index': '',
					// 		'filterItems[0].name': '主题',
					// 		'filterItems[0].operatertitle': '等于',
					// 		'filterItems[0].value': filterData.listItem[0].selected
					// 	}
					// } else if (filterData.listItem[0].selected == undefined) {
					// 	postData = {
					// 		'filterItems[0].fieldType': 'ft_ListStr',
					// 		'filterItems[0].id': 1,
					// 		'filterItems[0].name': '类型',
					// 		'filterItems[0].operatertitle': '等于',
					// 		'filterItems[0].value': filterData.listItem[1].selected.name
					// 	}
					// } else {
					// 	postData = {
					// 		isH5:'true',
					// 		pageSize:20,
					// 		start:0,
					// 		modid: 5035,
					// 		beginDate: filterData.stage.startTime,
					// 		endDate: filterData.stage.endTime,
					// 		returnIntShow: 1,
					// 		'filterItems[0].fieldType': 'ft_ListStr',
					// 		'filterItems[0].id': 1,
					// 		'filterItems[0].name': '类型',
					// 		'filterItems[0].operatertitle': '等于',
					// 		'filterItems[0].value': filterData.listItem[1].selected.name,
					// 		'filterItems[1].fieldType': 'ft_Str',
					// 		'filterItems[1].id': 4,
					// 		'filterItems[1].index': '',
					// 		'filterItems[1].name': '主题',
					// 		'filterItems[1].operatertitle': '等于',
					// 		'filterItems[1].value': filterData.listItem[0].selected
					// 	}
					// }
										
					COMMAND.init({
						url: INTERFACE.index.daily.list.url,
						data: postData,
						method: 'post',
						success:function(ret){
							console.log('过滤: ' + JSON.stringify(ret));
							that.items = that.dealPhoto(ret.resultData.ListData);
						}
					});
				}
			});
			
			//监听点击返回按钮后，清除缓存的过滤数据
			_g.addEventListener({
				name: api.winName + '-closeWin',
				success: function(ret) {
					_g.clearFilterLS(api.frameName)
				}
			});

			_g.topLoading({ // 上拉加载
				success: function(ret) {
					COMMAND.next({
						success: function(ret) {
							console.log('next');
							that.items = that.items.concat(that.dealPhoto(ret.resultData.ListData));
						}
					});
				}
			});

			_g.refresh({ // 下拉刷新
				success: function(ret) {
					COMMAND.refresh({
						success: function(ret) {
							console.log('refresh')
							console.log(JSON.stringify(ret));
							that.items = that.dealPhoto(ret.resultData.ListData);
							console.log(JSON.stringify(that.items));
						}
					});
				}
			});
        }
    });
});