define(function (require, exports, module) {
	var COMMAND = require('command');
	var INTERFACE = require('interface');
	var HTTP = require('http');

	/*移除刷新*/
	var userList = new Vue({
		el: '#userList',
		data: {
			items: [],
			selectedArr: [], //选中的'人名'
			idArr: [], //选中的'人名'对应的id
			selectedStr: '',
			totalItems: 0, //设置总志愿数量,
			selectedItems: [], // 选中的item
			currentshopId:'',
		},
		watch: {
			'selectedArr': function (val, oldVal) {
				this.selectedStr = val.join(',');
			},
			'items': function (val, oldVal) {
				if (val.length == 0) {
					$('#null').removeClass('uhide');
				} else {
					$('#null').addClass('uhide');
				}
			}
		},
		methods: {
			/*勾选职员*/
			select: function (item) {
				var that = this;

				item.selected = !item.selected;
				if (item.selected) {
					that.selectedArr = _.union(that.selectedArr, [item.name]); //添加
					that.idArr = _.union(that.idArr, [item.id]); //添加
					that.selectedItems = _.union(that.selectedItems, [item]);
				} else {

					$.each(that.selectedItems,function(key,value){
						if(value.name == item.name){
							that.selectedArr.splice(key,1); //删除
							that.idArr.splice(key,1); //删除
							that.selectedItems.splice(key,1);
						}
					})
				}
			},
			doShare: function () {
				//判断选择人数组 将选择人数组提交
				api.sendEvent({
					name: 'sharer-select',
					extra: {
						shareName: this.selectedArr,
						shareId: this.idArr,
						shareItem: this.selectedItems
					}
				});
				setTimeout(function () {
					api.closeWin();
				});
			}

		},
		mounted: function () {
			var that = this;
			var _selectedArr = [];
			var _idArr = [];
			that.selectedArr = api.pageParam.sharerNameArr
			that.idArr = api.pageParam.sharerIdArr;
			that.selectedItems = api.pageParam.sharerItems;

			console.log('selectedItems:'+_g.j2s(that.selectedItems))


			COMMAND.init({
				url: INTERFACE.base.url,
				method: 'post',
				data: {
					filter: '1=1',
					isH5: 'true',
					modId: 5034,
					viewname: 'qryEventOperator',
					start: 0
				},
				success: function (ret) {
					$.each(ret.listData, function (key, item) {
						item.selected = false;
						if (that.idArr.length != 0) {
							$.each(that.idArr, function (key, val) {
								if (val == item.id) {
									item.selected = true;
									// that.selectedItems.push(item);
									_selectedArr = _.union(_selectedArr, [item.name]); //添加
									_idArr = _.union(_idArr, [item.id]); //添加
									return;
								}
							});
						}
					});
					that.currentshopId = 0;
					that.selectedStr = api.pageParam.sharerNameArr.join(',');
					that.items = ret.listData;
					console.log('items: ' + JSON.stringify(that.items));
				}
			});
			//在win层点击提交数据按钮响应事件
			_g.addEventListener({
				name: 'getFrameDate',
				success: function (ret) {
					console.log('getFrameDate');
					that.doShare();
				}
			});

			//搜索
			_g.addEventListener({
				name: api.winName + '-search',
				success: function (ret) {
					var keyword = ret.value.keyword;
					var filterStr = 'isclient=0 and M.shopid=' + that.currentshopId + "and (M.opname like '%"+keyword +"%' or M.opcode like '%" +keyword + "%')"
					HTTP.ajax({
						url: INTERFACE.base.url,
						data: {
							filter: filterStr,
							isH5: 'true',
							// modId: 5034,
							start: 0,
							viewName: 'qryEventOperator'
						},
						success: function(ret) {

							$.each(ret.listData, function (key, item) {
								item.selected = false;
								$.each(that.idArr, function (key, val) {
									if (val == item.id) {
										item.selected = true;
										return;
									}
								});
							});
							that.items = ret.listData;
							
						},
						error: function(err) {
							_g.toastMsg({
								msg:err
							})
						}
					});
				}
			});

			//获取单据类型
			_g.addEventListener({
				name: api.winName + '-list-reload',
				success: function (ret) {
					api.sendEvent({
						name: api.winName + '-clear-keyword'
					});
					console.log('what is ret');
					console.log(JSON.stringify(ret));
					that.currentshopId = ret.value.id;
					var filterStr = 'isclient=0 and M.shopid=' + ret.value.id

					COMMAND.init({
						url: INTERFACE.base.url,
						method: 'post',
						data: {
							filter: filterStr,
							isH5: 'true',
							modId: 5034,
							start: 0,
							viewName: 'qryEventOperator'
						},
						success: function (ret) {

							$.each(ret.listData, function (key, item) {
								item.selected = false;
								$.each(that.idArr, function (key, val) {
									if (val == item.id) {
										item.selected = true;
										return;
									}
								});
							});
							that.items = ret.listData;
						}
					});
				}
			});

			// 上拉加载
			_g.topLoading({
				success:function(){
					COMMAND.next({
						success: function(ret){
							$.each(ret.listData, function (key, item) {
								item.selected = false;
								$.each(that.idArr, function (key, val) {
									if (val == item.id) {
										item.selected = true;
										return;
									}
								});
							});
							that.items = _.union(that.items, ret.listData)
						}
					})
				}
			})

		}
	});
});