define(function (require, exports, module) {
	var _C = require('components');
	var HTTP = require('http');
	var INTERFACE = require('interface');

	var vm = new Vue({
		el: '#vm',
		data: {
			isNeedReply: false,
			people: [],
			items: [],
			sharerNameArr: [], // 操作员名称数组
			sharerIdArr: [], // 操作员id数组
			depts: [],
			deleter: [], // 删除的操作员
			showReply:false,	//是否是参与人
			status:true,
			toggleReply:false,	//回复按钮块的显示

			billid:api.pageParam.billid,
			opid:'',
			isDetail:api.pageParam.isDetail,
		},
		methods: {
			toggleIsNeedReply: function() {
				this.isNeedReply = !this.isNeedReply
				console.log(this.isNeedReply);
			},
			selectItem: function(index) {
				var self = this;
				console.log('triggle');
				if (self.people[index].isSelect == undefined) {
					// self.people[index].isSelect = false;
					Vue.set(self.people[index], 'isSelect', false);
				}
				// self.people[index].isSelect = !self.people[index].isSelect;
				var curbool = !self.people[index].isSelect;
				Vue.set(self.people[index], 'isSelect', curbool);
				console.log('show the itmes');
				console.log(JSON.stringify(self.people));
			},
			// 点击 + 号添加员工
			addEmp: function() {
				var self = this;
				_g.openWin({
					name: 'oper',
					url: 'oper',
					pageParam: {
						sharerNameArr: self.sharerNameArr,
						sharerIdArr: self.sharerIdArr,
						sharerItems: self.people,
						depts: self.depts
					}
				});
			},
			// 点击 - 删除员工
			delEmp: function() {
				var self = this;
				console.log('triggle delete employee');
				var peopleTemp = []
				$.each(self.people, function(key, val) {
					if (val.isSelect == true) {
						if (val.a00oldjsonvalue) {
							self.deleter.push(val);
						}
						self.sharerIdArr.splice(key,1);
						self.sharerNameArr.splice(key,1);
					} else {
						peopleTemp.push(val)
					}
				});
				self.people = peopleTemp
			},

			toggle:function(){
				var self = this;
				self.toggleReply = !self.toggleReply;	//隐藏
				api.sendEvent({
					name: 'toggleReplyContent',
					extra: {
						toggleReply :self.toggleReply,
					}
				});
			},

			//回复
			reply:function(status){
				var self = this;

				var itemno = '';
				var index = 0
				$.each(self.people,function(key,value){
					if(value.empid == self.opid){
						itemno = value.itemno
						index = key
					}
				})

				HTTP.ajax({
					url: URLANNEX + '/ncrm/event/eventEdit!saveStatus.action',
					data: {
						billid:self.billid,
						itemno:itemno,
						status:status
					},
					success: function(ret) {
						console.log('reply:'+_g.j2s(ret));
						_g.toastMsg({
							msg:'回复成功'
						})
						if(status == 1){
							self.people[index-1].statusname='已接受'
						}else if(status == 2){
							self.people[index-1].statusname='已拒绝'
						}

						//返回编辑页面
						api.sendEvent({
							name:'schedules-detail-frame-list-reload',
							extra:{
								id:self.billid
							}
						});
						setTimeout(function() { api.closeWin()}, 500);
						
					},
					error: function(err) {
						_g.toastMsg({
							msg:err
						})
					}
				});

				self.toggleReply = false;	//隐藏
			}
		},
		created:function(){
			var self = this;
			self.people = api.pageParam.oper;
			console.log('self.people:'+ _g.j2s(self.people))
			self.isNeedReply = api.pageParam.isneedreply;
			self.opid = _g.getLS('opID');
			// self.opid = 1;

			var isPar = false;
			$.each(self.people,function(key,value){
				if(self.opid == value.empid){
					isPar = true;
				}
			})

			if(isPar && self.isNeedReply == 1){
				self.showReply = true;
			}

			if (self.people.length > 0) {
				_.each(self.people, function(val, key) {
					self.sharerNameArr.push(val.empname);
					self.sharerIdArr.push(val.empid);
					if (val.a00oldjsonvalue) {
						Vue.set(self.people[key], 'name', val.empname);
						Vue.set(self.people[key], 'mobilephone', val.mobile);
						Vue.set(self.people[key], 'homephone', val.phone);
					}
				});
				console.log(JSON.stringify(self.people));
			}
		},
		mounted: function () {
			var self = this;
//			console.log('---------------------')
//			// 提前获取分支机构数据
//			HTTP.ajax({
//				url: INTERFACE.base.url,
//				data: {
//					filter: '1=1',
//					isH5: 'true',
//					modId: 5034,
//					viewname: 'qryEventOperator',
//					start: 0
//				},
//				success: function(ret) {
//					self.depts = ret.listData
//					console.log('self.depts1111:'+_g.j2s(self.depts))
//				},
//				error: function(err) {
//					_g.toastMsg({
//						msg:err
//					})
//				}
//			});

			//返回 操作人的选择结果
			_g.addEventListener({
				name: 'sharer-select',
				success: function(ret) {
					console.log('sharer-select：'+_g.j2s(ret));
					self.sharerNameArr = ret.value.shareName,
					self.sharerIdArr = ret.value.shareId;
					self.people = ret.value.shareItem;

					_.each(ret.value.shareItem, function(val, key) {
						Vue.set(self.people[key], 'statusname', '未回复');
						if(val.id){
							Vue.set(self.people[key], 'empid', val.id);
						}
					});
				}
			});

			_g.addEventListener({
				name: api.winName + '-right',
				success: function(ret) {
					api.sendEvent({
						name: 'return-parti',
						extra: {
							oper: self.people,
							isneedreply: self.isNeedReply == false ? 0 : 1,
							deleter: self.deleter
						}
					});
					_g.closeWin();
				}
			});
		}
	});
});