define(function (require, exports, module) {
	var HTTP = require('http');
	var INTERFACE = require('interface');
	var MODULE = require('modules');
	var TIME = require('time');
  var nDate = TIME.getDates().eDate;

	var vm = new Vue({
		el: '#vm',
		data: {
			iscycle:'',
			startdate: '',
			enddate: '',
			cycletype:'',
			cycletypename:'',
			isremind:'',
			remindtime:'',
			byear:'',
			bmonth:'',
			bday:'',
			cycleType:[],

		},
		methods: {
			selectDate:function(date,type){
				var self = this;

				var selectedDate = date == null ? nDate : date

				api.openPicker({
				    type: 'date',
				    date: selectedDate,
				    title: '选择日期'
				}, function(ret, err) {
				    if (ret) {
				        self.byear = ret.year;
				        self.bmonth = ret.month > 0 && ret.month <= 9 ? '0'+ret.month : ret.month;
				        self.bday = ret.day > 0 && ret.day <= 9 ? '0'+ret.day : ret.day;
				        var date = self.byear+'-'+self.bmonth+'-'+self.bday;
				        if(type == 0){
				        	self.startdate = date;
				        }else{
				        	self.enddate = date;
				        }
				    } else {
				        alert(JSON.stringify(err));
				    }
				});
			},

			toggleIsCycle:function(){
				var self = this;
				self.iscycle = !self.iscycle;
			},

			toggleIsRemind:function(){
				var self = this;
				self.isremind = !self.isremind;
			},

			getCycleType:function(){
				var self = this;
				HTTP.ajax({
					url: INTERFACE.base['qryCycleType'].url,
					methods: 'post',
					data: INTERFACE.base['qryCycleType']['param'],
					success: function(ret){
						_.each(ret.listData, function(val, key){
							val.index = key
							val.value = val.name
							val.sub = [{}]
						})
						self.cycleType = ret.listData
						console.log('cycletype:'+_g.j2s(ret.listData))
					},
					error: function(err){
						_g.hideProgress()
						_g.toastMsg({msg:err.msg})
					}
				})
			},

			selectCycleType:function(){
				var self = this;
				var curActive={index:0 , name:'' , sub:[{}] };

				$.each(self.cycleType,function(key , val){
					if(val.id == self.cycletype){ 
						curActive={index:val.index , name:val.name , sub:[{}] };
						return;
					}
				});

				MODULE.scrollSelect({
					isCitySelect: false,
					data:self.cycleType,
					curActive:curActive,
					nextStep:function(ret){
						if(ret.eventType=='ok'){
							console.log('selectedInfo:'+_g.j2s(ret.selectedInfo[0]));
							self.cycletype = ret.selectedInfo[0].id;
							self.cycletypename = ret.selectedInfo[0].name;
						}
					}
				})
			}
		},
		mounted: function () {
			var self = this;

			self.iscycle = api.pageParam.iscycle;
			self.startdate = api.pageParam.startdate;
			self.enddate = api.pageParam.enddate;
			self.cycletype = api.pageParam.cycletype;
			self.cycletypename = api.pageParam.cycletypename;
			self.isremind = api.pageParam.isremind;
			self.remindtime = api.pageParam.remindtime;
			self.getCycleType();

			_g.addEventListener({
		    name: api.winName + '-right',
		    success:function(ret){
		    	if(self.enddate < self.startdate) { _g.toastMsg({ msg:'结束日期不能小于开始日期'}); _g.hideProgress(); return;}
		    	
		    	api.sendEvent({
						name: 'return-remind-time',
						extra: {
							iscycle : self.iscycle ? 1 : 0,
							startdate : self.startdate,
							enddate : self.enddate,
							cycletype : self.cycletype,
							cycletypename : self.cycletypename,
							isremind : self.isremind ? 1 : 0,
							remindtime : self.remindtime
						}
					})
					setTimeout(function(){ _g.closeWin() }, 300)
		    },
			});



		}
	});
});