define(function (require, exports, module) {

	var COMMAND = require('command');
	var INTERFACE = require('interface');
	var HTTP = require('http');
	var TIME = require('time');
	var stime = TIME.getDates().sDate;
	var etime = TIME.getDates().eDate;


	var list = new Vue({
		el: '#dailylist',
		data: {
			items: [],
			params:{
    	},
    	currentFrame: 'reply'
		},
		methods: {
			ajax:function(){
    		var self = this;
			
				COMMAND.init({
					url: INTERFACE.index.schedule.list.url,
					method: 'post',
					data: $.extend({
						beginDate:stime,	//开始日期
						endDate:etime,		//结束日期
						treetype:1,
						isneedreply:1,
					}, self.params),
					success: function(ret) {
						self.items = ret.resultData.ListData;
					}
				});
    	},
    	openDetail: function(billid) {
    		_g.openWin({
    			name: 'schedules-detail',
    			url: '../Index/schedules-detail',
    			pageParam: {
    				billid: billid,
    				reloadFrame:'reply-schedule',
    			}
    		});
    	},
    	deleteDaily:function(billid){
    		var self = this;
				var params = {
				    msg: '是否删除该日程?',
				    buttons: ['确定', '取消']
				};
				_g.confirm({
					params:params,
					success:function(ret){
						if(ret.buttonIndex==1){
							HTTP.ajax({
			    			url:INTERFACE.index.schedule.delete.url,
			    			data:{
			    				id:billid
			    			},
			    			success:function(ret){
			    				if(ret.errNo==0){
										_g.toastMsg({
											msg:'删除成功!'
										});
										api.sendEvent({
											name:'reply-schedule-list-reload',
											extra:{}
										});

										var eventList = _g.getLS('eventList') || [];
										console.log('eventList:'+_g.j2s(eventList));
										var eventId ='';
										$.each(eventList,function(key,value){
											console.log(key+':'+_g.j2s(value));
											if(value.billid == billid){
												eventId = value.eventId;
												eventList.splice(key,1);
											}
										})

										_g.setLS('eventList',eventList);

										var calendarMemo = api.require('calendarMemo');
								    calendarMemo.removeEvent({
								        eventId: eventId
								    }, function(ret) {
							        if (ret.status) {
							          console.log('删除成功')
							        }
								    });
				    			}else{
				    				_g.toastMsg({
				    					msg:ret.errMsg
				    				});
				    			}
			    			}
			    		});
						}
					}
				});
    	}
		},
		mounted: function () {
			var self = this;

			self.ajax();

			_g.refresh({ // 下拉刷新
				success: function (ret) {
					COMMAND.refresh({
						success: function (ret) {
							self.items = ret.resultData.ListData;
						}
					});
				}
			});

			_g.topLoading({ // 上拉加载
				success: function (ret) {
					COMMAND.next({
						success: function (ret) {
							self.items = self.items.concat(ret.resultData.ListData);
						}
					});
				}
			});

			//监听需要刷新本页面的事件
      _g.addEventListener({
        name:'reply-schedule-list-reload',
        success:function(ret){
        	//刷新
	      	COMMAND.refresh({
	      		success:function(ret){
		      		self.items = ret.resultData.ListData;
						}
					});
        }   	
      });

			_g.addEventListener({ // 搜索
				name: api.winName + '-search',
				success: function (ret) {
					COMMAND.search({
						searchJson: {
							searchKey: ret.value.keyword
						},
						success: function (ret) {
							// self.items.splice(0, self.items.length);
							// $.each(ret.resultData.ListData, function (index, element) {
							// 	// 不需要回复
							// 	if (element.isneedreply == 1) {
							// 		self.items.push(element);
							// 	}
							// });
							self.items = ret.resultData.ListData;
						}
					});
				}
			});

			// 监听添加事件
			_g.addEventListener({
				name: api.winName + '-add',
				success: function(ret) {
					_g.openWin({
						name: 'schedules-detail',
						url: '../Index/schedules-detail',
						pageParam:{
    					reloadFrame:'reply-schedule',
						}
					});
				}
			});

			//监听过滤事件
			var filterData = {
	    	filterName: 'selected-' + api.frameName,
	    	stage: {
					hasStage: true,
					startTime: etime,
					endTime: etime
				},
				listItem:[
				{
					type:'input',title:'主题',selected:'',
				},{
					type:'select-win',title:'创建人',tag: 'operator', selected: {value: '不限'},
				}]
	    };
	    _g.setLS('selected-'+api.frameName, filterData);

	    _g.addEventListener({
				name: api.winName + '-filter',
				success: function(ret) {
					if(self.currentFrame == 'reply') {
						_g.openWin({
							name:'filter',
							url:'../Common/filter',
							pageParam: _g.getLS('selected-'+api.frameName)
						})
					}
				}
			});

			// 监听进行过滤操作
			_g.addEventListener({
				name: 'selected-' + api.frameName + '-filterAction',
				success: function(ret) {
					//获取过滤数据
					var filterData = _g.getLS('selected-'+api.frameName)
					var len = 0;
					self.params={};
		     	_.each(filterData.listItem, function(val, key){
		     		if(!(val.selected.value == '不限' || val.selected.value == '')){
		     			console.log(_g.j2s(val.selected));
			     		switch(val.title){
			     			case '主题':
			     				if(val.selected){
			     					self.params["filterItems["+len+"].fieldType"]='ft_Str';
										self.params["filterItems["+len+"].id"]='2';
										self.params["filterItems["+len+"].index"]='';
										self.params["filterItems["+len+"].name"]='主题';
										self.params["filterItems["+len+"].operatertitle"]='包含';
										self.params["filterItems["+len+"].value"]=val.selected;
										len++;
			     				}
			     			break
		     				case '创建人':
			     				if(val.selected){
			     					self.params["filterItems["+len+"].fieldType"]='ft_ListStr';
										self.params["filterItems["+len+"].id"]='12';
										self.params["filterItems["+len+"].index"]=val.selected.code;
										self.params["filterItems["+len+"].name"]='创建人';
										self.params["filterItems["+len+"].operatertitle"]='等于';
										self.params["filterItems["+len+"].value"]=val.selected.name;
										len++;
			     				}
			     			break
			     			default:
			     			break
			     		}
			     	}
		     	})

		     	var beginDate = filterData.stage.startTime,
		     			endDate = filterData.stage.endTime;
		     	if(beginDate == endDate){
		     		self.params["filterItems["+len+"].fieldType"]='ft_Date';
						self.params["filterItems["+len+"].id"]='4';
						self.params["filterItems["+len+"].index"]='';
						self.params["filterItems["+len+"].name"]='开始时间';
						self.params["filterItems["+len+"].operatertitle"]='等于';
						self.params["filterItems["+len+"].value"]=beginDate;
						len++;
		     	}else{
		     		self.params["filterItems["+len+"].fieldType"]='ft_Date';
						self.params["filterItems["+len+"].id"]='4';
						self.params["filterItems["+len+"].index"]='';
						self.params["filterItems["+len+"].name"]='开始时间';
						self.params["filterItems["+len+"].operatertitle"]='大于等于';
						self.params["filterItems["+len+"].value"]=beginDate;
						len++;
						self.params["filterItems["+len+"].fieldType"]='ft_Date';
						self.params["filterItems["+len+"].id"]='4';
						self.params["filterItems["+len+"].index"]='';
						self.params["filterItems["+len+"].name"]='开始时间';
						self.params["filterItems["+len+"].operatertitle"]='小于等于';
						self.params["filterItems["+len+"].value"]=endDate;
						len++;
		     	}

		     	//self.params.isneedreply = 1;

		     	 console.log('self.params:'+_g.j2s(self.params));
					// 重新获取数据
					self.ajax()
				}
			});

			//监听点击返回按钮后，清除缓存的过滤数据
			_g.addEventListener({
				name: api.winName + '-closeWin',
				success: function(ret) {
					_g.clearFilterLS(api.frameName)
				}
			})

			// 监听tab选中当前哪个frame
			_g.addEventListener({
				name: 'schedules-currentFrame',
				success: function(ret) {
					self.currentFrame = ret.value.frameName
				}
			})
		}
	});
});