define(function (require, exports, module) {

	var _C = require("components");
	var COMMAND = require('command');
	var INTERFACE = require('interface');
	var HTTP = require('http');
	var QQ = require('qq');
	var wx = require('wx');
	var TIME = require('time');
	var nDate = TIME.getDates().eDate;

	var addFrame = new Vue({
		el: '#addFrame',
		data: {
			schedule: {
				//				name: '', // 主题
				//				address: '', // 地点
				isallday: false, // 是否全天安排
				//				startdate: '', // 开始日期时间
				//				enddate: '', // 结束日期时间
				//				isneedreply: 0, // 是否需要回复
				//				isremind: 0, // 是否需要提醒
				referbilltypename: '', // 业务类型 名称
				referbilltype: '', // 业务类型 id
				referbillcode: '', // 相关业务 code
				referbillid: '', // 相关业务 id
				remark: '',
				startdate:'',
				enddate:'',
			},
			// cyclestartdate: '',
			// cycleenddate: '',
			oper: [],
			master: {},
			isDetail: api.pageParam.billid ? 'true' : false,
			deleter: [],
			hasSaved:api.pageParam.billid ? 'true' : false, 
			billId:'',
			eventList:[],	//日程事件列表

			allDayStartDate:'',
			allDayEndDate:'',
			winSelectd: {
				'业务选择': {
				}, 
			},
			curwinSelected: '',
			winselectParams: {  //new
				'业务选择': {
					title: '业务选择',
					tag: 'billType'
				}
			}
		},
		methods: {
			openParti: function () {
				var self = this;
				_g.openWin({
					name: 'participants',
					url: 'participants',
					pageParam: {
						oper: self.oper,
						isneedreply: self.schedule.isneedreply == 0 ? false : true,
						billid:self.schedule.billid,
						isDetail:self.isDetail
					}
				});
			},
			openRemind: function () {
				var self = this;
				_g.openWin({
					name: 'remind',
					url: 'remind',
					pageParam: {
						startdate: self.schedule.cyclestartdate,
						enddate: self.schedule.cycleenddate,
						iscycle: self.schedule.iscycle == 0 ? false : true,
						cycletype:self.schedule.cycletype,
						cycletypename:self.schedule.cycletypename,
						isremind: self.schedule.isremind == 0 ? false : true,
						remindtime: self.schedule.remindtime,
					}
				});
			},
			toggleIsAllDay: function () {
				var self = this;
				self.schedule.isallday = !self.schedule.isallday;
				if(self.schedule.isallday){
					self.schedule.startdate = self.schedule.startdate.split(' ')[0]
					self.allDayStartDate = self.schedule.startdate + ' 00:00:00';
					self.schedule.enddate = self.schedule.enddate.split(' ')[0];
					self.allDayEndDate = self.schedule.enddate + ' 23:59:59';
				}else{
					self.schedule.startdate = self.schedule.startdate + ' 00:00:00';
					self.schedule.enddate = self.schedule.enddate + ' 00:00:00';
				}
			},
			timePicker: function (picker, state) {
				var self = this;
				$(picker).datetimePicker({
					title: '时间',
					times: function () {
						return [{
							values: (function () {
								var hours = [];
								for (var i = 0; i < 24; i++) hours.push(i > 9 ? i : '0' + i);
								return hours;
							})()
						},
						{
							divider: true, // 这是一个分隔符
							content: ':'
						},
						{
							values: (function () {
								var minutes = [];
								for (var i = 0; i < 60; i++) minutes.push(i > 9 ? i : '0' + i);
								return minutes;
							})()
						},
						{
							divider: true, // 这是一个分隔符
							content: ':'
						},
						{
							values: (function () {
								var seconds = [];
								for (var i = 0; i < 60; i++) seconds.push(i > 9 ? i : '0' + i);
								return seconds;
							})()
						}];
					},
					onChange: function (picker, values, displayValues) {
						var value = values[0] + '-' + values[1] + '-' + values[2] + ' ' + values[3] + ':' + values[4] + ':' + values[5];
						console.log(value);
						if (state == 'start') {
							self.schedule.startdate = value;
							console.log('start date: ' + self.schedule.startdate);
						} else {
							self.schedule.enddate = value;
							console.log('end date: ' + self.schedule.enddate);
						}
					}
				});
			},
			openTapGetDate:function(type){
				var self = this
				_g.openPicker({
					date: nDate,
					success: function(ret){
						// self.bill.master.billdate =  ret.year + '-' + ret.month + '-' + ret.day
						if(type == 'start'){
							self.schedule.startdate = ret.year + '-' + ret.month + '-' + ret.day;
							self.allDayStartDate = ret.year + '-' + ret.month + '-' + ret.day+ ' 00:00:00';
						}else{
							self.schedule.enddate = ret.year + '-' + ret.month + '-' + ret.day;
							self.allDayEndDate = ret.year + '-' + ret.month + '-' + ret.day+ ' 23:59:59';
						}
						
					}
				})
			},
			openWin: function (win, winName, data) {
				var self = this;
		
				_g.openWin({
					name: winName,
					url: '../' + win + '/' + winName,
					pageParam: data
				});
			},
			winSelect: function(title){
				var self = this
				self.curwinSelected = title
				var item = self.winselectParams[title]
				var params = {
					title: item.title,
					tag: item.tag,
					frameName: api.frameName,
					showName: INTERFACE.base[item.tag]['showName'],
					hasSearch: INTERFACE.base[item.tag]['param']['likeValue'] == undefined ? false : true
				}
				_g.openWin({
					name:'list-select',
					url:'../Common/list-select',
					pageParam: params
				})
			},
			//选择单据
			selectBill:function(billType){
				var self = this;
				
				if (self.schedule.referbilltypename == '') {
					_g.toastMsg({
						msg: '请先选择业务类型'
					});
					return;
				}

				_g.openWin({
					name: 'choose-bill',
					url: 'choose-bill',
					pageParam:{
						billType:billType
					}
				});
			},

			save: function (billid) {
				var self = this;
				var postData = {};
				postData['detail1Count'] = 0;
				postData['deletedDetail1Count'] = 0;
				if (self.oper.length > 0) {
					postData['detail1Count'] = self.oper.length;
					for (var i = 0; i < self.oper.length; i++) {
						postData['detail1[' + i + '].billid'] = self.oper[i].billid || -9999;
						postData['detail1[' + i + '].itemno'] = self.oper[i].itemno || -1;
						postData['detail1[' + i + '].status'] = 0; //
						postData['detail1[' + i + '].empid'] = self.oper[i].empid;
						postData['detail1[' + i + '].a00OldJsonValue'] = self.oper[i].a00OldJsonValue || '';
						postData['detail1[' + i + '].empname'] = self.oper[i].name;
						postData['detail1[' + i + '].departmentname'] = self.oper[i].departmentname;
						postData['detail1[' + i + '].phone'] = self.oper[i].homephone;
						postData['detail1[' + i + '].mobile'] = self.oper[i].mobilephone;
						postData['detail1[' + i + '].statusname'] = self.oper[i].statusname;
					}
				}
				if (self.deleter.length > 0) {
					postData['deletedDetail1Count'] = self.deleter.length;
					for (var i = 0; i < self.deleter.length; i++) {
						postData['deletedDetail1[' + i + '].billid'] = self.deleter[i].billid;
						postData['deletedDetail1[' + i + '].itemno'] = self.deleter[i].itemno;
						postData['deletedDetail1[' + i + '].status'] = self.deleter[i].status;
						postData['deletedDetail1[' + i + '].a00oldvaluejson'] = self.deleter[i].a00OldJsonValue;
						postData['deletedDetail1[' + i + '].empname'] = self.deleter[i].empname;
						postData['deletedDetail1[' + i + '].departmentname'] = self.deleter[i].departmentname;
						postData['deletedDetail1[' + i + '].phone'] = self.deleter[i].phone;
						postData['deletedDetail1[' + i + '].mobile'] = self.deleter[i].mobile;
						postData['deletedDetail1[' + i + '].statusname'] = self.deleter[i].statusname;
					}
				}
				
				postData['addnewFlag'] = self.isDetail ? 'false' : 'true';
				postData['master.a00OldJsonValue'] = self.schedule.a00OldJsonValue || '';
				// postData['master.accsetid'] = 0;
				postData['master.code'] = self.schedule.code == null ? '' : self.schedule.code;
				postData['master.address'] = self.schedule.address == null ? '' : self.schedule.address;
				postData['master.billcode'] = self.schedule.billcode == null ? '' : self.schedule.billcode; //ok
				postData['master.billdate'] = self.schedule.billdate; // ok
				postData['master.billid'] = billid || -9999;
				postData['master.billkind'] = self.schedule.billkind
				postData['master.cycleenddate'] = self.schedule.cycleenddate == null ? '' : self.schedule.cycleenddate;
				postData['master.cyclestartdate'] = self.schedule.cyclestartdate == null ? '' : self.schedule.cyclestartdate;
				// 没有类型的不传
				postData['master.cycletype'] = self.schedule.cycletype == null ? '' : self.schedule.cycletype;
				postData['master.cycletypename'] = self.schedule.cycletypename == null ? '' : self.schedule.cycletypename;
				//				postData['master.cyclevalue'] = '';
				//				postData['master.editdate'] = '';
				//				postData['master.editname'] = '';
				//				postData['master.editid'] = '';
				postData['master.enddate'] = self.schedule.enddate;
				//				postData['master.fullreferbillname'] = ''; same as above
				//				postData['master.id'] = '';
				postData['master.isallday'] = self.schedule.isallday == false ? 0 : 1;
				postData['master.iscycle'] = self.schedule.iscycle || 0;
				postData['master.isneedreply'] = self.schedule.isneedreply;
				postData['master.isremind'] = self.schedule.isremind;
				postData['master.name'] = self.schedule.name;
				postData['master.opdate'] = self.schedule.opdate;
				postData['master.opid'] = self.schedule.opid;
				//				postData['master.opname'] = self.master.opname;
				postData['master.referbillcode'] = self.schedule.referbillcode;
				postData['master.referbillid'] = self.schedule.referbillid;
				//				postData['master.referbillname'] = self.master.referbillname || '';
				postData['master.referbilltype'] = self.schedule.referbilltype;
				//				postData['master.referbilltypename'] = self.schedule.referbilltypename;
				postData['master.remark'] = self.schedule.remark == null ? '' : self.schedule.remark;
				postData['master.isneedreply'] = self.schedule.isneedreply;
				postData['master.remindtime'] = self.schedule.remindtime || '';
				//				postData['shopid'] = '';
				postData['master.startdate'] = self.schedule.startdate;




				if(!self.schedule.name){ _g.hideProgress(); _g.toastMsg({msg:'主题不能为空'}); return;}
				if(!self.schedule.code){ _g.hideProgress(); _g.toastMsg({msg:'编码不能为空'}); return;}
				if(!self.schedule.startdate || self.schedule.startdate == null){ _g.hideProgress(); _g.toastMsg({msg:'开始时间不能为空'}); return;}
				if(!self.schedule.enddate || self.schedule.enddate == null){ _g.hideProgress(); _g.toastMsg({msg:'结束时间不能为空'}); return;}
				if(self.schedule.enddate < self.schedule.startdate) { _g.hideProgress(); _g.toastMsg({msg:'结束时间不能小于开始时间'}); return;}

				HTTP.ajax({
					url: INTERFACE.index.schedule.save.url,
					data: postData,
					success: function (ret) {
						if(ret.errNo == 0){
							console.log('after save');
							console.log(JSON.stringify(ret));
							self.hasSaved = true;
							
							var billid = ret.billId;
							
							// 设置提醒
							var calendarMemo = api.require('calendarMemo');
							var params = {
								title: self.schedule.name,
								description: self.schedule.remark,
								startTime: self.schedule.isallday ? self.allDayStartDate : self.schedule.startdate,
								endTime: self.schedule.isallday ? self.allDayEndDate : self.schedule.enddate
							}

							if(!self.isDetail){
								calendarMemo.addEvent(params, function (ret) {
									if (ret) {
										_g.hideProgress()
										_g.toastMsg({
											msg: '保存成功'
										});

										var event = {};
										event['eventId'] = ret.eventId;
										event['billid'] = billid;
										console.log('event:'+_g.j2s(event));
										self.eventList.push(event);
										_g.setLS('eventList',self.eventList);
									}
								});
							}else{
								var eventId ='';
								$.each(self.eventList,function(key,value){
									console.log(key+':'+_g.j2s(value));
									if(value.billid == self.schedule.billid){
										eventId = value.eventId;
									}
								})

								var param = $.extend(params,{eventId:eventId})
								console.log('edit param:'+_g.j2s(param));
								_g.toastMsg({
									msg: '保存成功'
								});
								calendarMemo.updateEvent(param, function(ret){
									console.log('ret:'+_g.j2s(ret))
					        if(ret.status){
					        	_g.hideProgress()
//										_g.toastMsg({
//											msg: '保存成功'
//										});
					        	console.log('更新成功')
					        }
						    });
							}

							api.sendEvent({
								name:api.pageParam.reloadFrame+'-list-reload',
								extra:{}
							});
							setTimeout(function() { api.closeWin()}, 500);
						}
					}
				});

			},

			share:function(textJson,target){
				var that = this;
				wx.shareToWx({
					textJson: textJson,
					type: target,
					success: function (ret) {
						_g.toastMsg({
							msg: '分享成功'
						});
					},
					error: function (err) {
						_g.toastMsg({
							msg: '分享失败'
						});
					}
				});
			},
			ajax:function(url,param){
				var self = this;

				COMMAND.init({
					url: url,
					data: param,
					method: 'post',
					success: function (ret) {
						self.oper = ret.detail1;
						console.log('opers: ' + JSON.stringify(self.oper));
						_.each(ret.master, function (val, key) {
							if (key.indexOf('user') == -1) {
								self.master[key] = val;
							}
						});
						_.each(self.master, function (val, key) {
							if (val != null) {
								self.schedule[key] = val;
							}
						});
						console.log(JSON.stringify(self.schedule));
						if (self.schedule.isallday == 0) {
							self.schedule.isallday = false;
						} else {
							self.schedule.isallday = true;
						}

						if (!api.pageParam.billid) {	//新增时
							var myDate = new Date();
							var hour = myDate.getHours() > 9 ? myDate.getHours() : '0' + myDate.getHours();
							var minutes = myDate.getMinutes() > 9 ? myDate.getMinutes() : '0' + myDate.getMinutes();
							var seconds = myDate.getSeconds() > 9 ? myDate.getSeconds() : '0' + myDate.getSeconds();
							self.schedule.startdate = nDate + ' ' + hour + ':' + minutes +':'+ seconds;
							self.schedule.enddate = nDate + ' 23:59:59';
						}
						console.log(JSON.stringify(self.schedule));
						console.log(JSON.stringify(self.schedule.isallday));
					},
					error: function (err) {
						_g.toastMsg({
							msg: err.errMsg
						});
					}
				});
			}
		},
		mounted: function () {
			var self = this;

			self.eventList = _g.getLS('eventList') || [];
			console.log('eventList:'+_g.j2s(_g.getLS('eventList')));

			var url;
			var param = {};
			if (api.pageParam.billid) {
				url = INTERFACE.index.schedule.edit.url;
				self.billId = api.pageParam.billid
				param = {
					'id': self.billId
				};
				console.log(JSON.stringify(param));
			} else {
				url = INTERFACE.index.schedule.add.url;
			}
			
			self.ajax(url,param);

			// save
			_g.addEventListener({
				name: api.winName + '-right',
				success: function (ret) {
					_g.showLoading();
					console.log(self.billId);
					self.save(self.billId);
				}
			});

			// get remind-time
			_g.addEventListener({
				name: 'return-remind-time',
				success: function (ret) {
					self.schedule.iscycle = ret.value.iscycle;
					self.schedule.cyclestartdate = ret.value.startdate,
					self.schedule.cycleenddate = ret.value.enddate
					self.schedule.cycletype = ret.value.cycletype;
					self.schedule.cycletypename = ret.value.cycletypename;
					self.schedule.isremind = ret.value.isremind;
					self.schedule.remindtime = ret.value.remindtime;
				}
			});

			//get oper
			_g.addEventListener({
				name: 'return-parti',
				success: function (ret) {
					console.log('show the oper');
					console.log(JSON.stringify(ret));
					self.oper = ret.value.oper.length == 0 ? self.oper : ret.value.oper;
					self.schedule.isneedreply = ret.value.isneedreply;
					self.deleter = ret.value.deleter;
					console.log(JSON.stringify(self.deleter));
				}
			});

			// 获取win-select的选中数据
			_g.addEventListener({
				name: api.frameName + '-get-winselected',
				success: function (ret) {
					if (ret.value.tag == 'billType') {
						if (ret.value.selectedData.length > 0) {
							var pre = self.schedule.referbilltypename;
							var current = ret.value.selectedData[0].showName;
							self.schedule.referbilltypename = ret.value.selectedData[0].showName;
							self.schedule.referbilltype = ret.value.selectedData[0].id;
							if (pre != current) {
								self.schedule.referbillcode = '';
								self.schedule.referbillid = 0;
							}
						} else {
							self.schedule.referbilltypename = '';
							self.schedule.referbilltype = 0;
						}
					} else if (ret.value.tag == 'bill') {
						if (ret.value.selectedData.length > 0) {
							self.schedule.referbillcode = ret.value.selectedData[0].showName;
							self.schedule.referbillid = ret.value.selectedData[0].id;
						} else {
							self.schedule.referbillcode = '';
							self.schedule.referbillid = 0;
						}
					}
				}
			})

			//相关业务的 选择单据
			_g.addEventListener({
				name: 'choose-bill-return',
				success: function(ret) {
					self.schedule.referbillcode = ret.value.referbillcode;
					self.schedule.referbillid =  ret.value.referbillid;
				}
			});

			// 监听btn-layer-click 分享
			_g.addEventListener({
				name: api.winName + '-btns-layer-click',
				success: function (ret) {
					if(!self.hasSaved){
						_g.toastMsg({
							msg:'请先保存！'
						})
						return;
					}else{
						console.log('self.oper:'+_g.j2s(self.oper));
						var participants = '';
						$.each(self.oper,function(key,value){
							console.log(value.empname)
							var name = value.empname+' ';
							participants += name;
						})

						switch (ret.value.index) {
							case 1:
								var textJson = {
									title: '',
									content: {}
								};

								console.log(participants)
								textJson.title = '日程安排';
								textJson['content']['主题'] = self.schedule.name == null ? '' : self.schedule.name;
								textJson['content']['地点'] = self.schedule.address == null ? '' : self.schedule.address;
								textJson['content']['全天安排'] = self.schedule.isallday == 0 ? '否' :'是';
								textJson['content']['开始时间'] = self.schedule.startdate == null ? '' : self.schedule.startdate;
								textJson['content']['结束时间'] = self.schedule.enddate == null ? '' : self.schedule.enddate;
								textJson['content']['业务选择'] = self.schedule.referbilltypename == null ? '' : self.schedule.referbilltypename;
								textJson['content']['相关业务'] = self.schedule.referbillcode == null ? '' : self.schedule.referbillcode;
							  textJson['content']['参与人员'] = participants;

								QQ.shareText({
									textJson: textJson,
									success: function (ret) {
										_g.toastMsg({
											msg: '分享成功'
										});
									},
									error: function (err) {
										_g.toastMsg({
											msg: err.msg
										});
									}
								});
								break;
							case 0:
								api.actionSheet({
									title: '请选择分享方式',
									cancelTitle: '取消分享',
									buttons: ['分享到朋友圈', '分享给微信好友']
								}, function (ret, err) {
									var index = ret.buttonIndex;
									var target = '';
									if (index == 1) {
										target = 'wxTimeline';
									} else if(index == 2){
										target = 'wxSession';
									}else{
										return;
									}
									var textJson = {
										'事项': '日程安排',
										'主题': self.schedule.name == null ? '' : self.schedule.name,
										'地点': self.schedule.address == null ? '' : self.schedule.address,
										'全天安排': self.schedule.isallday == 0 ? '否' :'是',
										'开始时间': self.schedule.startdate == null ? '' : self.schedule.startdate,
										'结束时间': self.schedule.enddate == null ? '' : self.schedule.enddate,
										'业务选择': self.schedule.referbilltypename == null ? '' : self.schedule.referbilltypename,
										'相关业务': self.schedule.referbillcode == null ? '' : self.schedule.referbillcode,
									  '参与人员': participants
									}
									self.share(textJson,target);
								});
								break;
						}
					}
					
				}
			});

			//参与人回复后刷新编辑页面
			_g.addEventListener({
				name:'schedules-detail-frame-list-reload',
				success:function(ret){
					var url = INTERFACE.index.schedule.edit.url;
					var param = {
						'id': ret.value.id
					};

					self.ajax(url,param);
				}
			})
		}
	});
});