define(function (require, exports, module) {
	var _C = require("components");
	var wx = require('wx');
	var http = require('http');
	var TIME = require('time');
	var MAPS = require('maps');
	var INTERFACE = require('interface');
	var COMMAND = require('command');
	var RECORD = require('record');
	var STORAGE = require('storage');
	var photoBrowser = require('photoBrowser');
	var MODULES = require('modules');
	var FILE = require('file');

	//加载富文本编辑器
	var content = new Vue({
		el: '#content',
		data: {
			sign: {
				a00oldjsonvalue: '',
				attencedate: '',
				address: '',
				clientname:'',	//客户名称
				clientid: '',	//客户id
				id: '',  //签到id
				lat: '',	//地址纬度
				lng: '',	//地址经度
				opcode: '',
				opid: '',
				opname: '',
				remark: '',	//备注
			},
			recordUrl: [],	//录音地址
			annex:[],
			repeatSign:false,   //是否重复签到
			backupMaster:{},
			mode:api.pageParam.mode,   //模块：新增add,查看edit
			isEdit:false
		},
		components: {
			'record': _C.getRecord(),
//	    'chatbox': _C.getChatBox({
//	    	content:'',
//	    	placeholder:'请输入100字内的备注'
//	    })
		},
		methods: {
			openMap:function(){
				var self=this
				_g.openWin({
					name: 'map',
					url: 'map',
					pageParam: { lat: self.sign.lat, lng: self.sign.lng}
				})
				// _basic.openModuleWin('Index', 'map',{lon:self.sign.lng,lat:self.sign.lat});
			},
			winSelect:function(key){
				var self = this
				var params = {
					title: '客户',
					tag: 'trader',
					frameName: api.frameName,
					showName: INTERFACE.base['trader']['showName'],
					hasSearch: INTERFACE.base['trader']['param']['likeValue'] == undefined ? false : true,
					extraParams: {modId: 5036}
				}
				if(self.isEdit){
					_g.openWin({
						name:'list-select',
						url:'../Common/list-select',
						pageParam: params
					})
				}
				
			},
			//内容处理为带表情的内容
			dealTohtml:function(str,callback){
				var content = str == null ? '' : str;
				var emojiArr = content.match(/(?:\[)([^\[\]]*)(?:\])/g);
				if(Array.isArray(emojiArr) && emojiArr.length>0){
					$.ajax({ 
		        url: '../../res/img/emotion/emotion.json', 
		        type: 'get',
		        dataType: 'json',
		        success: function(ret){
		        	var data = ret;
	            for(var i=0; i<data.length; i++){
                for(var j=0; j<emojiArr.length; j++){
                  if(data[i].text == emojiArr[j]){
                  	content = content.replace(emojiArr[j], '<img src="../../res/img/emotion/'+ret[i].name+'.png">');
                  }
                }
	            }
	            callback(content);
		        }
			    });
				}
			},
			openAnnex:function(key){
				var self=this;
				if(self.annex.length != 0){
					// 打开附件
					var paramJson = {
						readOnly:true,
						isDetail: true,// 单据是否为详情情况
						isSign: true,
						dataJson: self.annex
					}
					_g.openWin({
						name: 'annex',
						url: '../Annex/annex',
						pageParam: {
							paramJson: paramJson
						}
					})
				}
				
			},
			sortMaster: function (master) {
        var key = '';
        var json_data = {};
        for (var x in master) {
            key = 'master.' + x;
            json_data[key] = master[x];
            if (json_data[key] == null) {
              delete json_data[key];
            }
        }
        return json_data;
		  },
		  addAjax: function(){
		  	// 新增签到
		  	var self = this
		  	_g.showLoading({})
				http.ajax({
					url: INTERFACE.index.outwork.add.url,
					data: INTERFACE.index.outwork.add.param,
					success:function(ret){
						//errNo为0时，操作成功
						_g.hideProgress()
						self.sign.attencedate = ret.master.attencedate
						self.sign.opcode = ret.master.opcode
						self.sign.opid = ret.master.opid
						self.sign.opname = ret.master.opname
					},
					other:function(ret){
						_g.hideProgress()
					},
					err:function(err){
						_g.hideProgress()
						_g.toastMsg({msg: err.msg})
					}
				})
		  },
		  detailAjax: function(id){
		  	// 查看签到详情
		  	var self = this
		  	_g.showLoading({})
				http.ajax({
					url: INTERFACE.index.outwork.detail.url,
					data: $.extend(INTERFACE.index.outwork.detail.param, {id: id}),
					success:function(ret){
						//errNo为0时，操作成功
						_g.hideProgress()
						self.sign.a00oldjsonvalue = ret.master.a00oldjsonvalue
						self.sign.attencedate = ret.master.attencedate
						self.sign.address = ret.master.address
						self.sign.clientname = ret.master.clientname
						self.sign.id = ret.master.id
						self.sign.lat = ret.master.lat
						self.sign.lng = ret.master.lng
						self.sign.remark = ret.master.remark
						self.annex = ret.data.attData //附件数据
					},
					other:function(ret){
						_g.hideProgress()
					},
					err:function(err){
						_g.hideProgress()
						_g.toastMsg({msg: err.msg})
					}
				})
		  },
		  uploadAnnex: function(annex, id){
		  	$.each(annex,function(index,val){
		  		var kind = 1  //声音
		  		if(val.voiceTime == undefined){
		  			kind = 0 //图片
		  		}
					setTimeout(function(){
						http.ajax({
							url: INTERFACE.annex.upload.url,
							data: {
								'fileFileName':val.saveName,
								'id': id,
								'modId':5036 ,
								'kind': kind,
								'voiceTime':val.voiceTime || 0,
							},
							files:{
								file: val.savePath
							},
							success:function(ret){
								//errNo为0时，操作成功
								//3.判断是否为最后一条上传成功了，是则提示签到成功
								if(annex.length == index+1){
									_g.hideProgress();
									_g.toastMsg({msg: '签到成功'});
									 if(api.pageParam.from == 'home'){
									 	_g.openWin({
									 		name: 'track',
									 		url: 'track',
									 		from: 'sign'
									 	})
									 }else{
									 	api.sendEvent({
									 		name:'track-reload',
									 	});
									 }
									self.repeatSign=true;
								}
							},
							other:function(ret){
								_g.toastMsg({msg: val.saveName + ret.errMsg})
							},
							err:function(err){
								_g.hideProgress()
								_g.toastMsg({msg: err.msg})
							}
						})
					},1600);
				});
		  },
		  saveAjax: function(){
		  	var self = this
		  	var postData={};
				postData['addnewFlag'] = 'true'
				postData['isH5'] = 'true'
				postData['master.address'] = self.sign.address
				postData['master.attencedate'] = self.sign.attencedate
				postData['master.clientid'] = self.sign.clientid
				postData['master.clientname'] = self.sign.clientname.trim(' ')
				postData['master.id'] = self.sign.id
				postData['master.lat'] = self.sign.lat;
				postData['master.lng'] = self.sign.lng;
				postData['master.opcode']=_g.getLS('operatorCode');
				postData['master.opid']=_g.getLS('opID');
				postData['master.opname']=_g.getLS('opName');
				postData['master.remark']=self.sign.remark; //备注
				_g.showLoading({msg:'正在保存'})
				http.ajax({
					url: INTERFACE.index.outwork.save.url,
					data: $.extend(INTERFACE.index.outwork.save.param, postData),
					success:function(ret){
						//errNo为0时，操作成功
						_g.hideProgress()
						//附件保存
						//1.照片和录音的路径合并,放在annex里
						var annex=_.union(self.recordUrl , uploadImg.selectImgs)
						if(annex.length != 0) {
							self.uploadAnnex(annex, ret.billId)
						} else {
							_g.hideProgress();
							_g.toastMsg({msg: '签到成功'}); 
							//无附件情况下
							if(api.pageParam.from == 'home'){
								//新增进入
								_g.openWin({
									name: 'track',
									url: 'track',
									from: 'sign'
								})
							}else{
								//查看进入
								api.sendEvent({
									name:'track-reload'
								});
							}
						}
					},
					other:function(ret){
						_g.hideProgress()
						_g.toastMsg({msg: ret.errMsg})
					},
					err:function(err){
						_g.hideProgress()
						_g.toastMsg({msg: err.msg})
					}
				})
		  }
		},
		created: function(){
			var self = this
			self.isEdit = self.mode == 'add' ? true : false 
			if(self.isEdit){
				_g.showLoading({msg: '正在定位'})
				MAPS.getLocation({
					success:function(ret){
						self.sign.lat = ret.lat
						self.sign.lng = ret.lon
						MAPS.getAddress({
							lon: ret.lon,
							lat: ret.lat,
							success: function(ret){
								_g.hideProgress()
								self.sign.address = ret.address
								self.addAjax()
							},
							error: function(err){
								_g.hideProgress()
								_g.toastMsg({msg: '定位失败'})
							}
						})
					}
				})
			} else {
				self.detailAjax(api.pageParam.billId)
			}
		},
		mounted: function(){
			var self = this;
			//提交（只有新增才有保存操作，查看详情只能查看，不能编辑）
			_g.addEventListener({
				name: api.winName + '-save',
				success: function(ret) {
					if(self.repeatSign){
						_g.toastMsg('不可重复签到');
						return;
					}
					self.saveAjax()
				}
			});
			
			// 获取录音数据
			_g.addEventListener({
				name: api.winName + '-get-record',
				success: function(ret) {
					self.recordUrl = ret.value.rec;
				}
			});
			//获取win-select的选中数据
			_g.addEventListener({
				name: api.frameName + '-get-winselected',
				success: function(ret) {
					if (ret.value.selectedData.length != 0) {
						self.sign.clientname = ret.value.selectedData[0]['showName']
						self.sign.clientid = ret.value.selectedData[0]['clientid']
					} else {
						self.sign.clientname = ''
						self.sign.clientid = 0
					}
				}
			})
		}
	})
	var uploadImg = new Vue({
		el: '#uploadImg',
		template: _g.getTemplate('Index/uploadImg-v'),
		data: {
			'broswerImgs':[],	//照片浏览器要查看的照片数组，只存路径，格式为数组
			'selectImgs':[]		//选择好的图片
		},
		methods: {
			//上传图片
			updatePic: function(){
				var self = this;
				_g.openButtons({
			    cancelTitle: '取消',
			    buttons: ['相册', '拍照']
				}, function(ret, err) {
					var index = ret.buttonIndex;
				    switch(index){
				    	case 1:
				    		MODULES.apiPicture({
				    			sourceType: 'library',
				    			success: function(ret) {
				    				if (ret.data != '') {
				    					var picName= FILE.getFullNameByPath(ret.data);
					    				var picType= FILE.getTypeByPath(ret.data);
					    				var index=uploadImg.selectImgs.length;
					    				uploadImg.broswerImgs.push(ret.data);
					    				uploadImg.selectImgs.push( {savePath:ret.data , saveName:picName , 'hasUploadPic':true} );
				    				}
				    			}
				    		});
				    		break;
				    	case 2:
				    		MODULES.apiPicture({
				    			sourceType: 'camera',
				    			success: function(ret) {
				    				if(ret.data!=''){
					    				var picName=FILE.getFullNameByPath(ret.data);
					    				var index=uploadImg.selectImgs.length;
					    				uploadImg.broswerImgs.push(ret.data);
					    				uploadImg.selectImgs.push( {savePath:ret.data , saveName:picName ,'hasUploadPic':true} );
					    			}
				    			}
				    		})
				    		break;
				    }
				});
			},
			detailPic: function(index){
				//查看图片
				_g.toastMsg({
					msg: '请长按或点击屏幕，退出图片浏览',
					duration: 800,
					location: 'middle'
				});
				setTimeout(function(){
					photoBrowser.open({
						imgs: uploadImg.broswerImgs,
						success: function(ret) {
							if (ret.eventType == 'longPress' || ret.eventType == 'click') {
								photoBrowser.close();
							}
						},
						error: function(err) {
							console.log('fucking error');
						}
					})
				},1000);
			},
			delUpdatePic: function(img){
				//删除图片
				var self=this;
				var params = {
					title: '',
				    msg: '是否删除该照片?',
				    buttons: ['确定', '取消']
				};
				_g.confirm({
					params: params,
					success: function(ret) {
						if (ret.buttonIndex == 1) {
							self.selectImgs = _.without(self.selectImgs, img);
							self.browserImgs = _.without(self.browserImgs, img.savepath);
						}
					}
				});
			},
		}
	});
})	
