define(function (require, exports, module) {
	var http = require('http');
	var MAPS = require('maps');
	var INTERFACE = require('interface');
	var COMMAND = require('command');
	var TIME = require('time')
	var stime = TIME.getDates().sDate
	var etime = TIME.getDates().eDate
	var lists=new Vue({
		el:"#dataContainer",
		data:{
			listData:[],
			params:{
				beginDate: stime,
				endDate: etime,
				isTrajectory: 'true',
				selectempcode: ''  //员工id
			},
			lng: '',
			lat: ''
	
		},
		methods:{
			ajax: function(){
				var self = this
				var params = $.extend(INTERFACE.index.outwork.list.param, self.params)
				COMMAND.init({
					url: INTERFACE.index.outwork.list.url,
					data: params,
					success:function(ret){
						self.listData = ret.resultData.ListData
						api.sendEvent({
             name:api.winName+'-points-change',
             extra:{
             	center: {'lng': self.lng, 'lat': self.lat},
             	points: self.listData,
             	mode: 'init'
             }
            });
					}
				})
			},
			openwin: function(item){
				_g.openWin({
					name: 'sign',
					url: 'sign',
					pageParam: {
						mode:'edit',
						from:'track',
						billId:item.id
					}
				});
			}
		},
		created: function(){
			var self = this
			_g.showLoading({msg: '正在定位'})
			MAPS.getLocation({
				success:function(ret){
					self.lat = ret.lat
					self.lng = ret.lon
					self.ajax()
				}
			})
			
		},
		mounted: function(){
			var self = this
			// 上拉加载
			_g.topLoading({
				success:function(){
					COMMAND.next({
						success: function(ret){
						self.listData = _.union(self.listData, ret.resultData.ListData)
						api.sendEvent({
             name:api.winName+'-points-change',
             extra:{
             	center: {'lng': self.lng, 'lat': self.lat},
             	points: ret.resultData.ListData,
             	mode: 'more'
             }
            });
						}
					})
				}
			})
			// 下拉刷新
			_g.refresh({
				success:function(){
					COMMAND.refresh({
						success: function(ret) {
							self.listData = ret.resultData.ListData
							api.sendEvent({
	             name:api.winName+'-points-change',
	             extra:{
	             	center: {'lng': self.lng, 'lat': self.lat},
	             	points: self.listData,
	             	mode: 'init'
	             }
	            });
						}
					})
				}
			})
			// 过滤
  		if(!_g.getLS('selected-'+api.frameName)) {
  			// 刚进入列表
  			var filterData = {
  				filterName: 'selected-' + api.frameName,
					stage: {
						hasStage: true,
						startTime: stime,
						endTime: etime
					},
					listItem:[{
						type:'select-win', title:'员工', tag: 'workers', selected: {value: '不限'}
					}]
				}
				_g.setLS('selected-'+api.frameName, filterData)
  		}
  		// 监听点击了过滤按钮
  		_g.addEventListener({
				name: api.winName + '-filter',
				success: function(ret) {
					// 打开过滤页面
					_g.openWin({
						name:'filter',
						url:'../Common/filter',
						pageParam: _g.getLS('selected-'+api.frameName)
					})
				}
			})
			// 监听进行过滤操作
			_g.addEventListener({
				name: 'selected-' + api.frameName + '-filterAction',
				success: function(ret) {
					//获取过滤数据
					var filterData = _g.getLS('selected-'+api.frameName)
		      self.params.beginDate = filterData.stage.startTime
		      self.params.endDate = filterData.stage.endTime
		      if (filterData.listItem.length != 0) {
						_.each(filterData.listItem, function(val, key){
			     		switch(val.title){
			     			case '员工':
			     				self.params.selectempcode = val.selected.code || ''
			     			break
			     			default:
			     			break
			     		}
			     	})
		      }
					
		     	// 重新获取数据
					self.ajax()
				}
			})
			//监听点击返回按钮后，清除缓存的过滤数据
			_g.addEventListener({
				name: api.winName + '-closeWin',
				success: function(ret) {
					_g.clearFilterLS(api.frameName)
				}
			})
			//添加按钮
			_g.addEventListener({
				name: api.winName + '-add',
				success: function(ret) {
					_g.openWin({
						name: 'sign',
						url: 'sign',
						pageParam: {
							mode:'add',
							from:'track'
						}
					});
				}
			})
		}
	});
	
});
