define(function (require, exports, module) {
	FusionCharts.ready(function(){//按数量
		var fusioncharts;
		//设置图表配置
		var chartConfiguration = {
     		"decimals": "2",  //小数点位数，0则对小数点部分进行四舍五入
			"formatNumberScale":"0", //数据是否自动转换为k/m格式
			"bgcolor": "FFFFFF",
      		"bgalpha": "0",
      		"showborder": "0",
		      "caption": "",
		      "subcaption": "",
		      "numberprefix": "",
		      "issliced": "1",
		      "streamlineddata": "0",
		      "ishollow": "0",
		      "chartrightmargin": "",
		      "baseFontSize":'12',
			"showValues":'0' //不显示值
    };
		var COMMAND = require('command');
		var INTERFACE = require('interface');
		var TIME = require('time')
		var stime = TIME.getDates().sDate
		var etime = TIME.getDates().eDate
		var content = new Vue({
			el: '#amountFunnel',
			data: {
				listData: [],
				params: {},
				currentFrame: 'by-amount'
			},
			methods: {
				sortData:function(items , callback){
					var self=this;
					var allZero=0;
					var showLen=items.length;
					//判断数据是否都为0
					var sortItem=[];
					console.log('sum'+JSON.stringify(items));
					$.each(items , function(key , val){
            if(!(val.name == '失败机会' || val.name == '无效机会' || val.name == '合  计')){
            	val.label=val.name+','+Math.floor(val.qty),
           	 	val.value=val.qty,
            	val._val=val.qty;
              sortItem.push(val);
							if(val.qty == 0){
								allZero++;
							}
            }else{
            	showLen=showLen-1;
            }
					})
					//数据都为0时，要进行处理，把图表渲染出来
					if(allZero == showLen){
						console.log('hello~~~~');
						var $val=String(100/allZero*100)+"%";
						$.each(sortItem , function(key , val){
							val.value=$val;
						});
					}
					callback(sortItem);
				},
	      renderFunel: function(data){
	        var self=this;
			    fusioncharts = new FusionCharts({
				    type: 'funnel',			//图表类型
				    renderAt: 'amountFunnel',  //绑定DOM对象
				    width: '100%',
				    height: '100%',
				    dataFormat: 'json',
				    dataSource: {
			        "chart": chartConfiguration,
			        "data": data
				    },
				    events:{
				    	"dataUpdated": function (evtObj, argObj) {
			      	}
				    }
					});
			    fusioncharts.render();
        },
	      updateFunel: function(data){
	        var self=this;
		    	fusioncharts.setJSONData({
		    		chart: chartConfiguration,
		    		data: data
		    	});
	      },
	      ajax: function(){
					var self = this
					COMMAND.init({
						url: INTERFACE.report.url,
						data: $.extend(INTERFACE.report.funnel.param.amount, self.params),
						hideProgress: true,
						success:function(ret){
							if(ret.errNo == 1){
								_g.toastMsg({
									msg:ret.errMsg
								})
							}else if(ret.errNo == 0){
								self.listData = ret.resultData.ReportData
								if(!_.isEmpty(ret.resultData.ReportData)){
		              self.sortData(ret.resultData.ReportData , function(data){
		              	self.renderFunel(data);
		              })
		            }
							}
						}
					})
				}
			},
			created: function() {
				var self = this
				self.ajax()
			},
			mounted: function() {
				var self = this
				// 过滤
		  		if(!_g.getLS('selected-'+api.frameName)) {
		  			// 刚进入列表
		  			var filterData = {
		  				isReportOrProvider: true,
		  				filterName: 'selected-' + api.frameName,
							stage: {
								hasStage: true,
								startTime: stime,
								endTime: etime
							},
							listItem:[]
						}
						_g.setLS('selected-'+api.frameName, filterData)
		  		}
				_g.addEventListener({
					name: api.winName + '-filter',
					success: function(ret) {
						// 打开过滤页面
						if(self.currentFrame == 'by-amount') {
							_g.openWin({
								name:'filter',
								url:'../Common/filter',
								pageParam: _g.getLS('selected-'+api.frameName)
							})
						}
					}
				})
				// 监听进行过滤操作
				_g.addEventListener({
					name: 'selected-' + api.frameName + '-filterAction',
					success: function(ret) {
						//获取过滤数据
						var filterData = _g.getLS('selected-'+api.frameName)
						self.params.startdate = filterData.stage.startTime
			      self.params.enddate = filterData.stage.endTime
			     	_.each(filterData.listItem, function(val, key){
			     		switch(val.title){
			     			case '客户':
			     				self.params.clientid = val.selected.clientid || 0
			     			break
			     			default:
			     			break
			     		}
			     	})
						// 重新获取数据
						self.ajax()
					}
				})
				//监听点击返回按钮后，清除缓存的过滤数据
				_g.addEventListener({
					name: api.winName + '-closeWin',
					success: function(ret) {
						_g.clearFilterLS(api.frameName)
					}
				})
				// 监听tab选中当前哪个frame
				_g.addEventListener({
					name: api.winName + '-change-tab',
					success: function(ret) {
						if (ret.value.index == 1) {
							self.currentFrame = 'by-amount'
						} else {
							self.currentFrame = 'by-sum'
						}
					}
				})
			}
		});
	});
});
