define(function (require, exports, module) {
	var HTTP = require('http');
	var BLE = require('ble/blePrinter');
	var COMMAND = require('command');
	var INTERFACE = require('interface');
	var TIME = require('time')
	var stime = TIME.getDates().sDate
	var etime = TIME.getDates().eDate
	var content = new Vue({
		el: '#content',
		data: {
			listData: [],
			startamtSum: 0.00, // 期初总计
			endamtSum: 0.00, //期末总计
			inamtSum: 0.00, //收入总计
			outamtSum: 0.00, //支出总计
			params: {
				beginDate: stime,
				endDate: etime,
				shopid: _g.getLS('shopID')

			},
			money: []
		},
		methods: {
			ajax: function(){
				var self = this
				console.log(JSON.stringify(self.params))
				console.log(JSON.stringify($.extend(INTERFACE.report.cashBank.param, self.params)))
				COMMAND.init({
					url: INTERFACE.report.cashBank.url,
					data: $.extend(INTERFACE.report.cashBank.param, self.params),
					method:'post',
					hideProgress: true,
					success:function(ret){
						self.listData = [];
						if (ret.resultData.ReportData) {
							_.each(ret.resultData.ReportData, function(val, key){
								if (val.rtype == 99) {
									self.startamtSum = val.startamt;
									self.endamtSum = val.endamt;
									self.inamtSum = val.inamt;
									self.outamtSum = val.outamt;
								}else{
									self.listData.push(val)
								}
							})
							if (ret.resultData.ReportData.length == 0) {
								self.endamtSum = self.startamtSum = 0.00;
								self.outamtSum = self.inamtSum = 0.00;
							}
						}
					}
				})
			}
		},
		created: function() {
			var self = this
			self.ajax()
			// self.getMoney() //币种暂时不过滤
		},
		mounted: function() {
			var self = this

			if(!_g.getLS('selected-'+api.frameName)) {
	  			// 刚进入列表
	  			var listItem = [];
	  			//仅总部操作员(shopid=0)提供分支机构过滤
	  			if(_g.getLS('shopID') == 0){
	  				listItem.push({
						type:'select-win', 
						title:'分支机构', 
						tag: 'shop', 
						selected: {value: '不限'}
					})
	  			}
	  			var filterData = {
	  				filterName: 'selected-' + api.frameName,
						stage: {
							hasStage: true,
							startTime: stime,
							endTime: etime
						},
						listItem: listItem
					}
					_g.setLS('selected-'+api.frameName, filterData)
	  		}
			_g.addEventListener({
				name: api.winName + '-filter',
				success: function(ret) {
					// 打开过滤页面
					_g.openWin({
						name:'filter',
						url:'../Common/filter',
						pageParam: _g.getLS('selected-' + api.frameName)
					})
				}
			})

			// 监听进行过滤操作
			_g.addEventListener({
				name: 'selected-' + api.frameName + '-filterAction',
				success: function(ret) {
					//获取过滤数据
					var filterData = _g.getLS('selected-'+api.frameName)
					self.params.beginDate = filterData.stage.startTime
		      		self.params.endDate = filterData.stage.endTime
		      		console.log(JSON.stringify(filterData))
			     	_.each(filterData.listItem, function(val, key){
			     		switch(val.title){
			     			case '分支机构':
			     				if (val.selected.value != '不限') {
			     					Vue.set(self.params, 'shopid', val.selected.shopid)
				     			}
			     			break
			     			default:
			     			break
			     		}
			     	})
					// 重新获取数据
					self.ajax()
				}
			})
			//监听点击返回按钮后，清除缓存的过滤数据
			_g.addEventListener({
				name: api.winName + '-closeWin',
				success: function(ret) {
					_g.clearFilterLS(api.frameName)
				}
			})


			//蓝牙打印
			_g.addEventListener({
				name: api.winName + '-print',
				success: function(ret) {
					var printData = {}
					var content = []
					// _.each(self.listData, function(val, key){
					// 	content.push({title: val.name, value: val.qty + '次'})
					// })

					_.each(self.listData, function(val, key){
						content.push({value: val.clientname, big: true})
						content.push({title: '单据编号', value: val.billcode})
						content.push({title: '单据日期', value: val.billdate})
						content.push({title: '金额', value: val.goodsamt})
						content.push({title: '收货', value: val.saledamt})
//						content.push({title: '付款', value: val.finishedamt})
					})

					printData.content = content

					BLE.setData({
						data:printData.content
					});
					BLE.printEvent();
				}
			})
		}
	});
});
