define(function (require, exports, module) {
	
	var BLE = require('ble/blePrinter');
	var COMMAND = require('command');
	var INTERFACE = require('interface');
	var TIME = require('time')
	var stime = TIME.getDates().sDate
	var etime = TIME.getDates().eDate
	var content = new Vue({
		el: '#content',
		data: {
			listData:[],
			params: {
				startdate: stime,
				enddate: etime,
				clientid: 0,
				billtype: 0
			},
			filterDate:'',
			filterClient:'',	
			filterBill:'',
		},
		methods: {
			ajax: function(){
				var self = this
				var param = {}
				param.startdate = self.params.startdate
				param.enddate  = self.params.enddate 
				param.pageSize = 1000
				self.filterDate = self.params.startdate + ' - ' + self.params.enddate;

				if(self.params.clientid != 0){
					param.clientid = self.params.clientid
				}
				if(self.params.billtype != 0){
					param.billtype = self.params.billtype
				}
				COMMAND.init({
					url: INTERFACE.report.url,
					data: $.extend(INTERFACE.report.clientFlow.param, param),
					method:'post',
					hideProgress: true,
					success:function(ret){
						console.log('client-flow:'+_g.j2s(ret));
						self.listData = ret.resultData.ReportData
					}
				})
			}
		},
		created: function() {
			var self = this
			if(_g.getLS('selected-'+api.frameName)) {
				var filterData = _g.getLS('selected-'+api.frameName)
				console.log('filterData:'+_g.j2s(filterData))
				self.params.startdate = filterData.stage.startTime
				self.params.enddate = filterData.stage.endTime

				console.log('clientname:'+ filterData.listItem[0]['selected']['name'])

				self.params.clientid = filterData.listItem[0]['selected']['clientid']
				self.filterClient = filterData.listItem[0]['selected']['name']
				self.params.billtype = filterData.listItem[1]['selected']['id']
				self.filterBill = filterData.listItem[1]['selected']['title']
				self.ajax()
			}
			// self.ajax()
		},
		mounted: function() {
			var self = this

			// 过滤
			_g.addEventListener({
				name: api.winName + '-filter',
				success: function(ret) {
					// 打开过滤页面
					_g.openWin({
						name:'filter',
						url:'../Common/filter',
						pageParam: _g.getLS('selected-'+api.frameName)
					})
				}
			})
			_g.closeWin({
				name: 'filter-win'
			})
			

			//监听点击返回按钮后，清除缓存的过滤数据
			_g.addEventListener({
				name: api.winName + '-closeWin',
				success: function(ret) {
					_g.clearFilterLS(api.frameName)
				}
			})

			//蓝牙打印
			// _g.addEventListener({
			// 	name: api.winName + '-print',
			// 	success: function(ret) {
			// 		var printData = {}
			// 		var content = []
			// 		_.each(self.listData, function(val, key){
			// 			content.push({title: val.name, value: val.qty + '次'})
			// 		})
			// 		printData.content = content
			// 	}
			// })
			// 
			_g.addEventListener({
				name: api.winName + '-print',
				success: function(ret) {
					var printData = {}
					var content = []
					content.push({value: self.curClientName, bold: true})
					_.each(self.listData, function(val, key){
						// content.push({value: val.clientname, big: true})
						content.push({title: '单据日期', value: val.billdate})
						content.push({title: '单号', value: val.billcode})
						content.push({title: '客户名称', value: val.name})
						content.push({title: '单据类型', value: val.typename})
						content.push({title: '金额', value: '¥' + val.amount})
						// content.push({title: '制单', value: '¥' + val.finishedamt})
					})
					// content.push({value: '期初：' + self.start + '   期末：' + self.end, bold: true})
					// content.push({value: '应收：' + self.get + '   收款：' + self.pay, bold: true})
					printData.content = content

					BLE.setData({
						data:printData.content
					});
					BLE.printEvent();
				}
			})

		}
	});
});
