define(function (require, exports, module) {
	var HTTP = require('http');
	var BLE = require('ble/blePrinter');
	var _C = require('components');
	var COMMAND = require('command');
	var INTERFACE = require('interface');
	var TIME = require('time')
	var stime = TIME.getDates().sDate
	var etime = TIME.getDates().eDate

	var content = new Vue({
		el: '#content',
		components: {
		    dropdownlayer: _C.getDropDownLayer({
		    	height: api.frameHeight + 10
		    }),
		},
		data: {
			listData: [],
			storelist: [], //仓库列表数据
			params: {
				beginDate: _g.getLS('CURRACCYEAR'),
				endDate: _g.getLS('CURRACCMONTH')
			},
			money: []
		},
		methods: {
			ajax: function(){
				var self = this
				COMMAND.init({
					url: INTERFACE.report.curStock.url,
					data: $.extend({}, INTERFACE.report.curStock.param, self.params),
					method:'post',
					hideProgress: true,
					success:function(ret){
						self.listData = [];
						_.each(ret.resultData.ReportData, function(val, key){
							if (val.rtype == 77) {
								self.listData.push(val)
							}
						})
					}
				})
			}
		},
		created: function() {
			var self = this
			self.ajax();
			//获取仓库列表
			COMMAND.init({
				url: INTERFACE.base.url,
				data: $.extend({pageSize: 10000}, INTERFACE.base.store.param),
				method:'post',
				hideProgress: true,
				success:function(ret){
					_.each(ret.listData, function(val, key){
						val.active = false
						self.storelist.push(val)
					})
					if (_g.getLS('shopID') == 0) { //总部操作员时才有“全部仓库”选择
						self.storelist.unshift({name: '全部仓库', storeid: 0, active: false})
					}
				}
			})

			// self.getMoney() //币种暂时不过滤
		},
		watch: {
			'params': function(newVal){
				var self = this
				self.ajax()
			}
		},
		mounted: function() {
			var self = this
			_g.addEventListener({
			    name: api.winName + '-search',
			    success: function(ret) {
					self.params = $.extend({}, {
						beginDate: _g.getLS('CURRACCYEAR'),
						endDate: _g.getLS('CURRACCMONTH')
					}, {
						'filterItemRelation': '全部或者',
						'filterItems[0].displayvalue': ret.value.keyword,
						'filterItems[0].fieldid': 150030,
						'filterItems[0].fieldlabel': '货品名称',
						'filterItems[0].fieldtype': 'ft_ListSt',
						'filterItems[0].itemno': 0,
						'filterItems[0].operate': '包含',
						'filterItems[0].realvalue': ret.value.keyword,
						'filterItems[1].displayvalue': ret.value.keyword,
						'filterItems[1].fieldid': 150020,
						'filterItems[1].fieldlabel': '货品编码',
						'filterItems[1].fieldtype': 'ft_Str',
						'filterItems[1].itemno': 1,
						'filterItems[1].operate': '包含',
						'filterItems[1].realvalue': ret.value.keyword 
					});
			    }
			})
			_g.addEventListener({
			    name: api.winName + '-当前库存-drop-down-layer-selected',
			    success: function(ret) {
			    	_.each(self.storelist, function(val, key){
     					if (val.storeid == ret.value.selected.storeid) {
     						//设置选中
     						val.active = true;
     						self.params = $.extend({}, self.params, {'storeid': val.storeid});
     					} else{
     						val.active = false
     					}
     					Vue.set(self.storelist, key, val);
     				})
			    }
			})

			// _g.addEventListener({
			// 	name: api.winName + '-filter',
			// 	success: function(ret) {
			// 		// 过滤
		 //  		if(!_g.getLS('selected-'+api.frameName)) {
		 //  			// 刚进入列表
		  			
		 //  			var filterData = {
		 //  				filterName: 'selected-' + api.frameName,
			// 				stage: {
			// 					hasStage: false
			// 				},
			// 				listItem: []
			// 			}
			// 			_g.setLS('selected-'+api.frameName, filterData)
		 //  		}
			// 		// 打开过滤页面
			// 		_g.openWin({
			// 			name:'filter',
			// 			url:'../Common/filter',
			// 			pageParam: _g.getLS('selected-' + api.frameName)
			// 		})
			// 	}
			// })

			// 监听进行过滤操作
			// _g.addEventListener({
			// 	name: 'selected-' + api.frameName + '-filterAction',
			// 	success: function(ret) {
			// 		//搜索框的内容清空
			//         api.sendEvent({
			//             name: api.winName + '-search-clear',
			//         })
			//         //获取过滤数据
			// 		var filterData = _g.getLS('selected-'+api.frameName)
			// 		self.params.beginDate = filterData.stage.startTime
		 //      		self.params.endDate = filterData.stage.endTime
		 //      		self.params.sdate = filterData.stage.startTime
		 //      		self.params.edate = filterData.stage.endTime
			//      	self.params.searchKey = "";
			// 		// 重新获取数据
			// 		self.ajax()
			// 	}
			// })
			//监听点击返回按钮后，清除缓存的过滤数据
			_g.addEventListener({
				name: api.winName + '-closeWin',
				success: function(ret) {
					_g.clearFilterLS(api.frameName)
				}
			})


			//蓝牙打印
			_g.addEventListener({
				name: api.winName + '-print',
				success: function(ret) {
					var printData = {}
					var content = []
					// _.each(self.listData, function(val, key){
					// 	content.push({title: val.name, value: val.qty + '次'})
					// })

					_.each(self.listData, function(val, key){
						content.push({value: val.clientname, big: true})
						content.push({title: '单据编号', value: val.billcode})
						content.push({title: '单据日期', value: val.billdate})
						content.push({title: '金额', value: val.goodsamt})
						content.push({title: '收货', value: val.saledamt})
						//content.push({title: '付款', value: val.finishedamt})
					})

					printData.content = content

					BLE.setData({
						data:printData.content
					});
					BLE.printEvent();
				}
			})
		}
	});
});
