define(function (require, exports, module) {
		//应收账款对账单frame
	var BLE = require('ble/blePrinter');
	var COMMAND = require('command');
	var INTERFACE = require('interface');
	var TIME = require('time')
	var stime = TIME.getDates().sDate
	var etime = TIME.getDates().eDate
	var content = new Vue({
		el: '#content',
		data: {
			listData:[],
			params: {
				startdate: stime,
				enddate: etime,
				filter: '1=1',
				clientid: '',
				cmbMoney: 0
			},
			curClientIndex: 0,
			curClientName: '',
			start: 0, // 期初
			end: 0, //期末
			get: 0, //应收
			pay: 0 //收款
		},
		methods: {
			ajax: function(){
				var self = this
				var param = {}
				param.startdate = self.params.startdate
				param.enddate  = self.params.enddate 
				param.pageSize  = 10000
				if(self.params.clientid != 0){
					param.clientid = self.params.clientid
				}
				//alert(_g.j2s($.extend(INTERFACE.report.getCredit.param, param)))
				COMMAND.init({
					url: INTERFACE.report.url,
					data: $.extend(INTERFACE.report.getCredit.param, param),
					hideProgress: true,
					success:function(ret){
						if(ret.errNo == 1){
							_g.toastMsg({
								msg:ret.errMsg
							})
						}else if(ret.errNo == 0){
							self.sortData(ret.resultData.ReportData)
						}
					}
				})
			},
			previous: function(){
				var self = this
				if(self.curClientIndex == 0){
					_g.toastMsg({ msg: '已是第一个客户'})
				} else {
					self.curClientIndex = self.curClientIndex - 1
					self.changeIndex()
				}
			},
			next: function(){
				var self = this
				var filterData = _g.getLS('selected-'+api.frameName)
				if(filterData.listItem[0]['selected'].length-1 == self.curClientIndex){
					_g.toastMsg({ msg: '已是最后一个客户'})
				} else {
					self.curClientIndex = self.curClientIndex + 1
					self.changeIndex()
				}
			},
			sortData: function(ReportData) {
				var self = this
				self.listData = [];
				_.each(ReportData, function(value, key){
					switch(value.invoiceid){
						case '':
							if(value.rtype == '20'){
								self.start = value.endamt || 0// 期初
							}
							if(value.rtype == '88'){
								self.end = value.endamt || 0// 期末
								self.get = value.amt || 0// 应收
								self.pay = value.ramt || 0// 收款
							}
						break;
						default:
							if( value.type == '应收款' || value.type == '预收款'){
								value.amt = value.ramt;
								value.onlyback = true;
							}
							self.listData.push(value)  //其他都是列表项
						break;
					}
				})
				//self.pay = (1*self.start + 1*self.get - 1*self.end).toFixed(2) //收款
				console.log('get:' +self.start + ',,' + self.get + ',,' + self.end)
			},
			changeIndex: function(){
				var self = this
				console.log(_g.j2s(_g.getLS('selected-'+api.frameName)))
				if(_g.getLS('selected-'+api.frameName)) {
					var filterData = _g.getLS('selected-'+api.frameName)
					self.params.startdate = filterData.stage.startTime
					self.params.enddate = filterData.stage.endTime
					self.params.clientid = filterData.listItem[0]['selected'][self.curClientIndex]['clientid']
					self.curClientName = filterData.listItem[0]['selected'][self.curClientIndex]['showName']
					self.ajax()
				}
			}
		},
		created: function() {
			var self = this
			self.changeIndex()
		},
		mounted: function() {
			var self = this
			_g.addEventListener({
				name: api.winName + '-filter',
				success: function(ret) {
					// 打开过滤页面
					_g.openWin({
						name:'filter',
						url:'../Common/filter',
						pageParam: _g.getLS('selected-'+api.frameName)
					})
				}
			})
			_g.closeWin({
				name: 'filter-win'
			})
			//监听点击返回按钮后，清除缓存的过滤数据
			_g.addEventListener({
				name: api.winName + '-closeWin',
				success: function(ret) {
					_g.clearFilterLS(api.frameName)
				}
			})
				//蓝牙打印
			_g.addEventListener({
				name: api.winName + '-print',
				success: function(ret) {
					var printData = {}
					var content = []
					content.push({value: self.curClientName, bold: true, align: 'c'})
					_.each(self.listData, function(val, key){
						content.push({title: '单据日期', value: val.billdate})
						content.push({title: '收款金额', value: val.receamt})
						content.push({value: val.typename + val.billcode})
					})
					content.push({value: '期初：' + self.start + '   期末：' + self.end, bold: true})
					content.push({value: '应收：' + self.get + '   收款：' + self.pay, bold: true})
					printData.content = content

					BLE.setData({
						data:printData.content
					});
					BLE.printEvent();
				}
			})
		}
	});
});
