define(function (require, exports, module) {
	var BLE = require('ble/blePrinter');
	var HTTP = require('http');
	var COMMAND = require('command');
	var INTERFACE = require('interface');
	var TIME = require('time')
	var stime = TIME.getDates().sDate
	var etime = TIME.getDates().eDate
	var content = new Vue({
		el: '#content',
		data: {
			listData: [],
			params: {
				startdate: stime,
				enddate: etime,
				clientid: '',
				// cmbMoney:''
			},
			money: []
		},
		methods: {
			ajax: function(){
				var self = this
				var param = {}
				param.startdate = self.params.startdate
				param.enddate  = self.params.enddate 
				param.pageSize = 10000
				if(self.params.clientid != 0){
					param.clientid = self.params.clientid
				}
				// if(self.params.cmbMoney != ''){
				// 	param.cmbMoney = self.params.cmbMoney
				// }

				COMMAND.init({
					url: INTERFACE.report.url,
					data: $.extend(INTERFACE.report.orderExecution.param, param),
					method:'post',
					hideProgress: true,
					success:function(ret){
						self.listData = ret.resultData.ReportData
						
					}
				})
			},
			// getMoney: function(){
			// 	var self = this
			// 	_g.showLoading({msg: '正在加载'})
			// 	HTTP.ajax({
			// 		url: INTERFACE.base.url,
			// 		data: INTERFACE.base.reportMoney.param,
			// 		method: 'post',
			// 		success: function(ret){
			// 			_g.hideProgress()
			// 			_.each(ret.listData, function(val, key){
			// 				console.log(key+':'+_g.j2s(val));
			// 				if(val.name == '人民币(本位币)'){
			// 					val.name = '人民币'
			// 				}
			// 				val.showName = val.name
			// 				val.selectedIndex = key
			// 				val.value = val.name
			// 				self.money.push(val)
			// 			})
			// 		},
			// 		error: function(err){
			// 			_g.hideProgress()
			// 			_g.toastMsg({msg: err.Msg})
			// 		}
			// 	})
			// }
		},
		created: function() {
			var self = this
			self.ajax()
			self.getMoney()
		},
		mounted: function() {
			var self = this
			// 过滤
  		_g.addEventListener({
				name: api.winName + '-filter',
				success: function(ret) {
					// 过滤
		  		if(!_g.getLS('selected-'+api.frameName)) {
		  			// 刚进入列表
		  			var filterData = {
		  				isReportOrProvider: true,
		  				filterName: 'selected-' + api.frameName,
							stage: {
								hasStage: true,
								startTime: stime,
								endTime: etime
							},
							listItem : [{
								type:'select-win', title:'供应商', tag: 'postProvider', selected: {value: '不限'}
							}]
						}
						_g.setLS('selected-'+api.frameName, filterData)
		  		}
					// 打开过滤页面
					_g.openWin({
						name:'filter',
						url:'../Common/filter',
						pageParam: _g.getLS('selected-' + api.frameName)
					})
				}
			})

			// 监听进行过滤操作
			_g.addEventListener({
				name: 'selected-' + api.frameName + '-filterAction',
				success: function(ret) {
					//获取过滤数据
					var filterData = _g.getLS('selected-'+api.frameName)
					self.params.startdate = filterData.stage.startTime
		      self.params.enddate = filterData.stage.endTime
		     	_.each(filterData.listItem, function(val, key){
		     		switch(val.title){
		     			case '供应商':
		     				self.params.clientid = Number(val.selected.id) || 0
		     			break
		     			default:
		     			break
		     		}
		     	})
					// 重新获取数据
					self.ajax()
				}
			})
			//监听点击返回按钮后，清除缓存的过滤数据
			_g.addEventListener({
				name: api.winName + '-closeWin',
				success: function(ret) {
					_g.clearFilterLS(api.frameName)
				}
			})


			//蓝牙打印
			_g.addEventListener({
				name: api.winName + '-print',
				success: function(ret) {
					var printData = {}
					var content = []
					// _.each(self.listData, function(val, key){
					// 	content.push({title: val.name, value: val.qty + '次'})
					// })

					_.each(self.listData, function(val, key){
						content.push({value: val.clientname, big: true})
						content.push({title: '单据编号', value: val.billcode})
						content.push({title: '单据日期', value: val.billdate})
						content.push({title: '金额', value: '¥' + val.goodsamt})
						content.push({title: '发货', value: '¥' + val.saledamt})
						content.push({title: '收款', value: '¥' + val.finishedamt})
					})

					printData.content = content

					BLE.setData({
						data:printData.content
					});
					BLE.printEvent();
				}
			})
		}
	});
});
