define(function (require, exports, module) {

	var BLE = require('ble/blePrinter');
	var HTTP = require('http');
	var COMMAND = require('command');
	var INTERFACE = require('interface');
	var TIME = require('time')
	var stime = TIME.getDates().sDate
	var etime = TIME.getDates().eDate
	var content = new Vue({
		el: '#content',
		data: {
			items:[],
			params:{
				startdate: stime,
				enddate: etime,
				goodsid:'',
				pageSize:10000
			}
		},
		methods: {
			ajax:function(){
				var self = this;

				if(self.params.goodsid == 0){
					self.params.goodsid = '';
				}
				COMMAND.init({
					url: INTERFACE.report.url,
					data: $.extend(INTERFACE.report.price.param, self.params),
					method:'post',
					hideProgress: true,
					success:function(ret){
						self.items = [];
						console.log('price:'+_g.j2s(ret))
						$.each(ret.resultData.ReportData,function(key,value){
							if(value.id != ''){
								self.items.push(value);
							}
						})
					}
				})
			}
		},
		created: function() {
			var self = this;
			self.ajax();
		},
		mounted: function() {
			var self = this;

			_g.rmLS('selected-'+api.frameName)
			// 过滤
  			_g.addEventListener({
				name: api.winName + '-filter',
				success: function(ret) {
					// 过滤
		  		if(!_g.getLS('selected-'+api.frameName)) {
		  			// 刚进入列表
		  			var filterData = {
		  				isReportOrProvider: true,
		  				filterName: 'selected-' + api.frameName,
							stage: {
								hasStage: true,
								startTime: stime,
								endTime: etime
							},
							listItem : [{
								type:'select-win', title:'商品', tag: 'goods', selected: {value: '不限'}
							}]
						}
						_g.setLS('selected-'+api.frameName, filterData)
		  		}
					// 打开过滤页面
					_g.openWin({
						name:'filter',
						url:'../Common/filter',
						pageParam: _g.getLS('selected-' + api.frameName)
					})
				}
			})


			// 监听进行过滤操作
			_g.addEventListener({
				name: 'selected-' + api.frameName + '-filterAction',
				success: function(ret) {
					// 清除关键字
		     	api.sendEvent({
						name: api.winName + '-search-clear',
					})
					self.params.searchkey = ''
					//获取过滤数据
					var filterData = _g.getLS('selected-'+api.frameName)
					self.params.startdate = filterData.stage.startTime
		      self.params.enddate = filterData.stage.endTime
		     	_.each(filterData.listItem, function(val, key){
	     			switch(val.title){
		     			case '商品':
		     				self.params.goodsid = Number(val.selected.goodsid) || 0
		     			break
		     			default:
		     			break
		     		}
		     		
		     	})
		     	
					// 重新获取数据
					self.ajax()
				}
			})

			//监听点击返回按钮后，清除缓存的过滤数据
			_g.addEventListener({
				name: api.winName + '-closeWin',
				success: function(ret) {
					_g.clearFilterLS(api.frameName)
				}
			})

			//蓝牙打印
			_g.addEventListener({
				name: api.winName + '-print',
				success: function(ret) {
					var printData = {}
					var content = []
					_.each(self.items, function(val, key){
						content.push({value: val.code + ' ' + val.name, bold: true})
						content.push({value: '最低价：' + val.lowprice + '  平均价：' + val.avegprice + '  最高价：' + val.highprice})
					})

					printData.content = content

					BLE.setData({
						data:printData.content
					});
					BLE.printEvent();
				}
			})

		}
	});
});
