define(function (require, exports, module) {
	var BLE = require('ble/blePrinter');
	var COMMAND = require('command');
	var INTERFACE = require('interface');
	var TIME = require('time')
	var stime = TIME.getDates().sDate
	var etime = TIME.getDates().eDate
	var content = new Vue({
		el: '#content',
		data: {
			listData:[],
			params: {
				startdate: stime,
				enddate: etime,
				storeID: 0, // 仓库ID
				goodsTypeID: 0, // 货品类别
				goodsid: 0, //货品
				pageSize: 9999,
			},
			showFilterName: []
		},
		methods: {
			ajax: function(){
				var self = this
				var param = {}
				param.startdate = self.params.startdate
				param.enddate  = self.params.enddate 
				param.pageSize  = 10000
				if(self.params.storeID != 0){
					param.storeID = self.params.storeID
				}
				if(self.params.goodsTypeID != 0){
					param.goodsTypeID = self.params.goodsTypeID
				}
				if(self.params.goodsid != 0){
					param.goodsid = self.params.goodsid
				}
				COMMAND.init({
					url: INTERFACE.report.url,
					data: $.extend(INTERFACE.report.productAmount.param, param),
					hideProgress: true,
					success:function(ret){
						if(ret.errNo == 1){
							_g.toastMsg({
								msg:ret.errMsg
							})
						}else if(ret.errNo == 0){
							var index = _.findLastIndex(ret.resultData.ReportData, {
							  name: '合计'
							})
							_.each(ret.resultData.ReportData,function(value,key){
								value.endqty = (+value.startqty)+(+value.inqty)-(+value.outqty);
							})
							self.listData = _.without(ret.resultData.ReportData, ret.resultData.ReportData[index]);
						}
					}
				})
			}
		},
		created: function() {
			var self = this
			self.ajax()

		},
		mounted: function() {
			var self = this
			
			// 过滤
			_g.rmLS('selected-'+api.frameName)
  		if(!_g.getLS('selected-'+api.frameName)) {
  			// 刚进入列表
  			var filterData = {
  				isReportOrProvider: true,
  				filterName: 'selected-' + api.frameName,
					stage: {
						hasStage: true,
						startTime: stime,
						endTime: etime
					},
					listItem:[{
						type:'select-win', title:'仓库', tag: 'store', selected: {value: '不限'}
					}, {
						type:'select-win', title:'货品类别', tag: 'goodsType', selected: {value: '不限'}
					}, {
						type:'select-win', title:'货品', tag: 'goods', selected: {value: '不限'}
					}]
				}
				_g.setLS('selected-'+api.frameName, filterData)
  		}
			_g.addEventListener({
				name: api.winName + '-filter',
				success: function(ret) {
					// 打开过滤页面
					_g.openWin({
						name:'filter',
						url:'../Common/filter',
						pageParam: _g.getLS('selected-'+api.frameName)
					})
				}
			})
			// 监听进行过滤操作
			_g.addEventListener({
				name: 'selected-' + api.frameName + '-filterAction',
				success: function(ret) {
					//获取过滤数据
					var showFilterName = []
					var filterData = _g.getLS('selected-'+api.frameName)
					self.params.startdate = filterData.stage.startTime
		      self.params.enddate = filterData.stage.endTime
		      showFilterName.push(self.params.startdate + '~' + self.params.enddate)
		     	_.each(filterData.listItem, function(val, key){
		     		if(val.selected.showName) {
     					showFilterName.push(val.selected.showName)
     				}
		     		switch(val.title){
		     			case '仓库':
		     				self.params.storeID = val.selected.storeid
		     			break
		     			case '货品':
		     				self.params.goodsid = val.selected.goodsid
		     			break
		     			case '货品类别':
		     				self.params.goodsTypeID = val.selected.id
		     			break
		     			default:
		     			break
		     		}
		     	})
		     	self.showFilterName = showFilterName
					// 重新获取数据
					self.ajax()
				}
			})
			//监听点击返回按钮后，清除缓存的过滤数据
			_g.addEventListener({
				name: api.winName + '-closeWin',
				success: function(ret) {
					_g.clearFilterLS(api.frameName)
				}
			})
				//蓝牙打印
			_g.addEventListener({
				name: api.winName + '-print',
				success: function(ret) {
					var printData = {}
					var content = []
					_.each(self.listData, function(val, key){
						if (val.bunit == undefined || val.bunit == null) { val.bunit = ''}
						if (val.startqty == undefined || val.startqty == null) { val.startqty = ''}
						if (val.endqty == undefined || val.endqty == null) { val.endqty = ''}
						if (val.inqty == undefined || val.inqty == null) { val.inqty = ''}
						if (val.outqty == undefined || val.outqty == null) { val.outqty = ''}
						content.push({value: val.code + '   ' + val.name + val.specs + '/' + val.bunit, bold: true})
						content.push({value: '期初：' + val.startqty + '   期末：' + val.endqty})
						content.push({value: '收入：' + val.inqty + '   发出：' + val.outqty})
					})
					
					printData.content = content
					
					BLE.setData({
						data:printData.content
					});
					BLE.printEvent();
				}
			})
		}
	});
});
