define(function (require, exports, module) {
	var BLE = require('ble/blePrinter');
	var http = require('http');
	var MODULES = require('modules');
	var COMMAND = require('command');
	var INTERFACE = require('interface')
	var TIME = require('time')
	var stime = TIME.getDates().sDate
	var etime = TIME.getDates().eDate
	var content = new Vue({
		el: '#content',
		data: {
			listData:[],
			currentFrame: 'profit-by-client', //当前选中的frame
			goodsamtSum: 0, //销售收入
			costamtSum: 0, //销售成本
			profitamtSum: 0, //销售毛利
			profitrateSum: 0, //毛利率
			showFilterName: [], //显示过滤条件
			params: {
				shopid: _g.getLS('shopID')
			}
		},
		methods: {
			ajax: function(){
				var self = this
				self.listData = [];
				self.goodsamtSum = 0; //销售收入
				self.costamtSum = 0; //销售成本
				self.profitamtSum = 0; //销售毛利
				self.profitrateSum = 0; //毛利率
				COMMAND.init({
					url: INTERFACE.report.saleProfit.urlByClient,
					data: $.extend(INTERFACE.report.saleProfit.param, self.params),
					hideProgress: true,
					success:function(ret){
						_.each(ret.resultData.ReportData, function(val, key){
							if (val.rtype == '99') {
								self.goodsamtSum = val.goodsamt; //销售收入
								self.costamtSum = val.taxamt; //销售成本
								self.profitamtSum = val.amount; //销售毛利
								self.profitrateSum = val.rate; //毛利率
							} else {
								self.listData.push(val);
							}
						})
					}
				})
			}
		},
		created: function() {
			var self = this
			self.ajax();
		},
		mounted: function() {
			var self = this
			
			_g.addEventListener({
				name: api.winName + '-change-tab',
				success: function(ret) {
					if(ret.value.index == 0){
						self.currentFrame = 'profit-by-client'
					} else if(ret.value.index == 1){
						self.currentFrame = 'profit-by-product';
					} else {
						self.currentFrame = 'profit-by-clerk'
					}
				}
			})
			// 过滤
	  		if(!_g.getLS('selected-'+api.frameName)) {
	  			// 刚进入列表
	  			var listItem = [];
	  			//仅总部操作员(shopid=0)提供分支机构过滤
	  			if(_g.getLS('shopID') == 0){
	  				listItem.push({
						type:'select-win', 
						title:'分支机构', 
						tag: 'shop', 
						selected: {value: '不限', shopid: 0}
					})
	  			}
	  			var filterData = {
	  				filterName: 'selected-' + api.frameName,
					stage: {
						hasStage: true,
						startTime: stime,
						endTime: etime
					},
					listItem: listItem
				}
				_g.setLS('selected-'+api.frameName, filterData)
	  		}
			_g.addEventListener({
				name: api.winName + '-filter',
				success: function(ret) {
					// 打开过滤页面
					if (self.currentFrame == 'profit-by-client') {
						_g.openWin({
							name:'filter',
							url:'../Common/filter',
							pageParam: _g.getLS('selected-'+api.frameName)
						})
					}
				}
			})
			// 监听进行过滤操作
			_g.addEventListener({
				name: 'selected-' + api.frameName + '-filterAction',
				success: function(ret) {
					//获取过滤数据
					var filterData = _g.getLS('selected-'+api.frameName)
					self.showFilterName = [];
					self.showFilterName.push(filterData.stage.startTime + '~' + filterData.stage.endTime);
					self.params.beginDate = filterData.stage.startTime
		      		self.params.endDate = filterData.stage.endTime
			     	_.each(filterData.listItem, function(val, key){
			     		switch(val.title){
			     			case '分支机构':
			     				self.showFilterName.push(val.selected.value);
				     			if (val.selected.value != '不限') {
				     				Vue.set(self.params, 'shopid', val.selected.shopid);
				     			}
			     			break
			     			default:
			     			break
			     		}
			     	})
		     	
					// 重新获取数据
					self.ajax()
				}
			})
			//监听点击返回按钮后，清除缓存的过滤数据
			_g.addEventListener({
				name: api.winName + '-closeWin',
				success: function(ret) {
					_g.clearFilterLS(api.frameName)
				}
			})
			
			//蓝牙打印
			_g.addEventListener({
				name: api.winName + '-print',
				success: function(ret) {
					var printData = {}
					var content = []
					_.each(self.listData, function(val, key){
						content.push({title: val.name, value: val.qty + '次'})
					})
					printData.content = content

					BLE.setData({
						data:printData.content
					});
					BLE.printEvent();
				}
			})
		}
	});
});
