define(function (require, exports, module) {
	var _C = require('components');
	var interface = require('interface')

	var header = new Vue({
		el: '#header',
		components: {
			'baseheader': _C.getHeader({
				title: '销售排行榜',
			}),
			'l-back': _C.getLback({

			}),
			'r-btns': _C.getRbtns({
				btns: [{
					icon: 'filter',
					event: api.winName + '-filter'
				}]
			}),
			basetabbar: _C.getBaseTabBar({
				tabs: [
					{
						title: '按客户',
						active: true
					},
					{
						title: '按货品',
						active: false
					},
					{
						title: '按业务员',
						active: false
					}
				],
				eventName: api.winName + '-change-tab'
			})
		},
		data: {},
		methods: {
			search: function(ret) {
				console.log('搜索' + _g.j2s(ret))
			},
			openframe: function(frameName){
				var self = this;
				_g.openFrame({
					name: frameName,
					url: frameName,
					pageParam: api.pageParam
				});
			}
		},
		created: function() {
			console.log(_g.j2s(api.pageParam));
		},
		mounted: function() {
			var self = this;
			self.openframe('charts-by-client')
			_g.addEventListener({
				name: api.winName + '-change-tab',
				success: function(ret) {
					var frameName = ''
					if(ret.value.index == 0){
						frameName = 'charts-by-client'
						self.openframe('charts-by-client')
					} else if(ret.value.index == 1){
						frameName = 'charts-by-product'
						self.openframe('charts-by-product')
					} else {
						frameName = 'charts-by-clerk'
						self.openframe('charts-by-clerk')
					}
					// api.sendEvent({
					// 	name: 'funnel-currentFrame',
					// 	extra: {
					// 		frameName: frameName
					// 	}
					// });
				}
			})
		}
	});
});
