define(function (require, exports, module) {
	var BLE = require('ble/blePrinter');
	var COMMAND = require('command');
	var INTERFACE = require('interface');
	var TIME = require('time')
	var stime = TIME.getDates().sDate
	var etime = TIME.getDates().eDate
	var content = new Vue({
		el: '#content',
		data: {
			listData:[],
			params: {
				startdate: stime,
				enddate: etime,
				clientid: ''
			}
		},
		methods: {
			ajax: function(){
				var self = this
				var param = {}
				param.startdate = self.params.startdate
				param.enddate  = self.params.enddate 
				param.pageSize  = 10000
				if(self.params.clientid != 0){
					param.clientid = self.params.clientid
				}
				COMMAND.init({
					url: INTERFACE.report.url,
					data: $.extend(INTERFACE.report.salesExecution.param, param),
					hideProgress: true,
					success:function(ret){
						if(ret.errNo == 1){
							_g.toastMsg({
								msg:ret.errMsg
							})
						}else if(ret.errNo == 0){
							self.listData = ret.resultData.ReportData
						}
					}
				})
			}
		},
		created: function() {
			var self = this
			self.ajax()
		},
		mounted: function() {
			var self = this
//			// 上拉加载
//			_g.topLoading({
//				success:function(){
//					COMMAND.next({
//						success: function(ret){
//						self.listData = _.union(self.listData, ret.resultData.ReportData)
//						}
//					})
//				}
//			})
//			// 下拉刷新
//			_g.refresh({
//				success:function(){
//					COMMAND.refresh({
//						success: function(ret) {
//							self.listData = ret.resultData.ReportData
//						}
//					})
//				}
//			})
			
			// 过滤
  		if(!_g.getLS('selected-'+api.frameName)) {
  			// 刚进入列表
  			var filterData = {
  				isReportOrProvider: true,
  				filterName: 'selected-' + api.frameName,
					stage: {
						hasStage: true,
						startTime: stime,
						endTime: etime
					},
					listItem:[{
						type:'select-win', title:'客户', tag: 'trader', selected: {value: '不限'}
					}]
				}
				_g.setLS('selected-'+api.frameName, filterData)
  		}
			_g.addEventListener({
				name: api.winName + '-filter',
				success: function(ret) {
					// 打开过滤页面
					_g.openWin({
						name:'filter',
						url:'../Common/filter',
						pageParam: _g.getLS('selected-'+api.frameName, filterData)
					})
				}
			})
			// 监听进行过滤操作
			_g.addEventListener({
				name: 'selected-' + api.frameName + '-filterAction',
				success: function(ret) {
					//获取过滤数据
					var filterData = _g.getLS('selected-'+api.frameName)
					// alert(JSON.stringify(filterData))
					self.params.startdate = filterData.stage.startTime
		      self.params.enddate = filterData.stage.endTime
		     	_.each(filterData.listItem, function(val, key){
		     		switch(val.title){
		     			case '客户':
		     				self.params.clientid = Number(val.selected.clientid) || 0
		     			break
		     			default:
		     			break
		     		}
		     	})
					// 重新获取数据
					self.ajax()
				}
			})
			//监听点击返回按钮后，清除缓存的过滤数据
			_g.addEventListener({
				name: api.winName + '-closeWin',
				success: function(ret) {
					_g.clearFilterLS(api.frameName)
				}
			})
				//蓝牙打印
			_g.addEventListener({
				name: api.winName + '-print',
				success: function(ret) {
					var printData = {}
					var content = []
					_.each(self.listData, function(val, key){
						content.push({value: val.clientname, bold: true})
						content.push({title: '单据编号', value: val.billcode})
						content.push({title: '单据日期', value: val.billdate})
						content.push({title: '金额', value: '¥' + val.goodsamt})
						content.push({title: '发货', value: '¥' + val.saledamt})
						content.push({title: '收款', value: '¥' + val.finishedamt})
						
					})
					printData.content = content
					
					BLE.setData({
						data:printData.content
					});
					BLE.printEvent();
				}
			})
		}
	});
});
