var _basic = {
	/* 
	 *打开窗口
	 *@param module 页面所在文件名
	 *@param con Win层名字
	 *@param par 为可选参数,页面参数,为reportClear则表示要清除report模块的缓存
	 */
	openModuleWin:function(module,con,par,subtype,duration){
		if (typeof(par) == 'undefined') {
			par = {};
		}else if(par == 'reportClear'){
			$api.rmStorage('filter');
			$api.rmStorage('filterName');
			$api.rmStorage('filterVal');
			par={};
		}
		if (typeof(subtype) == 'undefined'||subtype=={}) {
			subtype = 'from_right';
		}
		if (typeof(duration) == 'undefined'||duration=={}) {
			duration = 500;
		}
		api.openWin({
			name: con,
			url: '../'+module+'/'+con+'.html',
			pageParam: par,
			animation:{type:'reveal',subType:subtype,duration:duration},
			reload:true
		});
	},
	/* 
	 *打开窗口
	 *@param con Frame层名字
	 *@param top Frame左上角y坐标
	 *@param bool 为可选参数,Frame页面是否弹动
	 *@param par 为可选参数,页面参数
	 */
	openFrame:function(con,top,bool,par){
		var len = arguments.length;
		if (len == 2) {
			bool = false;
			par = {};
		} else if (len == 3) {
			if (typeof(bool) == 'boolean') {
				par = {};
			} else {
				par = bool;
				bool = false;
			}
		}
		api.openFrame({
			name: con,
			url: './'+con+'.html',
			pageParam: par,
			rect:{
				x:0,
				y:top,
				w:'auto',
				h:'auto'
			},
			bounces:bool,
			reload:true,
			animation:{type:'reveal',subType:'from_right',duration:500},
		});
	},
	/* 
	 *打开Framegroup
	 *@param groupName frame组名字
	 *@param topShift Frame组左上角y坐标
	 *@param hasbottom Frame组相对父window下外边距的距离(bottom_h的高度为底部栏高度)
	 *@param bool 为可选参数,Frame页面是否弹动
	 *@param frames 为可选参数,页面参数
	 */
	openFrameGroup:function(groupName,topShift,hasbottom,bool,frames){
		var bottom_h = 0;
		if(hasbottom){
			bottom_h = 50;
		}
		var len = arguments.length;
		if (len == 3) {
			bool = false;
			par = {};
		} else if (len == 4) {
			if (typeof(bool) == 'boolean') {
				par = {};
			} else {
				par = bool;
				bool = false;
			}
		}
		api.openFrameGroup({
			name:groupName,
			scrollEnabled: false,
		    rect:{
		    	x: 0,
			    y: topShift,
			    w: 'auto',
			    h: 'auto',
			    marginBottom: bottom_h
		    },
		    index: 0,
		    preload: 0,
			frames:frames
		}, function( ret, err ){
			if( ret ){
				$api.setStorage('_index', ret.index);
			}
		});
	},
	/* 
	 *tab下标切换移动 
	 *@param connect_group 要影响的tabgroup组
	 *@param tabgroup 当前tab组父节点
	 *@param tabs 当前tab组
	 *@param ele 当前对象
	 */
	setFrameChange:function(groupName,node,ele){
		var index_ = $api.attr(ele,'pos');
		var nodeList = $api.domAll(node);
		var num = nodeList.length;
		for (var i=0; i<num; i++) {
			$api.removeCls(nodeList[i], 'tx-purple');
		}
		$api.addCls(ele, 'tx-purple');
		var mark = $api.dom('mark');
		var tabgroup_width = $api.offset(ele).w*num;
		var markPosX = (tabgroup_width/num)*(index_);
		$api.css(mark, '-webkit-transform: translate(' + markPosX + 'px, 0)');
	},
	/* 
	 *FrameGroup下标切换时，frame切换的函数
	 *@param groupName frame组名字
	 *@param index_ 当前页面下标
	 */
	setFrameIndex:function(groupName,index_){
		api.setFrameGroupIndex({
			name:groupName,
			index:index_,
		});
	},
	//点击Body关闭Frame
	closeTipFrame:function(){
		var body = $api.dom('body');
        $api.addEvt(body, 'touchend', function(){
			api.closeFrame(); 
        }, false);
	},
	//返回按钮，关闭当前窗口
	goback:function(){
		api.closeWin();
	},
	/* 
	 *Win层头部兼容手机状态栏
	 *@param header 头部id
	 */
	getHeader:function(header){
		var obj = $api.byId(header);
		//$api.fixIos7Bar(obj);
		$api.fixStatusBar(obj);		
		var headerPos = $api.offset(obj);
		return headerPos;
	},
	/* 
	 *toast提醒
	 *@param msg 提醒信息
	 *@param location 提醒弹窗位置，默认为空，middle，设置1代表bottom
	 */
	toastMsg:function(msg,location){
		if(location == ''||location==undefined||location==null){
			location = 'middle';
		}
		else if(location == 1){
			location = 'bottom';
		}
		api.toast({
			msg:msg,
			duration:1500,
			location:location,
		});
	},
	//双击“返回键”退出App
//	exitApp: function(){
//		var url_suffix=$api.getStorage('sdIP');
//		api.addEventListener({
//			name: 'keyback'
//		},function(ret, err){
//			_basic.toastMsg('再按一次返回键退出应用',1);
//			api.addEventListener({
//				name: 'keyback'
//			},function(ret, err){
//				var postData={
//	   				url:'http://'+url_suffix+'/login/login!mobilelogout.action',
//	   				method:'post',
//	   				dataType:'json',
//	   				data:{}
//	   			};
//	   			function success(ret){
//					if(ret.errNo==0){
//						api.closeWidget({
//							retData: {name:'closeWidget'},
//							silent:true
//						});
//					}else{
//						//_basic.toastMsg(ret.errMsg,'middle',1000);
//						_basic.closeTologin(ret.errMsg);
//					}
//					
//	   			}
//	   			function failed(err){
//	   				_basic.toastMsg(err.msg);
//	   			}
//				_basic.Ajax(postData,success,failed);
//			});
//			setTimeout(function(){
//				_basic.exitApp();
//			},2000);
//		});
//	},
	//判断是否断网，如果断网，则返回false
	isConnectNet:function(){
		var connectionType = api.connectionType;
		if(connectionType=='unknown'||connectionType=='none'){
			return  false;
		}else{
			return true;
		}
	},
	/*向已打开的窗体执行脚本，也可用于传值-开始
	* win :指定的窗体名称
	* frame:窗体中的frame名称
	* callback :要执行的操作
	*data:回调函数的参数
	*/
	execScript:function(win,frame,callback,data){
		if(!data){
			data={};
		}
		var data=$api.jsonToStr(data);
		var jsfun='_basic.jsFun('+callback+','+data+')';
		api.execScript({
		    name:win,
		    frameName: frame,
		    script: jsfun
		});
	},
	jsFun:function(callback,data){
		callback(data);
	},
	//loading... 使用api.hideProgress(),隐藏
	showLoading:function(str){
		var tit_str='Loading';
		if(arguments.length=1&&str!=''){
			tit_str=str;
		}
		api.showProgress({
			style: 'default',
			animationType: 'fade',
			title: tit_str,
		});
	},
	//二维码/条形码扫描-需要在控制台中添加该模块FNScanner
	//retCallback:成功的回调函数
	//errCallback:失败的回调函数
	scanner:function(retCallback,errCallback){
		var FNScanner = api.require('FNScanner');
		FNScanner.openScanner({
		    autorotation: true,
		},function( ret, err ){
		    if( ret.eventType=="success" ){
       		 	retCallback(ret);
    		}else{
    			if(errCallback){
    				errCallback(err);
    			}
    		}
		});
	},
	/*
	 * 下拉刷新
	 * @callback function 回调函数
	*/
	refresh:function(callback){
		api.setRefreshHeaderInfo({
			visible: true,
			loadingImg: '',
			bgColor: '#eee',
			textColor: '#999',
			textDown: '下拉刷新...',
			textUp: '松开刷新...',
			showTime: true
		}, function(ret, err){
			callback(ret);
			api.refreshHeaderLoadDone();
		});
	},
	/*
	 * 上拉加载
	 * @callback function 回调函数
	*/
	topLoading:function(callback){
		api.addEventListener({
			name:'scrolltobottom',
			extra:{
				threshold: 15
			}
		},function(ret,err){
			callback(ret);
		});
	},
	/*
	 *异步加载数据
	 * data['url']：完整的接口地址,必需
	 * data['method']:请求方法，get/post
	 * data['data']:POST数据，必需
	 * retCallback:成功的回调函数
	 * errCallback:失败的回调函数
	 */
	Ajax:function(data,retCallback,errCallback){
		//console.log('this:'+JSON.stringify(data))
		api.ajax({
		    url: data['url'],
		    method: data['method']?data['method']:'post',
		    dataType:data['datatype']?data['datatype']:'json',
		    timeout:15,
		    data: {
		        values: data['data']
		    },
		},function(ret, err){
		    if (ret) {
		    		console.log(JSON.stringify(ret))
		        retCallback(ret);
		    } else {
		    	if(errCallback){
		    		errCallback(err);
		    	}
		    	
		        
		    }
		});
	},
	/*
	 * 显示/隐藏 frameGroup页面
	 * @param frameGroupName string frameGroup页面名称
	 * @param hiddenBool boolean 设置显示或隐藏
	 */
	toggleFrameGroup:function(frameGroupName, hiddenBool){
		api.setFrameGroupAttr({
		    name: frameGroupName,
		    hidden: hiddenBool,
		    animation:{type:'reveal',subType:'from_right',duration:500}
		});
	},
	/*
	 * 筛选页面默认开始时间为当前一个月前，结束日期为当前日期
	 * @return {[dateArr]} [返回开始时间sDate和结束时间eDate]
	 */
	getDates:function(){
		var transDoubleNum = function(num){
			return num = num>9? num:0+''+num;
		}
		var sDate,eDate;
		var dateArr;
		var myDate = new Date();
		var nowyear, nowmonth, nowdate;
		//获取当前日期
		nowyear = myDate.getFullYear();
		nowmonth = myDate.getMonth();
		nowdate = myDate.getDate();
		// if(api.systemType=='ios'){
		// 	var yearIndex=nowDateString.indexOf('年');
		// 	var monthIndex=nowDateString.indexOf('月');
		// 	var dayIndex=nowDateString.indexOf('日');
		// 	nowyear=nowDateString.substring(0,yearIndex);
		// 	nowmonth=nowDateString.substring(yearIndex+1,monthIndex);
		// 	nowdate=nowDateString.substring(monthIndex+1,dayIndex);
		// }
		eDate = nowyear +'-' + transDoubleNum(Number(nowmonth) + 1) + '-' + transDoubleNum(nowdate);
		dateArr = {
			eDate: eDate
		};
		var month = Number(nowmonth);
		var data = nowdate;
		//判断是否有31号
		if (data == 31) {
			if (nowmonth != 7) data = 30;
			else data = 31;
		}
		if (month == 2) { //二月份且为闰年
			if (((nowyear % 4 == 0) && (nowyear % 100 != 0)) || (nowyear % 400 == 0)) {
				data = 29;
			} else {
				data = 28;
			}
		}
		data = transDoubleNum(data);
		//判断是否为上一年
		if (month == 0) {
			sDate = Number(nowyear) - 1;
			sDate = sDate + '-12-' + data;
		} else {
			sDate = nowyear +'-' + transDoubleNum(month) + '-' + data;
		}
		dateArr.sDate = sDate;
		return dateArr;
	},
	/*
	 * 切换时间格式
	 * data 时间 例：‘2016-4-7’
	 * @return changeD 返回时间 例: '2016/4/7'
	 */
	changeData: function(data){
		data = data.split('-');
		var changeD = data[0] +'/' + data[1] + '/' + data[2];
		return changeD;
	},
	changeDate: function(data, cur, to) {
		data = data.split(cur);
		var changeD = data[0] + to + data[1] + to + data[2];
		return changeD;
	},
            /*
            输入一个时间 sDate,根据日期数days,输出一个结束日期eDate
            sDate格式是yyyy-mm-dd
            */
             countDate:function(sDate,days){
                var eDate;
                var dateArr=sDate.split('-');//将日期分割成数组
                var _sdate=new Date(dateArr[0],parseInt(dateArr[1])-1,parseInt(dateArr[2]));//创建新的日期对象

                var _sMillSec=_sdate.getTime();//将日期转换成毫秒进行计算
                var _eMillSec=_sMillSec+days*24*3600*1000;
                var _edate=new Date(_eMillSec);

                var _eYear=_edate.getFullYear();//年
                var _eMonth=_edate.getMonth()+1;//月
                var _eDate=_edate.getDate();//日

                //判断是否是闰年
                if(_eYear%4==0){
                    //判断是否是二月
                    if(_eMonth==2){
                        if(_eDate>29){
                            _eMonth++;
                            _eDate=_edate-29;
                        }
                    }
                }else{
                    //判断是否是二月
                    if(_eMonth==2){
                        if(_eDate>28){
                            _eMonth++;
                            _eDate=_edate-28;
                        }
                    }
                }

                //为日期补零
                if (_eMonth < 10)
                    _eMonth = '0' + _eMonth.toString();
                if (_eDate < 10)
                    _eDate = '0' + _eDate.toString();
                
                //字符串拼接
                edate=_eYear+'-'+_eMonth+'-'+_eDate;
                return edate;
            },   
	/*
	 * 通过日期模块，获取日期
	 * 自动填充在dom节点中 dom必须为input 因为使用了 val()方法 而不是 text()方法
	 * nor_date是默认传进来的日期，字符串,可选,eg:'2016-1-1'
	 * @return  value，返回选择选择日期的字符串
	 */
	getPickerDates:function(dom,nor_date,retCallback){
		var date_str='';
		var chooseDate='';
		if(arguments.length>=2){
			date_str=arguments[1];
		}
		api.openPicker({
			type:'date',
			date : date_str,
			title:'选择日期'
		},function(ret,err){
	        	if(ret){
	        		ret.month=ret.month*1;
	        		ret.day=ret.day*1;
	        		if(ret.day<10){
	        			ret.day='0'+ret.day;
	        		}
	        		if(ret.month<10){
	        			ret.month='0'+ret.month;
	        		}
			chooseDate=ret.year+'-'+ret.month+'-'+ret.day;
			$api.val(dom,chooseDate);
			if(retCallback!=undefined)
				retCallback();
			return chooseDate;
	        	}else{
	        		_basic.toastMsg('请重新选择时间');
	        	}
	        });
	},
	/*两个日期的比较*/
	//a:开始时间
	//b:结束时间
	compareDate:function(a,b){
		var arr = a.split("-");
	    var starttime = new Date(arr[0], arr[1], arr[2]);
	    var starttimes = starttime.getTime();
	    var arrs = b.split("-");
	    var lktime = new Date(arrs[0], arrs[1], arrs[2]);
	    var lktimes = lktime.getTime();
	    if (starttimes > lktimes) {
	        return false;
	    }
	    else
	        return true;
	},
	/*两个日期的比较,只用于首页模块的单据保存*/
	//a:开始时间
	//b:结束时间
	save_compareDate:function(a,b){
		var arr = a.split("-");
	    var starttime = new Date(arr[0], arr[1], arr[2]);
	    var starttimes = starttime.getTime();
	    var arrs = b.split("-");
	    var lktime = new Date(arrs[0], arrs[1], arrs[2]);
	    var lktimes = lktime.getTime();
	    if (starttimes >= lktimes) {
	        return false;
	    }
	    else
	        return true;
	},
	/*
	 * report报表页返回操作
	 */
	reportBack:function(){
		//清除缓存
		$api.rmStorage('filter');
		$api.rmStorage('filterName');
		api.closeWin();
	},
	/*
	 * 如返回信息为‘您没有登陆或长时间没使用，请重新登陆’或‘您的账号已在其它机器使用，请重新登录’时，要退到操作员的登录页
	 * str:errMsg的内容
	 */
	closeToLogin:function(str){
		if(str.indexOf('请重新登陆')>0||str.indexOf('请重新登录')>0){
			_basic.toastMsg(str);
			setTimeout(function(){
				api.closeToWin({
		            name: 'root',
		            animation: {
				        type: 'push',
				        subType: 'from_left',
				        duration: 800
				    }
	    		});
			},1000);
		}else{
			_basic.toastMsg(str);
		}
	},
	/*微信发送内容*/
	sendToWX:function(type,textJson,SUCCESS,ERR){
		var text='';
		if(type=='content'){
			text=textJson.title+'\r\n\r\n';
			$.each(textJson.content,function(key,val){
				text=text+key+": "+val+'\r\n';
			});
		}else if(type=='business_content'){
			text=textJson.title+'\r\n\r\n';
			$.each(textJson.content,function(key,val){
				if(key=='cutline'){
					text=text+'\r\n';
				}else{
					text=text+key+": "+val+'\r\n';
				}
			});
		}else{
			text=textJson.title;
		}
		
		//1.判断手机是否安装了微信客户端
		var wx = api.require('wx');
		wx.isInstalled(function(ret, err) {
		    if (ret.installed) {
		        //2.分享至微信好友
		        wx.shareText({
				    scene: 'session',
				    text: text
				}, function(ret, err) {
				    if (ret.status) {
				        SUCCESS(ret);
				    } else {
				    	ERR(err);
				    }
				});
		    } else {
		        _basic.toastMsg('当前设备未安装微信客户端');
		    }
		});
	}
}