define(function(require, exports, module) {

	var TIME = require('time');

	function business() {
		this.data = {};
	}

	business.prototype = {
		set: function(opts) {
			var self = this;
			var master = opts.data.master;
			var goods = opts.data.goods;
			console.log(_g.j2s(opts))
			self.data = self.getMaster({
				data: master
			})[opts.type];
			for (var g = 0; g < goods.length; g++) {
				self.data.goods.push(self.getDetail(goods[g]));
			}
			console.log(_g.j2s(self.data));
		},
		get: function(opts) {
			return this.data;
		},
		getQQData: function() { // 获取格式化的qq分享数据
			var self = this;
			var textJson = {
				title: self.data.title,
				content: {}
			}
			var master = self.data.master;
			for(var m=0; m<master.length-1; m++) {
				textJson.content[master[m].name] = master[m].value;
			}
			var goods = self.data.goods;
			//textJson['content']['商品明细'] = '';
//			for(var g=0; g<goods.length; g++) {
//				textJson.content['货品名称'] =  goods[g]['name'] || '';
//				textJson.content['数量'] = goods[g]['num'] || '0';
//				textJson.content['单价'] = (goods[g]['moneyname'] || '') + '' + (goods[g]['price'] || '0');
//				textJson.content['税率'] = (goods[g]['taxrate'] || '0') + '%';
//				textJson.content['金额'] = goods[g]['amount'] || '0';
//			}
			textJson.content.data = []
			for(var g=0; g<goods.length; g++) {
				var test = {}
				test['货品名称'] =  goods[g]['name'] || '';
				test['    数量'] = (goods[g]['num'] || '0') + '  单价: ' + (goods[g]['moneyname'] || '') + '' + (goods[g]['price'] || '0');
				//textJson.content['单价'] = (goods[g]['moneyname'] || '') + '' + (goods[g]['price'] || '0');
				test['    税率'] = (goods[g]['taxrate'] || '0') + '%  金额: ' + (goods[g]['amount'] || '0');
				//textJson.content['金额'] = goods[g]['amount'] || '0';
				textJson.content.data.push(test)
			}
			textJson.content[master[master.length-1].name] = master[master.length-1].value;
			return textJson;
		},
		getPrintData: function() { // 获取格式化的打印数据
			var self = this;
			// var companyname = _g.getLS('COMPANYNAME') || '';
			var content = [
				// {
				// 	value: companyname,
				// 	align: 'c',
				// 	big: true
				// },
				// {
				// 	value: self.data.title,
				// 	align: 'c',
				// 	cutline: true
				// }
			];

			var masterArr = self.data.master;
			for (var i = 0; i < masterArr.length - 1; i++) {
				content.push({
					title: masterArr[i].name,
					value: masterArr[i].value,
					nextline: i < masterArr.length - 2
				});
			}

			content.push({
				cutline: true
			});

			var goodsArr = self.data.goods;
			for (var i = 0; i < goodsArr.length; i++) {
				var name = goodsArr[i]['name'] || '';
				var num = goodsArr[i]['num'] || '0';
				var price = (goodsArr[i]['moneyname'] || '') + '' + (goodsArr[i]['price'] || '0');
				var taxrate = (goodsArr[i]['taxrate'] || '0') + '%';
				var amount = goodsArr[i]['amount'] || '0';
				content.push({
					value: name
				});
				content.push({
					title: '    数量',
					value: num,
					nextline: false
				});
				content.push({
					title: '    单价',
					value: price
				});
				content.push({
					title: '    税率',
					value: taxrate,
					nextline: false
				});
				content.push({
					title: '    金额',
					value: amount,
					nextline: i < goodsArr.length - 1
				});
			}

			content.push({
				cutline: true
			});

			content.push({
				title: '合计',
				value: (self.data.master[self.data.master.length - 1].value).toString()
			});

			// content.push({
			// 	nextline: true
			// });
			// content.push({
			// 	nextline: true
			// });

			// var opCode = _g.getLS('opCode'); // 操作人
			// content.push({
			// 	title: '打印人',
			// 	value: opCode,
			// 	align: 'r'
			// });
			// var date = TIME.getDates().eDate; // 当前日期
			// content.push({
			// 	title: '打印日期',
			// 	value: date,
			// 	align: 'r'
			// });
			return content;
		},
		getMaster: function(opts) { // 获取生成的主单据数据
			var self = this;
			var data = opts.data;
			return {
				pbilling: {
					title: '采购开单',
					master: [
						{ name: '日期', value: data.billdate || '' },
						{ name: '单号', value: data.billcode || '' },
						{ name: '单据类型', value: data.billkindname || '' },
						{ name: '供应商', value: data.tradername || '' },
						{ name: '发票类型', value: data.notetypename || '' },
						{ name: '币种', value: data.moneyname || '' },
						{ name: '本次现付', value: data.payamt || '0' },
						{ name: '结算方式', value: data.paymethodname || '' },
						{ name: '结算账户', value: data.accountname || '' },
						{ name: '结算单位', value: data.ctradername || '' },
						{ name: '项目', value: data.projectname || '' },
						{ name: '部门', value: data.depname || '' },
						{ name: '业务员', value: data.empname || '' },
						{ name: '合计', value: data.amount || '0' },
					],
					goods: []
				},
				sbilling: {
					title: '销售开单',
					master: [
						{ name: '日期', value: data.billdate || '' },
						{ name: '单号', value: data.billcode || '' },
						{ name: '单据类型', value: data.billkindname || '' },
						{ name: '客户', value: data.tradername || '' },
						{ name: '发票类型', value: data.notetypename || '' },
						{ name: '币种', value: data.moneyname || '' },
						{ name: '本次现收', value: data.payamt || '0' },
						{ name: '结算方式', value: data.paymethodname || '' },
						{ name: '结算账户', value: data.accountname || '' },
						{ name: '结算单位', value: data.ctradername || '' },
						{ name: '项目', value: data.projectname || '' },
						{ name: '部门', value: data.depname || '' },
						{ name: '业务员', value: data.empname || '' },
						{ name: '合计', value: data.amount || '0' },
					],
					goods: []
				},
				porder: {
					title: '采购订单',
					master: [
						{ name: '日期', value: data.billdate || '' },
						{ name: '单号', value: data.billcode || '' },
						{ name: '币种', value: data.moneyname || '' },
						{ name: '供应商', value: data.tradername || '' },
						{ name: '到货日期', value: data.revdate || '' },
						{ name: '中止', value: (data.closed == 1 ? '是' : '否') },
						{ name: '摘要', value: data.remark || '' },
						{ name: '项目', value: data.projectname || '' },
						{ name: '部门', value: data.depname || '' },
						{ name: '业务员', value: data.empname || '' },
						{ name: '合计', value: data.amount || '0' },
					],
					goods: []
				},
				sorder: {
					title: '销售订单',
					master: [
						{ name: '日期', value: data.billdate || '' },
						{ name: '单号', value: data.billcode || '' },
						{ name: '币种', value: data.moneyname || '' },
						{ name: '客户', value: data.tradername || '' },
						{ name: '发货日期', value: data.revdate || '' },
						{ name: '中止', value: (data.closed == 1 ? '是' : '否') },
						{ name: '摘要', value: data.remark || '' },
						{ name: '项目', value: data.projectname || '' },
						{ name: '部门', value: data.depname || '' },
						{ name: '业务员', value: data.empname || '' },
						{ name: '合计', value: data.amount || '0' }
					],
					goods: []
				},
				chance: {
					title: '销售机会',
					master: [
						{ name: '日期', value: data.billdate || '' },
						{ name: '编号', value: data.billcode || '' },
						{ name: '机会名称', value: data.name || '' },
						{ name: '客户', value: data.tradername || '' },
						{ name: '联系人', value: data.contactname || '' },
						{ name: '结束日期', value: data.enddate || '' },
						{ name: '阶段', value: data.chancetypename || '' },
						{ name: '可能性', value: (data.possibility || 0) + '%' },
						{ name: '金额', value: data.amount || 0 },
						{ name: '业务员', value: data.empname || '' },
						{ name: '摘要', value: data.remark || '' },
						{ name: '合计', value: data.amount || 0 }
					],
					goods: []
				},
				price: {
					title: '销售报价',
					master: [
						{ name: '日期', value: data.billdate || '' },
						{ name: '单号', value: data.billcode || '' },
						{ name: '主题', value: data.name || '' },
						{ name: '客户', value: data.tradername || '' },
						{ name: '联系人', value: data.contactname || '' },
						{ name: '状态', value: data.statusname || '' },
						{ name: '相关机会', value: data.chancename || '' },
						{ name: '开始日期', value: data.startdate || '' },
						{ name: '结束日期', value: data.enddate || '' },
						{ name: '摘要', value: data.remark || '' },
						{ name: '合计', value: data.amount || 0 }
					],
					goods: []
				}
			}
		},
		getDetail: function(opts) { // 获取生成的单据明细数据
			return {
				name: opts.goodscode + ' ' + (opts.goodsname || ''),
				num: opts.unitquantity + '' + (opts.unitname || ''),
				price: opts.unitprice,
				taxrate: opts.taxrate,
				amount: opts.amount
			}
		}
	}
	business.prototype.constructor = business;
	module.exports = new business();

});