define(function(require, exports, module) {

	var HTTP = require('http');
	var TIME = require('time');
	var BData = require('business-data');
	var QQ = require('qq');
	var mobShare = api.require('mobShare');
	function business() {
		this.interface = {
			base: {
				instruct: { // 批示
					list: { // 列表
						url: URLANNEX + '/bill/sapproval/sapprovalEdit!doGetListData.action',
						param: {
							'clientid': '', // 客户id
							'id': '', // 所选的单据id
							'modId': '' // 对应的是各个单据的modId（销售机会：10101 售后工单：10110 销售合同：10104 销售报价：20201 销售收款：20203）
						}
					},
					save: { // 保存
						url: URLANNEX + '/bill/sapproval/sapprovalEdit!save.action',
						param: {
							'addnewFlag': '', // true：新增 false：编辑	
							'master.content': '', // 批示内容
							'master.formid': '',
							'master.id': '',
							'master.itemno': '',
							'master.opdate': '', // 批示创建日期
							'master.opid': '', // 批示创建人id
							'master.opname': '', // 批示创建人
						}
					},
					del: { // 删除
						url: URLANNEX + '/bill/sapproval/sapprovalEdit!Delete.action',
						param: {
							'id': '', // 批示列表中 id
							'itemno': '', // 批示列表中 itemno
							'modId': '', // 批示列表中 formid
						}
					},
				},
				check: { // 审批流程列表
					url: URLANNEX + '/bill/selectbill/selectbillList!doGetSelectBillData.action',
					param: {
						'billType': 10111
					}
				},
				qryTrader: function(opts) {
					return {
						title: '客户',
						url: URLANNEX + '/lookupdm/lookupdata.action',
						param: {
							'filter': 'closed=0',  // 过滤时，报表和供应商中的过滤，是为'1=1'
							'modId': opts.modId,
							'likeValue': '',
							'viewname': 'qryCTrader'
						},
						showName: 'name'  //要显示的字段
					}
				},
				qryChanceState: function(opts) {
					return {
						title: '阶段',
						url: URLANNEX + '/crmlookupdm/crmlookupdata.action',
						param: {
							'filter': "(1=1) and (name like '%%')",  // 过滤时，报表和供应商中的过滤，是为'1=1'
							'modId': 150,
							'likeValue': '',
							'viewName': 'qryChanceState'
						},
						showName: 'name'  //要显示的字段
					}
				},
				qryEmploy: function(opts) {
					return {
						title: '业务员',
						url: URLANNEX + '/crmlookupdm/crmlookupdata.action',
						param: {
							'filter': "Sign='T'",  // 过滤时，报表和供应商中的过滤，是为'1=1'
							'modId': opts.modId,
							'likeValue': '',
							'viewName': 'qryEmploy'
						},
						showName: 'name'  //要显示的字段
					}
				},
				qryCcontcat: function(opts) {
					return {
						title: '联系人',
						url: URLANNEX + '/crmlookupdm/crmlookupdata.action',
						param: {
							'filter': 'clientid=' + opts.traderid + ' and closed=0',  // 过滤时，报表和供应商中的过滤，是为'1=1'
							'modId': opts.modId,
							'likeValue': '',
							'viewName': 'qryContact'
						},
						showName: 'name'  //要显示的字段
					}
				},
				qrySalePriceStatus: function(opts) {
					return {
						title: '状态',
						url: URLANNEX + '/crmlookupdm/crmlookupdata.action',
						param: {
							'filter': '',  // 过滤时，报表和供应商中的过滤，是为'1=1'
							'modId': opts.modId,
							'likeValue': '',
							'viewName': 'qrySalePriceStatus'
						},
						showName: 'name'  //要显示的字段
					}
				}
			},
			search: { // 5k搜索参数
				'iMoneyHeadType': '0',
				'filterItems[0].fieldType': 'ft_ListStr',
				'filterItems[0].id': '432',
				'filterItems[0].index': 'CG0001',
				'filterItems[0].name': '业务员',
				'filterItems[0].operatertitle': '包含',
				'filterItems[1].fieldType': 'ft_Str',
				'filterItems[1].id': '460',
				'filterItems[1].index': '',
				'filterItems[1].name': '单据编号',
				'filterItems[1].operatertitle': '包含',
				'filterItems[2].fieldType': 'ft_ListStr',
				'filterItems[2].id': '471',
				'filterItems[2].index': '1',
				'filterItems[2].name': '分支机构',
				'filterItems[2].operatertitle': '包含',
				'filterItems[3].fieldType': 'ft_ListStr',
				'filterItems[3].id': '476',
				'filterItems[3].index': 'null',
				'filterItems[3].name': '',
				'filterItems[3].operatertitle': '包含',
				'filterItems[4].fieldType': 'ft_ListStr',
				'filterItems[4].operatertitle': '包含',
				'filterItems[5].fieldType': 'ft_ListStr',
				'filterItems[5].id': '474',
				'filterItems[5].index': '1',
				'filterItems[5].name': '制单人',
				'filterItems[5].operatertitle': '包含',
				'filterItems[6].fieldType': 'ft_ListStr',
				'filterItems[6].id': '475',
				'filterItems[6].index': '1',
				'filterItems[6].name': '审核人',
				'filterItems[6].operatertitle': '包含',
				'filterisOR': 'true'
			},
			sorder: { // 销售订单
				list: {
					url: URLANNEX + '/sa/saorder/sorderList!doGetListData.action',
					param: {
						search: {
							'filterItems[4].id': '473',
							'filterItems[4].index': 'K001',
							'filterItems[4].name': '客户'
						}
					}
				},
				add: {
					url: URLANNEX + '/sa/saorder/sorderEdit!doGetAddnewData.action'
				},
				edit: {
					url: URLANNEX + '/sa/saorder/sorderEdit!doGetEditData.action'
				},
				del: {
					url: URLANNEX + '/sa/saorder/sorderEdit!Delete.action'
				},
				save: {
					url: URLANNEX + '/sa/saorder/sorderEdit!save.action'
				}
			},
			sbilling: { // 销售开单
				list: {
					url: URLANNEX + '/sa/sale/saleList!doGetListData.action',
					param: {
						search: {
							'filterItems[4].id': '473',
							'filterItems[4].index': 'K0022',
							'filterItems[4].name': '供应商'
						}
					}
				},
				add: {
					url: URLANNEX + '/sa/sale/saleEdit!doGetAddnewData.action'
				},
				edit: {
					url: URLANNEX + '/sa/sale/saleEdit!doGetEditData.action'
				},
				del: {
					url: URLANNEX + '/sa/sale/saleEdit!Delete.action'
				},
				save: {
					url: URLANNEX + '/sa/sale/saleEdit!save.action'
				}
			},
			porder: { // 采购订单
				list: {
					url: URLANNEX + '/pa/paorder/porderList!doGetListData.action',
					param: {
						search: {
							'filterItems[4].id': '477',
							'filterItems[4].index': 'K001',
							'filterItems[4].name': '客户'
						}
					}
				},
				add: {
					url: URLANNEX + '/pa/paorder/porderEdit!doGetAddnewData.action'
				},
				edit: {
					url: URLANNEX + '/pa/paorder/porderEdit!doGetEditData.action'
				},
				del: {
					url: URLANNEX + '/pa/paorder/porderEdit!Delete.action'
				},
				save: {
					url: URLANNEX + '/pa/paorder/porderEdit!save.action'
				}
			},
			pbilling: { // 采购开单
				list: {
					url: URLANNEX + '/pa/papurchase/ppurchaseList!doGetListData.action',
					param: {
						search: {
							'filterItems[4].id': '477',
							'filterItems[4].index': 'K0022',
							'filterItems[4].name': '供应商'
						}
					}
				},
				add: {
					url: URLANNEX + '/pa/papurchase/ppurchaseEdit!doGetAddnewData.action'
				},
				edit: {
					url: URLANNEX + '/pa/papurchase/ppurchaseEdit!doGetEditData.action'
				},
				del: {
					url: URLANNEX + '/pa/papurchase/ppurchaseEdit!Delete.action'
				},
				save: {
					url: URLANNEX + '/pa/papurchase/ppurchaseEdit!save.action'
				}
			},
			chance: { // 销售机会
				list: {
					param: {
						'condition_txf': {},
						'filterItemRelation': '',
						'isH5': true,
						'pageSize': '',
						'searchKey': '',
						'start': 0
					},
					url: URLANNEX + '/ncrm/chance/chanceList!doGetListData.action',
				},
				add: {
					url: URLANNEX + '/ncrm/chance/chanceEdit!doGetAddnewData.action',
				},
				edit: {
					url: URLANNEX + '/ncrm/chance/chanceEdit!doGetEditData.action',
				},
				del: {
					url: URLANNEX + '/ncrm/chance/chanceEdit!Delete.action',
				},
				save: {
					url: URLANNEX + '/ncrm/chance/chanceEdit!save.action',
				},
				approval: {
					url: URLANNEX + '/ncrm/chance/chanceEdit!CheckBill.action',
				}
			},
			price: { // 销售报价
				list: {
					param: {
						'condition_txf': {},
						'filterItemRelation': '',
						'isH5': true,
						'pageSize': '',
						'searchKey': '',
						'start': 0
					},
					url: URLANNEX + '/ncrm/ssaleprice/ssalepriceList!doGetListData.action',
				},
				add: {
					url: URLANNEX + '/ncrm/ssaleprice/ssalepriceEdit!doGetAddnewData.action',
				},
				edit: {
					url: URLANNEX + '/ncrm/ssaleprice/ssalepriceEdit!doGetEditData.action',
				},
				del: {
					url: URLANNEX + '/ncrm/ssaleprice/ssalepriceEdit!Delete.action',
				},
				save: {
					url: URLANNEX + '/ncrm/ssaleprice/ssalepriceEdit!save.action',
				},
				approval: {
					url: URLANNEX + '/ncrm/ssaleprice/ssalepriceEdit!CheckBill.action',
				}
			}
		};
		this.param = {
			sorder: {
				title: '销售订单',
				tips: '单号/客户',
				frameName: 'sale-order'
			},
			sbilling: {
				title: '销售开单',
				tips: '单号/客户',
				frameName: 'sale-billing'
			},
			porder: {
				title: '采购订单',
				tips: '单号/供应商',
				frameName: 'pur-order'
			},
			pbilling: {
				title: '采购开单',
				tips: '单号/供应商',
				frameName: 'pur-billing'
			},
			chance: {
				title: '销售机会',
				modId: 150,
				code: '010302',
			},
			price: {
				title: '销售报价',
				modId: 151,
				code: '010401',
			},
		};
		this.baseData = { // 5k基础资料请求参数
			url: URLANNEX + '/lookupdm/lookupdata.action',
			tradername: { // 供应商/客户
				sorder: function() {
					return {
						title: '客户',
						param: {
							viewname: 'qryTrader',
							filter: '(IsClient=1 and Closed=0 and TraderID>0 ) or (acctrader=1 and Closed=0 and TraderID>0 )',
							billedit: 'true',
							isH5: 'true',
							modeid: '12',
							likeValue: ''
						}
					}
				},
				porder: function() {
					return {
						title: '供应商',
						param: {
							viewname: 'qryTrader',
							filter: '(IsVendor=1 and Closed=0 and TraderID>0 ) or (acctrader=1 and Closed=0 and TraderID>0 )',
							billedit: 'true',
							isH5: 'true',
							modeid: '2',
							likeValue: ''
						}
					}
				},
				sbilling: function() {
					return {
						title: '客户',
						param: {
							'viewname': 'qryTrader',
							'filter': '(IsClient=1 and Closed=0 and TraderID>0 ) or (acctrader=1 and Closed=0 and TraderID>0 )',
							'billedit': 'true',
							'isH5': 'true',
							'modeid': '14',
							'likeValue': ''
						}
					}
				},
				pbilling: function() {
					return {
						title: '供应商',
						param: {
							'viewname': 'qryTrader',
							'filter': '(IsVendor=1 and Closed=0 and TraderID>0 ) or (acctrader=1 and Closed=0 and TraderID>0 )',
							'billedit': 'true',
							'isH5': 'true',
							'modeid': '4',
							'likeValue': ''
						}
					}
				}
			},
			depname: function() { // 部门
				return {
					title: '部门',
					param: {
						'viewname': 'qryDepartment',
						'filter': 'closed=0',
						'isH5': 'true',
						'likeValue': ''
					}
				}
			},
			empname: function() { // 业务员
				var shopid = _g.getLS('shopID');
				return {
					title: '业务员',
					param: {
						'viewname': 'qryEmploy',
						'filter': 'closed=0 and isrep=1 and shopid=' + shopid,
						'isH5': 'true',
						'likeValue': ''
					}
				}
			},
			notetypename: function() { // 发票类型
				return {
					title: '发票类型',
					param: {
						'viewname': 'qryNoteType',
						'filter': '1=1',
						'isH5': 'true',
						'likeValue': ''
					}
				}
			},
			paymethodname: function() { // 结算方式
				return {
					title: '结算方式',
					param: {
						'viewname': 'qryPayMethod',
						'filter': '1=1',
						'isH5': 'true',
						'likeValue': ''
					}
				}
			},
			accountname: function() { // 结算账户
				var shopid = _g.getLS('shopID') || '';
				return {
					title: '结算账户',
					param: {
						'viewname': 'qryAccount',
						'filter': 'shopid=' + shopid + ' and closed=0',
						'isH5': 'true',
						'likeValue': ''
					}
				}
			},
			moneyname: function() { // 币种
				return {
					title: '币种',
					param: {
						'viewname': 'qryMoney',
						'isH5': 'true'
					}
				}
			},
			billkindname: {
				sbilling: function() { // 单据类型(销售)
					return {
						title: '单据类型',
						param: {
							'viewname': 'qryBillKind',
							'isH5': 'true',
							'filter': 'kind=6'
						}
					}
				},
				pbilling: function() { // 单据类型(采购)
					return {
						title: '单据类型',
						param: {
							'viewname': 'qryBillKind',
							'isH5': 'true',
							'filter': 'kind=3'
						}
					}
				}
			},
			projectname: function() { // 项目名称
				return {
					title: '项目名称',
					param: {
						'viewname': 'qryproject',
						'isH5': 'true',
						'filter': 'closed=0',
						'likeValue': ''
					}
				}
			},
			ctradername: {
				sbilling: function(likeValue) { // 结算单位(销售开单)
					return {
						title: '结算单位',
						param: {
							'viewname': 'qryTrader',
							'filter': '(IsClient=1 and Closed=0 and TraderID>0  and IsCashTrader<>1) or (acctrader=1 and Closed=0 and TraderID>0 and IsCashTrader<>1)',
							'billedit': 'true',
							'isH5': 'true',
							'likeValue': likeValue
						}
					}
				},
				pbilling: function(likeValue) { // 结算单位(采购开单)
					return {
						title: '结算单位',
						param: {
							'viewname': 'qryTrader',
							'filter': '(IsVendor=1 and Closed=0 and TraderID>0  and IsCashTrader<>1) or (acctrader=1 and Closed=0 and TraderID>0 and IsCashTrader<>1)',
							'billedit': 'true',
							'isH5': 'true',
							'likeValue': likeValue
						}
					}
				}
			},
			goods: function() { // 货品
				return {
					title: '货品',
					param: {
						'viewname': 'qrygoods',
						'filter': '(closed=0 and Kind<8 and Kind <> 5) and (name like \'%%\' or code like \'%%\')',
						'isH5': 'true',
						'likeValue': ''
					}
				}
			}
		};
		this.billtype = {
			sorder: 12, //销售订单
			sbilling: 14, //销售开单
			porder: 2, //采购订单
			pbilling: 4, //采购开单
			chance: 150, // 销售机会
			price: 151 // 销售报价
		};
		this.modeid = {
			sorder: 12, //销售订单
			sbilling: 14, //销售开单
			porder: 2, //采购订单
			pbilling: 4 //采购开单
		};
		this.getCanEditPriceKey = { // 是否能修改单价权限的JSON字段
			'sorder': 'canEditSPrice',
			'sbilling': 'canEditSPrice',
			'porder': 'canEditPPrice',
			'pbilling': 'canEditPPrice'
		};
		this.getTraderTilte = {
			'sorder': '客户',
			'sbilling': '客户',
			'porder': '供应商',
			'pbilling': '供应商'
		};
		this.data = {
			type: '', // 业务类型
			mode: '', // 模式
			bill: {}, // 数据
			index: 0
		};
		this.modId = {
			'150': {
				name: '销售机会',
			},
			'151': {
				name: '销售报价',
			}
		};
		this.search = { // 5k搜索参数
			'iMoneyHeadType': '0',
			'filterItems[0].fieldType': 'ft_ListStr',
			'filterItems[0].id': '432',
			'filterItems[0].index': 'CG0001',
			'filterItems[0].name': '业务员',
			'filterItems[0].operatertitle': '包含',
			'filterItems[1].fieldType': 'ft_Str',
			'filterItems[1].id': '460',
			'filterItems[1].index': '',
			'filterItems[1].name': '单据编号',
			'filterItems[1].operatertitle': '包含',
			'filterItems[2].fieldType': 'ft_ListStr',
			'filterItems[2].id': '471',
			'filterItems[2].index': '1',
			'filterItems[2].name': '分支机构',
			'filterItems[2].operatertitle': '包含',
			'filterItems[3].fieldType': 'ft_ListStr',
			'filterItems[3].id': '476',
			'filterItems[3].index': 'null',
			'filterItems[3].name': '',
			'filterItems[3].operatertitle': '包含',
			'filterItems[4].fieldType': 'ft_ListStr',
			'filterItems[4].operatertitle': '包含',
			'filterItems[5].fieldType': 'ft_ListStr',
			'filterItems[5].id': '474',
			'filterItems[5].index': '1',
			'filterItems[5].name': '制单人',
			'filterItems[5].operatertitle': '包含',
			'filterItems[6].fieldType': 'ft_ListStr',
			'filterItems[6].id': '475',
			'filterItems[6].index': '1',
			'filterItems[6].name': '审核人',
			'filterItems[6].operatertitle': '包含',
			'filterisOR': 'true'
		};
	}

	business.prototype = {
		isString: function(val) { // 判断是否为字符串
			if (typeof val == "string") {
				return true;
			} else {
				return false;
			}
		},
		parseTonum: function(val) { // 字符串转为数字类型
			if (this.isString(val)) {
				val = val * 1;
			}
			return val;
		},
		checkNull: function(str) { // 判断数值是否为null,如果为null的话则返回空字符串'' 否则返回本身
			if (str === null || str === 'null') {
				return '';
			} else {
				return str;
			}
		},
		unknownToEmpty: function(val) { // 过滤null和undefined为空字符串 
			if (val === null || val === undefined) {
				val = '';
			}
			return val;
		},
		getTime: function() { // 获取当前时间
			var date = new Date();
			var hour = date.getHours();
			hour = hour > 9 ? hour : '0' + hour;
			var minute = date.getMinutes();
			minute = minute > 9 ? minute : '0' + minute;
			var second = date.getSeconds();
			second = second > 9 ? second : '0' + second;
			return hour + ':' + minute + ':' + second;
		},
		addKeyValue: function(opts) { // 为json添加key和value
			_.each(opts.data, function(ele, index, list) {
				ele[opts.key] = opts.value;
			});
			return opts.data;
		},
		judgCompForBase: function(opts) { // 判断权限设置参数(供应商/客户/结算单位)
			var shopid = _g.getLS('shopID');
			var shopAccount = _g.getLS('shopAccount');
			var opid = _g.getLS('opID');
			var shopTrader = _g.getLS('shopTrader');
			if ((shopid == '0' && shopAccount == '1' && opid != '0') || (shopid != '0' && shopTrader == '0')) {
				opts.filter = '(' + opts.filter + ') and shopid=' + shopid;
			}
			return opts;
		},
		setDetailFromTaxrate: function(opts) { // 根据税率变动单据明细的函数
			var goodsData = opts.goods;
			goodsData['taxrate'] = opts.taxrate;

			var origprice = goodsData['origprice']; //获取原始价格
			var unitquantity = goodsData['unitquantity']; //获取业务数量(在页面显示的数量)
			var unitprice = goodsData['unitprice']; //获取业务单价(要显示的单价)
			var disc = goodsData['disc']; //获取折扣
			//计算原始含税单价
			var origtaxprice = origprice * (1 + opts.taxrate / 100);
			goodsData['origtaxprice'] = origtaxprice;
			var taxprice = unitprice * (1 + opts.taxrate / 100); //含税单价=单价*(1+税率/100)
			goodsData['taxprice'] = taxprice;
			var lctaxprice = taxprice;
			goodsData['lctaxprice'] = lctaxprice;
			var amount = taxprice * unitquantity; //计算总额(需要显示)
			goodsData['amount'] = amount.toFixed(2);
			var taxamt = unitquantity * (taxprice - unitprice); //计算税额(需要显示)
			goodsData['taxamt'] = taxamt;
			var goodsamt = amount - taxamt; //计算货品价格 不含税的
			goodsData['goodsamt'] = goodsamt;
			var discamt = origtaxprice * (1 - disc / 100) * unitquantity; //计算折扣
			goodsData['discamt'] = discamt;
			var lcgoodsamt = goodsamt; //lc开头的都是不需要显示的
			goodsData['lcgoodsamt'] = lcgoodsamt;
			var lctaxamt = taxamt;
			goodsData['lctaxamt'] = lctaxamt;
			var lcamount = goodsamt + taxamt;
			goodsData['lcamount'] = lcamount;
			return goodsData;
		},
		getBilling_master: function(master, type, mode) {
			var master_backup = {};
			master_backup['billId'] = master['billid'];
			master_backup['master.amount'] = master['amount'];
			master_backup['master.billcode'] = master['billcode'];
			master_backup['master.billdate'] = master['billdate'];
			master_backup['master.billkind'] = master['billkind'];
			master_backup['master.hadexported'] = master['hadexported'] || 0;
			master_backup['master.billstate'] = master['billstate'] || 0;
			master_backup['master.closeinvoice'] = master['closeinvoice'] || 0;
			master_backup['master.contactfax'] = master['contactfax'] || '';
			master_backup['master.contactphone'] = master['contactphone'] || '';
			master_backup['master.departmentid'] = this.checkNull(master['departmentid']);
			master_backup['master.disc'] = master['disc'] || 100;
			master_backup['master.exrate'] = master['exrate'] || 1;
			master_backup['master.iscashtrader'] = master['iscashtrader'] || '';
			master_backup['master.lcamount'] = master['lcamount'];
			master_backup['master.lcpayamt'] = master['lcpayamt'];
			master_backup['master.lcreferamt'] = master['lcreferamt'] || 0;
			master_backup['master.linkman'] = master['linkman'] || '';
			master_backup['master.moneyid'] = master['moneyid'];
			master_backup['master.notetype'] = master['notetype'];
			if (mode == 'add') {
				master_backup['master.opid'] = _g.getLS('opID');
			} else {
				master_backup['master.opid'] = master['opid'];
			}
			master_backup['master.opname'] = master['opname']; //_g.getLS('opName')
			master_backup['master.payamt'] = master['payamt'];
			master_backup['master.paydate'] = master['paydate'] || '';
			master_backup['master.referamt'] = master['referamt'] || 0;
			master_backup['master.refercount'] = master['refercount'] || 0;
			master_backup['master.scamt'] = master['scamt'] || '';
			master_backup['master.sflag'] = master['sflag'] || 0;
			master_backup['master.shopid'] = this.checkNull(master['shopid']);
			master_backup['master.shopname'] = master['shopname'];
			master_backup['master.taxrate'] = this.checkNull(master['taxrate']);
			master_backup['master.termdays'] = master['termdays'] || 0;
			master_backup['master.traderid'] = this.checkNull(master['traderid']);
			master_backup['master.accountid'] = this.checkNull(master['accountid']);
			master_backup['master.paymethodid'] = this.checkNull(master['paymethodid']);
			master_backup['master.invoiceamt'] = master['invoiceamt'] || 0;
			master_backup['master.invoiceamt'] = master['invoiceamt'] || 0;
			master_backup['master.invoicetype'] = master['invoicetype'] || 0;
			if (type == 'sbilling') { // 销售开单
				master_backup['master.point'] = master['point'] || 0;
				master_backup['master.ishqstore'] = master['ishqstore'] || 0;
			}
			if (master['a00OldJsonValue']) { // 假如单据为已有的情况，则a00OldJsonValue要赋值
				master_backup['master.a00OldJsonValue'] = master['a00OldJsonValue'];
			}
			return master_backup;
		},
		getOrder_master: function(master, type, mode) {
			var master_backup = {};
			master_backup['master.ackappr'] = master['ackappr'] || 0;
			master_backup['master.amount'] = master['amount'];
			master_backup['master.billcode'] = master['billcode'];
			master_backup['master.billdate'] = master['billdate'];
			master_backup['master.billkind'] = master['billkind'] || 1;
			master_backup['master.hadexported'] = master['hadexported'] || 0;
			master_backup['master.billstate'] = master['billstate'] || 0;
			master_backup['master.billstatus'] = master['billstatus'] || 0;
			master_backup['master.closed'] = master['closed'];
			master_backup['master.contactfax'] = master['contactfax'] || '';
			master_backup['master.contactphone'] = master['contactphone'] || '';
			master_backup['master.departmentid'] = this.checkNull(master['departmentid']);
			master_backup['master.distributorid'] = this.checkNull(master['distributorid']);
			master_backup['master.exrate'] = master['exrate'] || 1;
			master_backup['master.forwardamt'] = master['forwardamt'] || 0;
			master_backup['master.iscashtrader'] = master['iscashtrader'] || '';
			master_backup['master.lcamount'] = master['lcamount'];
			master_backup['master.lcforwardamt'] = master_backup['master.forwardamt'];
			master_backup['master.linkman'] = master['linkman'] || '';
			master_backup['master.moneyid'] = master['moneyid'];
			if (mode == 'add') {
				master_backup['master.opid'] = _g.getLS('opID');
			} else {
				master_backup['master.opid'] = master['opid'];
			}
			master_backup['master.opname'] = master['opname'];
			master_backup['master.paymethodid'] = master['paymethodid'];
			master_backup['master.referamt'] = master['referamt'] || 0;
			master_backup['master.refercount'] = master['refercount'] || 0;
			master_backup['master.revdate'] = master['revdate'];
			master_backup['master.sflag'] = master['sflag'] || 0;
			master_backup['master.shopid'] = master['shopid'];
			master_backup['master.shopname'] = master['shopname'];
			master_backup['master.traderid'] = this.checkNull(master['traderid']);
			master_backup['master.ctraderid'] = this.checkNull(master['traderid']);
			master_backup['master.validdate'] = this.checkNull(master['validdate']);
			master_backup['master.remark'] = master['remark'];
			master_backup['master.empid'] = this.checkNull(master['empid']);
			master_backup['master.projectid'] = this.checkNull(master['projectid']);
			if (type == 'porder') {
				//采购订单
				master_backup['master.uploaded'] = master['uploaded'];
				master_backup['master.dsorder'] = master['dsorder'];
			} else {
				//销售订单
				master_backup['master.empid'] = master['empid'];
			}
			if (master['a00OldJsonValue']) {
				//假如单据为已有的情况，则a00OldJsonValue要赋值
				master_backup['master.a00OldJsonValue'] = master['a00OldJsonValue'];
			}
			return master_backup;
		},
		getBilling_detail: function(detail_backup, detail, index, type, detail_type, hasOld, isAdd) { //获取开单类的detail数据
			detail_backup[detail_type + '[' + index + '].billid'] = detail['billid'] || -9999;
			detail_backup[detail_type + '[' + index + '].amount'] = detail['amount'];
			detail_backup[detail_type + '[' + index + '].aprice'] = detail['aprice'];
			detail_backup[detail_type + '[' + index + '].batchcode'] = this.checkNull(detail['batchcode']);
			detail_backup[detail_type + '[' + index + '].breferid'] = this.checkNull(detail['breferid']);
			detail_backup[detail_type + '[' + index + '].baseunitname'] = detail['baseunitname'];
			detail_backup[detail_type + '[' + index + '].costtype'] = detail['costtype'];
			detail_backup[detail_type + '[' + index + '].disc'] = detail['disc'];
			detail_backup[detail_type + '[' + index + '].discamt'] = detail['discamt'];
			detail_backup[detail_type + '[' + index + '].erate'] = detail['erate'];
			detail_backup[detail_type + '[' + index + '].extqty'] = detail['extqty'];
			detail_backup[detail_type + '[' + index + '].goodsamt'] = detail['goodsamt'];
			detail_backup[detail_type + '[' + index + '].goodscode'] = detail['goodscode'];
			detail_backup[detail_type + '[' + index + '].goodsid'] = this.checkNull(detail['goodsid']);
			detail_backup[detail_type + '[' + index + '].goodskind'] = detail['goodskind'];
			detail_backup[detail_type + '[' + index + '].goodsname'] = detail['goodsname'];
			detail_backup[detail_type + '[' + index + '].goodstaxrate'] = this.checkNull(detail['goodstaxrate']);
			detail_backup[detail_type + '[' + index + '].ioqty'] = detail['ioqty'];
			detail_backup[detail_type + '[' + index + '].is__detail__modify'] = detail['is__detail__modify'];
			detail_backup[detail_type + '[' + index + '].isbatch'] = detail['isbatch'];
			detail_backup[detail_type + '[' + index + '].islargess'] = detail['islargess'];
			detail_backup[detail_type + '[' + index + '].itemno'] = this.checkNull(detail['itemno']);
			detail_backup[detail_type + '[' + index + '].lcamount'] = this.parseTonum(detail['amount']);
			detail_backup[detail_type + '[' + index + '].lcgoodsamt'] = this.parseTonum(detail['goodsamt']);
			detail_backup[detail_type + '[' + index + '].lcprice'] = detail['price'];
			detail_backup[detail_type + '[' + index + '].lctaxamt'] = detail['taxamt'];
			detail_backup[detail_type + '[' + index + '].lctaxprice'] = detail['taxprice'];
			detail_backup[detail_type + '[' + index + '].lcunitprice'] = this.parseTonum(detail['unitprice']);
			detail_backup[detail_type + '[' + index + '].origprice'] = detail['origprice'];
			detail_backup[detail_type + '[' + index + '].origtaxprice'] = detail['origtaxprice'];
			detail_backup[detail_type + '[' + index + '].price'] = detail['price'];
			detail_backup[detail_type + '[' + index + '].quantity'] = detail['quantity'];
			detail_backup[detail_type + '[' + index + '].refercount'] = detail['refercount'];
			detail_backup[detail_type + '[' + index + '].referextqty'] = detail['referextqty'];
			detail_backup[detail_type + '[' + index + '].referqty'] = detail['referqty'] || 0;
			detail_backup[detail_type + '[' + index + '].specs'] = detail['specs'];
			detail_backup[detail_type + '[' + index + '].storecode'] = this.checkNull(detail['storecode']);
			detail_backup[detail_type + '[' + index + '].storeid'] = this.checkNull(detail['storeid']);
			detail_backup[detail_type + '[' + index + '].storename'] = detail['storename'];
			detail_backup[detail_type + '[' + index + '].storeshopid'] = this.checkNull(detail['storeshopid']);
			detail_backup[detail_type + '[' + index + '].sumquantity'] = detail['sumquantity'] || 0;
			detail_backup[detail_type + '[' + index + '].taxamt'] = detail['taxamt'];
			detail_backup[detail_type + '[' + index + '].taxprice'] = this.parseTonum(detail['taxprice']);
			detail_backup[detail_type + '[' + index + '].taxrate'] = this.checkNull(detail['taxrate']);
			detail_backup[detail_type + '[' + index + '].unitid'] = this.checkNull(detail['unitid']);
			detail_backup[detail_type + '[' + index + '].unitname'] = detail['unitname'];
			detail_backup[detail_type + '[' + index + '].unitname1'] = detail['unitname1'];
			detail_backup[detail_type + '[' + index + '].unitprice'] = this.parseTonum(detail['unitprice']);
			detail_backup[detail_type + '[' + index + '].unitqty1'] = detail['unitqty1'];
			detail_backup[detail_type + '[' + index + '].unitqty2'] = detail['unitqty2'];
			detail_backup[detail_type + '[' + index + '].unitqty3'] = detail['unitqty3'];
			detail_backup[detail_type + '[' + index + '].unitquantity'] = this.parseTonum(detail['unitquantity']);
			detail_backup[detail_type + '[' + index + '].unitrate'] = detail['unitrate'];
			detail_backup[detail_type + '[' + index + '].unitrate1'] = detail['unitrate1'];
			detail_backup[detail_type + '[' + index + '].unitrate2'] = detail['unitrate2'];
			detail_backup[detail_type + '[' + index + '].unitrate3'] = detail['unitrate3'];
			detail_backup[detail_type + '[' + index + '].validdates'] = detail['validdates'];
			detail_backup[detail_type + '[' + index + '].productdate'] = this.checkNull(detail['productdate']);
			detail_backup[detail_type + '[' + index + '].validdate'] = this.checkNull(detail['validdate']);
			detail_backup[detail_type + '[' + index + '].barcode'] = detail['barcode'] || '';
			detail_backup[detail_type + '[' + index + '].barcodeid'] = this.checkNull(detail['barcodeid']);
			if (type == 'sbilling') {
				//销售开单
				detail_backup[detail_type + '[' + index + '].allotqty'] = detail['allotqty'];
				detail_backup[detail_type + '[' + index + '].invoiceamt'] = detail['invoiceamt'] || 0;
				detail_backup[detail_type + '[' + index + '].invoiceqty'] = detail['invoiceqty'] || 0;
				detail_backup[detail_type + '[' + index + '].isallot'] = detail['isallot'] || 0;
				detail_backup[detail_type + '[' + index + '].iscometrader'] = detail['iscometrader'];
				detail_backup[detail_type + '[' + index + '].margin'] = detail['margin'];
				detail_backup[detail_type + '[' + index + '].point'] = detail['point'] || 0;
				detail_backup[detail_type + '[' + index + '].unitname2'] = detail['unitname2'];
				detail_backup[detail_type + '[' + index + '].unitname3'] = detail['unitname3'];
				detail_backup[detail_type + '[' + index + '].iscometrader'] = detail['iscometrader'] || 0;
				detail_backup[detail_type + '[' + index + '].referbilltype'] = detail['referbilltype'] || 0;
			} else {
				//采购开单
				detail_backup[detail_type + '[' + index + '].alreadyapt'] = detail['alreadyapt'] || 0;
				//如果breferid是-9999的话 则将其置空
				if (detail['breferid'] == -9999)
					detail_backup[detail_type + '[' + index + '].breferid'] = '';
			}
			if (hasOld) {
				detail_backup[detail_type + '[' + index + '].a00OldJsonValue'] = detail['a00OldJsonValue'];
			} else {
				detail_backup[detail_type + '[' + index + '].a00OldJsonValue'] = '';
			}
			if (isAdd) {
				detail_backup[detail_type + '[' + index + '].itemno'] = (index + 1) * (-1);
				detail_backup[detail_type + '[' + index + '].sumquantity'] = 0;
			}
			return detail_backup;
		},
		getOrder_detail: function(detail_backup, detail, index, type, detail_type, hasOld, isAdd) {
			detail_backup[detail_type + '[' + index + '].billid'] = detail['billid'] || -9999;
			detail_backup[detail_type + '[' + index + '].amount'] = detail['amount'];
			detail_backup[detail_type + '[' + index + '].aprice'] = detail['aprice'];
			detail_backup[detail_type + '[' + index + '].baseunitname'] = detail['baseunitname'];
			detail_backup[detail_type + '[' + index + '].chargedate'] = detail['chargedate'];
			detail_backup[detail_type + '[' + index + '].closed'] = detail['closed'] || 0;
			detail_backup[detail_type + '[' + index + '].costtype'] = detail['costtype'];
			detail_backup[detail_type + '[' + index + '].disc'] = detail['disc'];
			detail_backup[detail_type + '[' + index + '].discamt'] = detail['discamt'];
			detail_backup[detail_type + '[' + index + '].erate'] = detail['erate'];
			detail_backup[detail_type + '[' + index + '].extqty'] = detail['extqty'];
			detail_backup[detail_type + '[' + index + '].gcmid'] = this.checkNull(detail['gcmid']);
			detail_backup[detail_type + '[' + index + '].goodsamt'] = detail['goodsamt'];
			detail_backup[detail_type + '[' + index + '].goodscode'] = detail['goodscode'];
			detail_backup[detail_type + '[' + index + '].goodsid'] = this.checkNull(detail['goodsid']);
			detail_backup[detail_type + '[' + index + '].goodskind'] = detail['goodskind'];
			detail_backup[detail_type + '[' + index + '].goodsname'] = detail['goodsname'];
			detail_backup[detail_type + '[' + index + '].goodstaxrate'] = this.checkNull(detail['goodstaxrate']);
			detail_backup[detail_type + '[' + index + '].ioqty'] = detail['ioqty'];
			detail_backup[detail_type + '[' + index + '].is__detail__modify'] = detail['is__detail__modify'];
			detail_backup[detail_type + '[' + index + '].isbatch'] = detail['isbatch'];
			detail_backup[detail_type + '[' + index + '].islargess'] = detail['islargess'];
			detail_backup[detail_type + '[' + index + '].itemno'] = detail['itemno'] || '';
			detail_backup[detail_type + '[' + index + '].lcamount'] = detail['amount'];
			detail_backup[detail_type + '[' + index + '].lcgoodsamt'] = detail['goodsamt'];
			detail_backup[detail_type + '[' + index + '].lcprice'] = detail['price'];
			detail_backup[detail_type + '[' + index + '].lctaxamt'] = detail['taxamt'];
			detail_backup[detail_type + '[' + index + '].lctaxprice'] = detail['taxprice'];
			detail_backup[detail_type + '[' + index + '].lcunitprice'] = detail['unitprice'];
			detail_backup[detail_type + '[' + index + '].origprice'] = detail['origprice'];
			detail_backup[detail_type + '[' + index + '].origtaxprice'] = detail['origtaxprice'];
			detail_backup[detail_type + '[' + index + '].price'] = detail['price'];
			//detail_backup[detail_type+'['+index+'].purrequestqty']=detail['purrequestqty'];
			detail_backup[detail_type + '[' + index + '].quantity'] = detail['quantity'];
			detail_backup[detail_type + '[' + index + '].refercount'] = detail['refercount'];
			detail_backup[detail_type + '[' + index + '].referextqty'] = detail['referextqty'];
			detail_backup[detail_type + '[' + index + '].referqty'] = detail['referqty'] || 0;
			detail_backup[detail_type + '[' + index + '].specs'] = detail['specs'];
			detail_backup[detail_type + '[' + index + '].sumquantity'] = detail['sumquantity'] || 0;
			detail_backup[detail_type + '[' + index + '].taxamt'] = detail['taxamt'];
			detail_backup[detail_type + '[' + index + '].taxprice'] = detail['taxprice'];
			detail_backup[detail_type + '[' + index + '].taxrate'] = this.checkNull(detail['taxrate']);
			detail_backup[detail_type + '[' + index + '].unitid'] = this.checkNull(detail['unitid']);
			detail_backup[detail_type + '[' + index + '].unitname'] = detail['unitname'];
			detail_backup[detail_type + '[' + index + '].unitname1'] = detail['unitname1'];
			detail_backup[detail_type + '[' + index + '].unitprice'] = detail['unitprice'];
			detail_backup[detail_type + '[' + index + '].unitqty1'] = detail['unitqty1'];
			detail_backup[detail_type + '[' + index + '].unitqty2'] = detail['unitqty2'];
			detail_backup[detail_type + '[' + index + '].unitqty3'] = detail['unitqty3'];
			detail_backup[detail_type + '[' + index + '].unitquantity'] = this.parseTonum(detail['unitquantity']);
			detail_backup[detail_type + '[' + index + '].unitrate'] = detail['unitrate'];
			detail_backup[detail_type + '[' + index + '].unitrate1'] = detail['unitrate1'];
			detail_backup[detail_type + '[' + index + '].unitrate2'] = detail['unitrate2'];
			detail_backup[detail_type + '[' + index + '].unitrate3'] = detail['unitrate3'];
			detail_backup[detail_type + '[' + index + '].validdates'] = detail['validdates'];
			detail_backup[detail_type + '[' + index + '].iscometrader'] = detail['iscometrader'] || 0;
			detail_backup[detail_type + '[' + index + '].referbilltype'] = detail['referbilltype'] || 0;
			detail_backup[detail_type + '[' + index + '].barcode'] = detail['barcode'] || '';
			detail_backup[detail_type + '[' + index + '].barcodeid'] = this.checkNull(detail['barcodeid']);
			if (type == 'porder') {
				//采购订单

			} else {
				//销售订单
				detail_backup[detail_type + '[' + index + '].purrequestqty'] = detail['purrequestqty'] || 0;
			}
			if (hasOld) {
				detail_backup[detail_type + '[' + index + '].a00OldJsonValue'] = detail['a00OldJsonValue'];
			}
			if (isAdd) {
				detail_backup[detail_type + '[' + index + '].itemno'] = (index + 1) * (-1);
			}
			return detail_backup;
		},
		setData: function(opts) { // 设置操作参数
			var self = this;
			$.extend(self.data, opts);
			BData.set({ // 格式化数据（用于分享、打印）
				type: self.data.type,
				data: self.data.bill
			});
		},
		del: function(opts) { // 删除
			var self = this;
			var data = self.data;
			_g.confirm({
				params: {
					msg: '确定删除该单据？',
					buttons: ['确定', '取消']
				},
				success: function(ret) {
					if (ret.buttonIndex == 1) {
						HTTP.ajax({
							url: self.interface[data.type]['del'].url,
							data: {
								billId: data.bill.id,
								checkStep: 0,
								id: data.bill.id
							},
							method: 'post',
							success: function(ret) {
								_g.toastMsg({
									msg: '删除成功！'
								});
								self.reloadList(); // 重新加载列表
								setTimeout(function() {
									api.closeWin();
								}, 1000);
							}
						});
					}
				}
			});
		},
		save: function(opts) { // 保存
			var self = this;
			_g.showLoading({
				title: '正在保存'
			});
			switch (self.data.type) {
				case 'chance':
					self.saveBill();
					break;
				case 'price':
					self.saveBill();
					break;
			}
		},
		saveBill: function() {
			var self = this;
			var data = self.data;
			var master = data.bill.master;

			var param = {
				url: self.interface[data.type].save.url,
				data: {}
			}
			$.extend(param.data, self.getSaveMaster()) // 生成主单据数据
			console.log(_g.j2s(param.data));
			if (data.type == 'chance' || data.type == 'price') {
				if (data.mode == 'add') {
					param.data['addnewFlag'] = 'true';
					param.data['billId'] = -9999;
					param.data['master.shopid'] = _g.getLS('shopID');
					param.data['master.shopname'] = self.checkNull(_g.getLS('shopName'));
					param.data['master.opid'] = _g.getLS('opID');
					param.data['master.opname'] = _g.getLS('opName');
					param.data['master.moneyname'] = '人民币'; // 币种
					param.data['master.moneycode'] = '￥';
					param.data['master.moneyid'] = 0; // 币种id
					param.data['master.exrate'] = 1; // 汇率
					param.data['master.billkind'] = 1;
				} else {
					param.data['addnewFlag'] = 'false';
					param.data['billId'] = data.bill.id;
					param.data['master.shopid'] = _g.getLS('shopID');
					param.data['master.shopname'] = self.checkNull(_g.getLS('shopName'));
					param.data['master.opid'] = _g.getLS('opID');
					param.data['master.opname'] = _g.getLS('opName');
					param.data['master.moneyname'] = '人民币'; // 币种
					param.data['master.moneycode'] = '￥';
					param.data['master.moneyid'] = 0; // 币种id
					param.data['master.exrate'] = 1; // 汇率
					param.data['master.billkind'] = 1;
				}
				param.data.startIndex = 0;
				param.data.undefined = 2;
				// 设置相关业务(引用单据)数据，需赋值给商品明细
				// _g.setLS('referbillid', business.unknownToEmpty(master.referbillid));
				// _g.setLS('referbillitemno', business.unknownToEmpty(master.referbillitemno));
				// _g.setLS('referbilltype', business.unknownToEmpty(master.referbilltype));
			}

			console.log('save first');

			var saveDetail = self.getSaveDetail(); // 生成商品明细(新增、编辑)数据
			
			$.extend(param.data, saveDetail.data);
			param.data.detail1Count = saveDetail.count; // 数量

			console.log('save second');
			var saveDeletedetail = self.getSaveDeletedetail(); // 生成商品明细(删除)数据
			console.log('save third');
			$.extend(param.data, saveDeletedetail.data);
			param.data.deletedetail1Count = saveDeletedetail.count; // 数量
			 for (var x in param.data) {
      	if(param.data[x] == null || param.data[x] == 'undefined'){
      		delete param.data[x]
      	}
      }
      //判断货品明细的数量是否为0
			if(data.bill.goods.length == 0 && data.type == 'price'){
				api.hideProgress();
				_g.toastMsg({
					msg: '请选择货品,再进行保存'
				});
				return
			}
			HTTP.ajax({
				url: param.url,
				data: param.data,
				success: function(ret) {
					_g.toastMsg({
						msg: '保存成功！'
					});
					if (self.data.mode == 'add') { // 如果新增，需要获取单据的id作为参数上传文件
						var annexList = _g.getLS('annex-list') || [];
						if(annexList.length > 0){
							self.updateAnnex({
								billId: ret.billId,
								modId: self.param[self.data.type].modId,
								annexList: annexList
							})
						}
					}
					self.reloadList(); // 重新加载列表
					setTimeout(function() {
						api.closeWin();
					}, 1000);
				},
				other: function(err) {
					api.hideProgress();
					_g.toastMsg({
						msg: err.errMsg
					});
				},
				error: function(err) {
					api.hideProgress();
					_g.toastMsg({
						msg: err.msg
					});
				}
			});
		},
		getSaveMaster: function() {
			var self = this;
			var data = self.data;
			var master = data.bill.master;
			var sortMaster = {}
			
//			_.each(master, function(val, key){
//				if(val != null){
//					sortMaster['master.' + key] = val
//				}
//				
//			})
			var param = {};
			switch (data.type) {
				case 'chance':
					param['master.a00OldJsonValue'] = master.a00OldJsonValue || '';
					// param['master.accsetid'] = self.checkNull(master.accsetid) || '';
					// param['master.activitycode'] = master.activitycode || '';
					param['master.activityid'] = self.checkNull(master.activityid);
					param['master.amount'] = master.amount || 0;
					// param['master.approvedid'] = master.approvedid || '';
					param['master.billstate'] = self.checkNull(master.billstate) || 0;
					// param['master.billstatename'] = master.billstatename || '';
					param['master.traderid'] = self.checkNull(master.traderid);
					param['master.tradername'] = self.checkNull(master.tradername);
					param['master.billcode'] = self.checkNull(master.billcode);
					param['master.contactid'] = self.checkNull(master.contactid);
					param['master.contactname'] = master.contactname || '';
					// param['master.donestep'] = master.donestep || 0;
					param['master.editdate'] = master.editdate || '';
					param['master.editid'] = self.checkNull(master.editid);
					// param['master.editname'] = master.editname || '';
					param['master.empid'] = self.checkNull(master.empid);
					param['master.empname'] = master.empname || '';
					param['master.enddate'] = master.enddate;
					param['master.billid'] = self.checkNull(master.billid);
					// param['master.isaudit'] = master.isaudit || '';
					// param['master.marketname'] = master.marketname || '';
					param['master.name'] = master.name || '';
					param['master.opdate'] = master.opdate || '';
					param['master.opid'] = self.checkNull(master.opid);
					param['master.opname'] = master.opname || '';
					param['master.possibility'] = master.possibility || 0;
					param['master.refercount'] = self.checkNull(master.refercount) || 0;
					param['master.remark'] = master.remark || '';
					param['master.rivalid'] = self.checkNull(master.rivalid);
					// param['master.rivalname'] = master.rivalname || '';
					param['master.sourceid'] = self.checkNull(master.sourceid);
					// param['master.sourcename'] = master.sourcename || '';
					param['master.chancetypename'] = master.chancetypename || '';
					param['master.status'] = self.checkNull(master.status);
					param['master.updatetime'] = master.updatetime || '';
					// param['master.havaudit'] = self.checkNull(master.havaudit) || '';
					if (master.billdate.length == 10) {
						param['master.billdate'] = master.billdate;
					} else {
						param['master.billdate'] = master.billdate;
					}
					param['master.closed'] = self.checkNull(master.closed) || 0;
					param['master.moneyid'] = self.checkNull(master.moneyid);
					param['master.moneyname'] = self.checkNull(master.moneyname);
					break;
				case 'price':
					param['master.a00OldJsonValue'] = master.a00OldJsonValue || '';
					param['master.accsetid'] = self.checkNull(master.accsetid);
					param['master.amount'] = master.amount || 0;
					param['master.billstate'] = self.checkNull(master.billstate) || 0;
					// param['master.chancecode'] = self.checkNull(master.chancecode);
					var chanceid = self.checkNull(master.chanceid);
					if(chanceid != ''){
						param['master.chanceid'] = chanceid
					}
					param['master.chancename'] = self.checkNull(master.chancename);
					param['master.traderid'] = self.checkNull(master.traderid);
					param['master.tradername'] = master.tradername;
					param['master.billcode'] = self.checkNull(master.billcode);
					param['master.contactid'] = self.checkNull(master.contactid);
					param['master.contactname'] = master.contactname || '';
					param['master.editdate'] = master.editdate || '';
					param['master.editid'] = self.checkNull(master.editid);
					// param['master.editname'] = master.editname || '';
					param['master.enddate'] = master.enddate;
					param['master.billid'] = self.checkNull(master.billid);
					param['master.name'] = self.checkNull(master.name);
					if (master.billdate.length == 10) {
						param['master.billdate'] = master.billdate
					} else {
						param['master.billdate'] = master.billdate;
					}
					param['master.opid'] = self.checkNull(master.opid);
					param['master.opname'] = master.opname || '';
					param['master.ownerid'] = master.ownerid || _g.getLS('employId');
					// param['master.ownername'] = master.ownername || '';
					param['master.refercount'] = self.checkNull(master.refercount) || 0;
					param['master.remark'] = self.checkNull(master.remark);
					param['master.startdate'] = master.startdate;
					param['master.status'] = self.checkNull(master.status);
					param['master.statusname'] = master.statusname || '';
					param['master.updatetime'] = master.updatetime || '';
					// param['master.havaudit'] = self.checkNull(master.havaudit) || '';
					break;
			}
			param = $.extend(sortMaster, param)
			console.log('param:'+JSON.stringify(param))
			return param;
		},
		getSaveDetail: function() {
			var self = this;
			var data = {};
			var itemno = 0;
			var index = 0; // 提交的数组序号
			var count = 0; // 数量
			var type = self.data.type;
			var goods = self.data.bill.goods;
			_.each(goods, function(ele, index, list) {
				if(ele.goodMode != 'delete'){
					if (ele.goodMode == 'add') {
						ele.itemno = --itemno; // itemno为商品明细id，新增时从-1开始
					}
					$.extend(data, self.getSaveDetailData({
						type: type,
						key: 'detail1',
						ele: ele,
						index: count
					}));
					count += 1;
				}
			});
			return {
				data: data,
				count: count
			};
		},
		getSaveDeletedetail: function() {
			var self = this;
			var data = {};
			var count = 0; // 数量
			var type = self.data.type;
			var delGoods = self.data.bill.delGoods;
			_.each(delGoods, function(ele, index, list) {
				$.extend(data, self.getSaveDetailData({
					type: type,
					key: 'deletedetail1',
					ele: ele,
					index: index
				}));
				count++; // 数量
			});
			return {
				data: data,
				count: delGoods.length
			};
		},
		openTapGetDate: function(opts){ //选择日期
		
			_g.openPicker({
				date: opts.billdate,
				success: function(ret){
					var dataJson = $.extend(opts.dataJson, {billDate: ret.year + '-' + ret.month + '-' + ret.day})
					api.ajax({
				    url: URLANNEX + '/common/bill/billpublic!doGetBillCode.action',
				    method: 'post',
				    data: {
			        values: {
			          param: JSON.stringify(dataJson)
			        },
			        files: {}
				    }
				}, function(ret, err) {
				    if (ret) {
				    	opts.success && opts.success(ret, dataJson.billDate);     
				    } else {
				      _g.toastMsg({msg: ret.errMsg})
				    }
				});
					
				}
			})
		},
		getSaveDetailData: function(opts) {
			var self = this;
			var param = {};
			console.log('opts.ele:'+_g.j2s(opts.ele))
			param[opts.key + '[' + opts.index + '].billid'] = opts.ele['billid'] || -9999;
			param[opts.key + '[' + opts.index + '].amount'] = opts.ele['amount'];
			param[opts.key + '[' + opts.index + '].aprice'] = opts.ele['aprice'];
			param[opts.key + '[' + opts.index + '].batchcode'] = self.checkNull(opts.ele['batchcode']);
			param[opts.key + '[' + opts.index + '].breferid'] = self.checkNull(opts.ele['breferid']);
			param[opts.key + '[' + opts.index + '].baseunitname'] = self.checkNull(opts.ele['baseunitname']);
			param[opts.key + '[' + opts.index + '].costtype'] = opts.ele['costtype'];
			param[opts.key + '[' + opts.index + '].disc'] = opts.ele['disc'];
			param[opts.key + '[' + opts.index + '].discamt'] = opts.ele['discamt'];
			param[opts.key + '[' + opts.index + '].erate'] = opts.ele['erate'];
			param[opts.key + '[' + opts.index + '].extqty'] = opts.ele['extqty'];
			param[opts.key + '[' + opts.index + '].goodsamt'] = opts.ele['goodsamt'];
			param[opts.key + '[' + opts.index + '].goodscode'] = opts.ele['goodscode'];
			param[opts.key + '[' + opts.index + '].goodsid'] = self.checkNull(opts.ele['goodsid']);
			param[opts.key + '[' + opts.index + '].goodskind'] = opts.ele['goodskind'];
			param[opts.key + '[' + opts.index + '].goodsname'] = opts.ele['goodsname'];
			param[opts.key + '[' + opts.index + '].goodstaxrate'] = self.checkNull(opts.ele['goodstaxrate']);
			param[opts.key + '[' + opts.index + '].ioqty'] = opts.ele['ioqty'];
			param[opts.key + '[' + opts.index + '].is__detail__modify'] = opts.ele['is__detail__modify'];
			param[opts.key + '[' + opts.index + '].isbatch'] = opts.ele['isbatch'];
			param[opts.key + '[' + opts.index + '].islargess'] = opts.ele['islargess'];
			param[opts.key + '[' + opts.index + '].itemno'] = self.checkNull(opts.ele['itemno']);
			param[opts.key + '[' + opts.index + '].lcamount'] = self.parseTonum(opts.ele['amount']);
			param[opts.key + '[' + opts.index + '].lcgoodsamt'] = self.parseTonum(opts.ele['goodsamt']);
			param[opts.key + '[' + opts.index + '].lcprice'] = opts.ele['price'];
			param[opts.key + '[' + opts.index + '].lctaxamt'] = opts.ele['taxamt'];
			param[opts.key + '[' + opts.index + '].lctaxprice'] = opts.ele['taxprice'];
			param[opts.key + '[' + opts.index + '].lcunitprice'] = self.parseTonum(opts.ele['unitprice']);
			param[opts.key + '[' + opts.index + '].origprice'] = opts.ele['origprice'];
			param[opts.key + '[' + opts.index + '].origtaxprice'] = opts.ele['origtaxprice'];
			param[opts.key + '[' + opts.index + '].price'] = opts.ele['price'];
			param[opts.key + '[' + opts.index + '].quantity'] = opts.ele['quantity'];
			param[opts.key + '[' + opts.index + '].refercount'] = opts.ele['refercount'];
			param[opts.key + '[' + opts.index + '].referextqty'] = opts.ele['referextqty'];
			param[opts.key + '[' + opts.index + '].referqty'] = opts.ele['referqty'] || 0;
			param[opts.key + '[' + opts.index + '].specs'] = opts.ele['specs'];
			param[opts.key + '[' + opts.index + '].storecode'] = self.checkNull(opts.ele['storecode']);
			param[opts.key + '[' + opts.index + '].storeid'] = self.checkNull(opts.ele['storeid']);
			param[opts.key + '[' + opts.index + '].storename'] = opts.ele['storename'];
			param[opts.key + '[' + opts.index + '].storeshopid'] = self.checkNull(opts.ele['storeshopid']);
			param[opts.key + '[' + opts.index + '].sumquantity'] = self.checkNull(opts.ele['sumquantity']) || 0;
			param[opts.key + '[' + opts.index + '].taxamt'] = opts.ele['taxamt'];
			param[opts.key + '[' + opts.index + '].taxprice'] = self.parseTonum(opts.ele['taxprice']);
			param[opts.key + '[' + opts.index + '].taxrate'] = self.checkNull(opts.ele['taxrate']);
			param[opts.key + '[' + opts.index + '].unitid'] = self.checkNull(opts.ele['unitid']);
			param[opts.key + '[' + opts.index + '].unitname'] = opts.ele['unitname'];
			param[opts.key + '[' + opts.index + '].unitname1'] = opts.ele['unitname1'];
			param[opts.key + '[' + opts.index + '].unitprice'] = self.parseTonum(opts.ele['unitprice']);
			param[opts.key + '[' + opts.index + '].unitqty1'] = opts.ele['unitqty1'];
			param[opts.key + '[' + opts.index + '].unitqty2'] = opts.ele['unitqty2'];
			param[opts.key + '[' + opts.index + '].unitqty3'] = opts.ele['unitqty3'];
			// if(self.data.type == 'price'){
			// 	param[opts.key + '[' + opts.index + '].unitquantity'] = self.parseTonum(opts.ele['unitquantity']);
			// }else{
				param[opts.key + '[' + opts.index + '].unitquantity'] = self.parseTonum(opts.ele['quantity']);
			// }
			param[opts.key + '[' + opts.index + '].quantity'] = param[opts.key + '[' + opts.index + '].unitquantity'] * self.parseTonum(opts.ele['unitrate']);
			param[opts.key + '[' + opts.index + '].unitrate'] = opts.ele['unitrate'];
			param[opts.key + '[' + opts.index + '].unitrate1'] = opts.ele['unitrate1'];
			param[opts.key + '[' + opts.index + '].unitrate2'] = opts.ele['unitrate2'];
			param[opts.key + '[' + opts.index + '].unitrate3'] = opts.ele['unitrate3'];
			param[opts.key + '[' + opts.index + '].validdates'] = opts.ele['validdates'] || 0;
			param[opts.key + '[' + opts.index + '].productdate'] = self.checkNull(opts.ele['productdate']);
			param[opts.key + '[' + opts.index + '].validdate'] = self.checkNull(opts.ele['validdate']);
			param[opts.key + '[' + opts.index + '].barcode'] = opts.ele['barcode'] || '';
			param[opts.key + '[' + opts.index + '].barcodeid'] = self.checkNull(opts.ele['barcodeid']);

			param[opts.key + '[' + opts.index + '].allotqty'] = opts.ele['allotqty'];
			param[opts.key + '[' + opts.index + '].invoiceamt'] = opts.ele['invoiceamt'] || 0;
			param[opts.key + '[' + opts.index + '].invoiceqty'] = opts.ele['invoiceqty'] || 0;
			param[opts.key + '[' + opts.index + '].isallot'] = opts.ele['isallot'] || 0;
			param[opts.key + '[' + opts.index + '].iscometrader'] = opts.ele['iscometrader'];
			param[opts.key + '[' + opts.index + '].margin'] = opts.ele['margin'];
			param[opts.key + '[' + opts.index + '].point'] = opts.ele['point'] || 0;
			param[opts.key + '[' + opts.index + '].unitname2'] = opts.ele['unitname2'];
			param[opts.key + '[' + opts.index + '].unitname3'] = opts.ele['unitname3'];
			param[opts.key + '[' + opts.index + '].iscometrader'] = opts.ele['iscometrader'] || 0;
			param[opts.key + '[' + opts.index + '].referbilltype'] = opts.ele['referbilltype'] || 0;

			if(opts.ele['referitemno']){
				param[opts.key + '[' + opts.index + '].referitemno'] = opts.ele['referitemno'];
			}

			if (opts.ele['goodMode'] == 'old' || opts.ele['goodMode'] == 'edit') {
				param[opts.key + '[' + opts.index + '].a00OldJsonValue'] = opts.ele['a00OldJsonValue'];
			} else {
				param[opts.key + '[' + opts.index + '].a00OldJsonValue'] = '';
			}
			if (opts.ele['goodMode'] == 'add') {
				param[opts.key + '[' + opts.index + '].itemno'] = (opts.index + 1) * (-1);
				param[opts.key + '[' + opts.index + '].sumquantity'] = 0;
			}
			return param;
		},
		approval: function(opts) { // 审核
			var self = this;
			_g.showLoading({
				title: '正在' + opts.tips + '中'
			});
			HTTP.ajax({
				url: self.interface[self.data.type].approval.url,
				data: {
					billId: self.data.bill.id,
					modId: self.data.bill.modId
				},
				success: function(ret) {
					if (ret.errNo == 0) {
						_g.toastMsg({
							msg: opts.tips + '成功'
						});
						self.reloadList();
						setTimeout(function() {
							api.closeWin();
						}, 800);
					} else {
						_g.toastMsg({
							msg: ret.errMsg
						});
					}
				}
			})
		},
		unapproval: function() { // 反审核
			var self = this;
			self.approval({
				tips: '反审核'
			});
		},
		updateAnnex: function(opts) { // 上传附件列表
			var billId = opts.billId;
			var modId = opts.modId;
			var annexList = opts.annexList;
			for (var i = 0; i < annexList.length; i++) {
				HTTP.ajax({
					url: URLANNEX + '/sys/file/sysFileUpload!uploadFile.action',
					data: {
						id: billId,
						modId: modId,
						fileFileName: annexList[i].filename + '.' + annexList[i].filetype, // 文件名+.文件格式
						voiceTime: annexList[i].voiceTime || 0, // 录音的时候voiceTime这个参数是大于0，如果是其它类型就等于0
					},
					files: {
						file: annexList[i].filepath,
					},
					success: function(ret) {
						_g.toastMsg({
							msg: ret.errMsg
						});
					},
					error: function(err) {
						_g.toastMsg({
							msg: ret.msg
						});
					}
				});
			}
		},
		reloadList: function() { // 重新加载列表
			api.sendEvent({
				name: 'bill-list-reload'
			});
		},
		getAnnex: function(opts) { // 获取附件列表
			HTTP.ajax({
				url: URLANNEX + '/sys/file/sysFileUpload!doGetListData.action',
				data: opts.data,
				success: function(ret) {
					opts.success && opts.success(ret);
				},
				error: function(err) {
					_g.toastMsg({
						msg: err.msg
					});
				}
			});
		},
		wxText: function(opts){
			var text = opts.textJson.title + '\r\n\r\n';
			$.each(opts.textJson.content, function(key, val) {
				if(key == 'data'){
					text = text + '\r\n';
					//val为数组
					$.each(val, function(dkey, dval){
						$.each(dval, function(ddkey, ddval){
							text = text + ddkey + ": " + ddval + '\r\n';
						})
					})
				}else{
					text = text + key + ": " + val + '\r\n';
				}
			});
			return text
		},
		share: function(opts) { // 分享操作
			var self = this;
			if (opts.type == 'wx') { // 微信
				var text = self.wxText({
					textJson: BData.getQQData()
				})
		
				var target1 = ''
				api.actionSheet({
					cancelTitle: '取消',
					buttons: ['分享给好友', '分享到朋友圈']
				}, function(ret, err) {
					if(ret.buttonIndex == 1){
						target1 = 'wxSession'
					}else if(ret.buttonIndex == 2){
						target1 = 'wxTimeline'
					} else {
						return;
					}
					mobShare.shareTo({
				    target: target1,
				    text: text,
					}, function(ret, err) {
				    if (ret.status) {
				      _g.toastMsg({
								msg: '分享成功'
							});
				    }
					});
				})
			} else { // QQ
				QQ.shareText({
					textJson: BData.getQQData(),
					success: function(ret) {
						_g.toastMsg({
							msg: '分享成功'
						});
					},
					error: function(err) {
						_g.toastMsg({
							msg: err.msg
						});
					}
				});
			}
		},
		print: function(opts) { // 打印操作
			var self = this;
			var BLE = require('ble/blePrinter');
			BLE.setData({ // 设置打印数据
				data: BData.getPrintData()
			});
			BLE.printEvent(); // 执行打印

			api.addEventListener({ // 选择打印机设备后自动打印事件
				name: 'new-printer-print-auto'
			}, function(ret, err) {
				BLE.printEvent();
			});
		},
		verify: function() { // 表单验证
			var self = this;
			var data = self.data;
			var master = data.bill.master;
			var bool = false;
			switch (data.type) {
				case 'chance':
					if (master.billcode === null || master.billcode === '') {
						_g.toastMsg({
							msg: '请先输入编号'
						});
						return;
					}
					if (master.possibility < 0 || master.possibility > 100) {
						_g.toastMsg({
							msg: '可能性必须在0-100之间'
						});
						return;
					}
					if (master.name === null || master.name === '') {
						_g.toastMsg({
							msg: '请先输入机会名称'
						});
						return;
					}
					if (master.traderid === null || master.traderid === '') {
						_g.toastMsg({
							msg: '请先选择客户'
						});
						return;
					}
					if (master.enddate === null || master.enddate === '') {
						_g.toastMsg({
							msg: '请先选择结束日期'
						});
						return;
					}
					if (master.stagename === null || master.stagename === '') {
						_g.toastMsg({
							msg: '请先选择阶段'
						});
						return;
					}
					// if (master.empid === null || master.empid === '') {
					// 	_g.toastMsg({
					// 		msg: '请先选择业务员'
					// 	});
					// 	return;
					// }
					bool = true;
					break;
				case 'price':
					if (master.code === null || master.code === '') {
						_g.toastMsg({
							msg: '请先输入编号'
						});
						return;
					}
					if (master.name === null || master.name === '') {
						_g.toastMsg({
							msg: '请先输入主题'
						});
						return;
					}
					if (master.traderid === null || master.traderid === '') {
						_g.toastMsg({
							msg: '请先选择客户'
						});
						return;
					}
					// if (master.contactid === null || master.contactid === '') {
					// 	_g.toastMsg({
					// 		msg: '请先选择联系人'
					// 	});
					// 	return;
					// }
					if (master.statusname === null || master.statusname === '') {
						_g.toastMsg({
							msg: '请先选择状态'
						});
						return;
					}
					if (master.startdate === null || master.startdate === '') {
						_g.toastMsg({
							msg: '请先选择开始日期'
						});
						return;
					}
					if (master.enddate === null || master.enddate === '') {
						_g.toastMsg({
							msg: '请先选择结束日期'
						});
						return;
					}
					if (master.enddate < master.startdate) {
						_g.toastMsg({
							msg: '开始日期不能大于结束日期'
						});
						return;
					}
					if (_g.getLS('productJson').list.length == 0) {
						_g.toastMsg({
							msg: '请先选择商品'
						});
						return;
					}
					bool = true;
					break;
				default:
			}
			return bool;
		}
	}

	business.prototype.constructor = business;
	module.exports = new business();

});
