define(function(require, exports, module) {

	var INTERFACE = require('interface');
	var HTTP = require('http');

	function business() {
		this.interface = {
			base: {
				qryTrader: function(opts) {
					return {
						title: '客户',
						url: URLANNEX + '/crmlookupdm/crmlookupdata.action',
						param: {
							'filter': 'closed=0',  // 过滤时，报表和供应商中的过滤，是为'1=1'
							'modId': opts.modId,
							'likeValue': '',
							'viewname': 'qryCTrader'
						},
						showName: 'name'  //要显示的字段
					}
				},
				qryChanceState: function(opts) {
					return {
						title: '阶段',
						url: URLANNEX + '/crmlookupdm/crmlookupdata.action',
						param: {
							'filter': 'kind=4',  // 过滤时，报表和供应商中的过滤，是为'1=1'
							'modId': opts.modId,
							'likeValue': '',
							'viewname': 'qryChanceState'
						},
						showName: 'name'  //要显示的字段
					}
				},
				qryEmploy: function(opts) {
					return {
						title: '业务员',
						url: URLANNEX + '/crmlookupdm/crmlookupdata.action',
						param: {
							'filter': 'closed=0',  // 过滤时，报表和供应商中的过滤，是为'1=1'
							'modId': opts.modId,
							'likeValue': '',
							'viewname': 'qryEmploy'
						},
						showName: 'name'  //要显示的字段
					}
				},
				qryCcontcat: function(opts) {
					return {
						title: '联系人',
						url: URLANNEX + '/crmlookupdm/crmlookupdata.action',
						param: {
							'filter': 'closed=0',  // 过滤时，报表和供应商中的过滤，是为'1=1'
							'modId': opts.modId,
							'likeValue': '',
							'viewname': 'qryCcontcat'
						},
						showName: 'name'  //要显示的字段
					}
				},
				qrySalePriceStatus: function(opts) {
					return {
						title: '状态',
						url: URLANNEX + '/crmlookupdm/crmlookupdata.action',
						param: {
							'filter': 'kind=26',  // 过滤时，报表和供应商中的过滤，是为'1=1'
							'modId': opts.modId,
							'likeValue': '',
							'viewname': 'qrySalePriceStatus'
						},
						showName: 'name'  //要显示的字段
					}
				}
			},
			chance: {
				list: {
					param: {
						'condition_txf': {},
						'filterItemRelation': '',
						'isH5': true,
						'pageSize': '',
						'searchKey': '',
						'start': 0
					},
					url: URLANNEX + '/ncrm/chance/chanceList!doGetListData.action',
				},
				add: {
					url: URLANNEX + '/ncrm/chance/chanceEdit!doGetAddnewData.action',
				},
				edit: {
					url: URLANNEX + '/ncrm/chance/chanceEdit!doGetEditData.action',
				},
				del: {
					url: URLANNEX + '/ncrm/chance/chanceEdit!Delete.action',
				},
				save: {
					url: URLANNEX + '/ncrm/chance/chanceEdit!save.action',
				},
				approval: {
					url: URLANNEX + '/bill/bchance/bchanceEdit!approvalSave',
				}
			},
			price: { // 销售报价
				list: {
					param: {
						'condition_txf': {},
						'filterItemRelation': '',
						'isH5': true,
						'pageSize': '',
						'searchKey': '',
						'start': 0
					},
					url: URLANNEX + '/ncrm/ssaleprice/ssalepriceList!doGetListData.action',
				},
				add: {
					url: URLANNEX + '/ncrm/ssaleprice/ssalepriceEdit!doGetAddnewData.action',
				},
				edit: {
					url: URLANNEX + '/ncrm/ssaleprice/ssalepriceEdit!doGetEditData.action',
				},
				del: {
					url: URLANNEX + '/ncrm/ssaleprice/ssalepriceEdit!Delete.action',
				},
				save: {
					url: URLANNEX + '/ncrm/ssaleprice/ssalepriceEdit!save.action',
				},
				approval: {
					url: URLANNEX + '/bill/ssaleprice/bssalepriceEdit!approvalSave',
				}
			}
		}
		this.param = {
			'chance': {
				title: '销售机会',
				modId: 150,
				code: '010302',
			},
			'price': {
				title: '销售报价',
				modId: 151,
				code: '010401',
			},
			'contract': {
				title: '销售合同',
				modId: 10104,
				code: '010402',
			},
			'gather': {
				title: '销售收款',
				modId: 20203,
				code: '010404',
			},
			'order': {
				title: '销售工单',
				modId: 10110,
				code: '',
			}
		};
		this.modId = {
			'150': {
				name: '销售机会',
			},
			'151': {
				name: '销售报价',
			},
			'10104': {
				name: '销售合同',
			},
			'20203': {
				name: '销售收款',
			},
			'10110': {
				name: '销售工单',
			},
			'20203': {
				name: '外勤签到',
			},
			'10108': {
				name: '工作日志'
			}
		};
		this.reg = {
			// 正则表达式
			'mobile': /^(13[0-9]|14[5|7]|15[0|1|2|3|5|6|7|8|9]|18[0|1|2|3|5|6|7|8|9])\d{8}$/, // 手机号码
			'phone': /\d{3}-\d{8}|\d{4}-\d{7}/, //电话号码
		};
	}

	business.prototype = {
		checkNull: function(str) { // 判断数值是否为null,如果为null的话则返回空字符串'' 否则返回本身
			if (str === null || str === 'null') {
				return '';
			} else {
				return str;
			}
		},
		getTime: function() { // 获取当前时间
			var date = new Date();
			var hour = date.getHours();
			hour = hour > 9 ? hour : '0' + hour;
			var minute = date.getMinutes();
			minute = minute > 9 ? minute : '0' + minute;
			var second = date.getSeconds();
			second = second > 9 ? second : '0' + second;
			return hour + ':' + minute + ':' + second;
		},
		getNewDay: function(opts) { // 在日期加上指定天数
			var nDate = new Date(opts.dateTemp);
			var millSeconds = Math.abs(nDate) + (opts.days * 24 * 60 * 60 * 1000);
			var rDate = new Date(millSeconds);
			var year = rDate.getFullYear();
			var month = rDate.getMonth() + 1;
			if (month < 10) month = "0" + month;
			var date = rDate.getDate();
			if (date < 10) date = "0" + date;
			return (year + "-" + month + "-" + date);
		},
		verify: function(type, billData) { // 表单验证
			var master = billData.master;
			var bool = false;
			switch (type) {
				case 'chance':
					if (master.code === null || master.code === '') {
						_g.toastMsg({
							msg: '请先输入编号'
						});
						return;
					}
					if (master.possibility < 0 || master.possibility > 100) {
						_g.toastMsg({
							msg: '可能性必须在0-100之间'
						});
						return;
					}
					if (master.name === null || master.name === '') {
						_g.toastMsg({
							msg: '请先输入机会名称'
						});
						return;
					}
					if (master.clientid === null || master.clientid === '') {
						_g.toastMsg({
							msg: '请先选择客户'
						});
						return;
					}
					if (master.enddate === null || master.enddate === '') {
						_g.toastMsg({
							msg: '请先选择结束日期'
						});
						return;
					}
					if (master.stagename === null || master.stagename === '') {
						_g.toastMsg({
							msg: '请先选择阶段'
						});
						return;
					}
					if (master.sourceid === null || master.sourceid === '') {
						_g.toastMsg({
							msg: '请先选择来源'
						});
						return;
					}
					if (master.empid === null || master.empid === '') {
						_g.toastMsg({
							msg: '请先选择业务员'
						});
						return;
					}
					bool = true;
					break;
				case 'price':
					if (master.code === null || master.code === '') {
						_g.toastMsg({
							msg: '请先输入编号'
						});
						return;
					}
					if (master.name === null || master.name === '') {
						_g.toastMsg({
							msg: '请先输入主题'
						});
						return;
					}
					if (master.clientid === null || master.clientid === '') {
						_g.toastMsg({
							msg: '请先选择客户'
						});
						return;
					}
					if (master.contactid === null || master.contactid === '') {
						_g.toastMsg({
							msg: '请先选择联系人'
						});
						return;
					}
					if (master.statusname === null || master.statusname === '') {
						_g.toastMsg({
							msg: '请先选择状态'
						});
						return;
					}
					if (master.startdate === null || master.startdate === '') {
						_g.toastMsg({
							msg: '请先选择开始日期'
						});
						return;
					}
					if (master.enddate === null || master.enddate === '') {
						_g.toastMsg({
							msg: '请先选择结束日期'
						});
						return;
					}
					if (_g.getLS('productJson').list.length == 0) {
						_g.toastMsg({
							msg: '请先选择商品'
						});
						return;
					}
					bool = true;
					break;
				case 'contract':
					if (master.code === null || master.code === '') {
						_g.toastMsg({
							msg: '请先输入编号'
						});
						return;
					}
					if (master.name === null || master.name === '') {
						_g.toastMsg({
							msg: '请先输入合同名称'
						});
						return;
					}
					if (master.typename === null || master.typename === '') {
						_g.toastMsg({
							msg: '请先选择类型'
						});
						return;
					}
					if (master.clientid === null || master.clientid === '') {
						_g.toastMsg({
							msg: '请先选择客户'
						});
						return;
					}
					if (master.signdate === null || master.signdate === '') {
						_g.toastMsg({
							msg: '请先选择签订日期'
						});
						return;
					}
					if (master.statusname === null || master.statusname === '') {
						_g.toastMsg({
							msg: '请先选择状态'
						});
						return;
					}
					if (master.type == '0' && (master.startdate === null || master.startdate === '')) {
						_g.toastMsg({
							msg: '请先选择开始日期'
						});
						return;
					}
					if (master.type == '0' && (master.enddate === null || master.enddate === '')) {
						_g.toastMsg({
							msg: '请先选择结束日期'
						});
						return;
					}
					if (master.type == '0' && (master.csignername === null || master.csignername === '')) {
						_g.toastMsg({
							msg: '请先选择客户签字人'
						});
						return;
					}
					if (master.type == '0' && (master.signername === null || master.signername === '')) {
						_g.toastMsg({
							msg: '请先选择公司签字人'
						});
						return;
					}
					if (_g.getLS('productJson').list.length == 0) {
						_g.toastMsg({
							msg: '请先选择商品'
						});
						return;
					}
					bool = true;
					break;
				case 'gather':
					if (master.code === null || master.code === '') {
						_g.toastMsg({
							msg: '请先输入编号'
						});
						return;
					}
					if (master.clientid === null || master.clientid === '') {
						_g.toastMsg({
							msg: '请先选择客户'
						});
						return;
					}
					if (master.paytypeid === null || master.paytypeid === '') {
						_g.toastMsg({
							msg: '请先选择结算方式'
						});
						return;
					}
					if (master.accountid === null || master.accountid === '') {
						_g.toastMsg({
							msg: '请先选择结算账户'
						});
						return;
					}
					if (master.factamount === '' || master.factamount < 0) {
						_g.toastMsg({
							msg: '现收金额不能小于0'
						});
						return;
					}
					if (master.factamount > billData.maxFactamount) {
						_g.toastMsg({
							msg: '现收金额不能大于' + billData.maxFactamount
						});
						return;
					}
					if (master.isbamount && (master.bamount === '' || master.bamount < 0)) {
						_g.toastMsg({
							msg: '预收金额不能小于0'
						});
						return;
					}
					if (master.isbamount && master.bamount > billData.maxBamount) {
						_g.toastMsg({
							msg: '预收金额不能大于' + billData.maxBamount
						});
						return;
					}
					bool = true;
					break;
				case 'order':
					if (master.code === null || master.code === '') {
						_g.toastMsg({
							msg: '请先输入编号'
						});
						return;
					}
					if (master.name === null || master.name === '') {
						_g.toastMsg({
							msg: '请先输入主题'
						});
						return;
					}
					if (master.executid === null || master.executid === '') {
						_g.toastMsg({
							msg: '请先选择执行人'
						});
						return;
					}
					if (master.type === null || master.type === '') {
						_g.toastMsg({
							msg: '请先选择服务类型'
						});
						return;
					}
					if (master.clientid === null || master.clientid === '') {
						_g.toastMsg({
							msg: '请先选择客户'
						});
						return;
					}
					if (master.mode === null || master.mode === '') {
						_g.toastMsg({
							msg: '请先选择服务方式'
						});
						return;
					}
					if (master.contactid === null || master.contactid === '') {
						_g.toastMsg({
							msg: '请先选择联系人'
						});
						return;
					}
					if (master.phone === null || master.phone === '') {
						_g.toastMsg({
							msg: '请先输入电话'
						});
						return;
					}
					if (master.address === null || master.address === '') {
						_g.toastMsg({
							msg: '请先输入地址'
						});
						return;
					}
					bool = true;
					break;
				default:
			}
			return bool;
		},
		unknownToEmpty: function(val) { // 过滤null和undefined为空字符串 
			if (val === null || val === undefined) {
				val = '';
			}
			return val;
		},
		save: { // 单据保存参数
			master: function(type, bill) {
				var master = bill.master;
				var param = {};
				switch (type) {
					case 'chance':
						param['master.a00OldJsonValue'] = master.a00OldJsonValue || '';
						param['master.accsetid'] = business.unknownToEmpty(master.accsetid) || '';
						param['master.activitycode'] = master.activitycode || '';
						param['master.activityid'] = master.activityid || '';
						param['master.amount'] = master.amount || 0;
						param['master.approvedid'] = master.approvedid || '';
						param['master.billstate'] = master.billstate || '';
						param['master.billstatename'] = master.billstatename || '';
						param['master.traderid'] = business.unknownToEmpty(master.traderid) || '';
						param['master.tradername'] = business.unknownToEmpty(master.tradername) || '';
						param['master.code'] = business.unknownToEmpty(master.code) || '';
						param['master.donestep'] = master.donestep || 0;
						param['master.editdate'] = master.editdate || '';
						param['master.editid'] = business.unknownToEmpty(master.editid) || '';
						param['master.editname'] = master.editname || '';
						param['master.empid'] = business.unknownToEmpty(master.empid) || '';
						param['master.empname'] = master.empname || '';
						param['master.enddate'] = master.enddate + ' 00:00:00';
						param['master.id'] = master.id || '';
						param['master.isaudit'] = master.isaudit || '';
						param['master.marketname'] = master.marketname || '';
						param['master.name'] = master.name || '';
						param['master.opdate'] = master.opdate || '';
						param['master.opid'] = master.opid;
						param['master.opname'] = master.opname || '';
						param['master.possibility'] = master.possibility;
						param['master.refercount'] = master.refercount;
						param['master.remark'] = master.remark || '';
						param['master.rivalid'] = master.rivalid || '';
						param['master.rivalname'] = master.rivalname || '';
						param['master.sourceid'] = business.unknownToEmpty(master.sourceid) || '';
						param['master.sourcename'] = master.sourcename || '';
						param['master.chancetypeName'] = master.chancetypeName || '';
						param['master.status'] = master.status;
						param['master.updatetime'] = master.updatetime || '';
						param['master.havaudit'] = business.unknownToEmpty(master.havaudit) || '';
						break;
					case 'price':
						param['master.a00OldJsonValue'] = master.a00OldJsonValue || '';
						param['master.accsetid'] = business.unknownToEmpty(master.accsetid) || '';
						param['master.amount'] = master.amount || 0;
						param['master.billstate'] = master.billstate;
						param['master.chancecode'] = business.unknownToEmpty(master.chancecode) || '';
						param['master.chanceid'] = business.unknownToEmpty(master.chanceid) || '';
						param['master.chancename'] = master.chancename || '';
						param['master.traderid'] = business.unknownToEmpty(master.traderid) || '';
						param['master.tradername'] = master.tradername;
						param['master.billcode'] = business.unknownToEmpty(master.billcode) || '';
						param['master.contactid'] = business.unknownToEmpty(master.contactid) || '';
						param['master.contactname'] = master.contactname || '';
						param['master.editdate'] = master.editdate || '';
						param['master.editid'] = business.unknownToEmpty(master.editid) || '';
						param['master.editname'] = master.editname || '';
						param['master.enddate'] = master.enddate + ' 00:00:00';
						param['master.id'] = master.id || '';
						param['master.name'] = business.unknownToEmpty(master.name) || '';
						if (master.billdate.length == 10) {
							param['master.billdate'] = master.billdate + ' ' + business.getTime();
						} else {
							param['master.billdate'] = master.billdate;
						}
						param['master.opid'] = master.opid;
						param['master.opname'] = master.opname || '';
						param['master.ownerid'] = master.ownerid || _g.getLS('employId');
						param['master.ownername'] = master.ownername || '';
						param['master.refercount'] = master.refercount;
						param['master.remark'] = master.remark || '';
						param['master.startdate'] = master.startdate + ' 00:00:00';
						param['master.status'] = master.status;
						param['master.statusname'] = master.statusname || '';
						param['master.updatetime'] = master.updatetime || '';
						param['master.havaudit'] = business.unknownToEmpty(master.havaudit) || '';
						break;
					case 'contract':
						param['master.a00OldJsonValue'] = master.a00OldJsonValue || '';
						param['master.accsetid'] = master.accsetid;
						param['master.amount'] = master.amount || 0;
						param['master.approvedid'] = master.approvedid || '';
						param['master.balamount'] = master.balamount || 0;
						param['master.balstatename'] = master.balstatename || '';
						param['master.balstatus'] = master.balstatus;
						param['master.billstate'] = master.billstate;
						param['master.chancecode'] = master.chancecode || '';
						param['master.chanceid'] = master.chanceid || '';
						param['master.chancename'] = master.chancename || '';
						param['master.clientid'] = master.clientid;
						param['master.clientname'] = master.clientname;
						param['master.code'] = master.code;
						param['master.donestep'] = master.donestep || 0;
						param['master.editdate'] = master.editdate;
						param['master.editid'] = master.editid;
						param['master.editname'] = master.editname || '';
						param['master.id'] = master.id || '';
						param['master.isaudit'] = master.isaudit || '';
						param['master.name'] = master.name;
						param['master.notifydays'] = master.notifydays || '';
						param['master.opdate'] = master.opdate;
						param['master.opid'] = master.opid;
						param['master.opname'] = master.opname || '';
						param['master.ownerid'] = master.ownerid || _g.getLS('employId');
						param['master.referamt'] = master.referamt;
						param['master.referbillcode'] = business.unknownToEmpty(master.referbillcode) || '';
						param['master.referbillid'] = business.unknownToEmpty(master.referbillid) || '';
						param['master.referbilltype'] = business.unknownToEmpty(master.referbilltype) || '';
						param['master.referbillname'] = master.referbillname || '';
						param['master.referbilltypename'] = master.referbilltypename || '';
						param['master.refercount'] = master.refercount;
						param['master.remark'] = master.remark || '';
						param['master.sendstatename'] = master.sendstatename || '';
						param['master.sendstatus'] = master.sendstatus;
						param['master.sendstatusname'] = master.sendstatusname || '';
						param['master.signdate'] = master.signdate;
						param['master.status'] = master.status || 0;
						param['master.statusname'] = master.statusname || '正常';
						param['master.type'] = master.type;
						param['master.typename'] = master.typename || '';
						param['master.updatetime'] = master.updatetime || '';
						param['master.havaudit'] = business.unknownToEmpty(master.havaudit) || '';
						if (master.type == '0') {
							// 合同类型
							param['master.startdate'] = master.startdate + ' 00:00:00';
							param['master.enddate'] = master.enddate + ' 00:00:00';
							param['master.signerid'] = master.signerid; // 公司签字人
							param['master.signername'] = master.signername || '';
							param['master.csignerid'] = master.csignerid; // 客户签字人
							param['master.csignername'] = master.csignername || '';
							param['master.provision'] = master.provision || ''; // 详细条款
						}
						break;
					default:
				}
				return param;
			},
			goods: function(type, goodsMode, goodsArr) {
				var dataJson = {};
				var itemno = 0;
				var index = 0; // 提交的数组序号
				var count = 0; // 数量
				var delIndex = 0;
				for (var i = 0; i < goodsArr.length; i++) {
					if (goodsArr[i].mode == 'edit' || goodsArr[i].mode == 'add') {
						if (goodsArr[i].mode == 'add') {
							// itemno为商品明细id，新增时从-1开始
							goodsArr[i].itemno = --itemno;
						}
						var detailKey = 'detail1'; // 新增/编辑的商品
						$.extend(dataJson, business.getGoodsSaveParam(type, detailKey, goodsArr[i], index));
						index += 1;
						count++; // 数量
					}
					if (goodsMode == 'del') {
						index = i;
						detailKey = 'deletedetail1'; // 删除的商品
						$.extend(dataJson, business.getGoodsSaveParam(type, detailKey, goodsArr[i], index));
						count++; // 数量
					}
				}
				return {
					data: dataJson, // 数据
					count: count, // 数量
				};
			}
		},
		getGoodsSaveParam: function(type, detailKey, item, i) { // 商品明细保存参数
			var param = {};
			// switch (type) {
			// 	case 'chance':
			// 		param[detailKey + '[' + i + '].a00OldJsonValue'] = item.a00OldJsonValue || '';
			// 		param[detailKey + '[' + i + '].accsetid'] = item.accsetid;
			// 		param[detailKey + '[' + i + '].amount'] = item.amount || 0;
			// 		param[detailKey + '[' + i + '].barcode'] = business.unknownToEmpty(item.barcode) || '';
			// 		param[detailKey + '[' + i + '].goodsid'] = item.goodsid;
			// 		param[detailKey + '[' + i + '].goodsname'] = item.goodsname || '';
			// 		param[detailKey + '[' + i + '].id'] = item.id;
			// 		param[detailKey + '[' + i + '].itemno'] = item.itemno;
			// 		param[detailKey + '[' + i + '].price'] = item.price || 0;
			// 		param[detailKey + '[' + i + '].quantity'] = item.quantity || 0;
			// 		param[detailKey + '[' + i + '].specs'] = item.specs;
			// 		param[detailKey + '[' + i + '].unitname'] = item.unitname || '';
			// 		break;
			// 	case 'price':
			// 		param[detailKey + '[' + i + '].a00OldJsonValue'] = item.a00OldJsonValue || '';
			// 		param[detailKey + '[' + i + '].accsetid'] = item.accsetid;
			// 		param[detailKey + '[' + i + '].amount'] = item.amount || 0;
			// 		param[detailKey + '[' + i + '].barcode'] = business.unknownToEmpty(item.barcode) || '';
			// 		param[detailKey + '[' + i + '].disc'] = item.disc || 0;
			// 		param[detailKey + '[' + i + '].discamount'] = item.cprice * item.quantity * item.disc || 0;
			// 		param[detailKey + '[' + i + '].goodsamount'] = item.goodsamount || 0;
			// 		param[detailKey + '[' + i + '].goodsid'] = item.goodsid;
			// 		param[detailKey + '[' + i + '].goodsname'] = item.goodsname || '';
			// 		param[detailKey + '[' + i + '].id'] = item.id;
			// 		param[detailKey + '[' + i + '].ispresent'] = item.ispresent || 0;
			// 		param[detailKey + '[' + i + '].itemno'] = item.itemno;
			// 		param[detailKey + '[' + i + '].oprice'] = item.oprice || 0;
			// 		param[detailKey + '[' + i + '].price'] = item.price || 0;
			// 		param[detailKey + '[' + i + '].quantity'] = item.quantity || 0;

			// 		// param[detailKey + '['+ i +'].referbillid'] = item.referbillid;
			// 		// param[detailKey + '['+ i +'].referbillitemno'] = item.referbillitemno;
			// 		// param[detailKey + '['+ i +'].referbilltype'] = item.referbilltype;
			// 		// param[detailKey + '['+ i +'].referitemno'] = item.referitemno || '';
			// 		// param[detailKey + '['+ i +'].refercount'] = item.refercount || 0;
			// 		// param[detailKey + '['+ i +'].referqty'] = item.referqty || 0;

			// 		param[detailKey + '[' + i + '].referbillid'] = business.unknownToEmpty(item.referbillid);
			// 		param[detailKey + '[' + i + '].referbillitemno'] = business.unknownToEmpty(item.referbillitemno);
			// 		param[detailKey + '[' + i + '].referbilltype'] = business.unknownToEmpty(item.referbilltype);
			// 		param[detailKey + '[' + i + '].referitemno'] = business.unknownToEmpty(item.referitemno);
			// 		param[detailKey + '[' + i + '].refercount'] = item.refercount || 0;
			// 		param[detailKey + '[' + i + '].referqty'] = item.referqty || 0;

			// 		param[detailKey + '[' + i + '].remark'] = item.remark || '';
			// 		param[detailKey + '[' + i + '].specs'] = item.specs || '';
			// 		param[detailKey + '[' + i + '].taxamount'] = item.taxamount || 0;
			// 		param[detailKey + '[' + i + '].taxrate'] = item.taxrate || 0;
			// 		param[detailKey + '[' + i + '].unitname'] = item.unitname || '';
			// 		break;
			// 	default:
			// }
			param[detailKey + '[' + i + '].billid'] = item['billid'] || -9999;
			param[detailKey + '[' + i + '].amount'] = item['amount'];
			param[detailKey + '[' + i + '].aprice'] = item['aprice'];
			param[detailKey + '[' + i + '].batchcode'] = this.checkNull(item['batchcode']);
			param[detailKey + '[' + i + '].breferid'] = this.checkNull(item['breferid']);
			param[detailKey + '[' + i + '].baseunitname'] = item['baseunitname'];
			param[detailKey + '[' + i + '].costtype'] = item['costtype'];
			param[detailKey + '[' + i + '].disc'] = item['disc'];
			param[detailKey + '[' + i + '].discamt'] = item['discamt'];
			param[detailKey + '[' + i + '].erate'] = item['erate'];
			param[detailKey + '[' + i + '].extqty'] = item['extqty'];
			param[detailKey + '[' + i + '].goodsamt'] = item['goodsamt'];
			param[detailKey + '[' + i + '].goodscode'] = item['goodscode'];
			param[detailKey + '[' + i + '].goodsid'] = this.checkNull(item['goodsid']);
			param[detailKey + '[' + i + '].goodskind'] = item['goodskind'];
			param[detailKey + '[' + i + '].goodsname'] = item['goodsname'];
			param[detailKey + '[' + i + '].goodstaxrate'] = this.checkNull(item['goodstaxrate']);
			param[detailKey + '[' + i + '].ioqty'] = item['ioqty'];
			param[detailKey + '[' + i + '].is__detail__modify'] = item['is__detail__modify'];
			param[detailKey + '[' + i + '].isbatch'] = item['isbatch'];
			param[detailKey + '[' + i + '].islargess'] = item['islargess'];
			param[detailKey + '[' + i + '].itemno'] = this.checkNull(item['itemno']);
			param[detailKey + '[' + i + '].lcamount'] = this.parseTonum(item['amount']);
			param[detailKey + '[' + i + '].lcgoodsamt'] = this.parseTonum(item['goodsamt']);
			param[detailKey + '[' + i + '].lcprice'] = item['price'];
			param[detailKey + '[' + i + '].lctaxamt'] = item['taxamt'];
			param[detailKey + '[' + i + '].lctaxprice'] = item['taxprice'];
			param[detailKey + '[' + i + '].lcunitprice'] = this.parseTonum(item['unitprice']);
			param[detailKey + '[' + i + '].origprice'] = item['origprice'];
			param[detailKey + '[' + i + '].origtaxprice'] = item['origtaxprice'];
			param[detailKey + '[' + i + '].price'] = item['price'];
			param[detailKey + '[' + i + '].quantity'] = item['quantity'];
			param[detailKey + '[' + i + '].refercount'] = item['refercount'];
			param[detailKey + '[' + i + '].referextqty'] = item['referextqty'];
			param[detailKey + '[' + i + '].referqty'] = item['referqty'] || 0;
			param[detailKey + '[' + i + '].specs'] = item['specs'];
			param[detailKey + '[' + i + '].storecode'] = this.checkNull(item['storecode']);
			param[detailKey + '[' + i + '].storeid'] = this.checkNull(item['storeid']);
			param[detailKey + '[' + i + '].storename'] = item['storename'];
			param[detailKey + '[' + i + '].storeshopid'] = this.checkNull(item['storeshopid']);
			param[detailKey + '[' + i + '].sumquantity'] = item['sumquantity'] || 0;
			param[detailKey + '[' + i + '].taxamt'] = item['taxamt'];
			param[detailKey + '[' + i + '].taxprice'] = this.parseTonum(item['taxprice']);
			param[detailKey + '[' + i + '].taxrate'] = this.checkNull(item['taxrate']);
			param[detailKey + '[' + i + '].unitid'] = this.checkNull(item['unitid']);
			param[detailKey + '[' + i + '].unitname'] = item['unitname'];
			param[detailKey + '[' + i + '].unitname1'] = item['unitname1'];
			param[detailKey + '[' + i + '].unitprice'] = this.parseTonum(item['unitprice']);
			param[detailKey + '[' + i + '].unitqty1'] = item['unitqty1'];
			param[detailKey + '[' + i + '].unitqty2'] = item['unitqty2'];
			param[detailKey + '[' + i + '].unitqty3'] = item['unitqty3'];
			param[detailKey + '[' + i + '].unitquantity'] = this.parseTonum(item['unitquantity']);
			param[detailKey + '[' + i + '].unitrate'] = item['unitrate'];
			param[detailKey + '[' + i + '].unitrate1'] = item['unitrate1'];
			param[detailKey + '[' + i + '].unitrate2'] = item['unitrate2'];
			param[detailKey + '[' + i + '].unitrate3'] = item['unitrate3'];
			param[detailKey + '[' + i + '].validdates'] = item['validdates'];
			param[detailKey + '[' + i + '].productdate'] = this.checkNull(item['productdate']);
			param[detailKey + '[' + i + '].validdate'] = this.checkNull(item['validdate']);
			param[detailKey + '[' + i + '].barcode'] = item['barcode'] || '';
			param[detailKey + '[' + i + '].barcodeid'] = this.checkNull(item['barcodeid']);

			param[detailKey + '[' + i + '].allotqty'] = item['allotqty'];
			param[detailKey + '[' + i + '].invoiceamt'] = item['invoiceamt'] || 0;
			param[detailKey + '[' + i + '].invoiceqty'] = item['invoiceqty'] || 0;
			param[detailKey + '[' + i + '].isallot'] = item['isallot'] || 0;
			param[detailKey + '[' + i + '].iscometrader'] = item['iscometrader'];
			param[detailKey + '[' + i + '].margin'] = item['margin'];
			param[detailKey + '[' + i + '].point'] = item['point'] || 0;
			param[detailKey + '[' + i + '].unitname2'] = item['unitname2'];
			param[detailKey + '[' + i + '].unitname3'] = item['unitname3'];
			param[detailKey + '[' + i + '].iscometrader'] = item['iscometrader'] || 0;
			param[detailKey + '[' + i + '].referbilltype'] = item['referbilltype'] || 0;

			if (item['goodMode'] == 'old' || item['goodMode'] == 'edit') {
				param[detailKey + '[' + i + '].a00oldjsonvalue'] = item['a00oldjsonvalue'];
			} else {
				param[detailKey + '[' + i + '].a00oldjsonvalue'] = '';
			}
			if (item['goodMode'] == 'add') {
				param[detailKey + '[' + i + '].itemno'] = (i + 1) * (-1);
				param[detailKey + '[' + i + '].sumquantity'] = 0;
			}
			return param;
		},
		listUpdate: function(self) { // 列表更新监听事件
			api.addEventListener({
				name: 'list-update'
			}, function(ret, err) {
				var mode = ret.value.mode;
				var index = ret.value.index || 0;
				var data = ret.value.data;
				switch (mode) {
					case 'add':
						setTimeout(function() {
							self.items.unshift(data);
						});
						break;
					case 'edit':
						self.items[index].clientname = data.clientname;
						self.items[index].isaudit = data.isaudit;
						self.items[index].billstate = data.billstate;
						self.items[index].name = data.name;
						self.items[index].stagename = data.stagename;
						self.items[index].enddate = data.enddate;
						self.items[index].amount = data.amount;

						self.items[index].code = data.code;
						self.items[index].statusname = data.statusname;
						self.items[index].opdate = data.opdate;
						self.items[index].opname = data.opname;

						self.items[index].signdate = data.signdate;
						self.items[index].statename = data.statename;
						self.items[index].signername = data.signername;

						self.items[index].accountname = data.accountname;
						self.items[index].billdate = data.billdate;

						self.items[index].typename = data.typename;
						self.items[index].goodsname = data.goodsname;
						self.items[index].executname = data.executname;

						break;
					case 'del':
						self.items.$remove(self.items[index]);
						break;
					default:
				}
			});
		},
		permission: { // 操作权限控制
			btn: function(permisJson) { // 判断业务流程（审批流程或批示流程），并添加按钮到视图
				var mode = permisJson.mode;
				var isaudit = permisJson.isaudit; // 是否为审批流程（0：批示流程（非审批流程），1：审批流程）
				var havaudit = permisJson.havaudit;
				var billstate = permisJson.billstate; // 单据状态（审批状态:0：未提交 1：待审批 2：审批中 3，审批不通过 4：审批通过）
				var id = permisJson.id; // 单据id
				var modId = permisJson.modId; // 单据modId

				var btnArr = [];
				if (mode == 'add') {
					btnArr.push('保存');
				} else {
					btnArr.push('分享', '打印');
					if (billstate == 0) {
						btnArr.push('保存', '删除', '审核');
					} else if (billstate == 1) {
						btnArr.push('反审核');
					}
				}

				// 生成操作按钮数据
				var btns = []; // 操作按钮(数组)
				for (var i = 0; i < btnArr.length; i++) {
					btns.push({ title: btnArr[i] });
				}
				this.setBtn(mode, btns);
			},
			setBtn: function(mode, btns) { // 发送按钮显示的事件
				api.sendEvent({
					name: api.winName + '-btn-more-update',
					extra: {
						'btns': btns, // 操作按钮(数组), eg.[{name:'删除'},{name:'保存'},{name:'分享'},{name:'撤回'},{name:'提交'},{name:'审批'},{name:'反审批'}]
					}
				});
			}
		},
		btnEvent: { // 按钮事件
			'del': function(opts) { // 删除
				var json = opts.paramJson;
				var type = json.type; // 类型
				var id = json.id; // 记录id
				var index = json.index; // 单据数组序号
				_g.confirm({ // 确认框
					title: '',
					msg: '确定删除该记录吗?',
					buttons: ['确定', '取消'],
					success: function(ret) {
						if (ret.buttonIndex == 1) {
							_g.showLoading({
								title: '删除中...'
							});
							HTTP.ajax({
								url: INTERFACE.business[type]['del'].url,
								data: {
									id: id,
									checkStep: 0
								},
								success: function(ret) {
									api.hideProgress();
									if (ret.errMsg == '') {
										_g.toastMsg({
											msg: '删除成功'
										});
									} else {
										_g.toastMsg({
											msg: ret.errMsg
										});
									}
									// 更新列表
									api.sendEvent({
										name: 'list-update',
										extra: {
											mode: 'del',
											index: index
										}
									});
									setTimeout(function() {
										api.closeWin();
									}, 1000);
								},
								error: function(err) {
									api.hideProgress();
									_g.toastMsg({
										msg: err.msg
									});
								}
							});
						}
					}
				});
			},
			'save': function(opts) { // 保存
				var json = opts.paramJson;
				var type = json.type; // 业务类型
				var mode = json.mode; // 模式（add：新增，edit：编辑）
				var bill = json.bill; // 主单据数据
				var index = json.index;
				var IsBillSubmit = json.IsBillSubmit;
				var param = {
					'url': INTERFACE.business[type]['save'].url,
					'data': {
						'start': 0, // 判断权限用，暂且默认0
						'IsBillSubmit': IsBillSubmit || 0, // 用来进行保存，提交，撤销(0－正常保存数据；1－单据审批提交；2－单据审批撤销)
					}
				}
				if (mode == 'add') {
					// 新增
					param.data.addnewFlag = 'true';
					param.data.detail1Count = 0; // 新增货品明细数量
				} else {
					// 编辑
					param.data.id = bill.id;
					param.data.addnewFlag = 'false';
					// bill.master.billstate = 1;
				}
				// 主单据数据
				$.extend(param.data, business.save.master(type, bill));
				// 如果不是销售工单则有商品明细数据
				if (type != 'order' && type != 'gather') {

					// 设置相关业务(引用单据)数据，需赋值给商品明细
					_g.setLS('referbillid', business.unknownToEmpty(bill.master.referbillid));
					_g.setLS('referbillitemno', business.unknownToEmpty(bill.master.referbillitemno));
					_g.setLS('referbilltype', business.unknownToEmpty(bill.master.referbilltype));

					// 新增或被编辑的商品明细
					var detail = business.save.goods(type, 'edit', _g.getLS('productJson').list);
					$.extend(param.data, detail.data); // 商品明细数据
					param.data.detail1Count = detail.count; // 数量

					// 被删除的商品明细数据
					var deletedetail = business.save.goods(type, 'del', bill.delGoods);
					$.extend(param.data, deletedetail.data); // 商品明细数据
					param.data.deletedetail1Count = deletedetail.count; // 数量

					_g.rmLS('referbillid');
					_g.rmLS('referbillitemno');
					_g.rmLS('referbilltype');
				}
				if (!opts.hiddenTips) {
					var tips = opts.tips || '保存';
					_g.showLoading({
						title: tips + '中...'
					});
				}
				HTTP.ajax({
					url: param.url,
					data: param.data,
					success: function(ret) {
						if (mode == 'add') {
							// 上传附件列表
							var billId = ret.master.id; // 新增单据id
							var annexList = _g.getLS('annex-list') || '';
							if (annexList != '') {
								business.updateAnnex(billId, business.param[type].modId, annexList);
							}
						}
						// 保存成功提示
						api.hideProgress();
						if (!opts.hiddenTips) {
							_g.toastMsg({
								msg: tips + '成功'
							});
						}
						// 回调
						opts.success && opts.success(ret);
						// 更新列表
						api.sendEvent({
							name: 'list-update',
							extra: {
								mode: mode,
								index: index,
								data: ret.master
							}
						});
					},
					other: function(err) {
						api.hideProgress();
						_g.toastMsg({
							msg: err.msg
						});
					},
					error: function(err) {
						api.hideProgress();
						opts.error && opts.error(err);
					}
				});
			},
			'share': function(opts) { // 微信分享
				var json = opts.paramJson;
				api.actionSheet({
					cancelTitle: '取消',
					buttons: ['发送至微信', '微信通知']
				}, function(ret, err) {
					var WX = require('wx');
					var master = json.bill.master;
					var goods = json.bill.goods;
					var title = business.param[json.type].title;
					var textJson = {};
					textJson.content = {};
					textJson.goods = {};
					if (ret.buttonIndex == 1) {
						// 发送内容
						textJson.title = title; // 标题
						// 主单据
						switch (json.type) {
							case 'choice':
								// 销售机会
								textJson['content']['编号'] = business.unknownToEmpty(master.billcode) || '';
								textJson['content']['机会名称'] = master.name || '';
								textJson['content']['客户名称'] = master.tradername || '';
								textJson['content']['截止日期'] = master.enddate || '';
								textJson['content']['阶段'] = master.chancetypeName || '';
								textJson['content']['可能性'] = master.possibility || 0;
								textJson['content']['机会来源'] = master.sourcename || '';
								textJson['content']['相关市场活动'] = master.activitycode || '';
								textJson['content']['竞争对手'] = master.rivalname || '';
								textJson['content']['业务员'] = master.empname || '';
								textJson['content']['备注'] = master.remark || '';
								textJson['content']['合计'] = master.amount || 0;
								if (goods.length > 0) {
									textJson['content']['商品明细'] = '';
									for (var i = 0; i < goods.length; i++) {
										var goodsname = '商品名称: ' + goods[i].goodsname || '';
										var quantity = '数量: ' + (goods[i].quantity || '');
										var unitname = goods[i].unitname || '';
										if (unitname != '') {
											quantity += '(' + unitname + ')';
										}
										var price = '单价: ' + (goods[i].price || '');
										var amount = '金额: ' + (goods[i].amount || '');
										textJson['content']['商品明细'] += '\r\n' + goodsname + '\r\n' + quantity + '\r\n' + price + '\r\n' + amount + '\r\n';
									}
								}
								break;
							case 'price':
								// 销售报价
								textJson['content']['日期'] = master.billdate || '';
								textJson['content']['单号'] = business.unknownToEmpty(master.billcode) || '';
								textJson['content']['主题'] = master.name || '';
								textJson['content']['客户名称'] = master.tradername || '';
								textJson['content']['联系人'] = master.contactname || '';
								textJson['content']['状态'] = master.statusname || '';
								textJson['content']['相关机会'] = master.chancename || '';
								textJson['content']['开始日期'] = master.startdate || '';
								textJson['content']['结束日期'] = master.enddate || '';
								textJson['content']['备注'] = master.remark || '';
								if (goods.length > 0) {
									textJson['content']['商品明细'] = '';
									for (var i = 0; i < goods.length; i++) {
										var goodsname = '商品名称: ' + (goods[i].goodsname || '');
										var quantity = '数量: ' + (goods[i].quantity || '');
										var unitname = goods[i].unitname || '';
										if (unitname != '') {
											quantity += '(' + unitname + ')';
										}
										var price = '单价: ' + goods[i].price || 0;
										var taxrate = '税率: ' + (goods[i].taxrate || 0) + '%';
										var amount = '金额: ' + goods[i].amount || 0;
										textJson['content']['商品明细'] += '\r\n' + goodsname + '\r\n' + quantity + '\r\n' + price + '\r\n' + taxrate + '\r\n' + amount + '\r\n';
									}
								}
								break;
							case 'contract':
								// 销售合同
								textJson['content']['编号'] = business.unknownToEmpty(master.code) || '';
								textJson['content']['合同名称'] = master.name || '';
								textJson['content']['类型'] = master.typename || '';
								textJson['content']['客户名称'] = master.clientname || '';
								textJson['content']['签订日期'] = master.signdate || '';
								textJson['content']['执行状态'] = master.sendstatusname || '';
								textJson['content']['相关业务'] = (master.referbillcode || '') + ' ' + (master.referbillname || '');
								textJson['content']['开始日期'] = master.startdate || '';
								textJson['content']['结束日期'] = master.enddate || '';
								textJson['content']['客户签字人'] = master.csignername || '';
								textJson['content']['公司签字人'] = master.signername || '';
								textJson['content']['签字日期'] = master.signdate;
								textJson['content']['备注'] = master.remark || '';
								if (goods.length > 0) {
									textJson['content']['商品明细'] = '';
									for (var i = 0; i < goods.length; i++) {
										var goodsname = '商品名称: ' + (goods[i].goodsname || '');
										var quantity = '数量: ' + (goods[i].quantity || '');
										var unitname = goods[i].unitname || '';
										if (unitname != '') {
											quantity += '(' + unitname + ')';
										}
										var price = '单价: ' + goods[i].price || 0;
										var taxrate = '税率: ' + (goods[i].taxrate || 0) + '%';
										var amount = '金额: ' + goods[i].amount || 0;
										textJson['content']['商品明细'] += '\r\n' + goodsname + '\r\n' + quantity + '\r\n' + price + '\r\n' + taxrate + '\r\n' + amount + '\r\n';
									}
								}
								break;
							case 'gather':
								// 销售收款
								textJson['content']['编号'] = business.unknownToEmpty(master.code) || '';
								textJson['content']['收款日期'] = master.billdate;
								textJson['content']['客户'] = master.clientname || '';
								textJson['content']['合同/订单'] = business.unknownToEmpty(master.bargaincode) || '';
								textJson['content']['预收金额'] = master.bamount || 0;
								textJson['content']['现收金额'] = master.factamount || 0;
								textJson['content']['结算方式'] = master.paytypename || '';
								textJson['content']['结算账户'] = master.accountname || '';
								textJson['content']['金额'] = master.amount || 0;
								textJson['content']['备注'] = master.remark || '';
								break;
							case 'order':
								// 销售工单
								textJson['content']['编号'] = business.unknownToEmpty(master.code) || '';
								textJson['content']['主题'] = master.name || '';
								textJson['content']['执行人'] = master.executname || '';
								textJson['content']['服务类型'] = master.typename || '';
								textJson['content']['客户'] = master.clientname || '';
								textJson['content']['联系人'] = master.contactname || '';
								textJson['content']['电话'] = master.phone || '';
								textJson['content']['地区'] = master.areaname || '';
								textJson['content']['地址'] = master.address || '';
								textJson['content']['预约时间'] = master.opdate;
								textJson['content']['相关业务'] = master.referbilltypename || '';
								textJson['content']['相关产品'] = master.goodsname || '';
								textJson['content']['反馈问题'] = master.remark || '';
								break;
							default:
						}
						_g.showLoading({
							title: '打开微信中'
						});
						WX.sendToWX({
							type: 'business_content',
							title: textJson.title,
							content: textJson.content,
							success: function(ret) {
								opts.success && opts.success(ret);
							},
							error: function(err) {
								opts.error && opts.error(err);
							}
						});
					} else if (ret.buttonIndex == 2) {
						// 发送通知
						// 请查阅+业务类型名称+编号+截止日期
						switch (json.type) {
							case 'choice':
								master['date'] = master['enddate'];
								break;
							case 'price':
								master['date'] = master['opdate'];
								break;
							case 'contract':
								master['date'] = master['startdate'];
								break;
							case 'gather':
								master['date'] = master['billdate'];
								break;
							case 'order':
								master['date'] = master['opdate'];
								break;
						}
						var shareMsg = '请查阅' + (title || '') + (master['code'] || '') + (master['date'] || '');
						textJson.title = shareMsg;
						_g.showLoading({
							title: '打开微信中'
						});
						WX.sendToWX({
							type: 'notify',
							title: textJson.title,
							content: textJson.content,
							success: function(ret) {
								opts.success && opts.success(ret);
							},
							error: function(err) {
								opts.error && opts.error(err);
							}
						});
					}
				});
			},
			'revoke': function(opts) { // 撤回
				opts.paramJson.IsBillSubmit = 2;
				business.btnEvent.save({
					paramJson: opts.paramJson,
					tips: '撤回',
					success: function(ret) {
						opts.success && opts.success(ret);
					}
				});
			},
			'submit': function(opts) { // 提交
				opts.paramJson.IsBillSubmit = 1;
				business.btnEvent.save({
					paramJson: opts.paramJson,
					tips: '提交',
					success: function(ret) {
						opts.success && opts.success(ret);
					}
				});
			},
			'approval': function(opts) { // 审批
				var paramJson = opts.paramJson;
				var postInfo = {
						url: INTERFACE.business[opts.type].approval.url,
						param: {
							'approvedid': paramJson.approvedid, // 单据id
							'billId': paramJson.billId, // 单据id
							'donestep': paramJson.donestep, // 审批步骤
							'isAudit': 'true', // 审批
						}
					}
					// 审批中心 - 填写审批意见
				_g.openWin({
					name: 'approval',
					url: '../Index/approval',
					pageParam: {
						'list': [
							{ 'billcode': paramJson.code }
						],
						'from': 'business',
						'postInfo': postInfo
					}
				});
			},
			'unApproval': function(opts) { // 反审批
				var paramJson = opts.paramJson;
				var param = {
					url: INTERFACE.business[opts.type].approval.url,
					data: {
						'approvedid': paramJson.approvedid, // 单据id
						'billId': paramJson.billId, // 单据id
						'donestep': paramJson.donestep, // 审批步骤
						'isAudit': 'false', // 反审批
					}
				}
				var UnAuditAll = _g.getLS('UnAuditAll');
				if (UnAuditAll == '1') {
					_g.confirm({
						title: '反审批操作',
						msg: '单据号:' + paramJson.code,
						buttons: ['最后步骤反审批', '全部反审批', '取消'],
						success: function(ret) {
							if (ret.buttonIndex != 3) {
								if (ret.buttonIndex == 1) {
									param.data.kind = 0; //单次反审批
								} else if (ret.buttonIndex == 2) {
									param.data.kind = 1; //全部反审批
								}
								HTTP.ajax({
									url: param.url,
									data: param.data,
									success: function(ret) {
										_g.toastMsg({
											msg: '操作成功'
										});
										opts.success && opts.success(ret);
									},
									error: function(err) {
										_g.toastMsg({
											msg: err.msg
										});
									}
								});
							}
						}
					});
				} else {
					param.data.kind = 0; //单次反审批
					HTTP.ajax({
						url: param.url,
						data: param.data,
						success: function(ret) {
							_g.toastMsg({
								msg: '操作成功'
							});
							opts.success && opts.success(ret);
						},
						error: function(err) {
							_g.toastMsg({
								msg: err.msg
							});
						}
					});
				}
			}
		},
		getReferbilltype: function(type, callFunc) { // 获取业务类型数据
			HTTP.ajax({
				url: INTERFACE.base.url,
				data: INTERFACE.base['dsbilltype_' + type].param,
				success: function(ret) {
					callFunc(ret);
				},
				error: function(err) {
					_g.toastMsg({
						msg: err.msg
					});
				}
			});
		},
		getAnnex: function(param, callFunc) { // 获取附件数据
			HTTP.ajax({
				url: INTERFACE.annex['list'].url,
				data: param,
				success: function(ret) {
					console.log('附件数据：' + JSON.stringify(ret));
					callFunc(ret);
				},
				error: function(err) {
					_g.toastMsg({
						msg: err.msg
					});
				}
			});
		},
		getAnnexUrl: function(opts) { // 获取附件文件地址
			var fileUrl = INTERFACE.annex['download'].url + '?id=' + opts.data.id + '&modId=' + opts.data.modId + '&itemno=' + opts.data.itemno;
			console.log('文件地址：' + fileUrl);
			return fileUrl;
		},
		updateAnnex: function(billId, modId, annexList) { // 上传附件列表
			for (var i = 0; i < annexList.length; i++) {
				api.ajax({
					url: INTERFACE.annex['upload'].url,
					method: 'post',
					data: {
						values: {
							id: billId,
							modId: modId,
							fileFileName: annexList[i].filename + '.' + annexList[i].filetype, // 文件名+.文件格式
							voiceTime: annexList[i].voiceTime || 0, // 录音的时候voiceTime这个参数是大于0，如果是其它类型就等于0
						},
						files: {
							file: annexList[i].filepath,
						}
					}
				}, function(ret, err) {
					if (ret) {
						console.log('上传返回参数：' + JSON.stringify(ret));
						if (ret.errNo == 0) {
							_g.toastMsg({
								msg: ret.errMsg
							});
						} else {
							_g.toastMsg({
								msg: ret.errMsg
							});
						}
					} else {
						_g.toastMsg({
							msg: err.msg
						});
					}
				});
			}
		},
		unique: function(arr) { // 数组去重
			var result = [],
				hash = {};
			for (var i = 0, elem;
				(elem = arr[i]) != null; i++) {
				if (!hash[elem]) {
					result.push(elem);
					hash[elem] = true;
				}
			}
			return result;
		},
		addJsonArrVal: function(arr, key, value) { // JSON数组添加键值
			if (Array.isArray(arr) && arr.length > 0) {
				for (var i = 0; i < arr.length; i++) {
					arr[i][key] = value;
				}
			}
			return arr;
		}
	}

	business.prototype.constructor = business;
	module.exports = new business();

});
