define(function (require, exports, module) {
	function _C() {}

	_C.prototype = {
		getItemSelect: function (opts){ // 选择列表
			return {
				template: _g.getTemplate('Common/components/item-select-v'),
				data: function () {
					return {
						frameName: opts.frameName
					}
				},
				props: ['item', 'key', 'index'],
				methods: {
					selectIt: function(){
						var self = this
						api.sendEvent({
							name: self.frameName + '-selectIt',
							extra: {
								key: self.key,
								item: self.item,
								index: self.index
							}
						})
					}
				},
				created: function () {
					var self = this;
				}
			}
		},
		getBaseIcon: function (opts){ // 基础图标
			return {
				template: _g.getTemplate('Common/components/base-icon-v'),
				data: function () {
					return {
						frameName: opts.frameName
					}
				},
				props: ['item', 'type'],
				methods: {
					
				},
				created: function () {
					var self = this;
				}
			}
		},
		getBaseHeader: function (opts) { // 头部
			return {
				template: _g.getTemplate('Common/header/base-header-v'),
				data: function () {
					return {
						title: '', // 标题
						tabs: [], // tab按钮 [{title: '标题'}]
						btns: [], // {name: '文字按钮', icon: (filter|add|right|more|del|save|wx|qq|print), event: '事件名', hidden: (true|false)}
						showTitleSelect: false, // 是否显示下拉类型标题
						titleSelectState: 0,
						titleList: [] // [{title: '标题'}]
					}
				},
				methods: {
					init: function (opts) { // 初始化
						var self = this;
						self.btns = opts.btns || [];
						var tempTabs = opts.tabs || [];
						if (tempTabs.length > 0) {
							_.each(tempTabs, function (ele, index, list) {
								ele.active = false;
							});
							tempTabs[0].active = true;
							self.tabs = tempTabs;
						}
						self.showTitleSelect = opts.showTitleSelect || false;
						self.titleList = opts.titleList || [];
						if (self.titleList.length > 0) {
							self.title = self.titleList[0].title || '';
						}
						self.title = opts.title || '';
					},
					openBtnsLayer: function (opts) { // 打开下拉按钮组
						var self = this;
						var btn = opts.btn;
						if (!btn.state) {
							var autoFrame = {
								name: 'btns-layer',
								url: '../Common/header/btns-layer',
								rect: {
									y: Number(_g.getLS('statusBarHeight')) + 44
								}
							}
							btn.frame = $.extend(autoFrame, btn.frame || {});
							_g.openFrame(btn.frame);
							_g.addEventListener({
								name: btn.frame.name + '-frame-state',
								success: function (ret) {
									btn.state = ret.value.state;
								}
							})
							btn.state = 1;
						} else if (btn.state == 1) {
							api.setFrameAttr({
								name: btn.frame.name + '-frame',
								hidden: true
							});
							btn.state = 2;
						} else {
							api.setFrameAttr({
								name: btn.frame.name + '-frame',
								hidden: false
							});
							btn.state = 1;
						}
					},
					clickLeft: function () { // 左按钮
						api.sendEvent({
							name: api.winName + '-closeWin'
						})
						if (api.winName === 'root') {
							_g.closeApp()
						} else {
							_g.closeWin()
						}

					},
					clickSelect: function () { // 下拉类型标题
						var self = this;
						var frameName = 'btns-layer-c';
						if (self.titleSelectState == 0) {
							_g.openFrame({
								name: frameName,
								url: '../Common/header/btns-layer',
								rect: {
									y: Number(_g.getLS('statusBarHeight')) + 44
								},
								pageParam: {
									location: 'center',
									btns: self.titleList
								}
							});
							_g.addEventListener({
								name: frameName + '-frame-state',
								success: function (ret) {
									self.titleSelectState = ret.value.state;
								}
							});
							_g.addEventListener({
								name: api.winName + '-btns-layer-click',
								success: function (ret) {
									self.title = ret.value.btn.title;
								}
							});
							self.titleSelectState = 1;
						} else if (self.titleSelectState == 1) {
							_g.setFrameAttr({
								name: frameName,
								hidden: true
							});
							self.titleSelectState = 2;
						} else {
							_g.setFrameAttr({
								name: frameName,
								hidden: false
							});
							self.titleSelectState = 1;
						}
					},
					clickTab: function (tab, index) { // tab按钮
						if (tab.active) {
							return;
						}
						var self = this;
						_.each(self.tabs, function (ele, index, list) {
							ele.active = false;
						});
						tab.active = true;
						api.sendEvent({
							name: api.winName + '-tab-click',
							extra: {
								tab: tab,
								index: index
							}
						});
					},
					clickRight: function (btn) { // 右按钮
						var self = this;
						if (btn.event) { // 发送事件
							api.sendEvent({
								name: btn.event,
								extra: {
									data: btn
								}
							});
							if (btn.icon == 'more') { // 判断为more类型按钮
								self.openBtnsLayer({
									btn: btn
								});
							}
						}
					}
				},
				created: function () {
					var self = this;
					console.log(_g.j2s(opts));
					self.init(opts); // 初始化
				},
				mounted: function () {
					var self = this;

					_g.addEventListener({ // 监听安卓的物理返回键
						name: 'keyback',
						success: function (ret) {
							self.clickLeft();
						}
					});

					_g.addEventListener({ // 按钮组更新
						name: api.winName + '-btns-update',
						success: function (ret) {
							self.btns = ret.value.btns;
						}
					});

					_g.addEventListener({ // 控制按钮隐藏/显示
						name: api.winName + '-btns-bubble',
						success: function (ret) {
							var index = ret.value.index || 0;
							_.each(self.btns, function (ele, index, list) {
								if (ele.hidden !== undefined) {
									ele.hidden = true;
								}
							});
							self.btns[index].hidden = false;
						}
					});

					_g.addEventListener({
						name: api.winName + '-btn-more-update',
						success: function (ret) {
							console.log(_g.j2s(ret));
							_.each(self.btns, function (ele, index, list) {
								if (ele.icon == 'more') {
									ele.frame = {
										pageParam: {}
									}
									ele.frame.pageParam.btns = ret.value.btns;
								}
							})
						}
					});

					_g.fixStatusBar(); // 适配手机头部状态栏
				}
			}
		},
		//新的，旧的未检查更替
		getHeader: function (opts) { // 头部
			return {
				template: _g.getTemplate('Common/header/header-v'),
				data: function () {
					return {
						title: opts.title || '' // 标题
					}
				},
				methods: {
					init: function (opts) { // 初始化
						var self = this;
						self.title = opts.title || '';
					}
				},
				created: function () {
					var self = this;
					console.log(_g.j2s(opts));
					// self.init(opts); // 初始化
				},
				mounted: function () {
					var self = this;
					_g.fixStatusBar(); // 适配手机头部状态栏
				}
			}
		},
		getLback: function (opts) { // 头部返回按钮
			return {
				template: _g.getTemplate('Common/header/l-back-v'),
				data: function () {
					return {
					}
				},
				methods: {
					clickLeft: function () { // 左按钮
						api.sendEvent({
							name: api.winName + '-closeWin'
						})
						if (api.winName === 'root') {
							_g.closeApp()
						} else {
							_g.closeWin()
						}
					}
				},
				created: function () {
					var self = this;
					console.log(_g.j2s(opts));
				},
				mounted: function () {
					var self = this;
					_g.addEventListener({ // 监听安卓的物理返回键
						name: 'keyback',
						success: function (ret) {
							self.clickLeft();
						}
					});
				}
			}
		},
		getRbtns: function (opts) { // 头部右侧按钮组
			return {
				template: _g.getTemplate('Common/header/r-btns-v'),
				data: function () {
					return {
						btns: opts.btns
					}
				},
				methods: {
					clickRight: function(btn){
						var self = this;
						api.sendEvent({
							name: btn.event,
							extra: {}
						});
					}
				},
				created: function () {
					var self = this;
					console.log(_g.j2s(opts));
				},
				mounted: function () {
					var self = this;
				}
			}
		},
		getTabBar: function (opts) { // tab切换
			return {
				template: _g.getTemplate('Common/header/tab-v'),
				data: function () {
					return {
						tabs: [{
							title: '',
							active: true
						}],
						eventName: '',
						tabStyle: {
							'-webkit-transform': 'translate(0, 0)',
							'transform': 'translate(0, 0)'
						}
					}
				},
				methods: {
					init: function () {
						var self = this;
						console.log(_g.j2s(opts))
						self.tabs = opts.tabs;
						var tabsLen = self.tabs.length;
						_.each(self.tabs, function (element, index, list) {
							if (index == 0) {
								element.active = true;
							} else {
								element.active = false;
							}
						});
						self.tabStyle.width = api.frameWidth / tabsLen / 2 + 'px'
						self.tabStyle.left = api.frameWidth / tabsLen / 4 + 'px'
					},
					onTapSwitch: function (tab, index) { // 切换tab
						var self = this;
						console.log(_g.j2s(tab));
						console.log(index);

						var tabsLen = self.tabs.length;
						var transform = index * api.frameWidth / tabsLen + 'px';
						self.tabStyle['-wbkit-transform'] = 'translate(' + transform + ', 0)';
						self.tabStyle['transform'] = 'translate(' + transform + ', 0)';

						_.each(self.tabs, function (element, index, list) {
							element.active = false;
						});
						tab.active = true;
						api.sendEvent({
							name: self.eventName || api.winName + '-change-tab',
							extra: {
								tab: tab,
								index: index
							}
						});
					}
				},
				created: function () {
					var self = this;
					self.init();
				}
			}
		},
		//新的，旧的未检查更替
		getBaseTabBar: function (opts) { // tab切换(基础组件)
			return {
				template: _g.getTemplate('Common/components/base-tab-v'),
				data: function () {
					return {
						tabs: [{
							title: '',
							active: true
						}],
						tabStyle: {
							'-webkit-transform': 'translate(0, 0)',
							'transform': 'translate(0, 0)'
						}
					}
				},
				methods: {
					init: function () {
						var self = this;
						console.log(_g.j2s(opts))
						self.tabs = opts.tabs;
						var tabsLen = self.tabs.length;
						self.tabStyle.width = api.frameWidth / tabsLen / 2 + 'px'
						self.tabStyle.left = api.frameWidth / tabsLen / 4 + 'px'
					},
					onTapSwitch: function (tab, index) { // 切换tab
						var self = this;
						console.log(_g.j2s(tab));
						console.log(index);

						var tabsLen = self.tabs.length;
						var transform = index * api.frameWidth / tabsLen + 'px';
						self.tabStyle['-wbkit-transform'] = 'translate(' + transform + ', 0)';
						self.tabStyle['transform'] = 'translate(' + transform + ', 0)';

						_.each(self.tabs, function (element, index, list) {
							element.active = false;
						});
						tab.active = true;
						api.sendEvent({
							name: api.winName + '-change-tab',
							extra: {
								tab: tab,
								index: index
							}
						});
					}
				},
				created: function () {
					var self = this;
					self.init();
				}
			}
		},
		//新的
		getDropDownShower: function (opts) { // 头部下拉组件
			return {
				template: _g.getTemplate('Common/components/drop-down-shower-v'),
				data: function () {
					return {
						curClass: 'down', //当前箭头的状态
						selectedStr: opts.selectedStr || '' //选中的下拉值字符串
					}
				},
				props: ['name'],  //下拉选择层的数据源
				methods: {
					onTapOpenLayer: function(){ //打开下拉选择层
						var self = this;
						api.sendEvent({
							name: api.winName + '-' + self.name + '-drop-down-layer',
							extra: {
								type: 'change'  //切换layer的显示
							}
						});
					}
				},
				created: function () {
					var self = this;
				},
				mounted: function () {
					var self = this;
					_g.addEventListener({ 
						name: api.winName + '-' + self.name + '-drop-down-layer',
						success: function (ret) {
							switch(ret.value.type){
								case 'selected': //选中
									self.curClass = self.curClass == 'down' ? 'up' : 'down';
									self.selectedStr = ret.value.selected.name;
								break;
								// case 'get-result': //外部设置选中值
								// 	self.selectedStr = ret.value.selected.name;
								// break;
								case 'change': //layer层隐藏或显示
									self.curClass = self.curClass == 'down' ? 'up' : 'down';
								break
								default:
								break;
							}
						}
					});
				}
			}
		},
		//新的
		getDropDownLayer: function (opts) { // 下拉选择层组件（一般和头部下拉组件结合使用）
			return {
				template: _g.getTemplate('Common/components/drop-down-layer-v'),
				data: function () {
					return {
						height: opts.height,
						isLayerShow: false, //控制下拉选择层是否显示
					}
				},
				props: ['items', 'name'], 
				methods: {
					hideLayer: function(){
						var self = this;
						api.sendEvent({
							name: api.winName + '-' + self.name + '-drop-down-layer',
							extra: {
								type: 'change'  //操作类型
							}
						});
					},
					onTapChoose: function(item, index){ //选择
						var self = this;
						api.sendEvent({
							name: api.winName + '-' + self.name + '-drop-down-layer',
							extra: {
								type: 'selected',  //操作类型
								selected: item
							}
						});
					}
				},
				created: function () {
					var self = this;
				},
				mounted: function () {
					var self = this;
					
					_g.addEventListener({ 
						name: api.winName + '-' + self.name + '-drop-down-layer',
						success: function (ret) {
							switch(ret.value.type){
								case 'change': //打开/隐藏layer
									self.isLayerShow = !self.isLayerShow;
								break;
								case 'selected': //选中，会自动隐藏layer
									self.isLayerShow = !self.isLayerShow;
									api.sendEvent({
										name: api.winName + '-' + self.name + '-drop-down-layer-selected',
										extra: {
											selected: ret.value.selected
										}
									});
								break;
								default:
								break;
							}
						}
					});
				}
			}
		},
		//新的
		getBtnsLayer: function (opts) { // 头部 下拉选择按钮组 组件
			return {
				template: _g.getTemplate('Common/components/btns-layer-v'),
				data: function () {
					return {
						height: opts.height,
						isLayerShow: false, //控制下拉选择层是否显示
					}
				},
				props: ['items'], 
				methods: {
					hideLayer: function(){
						var self = this;
						api.sendEvent({
							name: api.winName + '-btns-layer',
							extra: {
								type: 'change'  //操作类型
							}
						});
					},
					onTapChoose: function(item, index){ //选择
						var self = this;
						api.sendEvent({
							name: api.winName + '-btns-layer',
							extra: {
								type: 'selected',  //操作类型
								selected: item
							}
						});
					},
					init: function(){ //初始化
						var self = this;
						$.each(self.items, function(key, value) {
		                    switch (value.title) {
		                        case '保存':
		                            value.icon = 'save';
		                            value.sort = 0;
		                            break;
		                        case '提交':
		                            value.icon = 'right';
		                            value.sort = 1;
		                            break;
		                        case '撤回':
		                            value.icon = 'revoke';
		                            value.sort = 2;
		                            break;
		                        case '审核':
		                            value.icon = 'check';
		                            value.sort = 3;
		                            break;
		                        case '反审核':
		                            value.icon = 'uncheck';
		                            value.sort = 4;
		                            break;
		                        case '审批流程':
		                            value.icon = 'checkStep';
		                            value.sort = 5;
		                            break;
		                        case '微信分享':
		                            value.icon = 'wx';
		                            value.sort = 6;
		                            break;
		                        case 'QQ分享':
		                            value.icon = 'qq';
		                            value.sort = 7;
		                            break;
		                        case '打印':
		                            value.icon = 'print';
		                            value.sort = 8;
		                            break;
		                        case '删除':
		                            value.icon = 'del';
		                            value.sort = 9;
		                            break;
		                        default:
		                            value.icon = '';
		                    }
		                });
					}
				},
				created: function () {
					var self = this;
					self.init();

				},
				mounted: function () {
					var self = this;
					_g.addEventListener({ 
						name: api.winName + '-btns-layer',
						success: function (ret) {
							switch(ret.value.type){
								case 'change': //打开/隐藏layer
									self.isLayerShow = !self.isLayerShow;
								break;
								case 'selected': //选中  ，会自动隐藏layer
									self.isLayerShow = !self.isLayerShow;
									api.sendEvent({
										name: api.winName + '-btns-layer-selected',
										extra: {
											selected: ret.value.selected
										}
									});
								break;
								default:
								break;
							}
						}
					});
				}
			}
		},
		//新的，旧的未检查更替
		getBaseSearchBar: function (opts) { // 基础搜索栏
			return {
				template: _g.getTemplate('Common/components/base-search-v'),
				data: function () {
					return {
						tips: opts.tips || '', //搜索栏里的提示语
						keyword: '' , //搜索框里的内容
						showScan: opts.showScan || false, //是否有扫描功能，默认为false
					}
				},
				methods: {
					onTapSearch: function () { // 输入搜索
						var self = this;
						$('input[type=search]').blur(); //输入框失去焦点
						self.sendSearchEvent({
							type: 'input'
						});
					},
					sendSearchEvent: function (opts) { // 发送搜索事件
						var self = this;
						api.sendEvent({
							name: api.winName + '-search',
							extra: {
								keyword: self.keyword,
								type: opts.type
							}
						});
					},
					onTapScan: function () { //扫描搜索
						var self = this;
						var MODULES = require('modules');
						MODULES.scan({
							success: function (ret) {
								self.keyword = ret.content;
								self.sendSearchEvent({
									type: 'barcode'
								})
							},
							error: function (err) {
								_g.toastMsg({
									msg: '扫描失败，请重试！'
								});
							}
						});
					}
				},
				created: function () {
					var self = this;
					console.log(_g.j2s(opts));
				},
				mounted: function () {
					var self = this;
					// 从command.refresh方法中统一发送监听，或进行过滤时，也会发送。
					_g.addEventListener({ 
						name: api.winName + '-search-clear',
						success: function (ret) {
							self.keyword = '';
						}
					});
					// _g.addEventListener({ // 往搜索框里加keyword
					// 	name: api.winName + '-get-keyword',
					// 	success: function (ret) {
					// 		self.keyword = ret.value.keyword
					// 	}
					// });
				}
			}
		},
		getSearchBar: function (opts) { // 搜索栏
			return {
				template: _g.getTemplate('Common/header/search-v'),
				data: function () {
					return {
						tips: '', //搜索栏里的提示语
						type: '', //下拉选定的内容的id
						keyword: '',
						showSelect: false, //是否有下拉选择的frame
						showScan: false, //是否有扫描功能
						isDistribute: false, //是否是打开报表模块里的客户分布页
						showSearchbar: true, //判断是否显示搜索框
						isHome: false, //是否是 一级页面的搜索
						selectList: { // 下拉内容
							url: '',
							data: [],
							title: ''
						},
						firstOpen: true,
						layerState: 0
					}
				},
				props: ['curFrame'],
				watch: {
					keyword: function (oldVal, newVal) {
						var self = this;
						// self.sendSearchEvent();
					}
				},
				methods: {
					init: function () { // 初始化数据
						var self = this;
						self.tips = opts.tips || '';
						self.showSelect = opts.showSelect || false;
						self.showScan = opts.showScan || false;
						self.isDistribute = opts.isDistribute || false;
						self.type = opts.type || '';
						self.selectList = $.extend(self.selectList, opts.selectList);
						self.showSearchbar = opts.showSearchbar === undefined ? true : opts.showSearchbar;
						self.isHome = opts.isHome === undefined ? false : opts.isHome;
						self.onTapSelect = function () {
							self.openSelectList();
						}
					},
					onTapSelect: null, // 打开选择列表
					onTapSearch: function () { // 搜索
						var self = this;
						$('input[type=search]').blur(); //输入框隐藏
						self.sendSearchEvent();
					},
					sendSearchEvent: function () { // 发送搜索事件
						var self = this;
						api.sendEvent({
							name: api.winName + '-search',
							extra: {
								keyword: self.keyword,
								opts: opts
							}
						});
					},
					onTapScan: function () { //扫描
						var self = this;
						var MODULES = require('modules');
						MODULES.scan({
							success: function (ret) {
								self.$parent.keyword = ret.content;
								self.keyword = ret.content;
								api.sendEvent({
									name: api.winName + '-scan',
									extra: {
										content: ret.content,
										opts: opts
									}
								});
							},
							error: function (err) {
								_g.toastMsg({
									msg: '扫描失败，请重试！'
								});
							}
						});
					},
					openSelectList: function () { // 打开选择列表
						var self = this;
						var frameName = 'select-list';
						// if (self.layerState == 0) {

						// 	_g.fixStatusBar();
						// 	var opsT = $('#header').height()
						// 	if (self.isHome) {
						// 		opsT = opsT + 44; //44为搜索栏的高度
						// 	}
						// 	if (api.systemType == 'ios' && (api.winName == 'check' || api.winName == 'sharer')) {
						// 		opsT = opsT + 1;
						// 	}
						// 	_g.openFrame({
						// 		name: frameName,
						// 		url: self.selectList.url,
						// 		rect: {
						// 			y: opsT,
						// 		},
						// 		pageParam: {
						// 			data: self.selectList.data
						// 		},
						// 		reload: false,
						// 		animation: {
						// 			type: 'fade',
						// 			duration: 300
						// 		},
						// 	});
						// 	_g.addEventListener({
						// 		name: frameName + '-frame-state',
						// 		success: function (ret) {
						// 			self.layerState = ret.value.state;
						// 		}
						// 	});
						// 	self.layerState = 1;
						// } else if (self.layerState == 1) {
						// 	_g.setFrameAttr({
						// 		name: frameName,
						// 		bounces: false,
						// 		hidden: true
						// 	});
						// 	self.layerState = 2;
						// } else {
						// 	_g.setFrameAttr({
						// 		name: frameName,
						// 		bounces: false,
						// 		hidden: false
						// 	});
						// 	self.layerState = 1;
						// }
						if (self.layerState == 0) {

							_g.fixStatusBar();
							var opsT = $('#header').height()
							if (self.isHome) {
								opsT = opsT + 44; //44为搜索栏的高度
							}
							if (api.systemType == 'ios' && (api.winName == 'check' || api.winName == 'sharer')) {
								opsT = opsT + 1;
							}
							_g.openFrame({
								name: frameName,
								url: self.selectList.url,
								rect: {
									y: opsT,
								},
								pageParam: {
									data: self.selectList.data
								},
								reload: false,
								animation: {
									type: 'fade',
									duration: 300
								},
							});
							_g.addEventListener({
								name: frameName + '-frame-state',
								success: function (ret) {
									self.layerState = ret.value.state;
								}
							});
							console.log('before:'+self.layerState)
							self.layerState = 1;
							console.log('after:'+self.layerState)
						} else if (self.layerState == 1) {
							_g.setFrameAttr({
								name: frameName,
								bounces: false,
								hidden: true
							});
							console.log('before:'+self.layerState)
							self.layerState = 0;
							console.log('after:'+self.layerState)
						}
					}
				},
				created: function () {
					var self = this;
					console.log(_g.j2s(opts));
					self.init(opts); // 初始化数据
				},
				mounted: function () {
					var self = this;

					_g.addEventListener({ // 监听下拉列表变化
						name: api.winName + '-select-data',
						success: function (ret) {
							self.openSelectList();
							console.log(_g.j2s(ret))
							if(api.winName == 'index-win'){
								api.sendEvent({ // 通知列表页，根据选中的类型，进行列表刷新
									name: api.winName + '-search-select-data',
									extra: ret.value.data
								});
							}
							if (ret.value != '') { // 如有传数据，则会刷新列表
								self.selectList.title = ret.value.data.name;
								api.sendEvent({ // 通知列表页，根据选中的类型，进行列表刷新
									name: api.winName + '-list-reload',
									extra: {
										typeName: ret.value.typeName,
										typeId: ret.value.self,
										// add for mine
										name: ret.value.data.type,
										id: ret.value.data.id
									}
								});
							}
						}
					});

					_g.addEventListener({
						name: api.winName + '-search-clear',
						success: function (ret) {
							self.keyword = '';
						}
					});
					_g.addEventListener({ // 往搜索框里加keyword
						name: api.winName + '-get-keyword',
						success: function (ret) {
							self.keyword = ret.value.keyword
						}
					});
					_g.addEventListener({ //如果首页模块-审批单据列表中，头部标题有切换，则listTitle设置为“全部”
						name: api.winName + '-clear-typeChoose',
						success: function (ret) {
							self.selectList.title = ret.value.title;
						}
					});

					_g.addEventListener({ // 切换tab-frame的时候要搜索
						name: api.winName + '-presearch',
						success: function (ret) {
							console.log('search.keyword.length : ' + self.keyword.length);
							if (self.keyword.length != 0) {
								console.log('-preseach');
								self.sendSearchEvent();
							}
						}
					});
				}
			}
		},
		getRecord: function () { // 录音
			return {
				template: _g.getTemplate('Common/record-v'),
				data: function () {
					return {
						RECORD: require('record'),
						FILE: require('file'),
						TIME: require('time'),
						startTime: 0,
						endTime: 0,
						secondTime: 0, // 录音时长（毫秒）
						maxTime: 600000, //录音最长时间
						isRecording: true, //未录制状态
						hideRecordMode: true, //录制模式
						recordList: []
					}
				},
				watch: {
					'recordList': function (val, newVal) {
						console.log('recordList：' + JSON.stringify(val));
						api.sendEvent({
							name: api.winName + '-get-record',
							extra: {
								rec: val
							}
						});
					}
				},
				methods: {
					recording: function (event) { //录音
						event.preventDefault();
						var self = this;
						self.hideRecordMode = false;
						var time = new Date();
						self.startTime = time.getTime();
						self.RECORD.start(); //开始录音
						setTimeout(function () { //时长限制
							self.stopRecording(); //停止录制
							_g.toastMsg({
								msg: '录制时间已经超过最长10分钟'
							});
						}, self.maxTime);
					},
					stopRecording: function () { // 停止录音
						var self = this;
						var _time = new Date();
						console.log('停止录音');
						self.endTime = _time.getTime();
						var speedTime = self.secondTime = self.endTime - self.startTime;
						console.log('speedTime:' + speedTime);
						if (speedTime >= 1000 && self.startTime != 0) { // 录制成功
							self.hideRecordMode = true;
							self.isRecording = false;
							self.RECORD.stop({
								success: function (ret) {
									var recName = self.FILE.getFullNameByPath(ret.path);
									var spTime = self.TIME.millisecondToDate(speedTime);
									setTimeout(function () {
										self.recordList.push({
											isPlay: false,
											savePath: ret.path,
											saveName: recName,
											speedTime: spTime,
											voiceTime: self.secondTime
										}); //录音地址
									});
									self.startTime = 0;
								}
							});
						} else { // 录制时间过短
							self.hideRecordMode = true;
							_g.toastMsg({
								msg: '录制时间过短'
							});
							self.startTime = 0;
						}
					},
					delRecord: function (rec) { // 删除录音
						var self = this;
						console.log('delRecord: '+ JSON.stringify(rec));
						_g.confirm({
							params: {
								title: '',
								msg: '是否删除该录音?',
								buttons: ['确定', '取消']
							},
							success: function (ret) {
								if (ret.buttonIndex == 1) {
									self.recordList = _.without(self.recordList, rec);
								}
							}
						});
					},
					playRecord: function (rec) { // 播放录音
						console.log('play record: ' + JSON.stringify(rec));
						var self = this;
						if (rec.savePath != '') {
							rec.isPlay = true;
							self.RECORD.play({
								url: rec.savePath,
								success: function (ret) {
									rec.isPlay = false;
								},
								error: function (err) {
									rec.isPlay = false;
								}
							});
						}
					}
				}
			}
		},
		getIconList: function () {

		},
		getChatBox: function (opts) { // 表情输入
			return {
				template: _g.getTemplate('Common/chatBox-v'),
				data: function () {
					return {
						chatBoxModule: api.require('LRKJUIChatBox'),
						chatBox: {
							crrunt_input: 0,
							value: '',
							input_index: 0,
							star: '',
							end: '',
							show_emotion: false,
						},
						content: '',
						placeholder: ''
					}
				},
				methods: {
					crrunt: function (num) {
						this.chatBox.crrunt_input = num;
					},
					getcrrunt: function (num) {
						var self = this;
						var cursurPosition = -1;
						var oTa1 = document.getElementById('emojiArea');
						var evt = window.event;
						if (oTa1.value == '') {
							return;
						} else {
							if (oTa1.selectionStart) {
								//非IE浏览器
								cursurPosition = oTa1.selectionStart;
							} else {
								cursurPosition = 0;
							}
							return cursurPosition;
						}
					},
					openChatBox: function (opts) {
						var self = this;
						self.chatBoxModule.open({
							emotionPath: 'widget://res/img/emotion',
							customBtns: {
								btns: [{
									title: '',
									normalImg: 'widget://res/img/emoji.png',
									activeImg: ''
								}],
							}
						}, function (ret, err) {
							if (ret) {
								var $this = $('#emojiArea')[0];
								if (ret.eventType == 'maskTap') {
									// 点击了遮罩, 收起UIChatbox的时候, 需要移除焦点
									document.activeElement.blur();
									self.chatBoxModule.closeBoard();
									self.chatBoxModule.closeKeyboard();
								}
								if (ret.eventType == 'emotionBtn') {
									if (api.systemType == 'ios') {
										if (ret.emotionBtnState == 1) {
											// 当前是表情的状态, 需要把input的焦点移除
											$this.blur();
											// 获取输入框的值
											self.chatBox.value = self.content;
											//获取当前光标位置
											self.chatBox.input_index = self.getcrrunt(self.chatBox.crrunt_input);
											//获取光标前的字符串
											self.chatBox.star = self.chatBox.value.substring(0, self.chatBox.input_index);
											//获取光标后的字符串
											self.chatBox.end = self.chatBox.value.substring(self.chatBox.input_index, self.chatBox.value.length);
											//将star赋值给chatBox
											self.chatBoxModule.value({
												msg: self.chatBox.star
											});
										} else if (ret.emotionBtnState == 0) {
											if ($this.setSelectionRange) {
												//W3C
												setTimeout(function () {
													$this.setSelectionRange(self.chatBox.star.length, self.chatBox.star.length);
												}, 0);
											} else if ($this.createTextRange) {
												//IE
												var textRange = $this.createTextRange();
												textRange.moveStart("character", self.star.length);
												textRange.moveEnd("character", self.star.length);
												textRange.select();
											}
										}
									}
								}
								if (ret.customBtnsIndex == 0) {
									self.chatBoxModule.closeBoard();
									self.chatBoxModule.closeKeyboard();
									self.openLabel();
								} else if (ret.customBtnsIndex == 1) {
									self.chatBoxModule.closeBoard();
									self.chatBoxModule.closeKeyboard();
								} else if (ret.customBtnsIndex == 2) {
									self.chatBoxModule.closeBoard();
									self.chatBoxModule.closeKeyboard();
									self.openImgs();
								}
							}
						});

						if (api.systemType == 'android') {
							// 打开/收起表情选择器
							self.chatBoxModule.addEventListener({
								target: 'inputBar',
								name: 'showEmotion'
							}, function (ret, err) {
								if (ret) {
									// 获取输入框的值
									self.chatBox.value = self.content;
									//获取当前光标位置
									self.chatBox.input_index = self.getcrrunt(self.chatBox.crrunt_input);
									//获取光标前的字符串
									self.chatBox.star = self.chatBox.value.substring(0, self.chatBox.input_index);
									//获取光标后的字符串
									self.chatBox.end = self.chatBox.value.substring(self.chatBox.input_index, self.chatBox.value.length);
									//将star赋值给chatBox
									self.chatBoxModule.value({
										msg: self.chatBox.star
									});
								}
							});
						}

						// 点击表情
						self.chatBoxModule.addEventListener({
							target: 'inputBar',
							name: 'valueChanged'
						}, function (ret, err) {
							if (ret) {
								if (ret.value != self.chatBox.star) {
									self.chatBox.star = ret.value;
									//将改变的字符串插回原先的输入值
									self.content = ret.value + self.chatBox.end;
									var obj = document.getElementById('emojiArea');
									if (api.systemType == 'android') {
										if (obj.setSelectionRange) { //W3C
											setTimeout(function () {
												obj.setSelectionRange(self.chatBox.star.length, self.chatBox.star.length);
											});
										} else if (obj.createTextRange) { //IE
											var textRange = obj.createTextRange();
											textRange.moveStart("character", self.star.length);
											textRange.moveEnd("character", self.star.length);
											textRange.select();
										}
									}
								} else {
									return;
								}
							}
						});
					},
				},
				created: function () {
					var self = this;
					self.content = opts.content;
					self.placeholder = opts.placeholder == undefined ? '请输入100字内的批示' : opts.placeholder;
				},
				mounted: function () {
					var self = this;
					self.openChatBox();
					api.addEventListener({
						name: api.winName + '-save'
					}, function (ret, err) {
						//把填写的内容更新到批示页
						api.sendEvent({
							name: 'instruct-reload',
							extra: {
								'content': self.content,
								'instructId': api.pageParam.instructId
							}
						});
						setTimeout(function () {
							api.closeWin();
						});
					});
				}
			}
		},
		getInstruct: function (opts) { // 批示
			return {
				template: _g.getTemplate('Common/instruct-v'),
				data: function () {
					return {
						TIME: require('time'),
						INTERFACE: require('interface'),
						page: {
							isShow: true, // 是否显示批示列表
							isList: true, // 是否展开批示列表
							isDelMode: false, // 是否显示删除模式蒙版
							delIndex: '', // 长按删除的元素序号
							fixToBottom: false, //批示按钮是否固定在底部，默认为否
						},
						param: {
							id: '', // 所选的单据id
							modId: '' // 对应的是各个单据的modId（销售机会：10101 售后工单：10110 销售合同：10104 销售报价：20201 销售收款：20203）
						},
						items: []
					}
				},
				methods: {
					toggleList: function () {
						// 展开/收起 列表
						var self = this;
						self.page.isList = !self.page.isList; // 批示列表展开/收起
					},
					doInstruct: function () {
						// 批示
						var item = {
							'instructId': -999,
							'content': ''
						}
						_g.openWin({
							name: 'comment',
							url: '../Common/comment',
							pageParam: {
								'addnewFlag': true,
								'index': '',
								'item': item
							}
						});
					},
					dealPhoto: function (obj) {
						//$.each(obj,function(key ,val){
						if (obj.pictureurl == null) {
							obj.pictureurl = '../../res/img/timg.jpg';
						} else {
							obj.pictureurl = URLANNEX + '/' + obj.pictureurl;
						}
						//});
						return obj;
					},
					dealTohtml: function (str, callBack) {
						var content = str;
						var emojiArr = content.match(/(?:\[)([^\[\]]*)(?:\])/g);
						if (Array.isArray(emojiArr) && emojiArr.length > 0) {
							$.ajax({
								url: '../../res/img/emotion/emotion.json',
								type: 'get',
								dataType: 'json',
								success: function (ret) {
									var data = ret;
									for (var i = 0; i < data.length; i++) {
										for (var j = 0; j < emojiArr.length; j++) {
											if (data[i].text == emojiArr[j]) {
												content = content.replace(emojiArr[j], '<img src="../../res/img/emotion/' + ret[i].name + '.png">');
											}
										}
									}
									callBack(content);
								}
							});
						} else {
							callBack(content);
						}
					},
					getList: function () {
						// 获取批示列表
						var self = this;
						console.log('获取批示列表');
						var param = {
							'url': URLANNEX + '/ncrm/joblog/joblogList!doGetRemarkListData.action',
							'data': {
								'isH5': 'true',
								'billid': self.param.id, // 所选的单据id
								'mod': self.param.modId // 对应的是各个单据的modId（销售机会：10101 售后工单：10110 销售合同：10104 销售报价：20201 销售收款：20203）
							}
						}
						var HTTP = require('http');
						var TIME = require('time');
						var business = require('business');
						HTTP.ajax({
							url: param.url,
							data: param.data,
							success: function (ret) {
								$.each(ret.resultData.ListData, function (key, val) {
									val = self.dealPhoto(val); //头像处理
									val.opdate = TIME.sortdate(val.opdate); //时间处理
									//表情处理
									self.dealTohtml(val.content, function (str) {
										val._content = str;
										if (ret.resultData.ListData.length - 1 == key) {
											self.items = business.addJsonArrVal(ret.resultData.ListData, 'hideDelBtn', true); // 添加删除按钮
											console.log('处理后:' + JSON.stringify(self.items));
											self.items.length; // 获取批示数量
										}
									});
								});
							},
							error: function (err) {
								_g.toastMsg({
									msg: err.msg
								});
							}
						});
					},
					openEdit: function (index) {
						// 编辑
						var self = this;
						if (self.page.isDelMode == true) { return;}
						
						_g.openWin({
							name: 'comment',
							url: '../Common/comment',
							pageParam: {
								'addnewFlag': false,
								'index': index,
								'item': self.items[index]
							}
						});
					},
					onDelMode: function (_index, item) {
						var self = this;
						if (item.opname != _g.getLS('opName')) { return;}
						// 长按进入删除模式
						self.page.delIndex = _index; // 长按删除元素的序号
						self.page.isDelMode = true; // 显示删除按钮
						self.items[_index].hideDelBtn = false; // 显示删除蒙版
					},
					offDelMode: function () {
						var self = this;
						//关闭删除模式
						self.items[self.page.delIndex].hideDelBtn = true; // 隐藏删除按钮
						self.page.isDelMode = false; // 去除删除蒙版
					},
					removeItem: function (item) {
						var index = this.items.indexOf(item);
						this.items.splice(index, 1);
					},
					delItem: function (_item, _index) {
						// 删除批示
						var self = this;

						var INTERFACE = require('interface');
						var param = {
							'url': INTERFACE.business.base['instruct'].del.url,
							'data': {
								'master.id': _item.id,
								'master.itemno': _item.itemno,
								'mod': self.param.modId,
							}
						}
						var HTTP = require('http');
						HTTP.ajax({
							url: param.url,
							data: param.data,
							success: function (ret) {
								// self.items.$remove(_item);
								self.removeItem(_item);
								_g.toastMsg({
									msg: '删除成功'
								});
							_item.hideDelBtn = true; // 隐藏删除按钮
							self.page.isDelMode = false; // 去除删除蒙版	
							},
							error: function (err) {
								_g.toastMsg({
									msg: err.msg
								});
								_item.hideDelBtn = true; // 隐藏删除按钮
								self.page.isDelMode = false; // 去除删除蒙版
							}
						});
					},
				},
				mounted: function () {
					var self = this;
					self.page.fixToBottom = opts.fixToBottom == undefined ? false : opts.fixToBottom;
					// 获取批示列表
					_g.addEventListener({
						name: 'instruct-list',
						success: function (ret) {
							self.page.isShow = true;
							self.param = ret.value.paramJson;
							self.getList(); // 获取批示列表 
						}
					});
					// 新增/编辑批示
					_g.addEventListener({
						name: 'instruct-save',
						success: function (ret) {
							var HTTP = require('http');
							var INTERFACE = require('interface');
							var paramJson = ret.value.paramJson;
							var index = paramJson.index; // 编辑元素序号
							var content = paramJson.content; // 批示内容
							var addnewFlag = paramJson.addnewFlag; // true：新增 false：编辑	
							var itemno = paramJson.itemno || -1; // 批示id
							// var opdate = (new Date()).Format("yyyy-M-d h:m:s");
							var opdate = (new Date()).Format("yyyy-MM-dd");

							var param = {
								'url': INTERFACE.business.base['instruct'].save.url,
								'data': {
									'isH5': 'true',
									// 'addnewFlag': addnewFlag.toString(), // true：新增 false：编辑	
									'master.content': content, // 批示内容
									'master.itemno': itemno,
									'master.opdate': opdate, // 批示创建日期
									'master.modid': self.param.modId,
									'master.id': self.param.id,
									'master.opid': _g.getLS('opID'), // 批示创建人id
								}
							};

							// if (!addnewFlag) {
							// 	$.extend(param.data, {
							// 		'master.formid': self.items[index].formid,
							// 		'master.id': self.items[index].id,
							// 	});
							// }
							HTTP.ajax({
								url: param.url,
								data: param.data,
								success: function (ret) {
									if (addnewFlag) {
										// 新增
										ret.master['hideDelBtn'] = true;
										ret.master['opid'] = _g.getLS('opId');
										ret.master['opname'] = _g.getLS('opName');
										ret.master = self.dealPhoto(ret.master); //处理头像
										//处理批示内容
										self.dealTohtml(ret.master.content, function (str) {
											ret.master._content = str;
											self.items.push(ret.master); // 显示到批示列表
										});
									} else {
										// 编辑
										// 更新数据
										self.items[index].content = content;
										self.dealTohtml(content, function (str) {
											self.items[index]._content = str;
										});
										self.items[index].opdate = opdate;
									}
									api.sendEvent({
										name: 'commentSubmit',
										extra: {
											result: 'success',
											msg: '保存成功'
										}
									});
								},
								other: function (ret) {
									api.sendEvent({
										name: 'commentSubmit',
										extra: {
											result: 'failed',
											msg: ret.errMsg
										}
									});
								},
								error: function (err) {
									api.sendEvent({
										name: 'commentSubmit',
										extra: {
											result: 'failed',
											extra: {
												result: 'failed',
												msg: err.msg
											}
										}
									});
								}
							});
						},
						error: function (err) {
							alert('error');
						}
					});
				}
			}
		}
	}
	_C.prototype.constructor = _C;
	module.exports = new _C();
});