define(function(require, exports, module) {
	var TIME = require('time')
	var stime = TIME.getDates().sDate
	var etime = TIME.getDates().eDate
	function _interface() {
		this.base = { // 基础资料
			// 参数说明
			// {‘businessTrader’：客户（销售报价/机会中的）,'money': '币种','reportMoney': '币种', 'billTrader': '供应商', 'unit': '结算单位', 'project': '项目', 'goods': '货品', 'store': '仓库', 'goodsType': '货品类别', area': '地区', 'source': '客户来源', 'state': '客户状态, 'level': 客户等级', 'traderType': '往来类型', 
			// 'operator': '所有人', 'history': '移交历史', corpType': '行业类型', 'department': '跟踪部门', 'shipType': '运输方式, 'shop': 分支机构', 
			// 'noteType': '发票类型', 'payMethod': '结算方式', 'payAccount': '收款方式', subject': '预收款科目（/预付款科目）',‘clientPriKind’: ‘成员类型’, 'clientpriList': '成员', 'employ':'业务员', 'shareShop': '共享人组', logkind': '日志类型', 'sharer': '共享人',
			// 'contcat': '联系人', 'billType': '跟进业务类型', 'followOperator': '跟进人','bill': '跟进单据', CRkind: '跟进方式',
			// 'trader': '客户', 'workers': '员工', 'department': '部门','clientPriKind': '成员类型','member':'成员', 'billKind': '单据类型'}
			url: URLANNEX + '/lookupdm/lookupdata.action',
			'businessTrader': {
				title: '客户',
				param: {
					'filter': "CLOSED='F' and phoneapply='T'", 
					'viewname': 'client_ds' ,
					'likeValue': ''
				},
				showName: ['shortname']
			},
			'money': {
				title: '币种',
				param: {
					'filter': '1=1',
					'likeValue': '',
					'viewname': 'qryMoney'
				},
				showName: ['name']
			},
			'reportMoney': {
				title: '币种',
				param: {
					'iMoneyHeadType': '1',
					'filter': '1=1',
					'likeValue': '',
					'viewname': 'qryMoneyRpt'
				},
				showName: ['name']
			},
			'dsemploy': {
				title: '报价人',
				param: {
					'filter': '1=1',
					'viewname': 'dsemploy',
				},
				showName: ['name']
			},
			'qryChanceState': { // 阶段进程(销售机会列表过滤)
				title: '阶段',
				url: URLANNEX + '/crmlookupdm/crmlookupdata.action',
				param: {
					'filter': '1=1',
					'modId': 150,
					'viewName': 'qryChanceState',
				},
				showName: ['name']
			},
			'qrySalePriceStatus': { // 状态(销售报价列表过滤)
				title: '状态',
				url: URLANNEX + '/crmlookupdm/crmlookupdata.action',
				param: {
					'filter': '',
					'modId': 151,//2155,
					'viewName': 'qrySalePriceStatus'
				},
				showName: ['name']
			},
			'billTrader': {
				title: '供应商',
				param: {
					'filter': '',
					'likeValue': '',
					'viewname': 'trader_DS'
				}
			},
			'unit': {
				title: '结算单位',
				param: {
					'filter': '',
					'likeValue': '',
					'viewname': 'trader_DS'
				},
				showName: ['name']
			},
			'project': {
				title: '项目',
				param: {
					'filter': '',
					'likeValue': '',
					'viewname': 'Department_DS'
				}
			},
			'goods': {
				title: '货品',
				param: {
					'filter': '',
					'viewname': 'goods'
				},
				showName: ['name']
			},
			'store': {
				title: '仓库',
				param: {
					'filter': '',
					'viewname': 'Store_DS'
				},
				showName: ['name']
			},
			'goodsType': {
				title: '货品类别',
				url: URLANNEX + '/common/goodstype/goodstypeTree!queryChildrenComTree.action',
				param: {
					'node': 0
				},
				showName: ['text']
			},
			'area': {
				title: '地区',
				param: {
					'filter': '1=1',
					'likeValue': '',
					'viewname': 'qryArea'
				},
				showName: ['name'],
			},
			'source': {
				title: '客户来源',
				param: {
					'filter': '1=1',
					'likeValue': '',
					'viewname': 'qrySourceType'
				},
				showName: ['name']
			},
			'state': {
				title: '客户状态',
				param: {
					'filter': '1=1',
					'likeValue': '',
					'viewname': 'qryGuestStatus'
				},
				showName: ['name']
			},
			'level': {
				title: '客户等级',
				param: {
					'filter': '1=1',
					'likeValue': '',
					'viewname': 'qryTraderLev'
				},
				showName: ['name']
			},
			'traderType': {
				title: '往来类型',
				param: {
					'filter': '',
					'likeValue': '',
					'viewname': 'TraderType_DS'
				},
				showName: ['name']
			},
			'qryOperator': {
				title: '制单人',
				param: {
					'filter': '1=1',
					'likeValue': '',
					'viewname': 'qryOperator'
				},
				showName: ['name']
			},
			'operator': {
				title: '所有人',
				param: {
					'filter': 'isuse<>1',
					'likeValue': '',
					'viewname': 'Operator_DS'
				},
				showName: ['opname']
			},
			'history': {
				url: URLANNEX + '/ncrm/clienttransfer/clienttransferEdit!looktransferHistory.action',
				title: '移交历史',
				param: {
					isH5: 'true'
				},
				showName: ['name']
			},
			'corpType': {
				title: '行业类型',
				param: {
					'filter': '1=1',
					'likeValue': '',
					'viewname': 'qryCorpType'
				},
				showName: ['name']
			},
			'department': {
				title: '跟踪部门',
				param: {
					'filter': '1=1',
					'likeValue': '',
					'viewname': 'Shop_DS'
				}
			},
			'shipType': {
				title: '运输方式',
				param: {
					'filter': '1=1',
					'likeValue': '',
					'viewname': 'ShipType_DS'
				}
			},
			'shop': {
				title: '分支机构',
				param: {
					'filter': '',
					'likeValue': '',
					'viewname': 'Shop_DS'
				},
				showName: ['name']
			},
			'noteType': {
				title: '发票类型',
				param: {
					'filter': '1=1',
					'likeValue': '',
					'viewname': 'billtype_ds'
				}
			},
			'money': {
				title: '币种',
				param: {
					'filter': '1=1',
					'likeValue': '',
					'viewname': 'qryMoney'
				},
				showName: ['name']
			},
			'payMethod': {
				title: '结算方式',
				param: {
					'filter': '1=1',
					'likeValue': '',
					'viewname': 'qryPayMethod'
				}
			},
			'payType': {
				title: '收款账户',
				param: {
					'filter': '1=1',
					'likeValue': '',
					'viewname': 'paytype_ds'
				}
			},
			'payAccount': {
				title: '收款方式',
				param: {
					'filter': '1=1',
					'likeValue': '',
					'viewname': 'bank_ds'
				}
			},
			'subject': {
				title: '预收款科目',  //或预收款科目()
				param: {
					'filter': '1=1',
					'likeValue': '',
					'viewname': 'qrySubject'
				},
				showName:['code','name']
			},
			'clientPriKind': {
				title: '成员类型',  
				param: {
					'viewname': 'clientPriKind'
				}
			},
			'clientpriList': {
				title: '成员',  
				param: {
					'id': '' //成员类型id
				}
			},
			'shareShop': {
				title: '共享人组',
				url: URLANNEX + '/oa/archives/archivesEdit!doGetOpGroup.action',  
				param: {
					'query': ''
				}
			},
			'employ': {
				title: '业务员',
				param: {
					'filter': "IsOperate='T' and SIGN='T' and shopid =0",
					'likeValue': '',
					'viewname': 'employ_ds',
					'isCtrl':'true',
					'modId':1,
				},
				showName: ['name']  //要显示的字段
			},
			'qryEmploy': { //与employ的一致
				title: '业务员',
				param: {
					'filter': "Sign='T'",
					'likeValue': '',
					'viewName': 'qryEmploy'
				},
				showName: ['name']  //要显示的字段
			},
			'logkind': {
				title: '日志类型',
				param: {
					'filter': '1=1',
					'viewname': 'qrylogkind'
				},
				showName: ['name']
			},
			'sharer': {
				title: '共享人',
				param: {
					'filter': '',  //and m.shopid=0,,,其中0的位置为对应共享人组的id
					'viewname': 'qryOperator'
				}
			},
			'contcat': {
				title: '联系人',
				url: URLANNEX + '/crmlookupdm/crmlookupdata.action',
				param: {
					'filter': '',// clientid =41(41为对应客户id)
					'likeValue': '',
					'viewName': 'qryContact'
				},
				showName: ['name']
			},
			'qryCcontcat': {  //与contcat一致
				title: '联系人',
				url: URLANNEX + '/crmlookupdm/crmlookupdata.action',
				param: {
					'filter': '',// clientid =41(41为对应客户id)
					'likeValue': '',
					'modId': 150,
					'viewName': 'qryContact'
				},
				showName: ['name']
			},
			'billType': {
				title: '跟进业务类型',
				url: URLANNEX + '/crmlookupdm/crmlookupdata.action',
				param: {
					'viewName': 'qryBillType',
					'filter': 'billtypeid =3 or billtypeid=4 or billtypeid=5 or billtypeid =19 or billtypeid =20 or billtypeid =21 or billtypeid =31 or billtypeid=150 or billtypeid =151  or billtypeid =156'
				},
				showName: ['name']
			},
			'followOperator': {
				title: '跟进人',
				url: URLANNEX + '/crmlookupdm/crmlookupdata.action',
				param: {
					'modId': 155,
					'likeValue': '',
					'viewName': 'qryOperator'
				},
				showName: ['name']
			},
			'bill': {
				title: '跟进单据',
				url: URLANNEX + '/bill/selectbill/selectbillList!doGetSelectBillData.action',
				param: {
					'modId': 155,
					'isH5': 'true'
				}
			},
			'CRkind': {
				title: '跟进方式',
				url: URLANNEX + '/crmlookupdm/crmlookupdata.action',
				param: {
					'viewName': 'qryCRkind'
				},
				showName: ['name']
			},
			'trader': {
				title: '客户',
				url: URLANNEX + '/crmlookupdm/crmlookupdata.action',
				param: {
					'filter': '(isclient=1 or acctrader =1) and Closed=0 and TraderID>0',  // 
					'likeValue': '',
					'viewName': 'qryTrader'
				},
				showName: ['name']  //要显示的字段
			},
			'qryTrader': {  //销售机会中用到，其作用和trader的一样
				title: '客户',
				param: {
					'filter': 'closed=0',  // 过滤时，报表和供应商中的过滤，是为'1=1'
					'modId': 150,
					'likeValue': ''
				},
				showName: ['code', 'shortname']  //要显示的字段
			},
			'vendor':{	//报表模块
				title: '供应商',
				param: {
					'filter': '1=1',  // 
					'likeValue': '',
					'viewname': 'vendor_ds'
				},
				showName: ['shortname']  //要显示的字段
			},
			'workers': {
				title: '员工',
				url: URLANNEX + '/crmlookupdm/crmlookupdata.action',
				param: {
					'filter': '1=1',
					'modId': 2155,
					'likeValue': '',
					'viewName': 'qryEmploy'
				},
				showName: ['name']  //要显示的字段
			},
			'department': {
				title: '部门',
				param: {
					'viewname': 'qryDepartment'
				},
				showName: ['name']
			},
			'clientPriKind': {
				title: '成员类型',
				param: {
					'viewname': 'clientPriKind'
				},
				showName: ['name']
			},
			'member': {
				title: '成员',
				url: URLANNEX + '/ncrm/clientpri/clientpriList!doGetSelectPriData.action',
				param: {
					'kind': ''  //对应成员类型id
				},
				showName: ['name']
			},
			'billKind': {
				title: '单据类型',
				param: {
					'filter': '( id in(2,3,4,12,13,14,21,25,26,61,62,1,5,11,15,22,23,27,28,29,30,31,40,51,52,53,127,41,42,43,45) or id in(150,151))',
					'viewname': 'qryABillKind'
				}
			},
			'gcm': {
				title: '存货类型',
				param: {
					'filter': '1=1',
					'viewname': 'gcm_DS'
				},
				showName: ['name']
			},
			'costType': {
				title: '成本核算',
				param: {
					'filter': '1=1',
					'viewname': 'costingtype_DS'
				},
				showName: ['name']
			},
			'qryCycleType': { // 重复周期(日程安排循环与提醒)
				title: '重复周期',
				url: URLANNEX + '/crmlookupdm/crmlookupdata.action',
				param: {
					'filter': '1=1',
					'viewName': 'qryCycleKind'
				},
				showName: ['name']
			},
		}
		this.business = { // 业务模块
			'base': {
				'instruct': { // 批示
					list: { // 列表
						url: URLANNEX + '/ncrm/joblog/joblogList!doGetRemarkListData.action',
						param: {
							'clientid': '', // 客户id
							'id': '', // 所选的单据id
							'modId': '' // 对应的是各个单据的modId（销售机会：10101 售后工单：10110 销售合同：10104 销售报价：20201 销售收款：20203）
						}
					},
					save: { // 保存
						url: URLANNEX + '/ncrm/joblog/joblogEdit!saveApproval.action',
						param: {
							'addnewFlag': '', // true：新增 false：编辑	
							'master.content': '', // 批示内容
							'master.formid': '',
							'master.id': '',
							'master.itemno': '',
							'master.opdate': '', // 批示创建日期
							'master.opid': '', // 批示创建人id
							'master.opname': '', // 批示创建人
						}
					},
					del: { // 删除
						url: URLANNEX + '/ncrm/joblog/joblogEdit!deleteApproval.action',
						param: {
							'id': '', // 批示列表中 id
							'itemno': '', // 批示列表中 itemno
							'modId': '', // 批示列表中 formid
						}
					}
				},
				'check': { // 审批流程列表
					url: URLANNEX + '/bill/selectbill/selectbillList!doGetSelectBillData.action',
					param: {
						'billType': 10111
					}
				}
			},
			search: { // 5k搜索参数
				'iMoneyHeadType': '0',
				'filterItems[0].fieldType': 'ft_ListStr',
				'filterItems[0].id': '432',
				'filterItems[0].index': 'CG0001',
				'filterItems[0].name': '业务员',
				'filterItems[0].operatertitle': '包含',
				'filterItems[1].fieldType': 'ft_Str',
				'filterItems[1].id': '460',
				'filterItems[1].index': '',
				'filterItems[1].name': '单据编号',
				'filterItems[1].operatertitle': '包含',
				'filterItems[2].fieldType': 'ft_ListStr',
				'filterItems[2].id': '471',
				'filterItems[2].index': '1',
				'filterItems[2].name': '分支机构',
				'filterItems[2].operatertitle': '包含',
				'filterItems[3].fieldType': 'ft_ListStr',
				'filterItems[3].id': '476',
				'filterItems[3].index': 'null',
				'filterItems[3].name': '',
				'filterItems[3].operatertitle': '包含',
				'filterItems[4].fieldType': 'ft_ListStr',
				'filterItems[4].operatertitle': '包含',
				'filterItems[5].fieldType': 'ft_ListStr',
				'filterItems[5].id': '474',
				'filterItems[5].index': '1',
				'filterItems[5].name': '制单人',
				'filterItems[5].operatertitle': '包含',
				'filterItems[6].fieldType': 'ft_ListStr',
				'filterItems[6].id': '475',
				'filterItems[6].index': '1',
				'filterItems[6].name': '审核人',
				'filterItems[6].operatertitle': '包含',
				'filterisOR': 'true'
			},
			// 业务模块
			// 参数说明：
			// {'chance': '销售机会', 'price': '销售报价', 'contract': '销售合同', 'gather': '销售收款', 'order': '销售工单'}
			// {'list': '列表', 'add': '新增', 'edit': '编辑', 'param': '接口参数', 'url': '接口地址'}
			// 销售机会
			'chance': {
				list: {
					param: {
						'condition_txf': {},
						'filterItemRelation': '',
						'isH5': true,
						'pageSize': '',
						'searchKey': '',
						'start': 0
					},
					url: URLANNEX + '/ncrm/chance/chanceList!doGetListData.action',
				},
				add: {
					url: URLANNEX + '/ncrm/chance/chanceEdit!doGetAddnewData.action',
				},
				edit: {
					url: URLANNEX + '/ncrm/chance/chanceEdit!doGetEditData.action',
				},
				del: {
					url: URLANNEX + '/ncrm/chance/chanceEdit!Delete.action',
				},
				save: {
					url: URLANNEX + '/ncrm/chance/chanceEdit!save.action',
				},
				approval: {
					url: URLANNEX + '/bill/bchance/bchanceEdit!approvalSave',
				}
			},
			'price': { // 销售报价
				list: {
					param: {
						'condition_txf': {},
						'filterItemRelation': '',
						'isH5': true,
						'pageSize': '',
						'searchKey': '',
						'start': 0
					},
					url: URLANNEX + '/ncrm/ssaleprice/ssalepriceList!doGetListData.action',
				},
				add: {
					url: URLANNEX + '/ncrm/ssaleprice/ssalepriceEdit!doGetAddnewData.action',
				},
				edit: {
					url: URLANNEX + '/ncrm/ssaleprice/ssalepriceEdit!doGetEditData.action',
				},
				del: {
					url: URLANNEX + '/ncrm/ssaleprice/ssalepriceEdit!Delete.action',
				},
				save: {
					url: URLANNEX + '/ncrm/ssaleprice/ssalepriceEdit!save.action',
				},
				approval: {
					url: URLANNEX + '/bill/ssaleprice/bssalepriceEdit!approvalSave',
				}
			},
			'contract': { // 销售合同
				list: {
					param: {
						'condition_txf': {},
						'filterItemRelation': '',
						'isH5': true,
						'pageSize': '',
						'searchKey': '',
						'start': 0
					},
					url: URLANNEX + '/bill/bargain/bbargainList!doGetListData.action',
				},
				add: {
					url: URLANNEX + '/bill/bargain/bbargainEdit!doGetAddnewData.action',
				},
				edit: {
					url: URLANNEX + '/bill/bargain/bbargainEdit!doGetEditData.action',
				},
				del: {
					url: URLANNEX + '/bill/bargain/bbargainEdit!Delete.action',
				},
				save: {
					url: URLANNEX + '/bill/bargain/bbargainEdit!save.action',
				},
				approval: {
					url: URLANNEX + '/bill/bargain/bbargainEdit!approvalSave',
				}
			},
			'gather': { // 销售收款
				list: {
					param: {
						'condition_txf': {},
						'filterItemRelation': '',
						'isH5': true,
						'pageSize': '',
						'searchKey': '',
						'start': 0
					},
					url: URLANNEX + '/bill/scharge/bschargeList!doGetListData.action',
				},
				add: {
					url: URLANNEX + '/bill/scharge/bschargeEdit!doGetAddnewData.action',
				},
				edit: {
					url: URLANNEX + '/bill/scharge/bschargeEdit!doGetEditData.action',
				},
				del: {
					url: URLANNEX + '/bill/scharge/bschargeEdit!Delete.action',
				},
				save: {
					url: URLANNEX + '/bill/scharge/bschargeEdit!save.action',
				},
				approval: {
					url: URLANNEX + '/bill/scharge/bschargeEdit!approvalSave',
				}
			},
			'order': { // 销售工单
				list: {
					param: {
						'condition_txf': {},
						'filterItemRelation': '',
						'isH5': true,
						'pageSize': '',
						'searchKey': '',
						'start': 0
					},
					url: URLANNEX + '/bill/saleservice/bsaleserviceList!doGetListData.action',
				},
				add: {
					url: URLANNEX + '/bill/saleservice/bsaleserviceEdit!doGetAddnewData.action',
				},
				edit: {
					url: URLANNEX + '/bill/saleservice/bsaleserviceEdit!doGetEditData.action',
				},
				del: {
					url: URLANNEX + '/bill/saleservice/bsaleserviceEdit!Delete.action',
				},
				save: {
					url: URLANNEX + '/bill/saleservice/bsaleserviceEdit!save.action',
				},
				approval: {
					url: URLANNEX + '/bill/saleservice/bsaleserviceEdit!approvalSave',
				}
			},
			'sorder': { // 销售订单
				list: {
					url: URLANNEX + '/sa/saorder/sorderList!doGetListData.action',
					param: {
						search: {
							'filterItems[4].id': '473',
							'filterItems[4].index': 'K001',
							'filterItems[4].name': '客户'
						}
					}
				},
				add: {
					url: URLANNEX + '/sa/saorder/sorderEdit!doGetAddnewData.action'
				},
				edit: {
					url: URLANNEX + '/sa/saorder/sorderEdit!doGetEditData.action'
				},
				del: {
					url: URLANNEX + '/sa/saorder/sorderEdit!Delete.action'
				},
				save: {
					url: URLANNEX + '/sa/saorder/sorderEdit!save.action'
				}
			},
			'sbilling': { // 销售开单
				list: {
					url: URLANNEX + '/sa/sale/saleList!doGetListData.action',
					param: {
						search: {
							'filterItems[4].id': '473',
							'filterItems[4].index': 'K0022',
							'filterItems[4].name': '供应商'
						}
					}
				},
				add: {
					url: URLANNEX + '/sa/sale/saleEdit!doGetAddnewData.action'
				},
				edit: {
					url: URLANNEX + '/sa/sale/saleEdit!doGetEditData.action'
				},
				del: {
					url: URLANNEX + '/sa/sale/saleEdit!Delete.action'
				},
				save: {
					url: URLANNEX + '/sa/sale/saleEdit!save.action'
				}
			},
			'porder': { // 采购订单
				list: {
					url: URLANNEX + '/pa/paorder/porderList!doGetListData.action',
					param: {
						search: {
							'filterItems[4].id': '477',
							'filterItems[4].index': 'K001',
							'filterItems[4].name': '客户'
						}
					}
				},
				add: {
					url: URLANNEX + '/pa/paorder/porderEdit!doGetAddnewData.action'
				},
				edit: {
					url: URLANNEX + '/pa/paorder/porderEdit!doGetEditData.action'
				},
				del: {
					url: URLANNEX + '/pa/paorder/porderEdit!Delete.action'
				},
				save: {
					url: URLANNEX + '/pa/paorder/porderEdit!save.action'
				}
			},
			'pbilling': { // 采购开单
				list: {
					url: URLANNEX + '/pa/papurchase/ppurchaseList!doGetListData.action',
					param: {
						search: {
							'filterItems[4].id': '477',
							'filterItems[4].index': 'K0022',
							'filterItems[4].name': '供应商'
						}
					}
				},
				add: {
					url: URLANNEX + '/pa/papurchase/ppurchaseEdit!doGetAddnewData.action'
				},
				edit: {
					url: URLANNEX + '/pa/papurchase/ppurchaseEdit!doGetEditData.action'
				},
				del: {
					url: URLANNEX + '/pa/papurchase/ppurchaseEdit!Delete.action'
				},
				save: {
					url: URLANNEX + '/pa/papurchase/ppurchaseEdit!save.action'
				}
			},
			'sale-return': { //销售退货
				list: {
					url: URLANNEX + '/sa/sreturn/sreturnList!doGetListData.action'
				}
			},
			'pur-return': { //采购退货
				list: {
					url: URLANNEX + '/pe/preturn/preturnList!doGetListData.action'
				}
			},
			'pur-gain': { //采购收货
				list: {
					url: URLANNEX + '/pe/recieve/recieveList!doGetListData.action'
				}
			},
			'sale-del': { //销售发货
				list: {
					url: URLANNEX + '/sa/invoice/invoiceList!doGetListData.action'
				}
			},
			'cash-sale': { //现款销售
				list: {
					url: URLANNEX + '/sa/cashsale/cashsaleList!doGetListData.action'
				}
			},
			'cash-pur': { //现款采购
				list: {
					url: URLANNEX + '/pe/cashrecieve/cashrecieveList!doGetListData.action'
				}
			},
			'pur-order': { //采购订单
				list: {
					url: URLANNEX + '/pe/peorder/porderList!doGetListData.action'
				}
			},
			'sale-order': { //销售订单
				list: {
					url: URLANNEX + '/sa/saorder/sorderList!doGetListData.action'
				}
			}
		},
		this.client = { //客户模块
			//{'clients':客户,'near':客户定位,'linker':联系人,'follow':客户跟进,'base':基础信息,'relation':公关关系}
			clients: {
				//客户
				'list': {
					url: URLANNEX + '/common/client/clientList!doGetListData.action',
					param: {
						beginDate: stime,
						endDate: etime,
						pageSize: "",
						start: 0,
						isH5:"true",
						iMoneyHeadType:"0",
						modId:"2402"
					}
				},
				'detail': {
					url: URLANNEX + '/common/client/clientEdit!doGetEditData.action',
					param: {
						id: '',
						isH5:"true",
						modId:"2402"
					}
				},
				'add': {
					url: URLANNEX + '/common/client/clientEdit!doGetAddnewData.action',
					param: {
						modId: "2402"
					}
				},
				'delete': {
					url: URLANNEX + '/common/client/clientEdit!delete.action',
					param: {
					}
				},
				'save': {
					url: URLANNEX + '/common/client/clientEdit!save.action',
					param: {
					}
				}
			},
			near: { // 客户定位
				url: URLANNEX + '/common/client/clientList!doGetListData.action',
				param: {
					address: '',
					pageSize: '',
					start: '',
					modId:2402,
					isH5:'true'
				}
			},
			linker: { //联系人
				'list': {
					url: URLANNEX + '/ncrm/contact/contactList!doGetListData.action',
					param: {
						searchKey: '',
						pageSize: '',
						start: 0,
						isMobile: 'true',
						isH5:'true',
						modId:5033
					}
				},
				'add': {
					url: URLANNEX + '/ncrm/contact/contactEdit!doGetAddnewData.action',
					param: {}
				},
				'edit': {
					url: URLANNEX + '/ncrm/contact/contactEdit!doGetEditData.action',
					param: {
						id: '',
						isH5:'true',
					}
				},
				'delete': {
					url: URLANNEX + '/ncrm/contact/contactEdit!delete.action',
					param: {
						checkStep: 0,
						id: '',
						isH5:'true',
						modId:5033
					}
				},
				'save': {
					url: URLANNEX + '/ncrm/contact/contactEdit!save.action',
					param: {
						addnewFlag: '',
						filterSQL: '',
						id: '',
						start: ''
					}
				},
				'uploadPic': {
					url: URLANNEX + '/basedata/picture/pictureEdit!upPicture.action',
					param: {
						id: '',
						imgFile: '',
						isMobile: 'true',
						modId: 5033
					}
				}
			},
			follow: { // 跟进
				'list': {
					url: URLANNEX + '/ncrm/contactrecord/contactrecordList!doGetListData.action',
					param: {
						isH5: 'true',
						pageSize: '',
						start: 0,
						beginDate: '',
						endDate: ''
					}
				},
				'add': {
					url: URLANNEX + '/ncrm/contactrecord/contactrecordEdit!doGetAddnewData.action',
					param: {

					}
				},
				'edit': {
					url: URLANNEX + '/ncrm/contactrecord/contactrecordEdit!doGetEditData.action',
					param: {
						id: ''
					}
				},
				'save': {
					url: URLANNEX + '/ncrm/contactrecord/contactrecordEdit!save.action',
					param: {
						addnewFlag: '',
						filterSQL: ''
					}
				},
				'delete': {
					url: URLANNEX + '/ncrm/contactrecord/contactrecordEdit!Delete.action',
					param: {
						checkStep: 0,
						id: ''
					}
				}
			},
//			relation: { // 公关关系
//				'add': {
//					url: URLANNEX + '/bill/relation/lrelationEdit!doGetAddnewData.action',
//					param: {
//
//					}
//				},
//				'save': {
//					url: URLANNEX + '/bill/relation/lrelationEdit!save.action',
//					param: {
//						addnewFlag: '', //true：新增保存 false：编辑保存
//						filterSQL: '',
//						start: 0
//					}
//				},
//				'delete': {
//					url: URLANNEX + '/bill/selectbill/selectbillList!deleteBill.action',
//					param: {
//						id: '', //对应改联系人id
//						modId: 10009
//					}
//				}
//			}
		}
		this.report = { // 报表模块
			//参数说明：
			url: URLANNEX + '/ncrm/crmreport/crmreport!doGetReportData.action',
			hot: { // 客户跟进热度分析(crm)
				param: {
					modId: 56723, //61302,
					isH5: 'true',
					startdate: stime,
					enddate: etime
				}
			},
			funnel: { // 销售漏斗(crm)
				param: {
					amount:{  // 按数量
						modId: 56720, //61304,
						isH5: 'true',
						startdate: stime,
						enddate: etime
					},
					sum:{  // 按金额
						modId: 56721, //61303,
						isH5: 'true',
						startdate: stime,
						enddate: etime
					}
				}
			},
			price: { // 销售报价分析(crm)
				param: {
					modId: 56722,
					isH5: 'true',
					startdate: stime,
					enddate: etime
				}
			},
			salesExecution: { // 销售订单执行情况表(new)
				param: {
					modId: 56725,
					isH5: 'true',
					startdate: stime,
					enddate: etime
				}
			},
			orderExecution: { // 采购订单执行情况表(new)
				param: {
					modId: 56724,
					isH5: 'true',
					startdate: stime,
					enddate: etime
				}
			},
			getCredit: { // 应收账款对账单(3/5k)
				param: {
					modId: 56322, //232,
					isH5: 'true',
					startdate: stime,
					enddate: etime
				}
			},
			postCredit: { // 应付账款对账单(3/5k)
				param: {
					modId: 56323, //233,
					isH5: 'true',
					startdate: stime,
					enddate: etime
				}
			},
			productAmount: { // 货品账面数量汇总表(new)
				param: {
					modId: 80518, //147,
					isH5: 'true',
					startdate: stime,
					enddate: etime
				}
			},
			salesStatistics: { // 销售业绩统计表(new)
				param: {
					modId: 80413, //125,
					isH5: 'true',
					startdate: stime,
					enddate: etime
				}
			},
			clientFlow: { // 客户流水(new);
				param: {
					modId: 2529, //165,
					isH5: 'true',
					startdate: stime,
					enddate: etime
				}
			},
			cashBank: { // 现金银行汇总表(new)
				url: URLANNEX + '/report/mastbankrpt!doGetReportData.action',
				param: {
					beginDate: stime,
					endDate: etime,
					storeid: 0,
					isNotAmount: 0,
					isNotPrice: 0
				}
			},
			curStock: { // 当前库存(new)
				url: URLANNEX + '/report/mastpartstorerptform!doGetReportData.action',
				param: {
					// beginDate: stime,
					// endDate: etime,
					filterItemRelation: '',
					storeid: 0,
					shopid: 0,
					iAllot: -5,
					isNotAmount: 0,
					isNotPrice: 0
				}
			},
			saleCharts: { // 销售排行榜(new)
				urlByClient: URLANNEX + '/report/mastsalebyclientrptform!doGetReportData.action',
				urlByEmploy: URLANNEX + '/report/mastsalebyemployrptform!doGetReportData.action',
				urlByPro: URLANNEX + '/report/mastsalebygoodsrptform!doGetReportData.action',
				param: {
					beginDate: stime,
					endDate: etime,
					storeid: 0,
					isNotAmount: 0,
					isNotPrice: 0
				}
			},
			saleProfit: { // 销售毛利(new)
				urlByClient: URLANNEX + '/report/simpleprofitbyclientrptform!doGetReportData.action',
				urlByPro: URLANNEX + '/report/simpleprofitbygoodsrptform!doGetReportData.action',
				urlByEmploy: URLANNEX + '/report/simpleprofitbyoperaterptform!doGetReportData.action',
				param: {
					beginDate: stime,
					endDate: etime,
					storeid: 0,
					isNotAmount: 0,
					isNotPrice: 0,
					Unit: 0,
					iAllot: 0
				}
			}
		}
		this.index = { //工作日志
			daily: {
				add: {
					url: URLANNEX + '/ncrm/joblog/joblogEdit!doGetAddnewData.action',
					param: {}
				},
				list: {
					url: URLANNEX + '/ncrm/joblog/joblogList!doGetListData.action',
					param: {}
				},
				del: {
					url: URLANNEX + '/ncrm/joblog/joblogEdit!Delete.action',
					param: {}
				},
				save: {
					url: URLANNEX + '/ncrm/joblog/joblogEdit!save.action',
					param: {}
				},
				detail: {
					url: URLANNEX + '/ncrm/joblog/joblogEdit!doGetEditData.action',
					param: {}
				},
			},
			sharer: { // 选择共享人
				title: '共享人',
				url: URLANNEX + '/oa/archives/archivesEdit!doGetOpList.action',
				param: {
					'modeid': 160,//160,
					'isH5': 'true'
				}
			},
//			check: { // 审批中心
//				getList: {
//					url: URLANNEX + '/batchcheck/batchcheckList!doGetListData.action',
//					param: {
//						"pageSize":"20",
//		        "start":"0",
//		        "modId":"2081",
//		        "sdate":stime,
//		        "beginDate":stime,
//		        "endDate":etime,
//		        "edate":etime,
//		        "billstate":"", // 单据状态
//		        "billtype":"", // 单据类型
//		        "iMoneyHeadType":"0",
//		        "limit":"20",
//		        "ipurpose":"0"
//		        // "billcode":"", // 关键字
//		        // "traderid":"", // 关键字
//		        // "opid":"", // 关键字
//		        // "filterisOR":"true"
//					}
//				},
//				checkOperation: {  //审核操作
//					url: URLANNEX + '/batchcheck/batchcheckList!CheckBill.action',
//					param: {
//
//					}
//				}
//			},
			outwork: { // 外勤
				'add': {
					url: URLANNEX + '/ncrm/attence/attenceEdit!doGetAddnewData.action',
					param: {
						modId: 5036,
						isH5: 'true'
					}
				},
				'save': {
					url: URLANNEX + '/ncrm/attence/attenceEdit!save.action',
					param: {
						modId: 5036,
						isH5: 'true'
					}
				},
				'list': {
					url: URLANNEX + '/ncrm/crmattence/crmattenceList!doGetListData.action',
					param: {
						isH5: 'true',
						modId: 5037
					}
				},
				'detail': {
					url: URLANNEX + '/ncrm/attence/attenceEdit!doGetEditData.action',
					param: {
						isH5: 'true',
						modId: 5036
					}
				}			
			},
			schedule: {
				'add': {
					url: URLANNEX + '/ncrm/event/eventEdit!doGetAddnewData.action'
				},
				'edit': {
					url: URLANNEX + '/ncrm/event/eventEdit!doGetEditData.action'
				},
				'list': {
					url: URLANNEX + '/ncrm/event/eventList!doGetListData.action'
				},
				'delete': {
					url: URLANNEX + '/ncrm/event/eventEdit!delete.action'
				},
				'save': {
					url: URLANNEX + '/ncrm/event/eventEdit!save.action'
				}
			}
		}
		this.annex = { //附件
			'list': { // 查找附件列表
				url: URLANNEX + '/sys/file/sysFileUpload!doGetListData.action',
			},
			'upload': { // 附件上传
				url: URLANNEX + '/sys/file/sysFileUpload!uploadFile.action',
			},
			'del': { // 删除附件
				url: URLANNEX + '/sys/file/sysFileUpload!deleteFile.action',
			},
			'download': { // 下载附件
				url: URLANNEX + '/sys/file/sysFileUpload!openFile.action',
			},
			'editName': { // 修改附件名称
				url: URLANNEX + '/sys/file/sysFileUpload!editFileName.action',
			}
		}
		this.filter = { // 报表模块高级筛选的参数
			'distribution': { // 客户分布
				'fieldname': ['ct.lccode', 'm.sourceid', 'm.industryid', 'm.state',
					'm.vip', 'm.pclientid', 'm.activityid'
				],
				'fieldtype': [7, 5, 5, 5, 5, 5, 5],
				'realvaluename': ['lccode', 'id', 'id', 'id', 'id', 'id', 'id']
			},
			'hot': { // 热度分析
				'fieldname': ['m.clientid'],
				'fieldtype': [4],
				'realvaluename': ['id']
			},
			'funnel': {
				'name': ['机会阶段'],
				'fieldenname': ['status'],
				'fieldtype': [5],
				'realvaluename': ['id']
			},
			'bill': {
				'fieldname': ['m.clientid'],
				'fieldtype': [4],
				'realvaluename': ['id']
			},
			'execute': {
				'fieldname': ['m.billstatus', 'm.clientid', 'c.code', 'm.signdate'],
				'fieldtype': [11, 4, 2, 1],
				'realvaluename': ['id', 'name', 'name', '']
			},
			'price': {
				'fieldname': ['d.goodsid'],
				'fieldtype': [5],
				'realvaluename': ['id']
			}
		}
	}

	_interface.prototype = {}

	_interface.prototype.constructor = _interface;
	module.exports = new _interface();
});
