define(function(require, exports, module) {
	/**
	 * [bMap 百度地图]
	 */
	var bMap = api.require('bMap');

	function Maps() {}

	Maps.prototype = {
    open: function(opts){
      var self = this
      bMap.open({
        rect:{
          x: 0,
            y: opts.y,
            w: opts.wid,
            h: opts.height
        },
          center: {
            lon:opts.lon,
            lat:opts.lat
          },
          zoomLevel: 10,
          showUserLocation: true,
          fixedOn: api.frameName,
          fixed: true
      }, function(ret, err) {
          if (ret.status) {
            opts.success && opts.success(ret)
          } else {
            opts.error && opts.error(err)
          }
      });
    },
		getAddress: function(opts) { // 由经纬度获取对应的地址
			var self = this
			bMap.getNameFromCoords({
				lon: opts.lon,
				lat: opts.lat,
			}, function(ret, err) {
				if (ret.status) {
					opts.success && opts.success(ret);
				} else {
					opts.error && opts.error(err);
				}
			});
		},
		getLocation: function(opts) { //获取当前的经纬度，并且获得当前地址
			var self = this;
			bMap.getLocation({
				accuracy: opts.accuracy || '100m',
				autoStop: opts.autoStop || true,
				filter: opts.filter || 1
			}, function(ret, err) {
				if (ret.status) {
					self.stopLocation()
					opts.success && opts.success(ret);
					// self.getAddress({ lon: ret.lon, lat: ret.lat }, nextStep);
				} else {
					api.hideProgress();
					opts.error && opts.error(err);
					_g.toastMsg({msg: '请检查该应用的定位权限'});
				}
			});
		},
		stopLocation: function() { // 停止定位
			bMap.stopLocation();
		},
		getCoordsFromName: function(opts) { // 根据地区地址获取相应的经纬度
			var self = this;
			if (!opts.address) { // address不能传空值
				return;
			}
			bMap.getCoordsFromName({
				city: opts.city || '',
				address: opts.address
			}, function(ret, err) {
				if (ret.status) {
					opts.success && opts.success(ret);
				} else {
					opts.error && opts.error(err);
				}
			});
		},
		getDistance: function(opts) { // 获取坐标点之间的距离
			bMap.getDistance(opts.params, function(ret) {
				if (ret.status) {
					opts.success && opts.success(ret);
				} else {
					opts.error && opts.error(ret);
				}
			});
		}
	}

	Maps.prototype.constructor = Maps;
	module.exports = new Maps();
});
