define(function(require,exports,module){
	function _report(){
		//接口地址
		this.url_suffix= $api.getStorage('sdIP');
	}
	_report.prototype={
		/*
		 * 报表页面添加过滤条件
		 * name frame层名字
		 * type frame层类型，0为FrameGroup，1为frame
		 * frames FrameGroup页面组
		 */
		setfilter:function(name,type,frames) {
			var str="";
			var f_name = $api.getStorage('filterName');
			var clear = 0;
			$('.filtEle').remove();
			$('#filtArea').append('<div class="filtEle">'+f_name.sDate+'~'+f_name.eDate+'</div>');
			if (f_name.filter.length != 0) {
				for (var i = 0; i < f_name.filter.length; i++) {
					str += '<div class="filtEle">'+ f_name.filter[i] +'</div>'
				};
				$('#filtArea').append(str);
				$('#filtArea').show();
			}
			//头部兼容及获取头部位置与宽高
			var headerH = _basic.getHeader('header').h;
			headerH = headerH + $api.offset($api.dom('.bg')).h + 5;
			$api.setStorage('headerH', headerH);
			if (type == 1) {
				_basic.openFrame(name,headerH,false,'');
			} else {
				//重新获取FrameGroup页面组的数据
				api.closeFrameGroup({
					name: name
				});
				_basic.openFrameGroup(name,headerH,false,false,frames);
				//获取报表页面类型
				var type = $api.getStorage('type');
				//设置当前显示页面
				api.sendEvent({
					name:'current_'+type,
				});
			}
		},
		/*
		 * 报表页面数据获取拼接函数
		 * modId 页面获取数据id
		 * html 获取数据html拼接代码函数
		 * type 报表页面类型，list: 单据页面；collect：财务汇总; product: 货品库存
		 * url 接口地址
		 */
		addData: function(modId, html, type, url){
			_basic.showLoading();
			//获取缓存筛选条件
			var filter = $api.getStorage('filter');
			var backcall = function(ret){
				if((ret.errNo == 0) || ((ret.errNo == '-1') && (ret.errMsg == null))){
					var data = ret.resultData.ReportData;
					var tip;
					//定义货币符号
					var moneyC = '￥';
					//判断是否有过滤条件缓存
					if (typeof(filter) == 'undefined') {
						tip = '最近一个月内无数据';
					} else {
						tip = '暂无数据';
					}
					var arg = {
						'data': data,
						'moneyC': moneyC,
						'tip': tip
					}
					html(arg);
				} else {
					api.hideProgress();
					if (ret.errMsg != null){
						_basic.closeToLogin(ret.errMsg);
					}
				}
			};
			var err = function(ret){
				api.hideProgress();
				//报错提示
				_basic.toastMsg('err:'+ret.msg);
			};
			var sDate,eDate;
			//参数
			var postData={
			  'modId': modId,
			  'Unit': '0',
			  'iAllot': '12',
			  'isNotAmount': '0',
			  'isNotPrice': '0',
			  'filterItemRelation': '全部并且',
			  'storeid': 0
			};
			postData['shopid']= $api.getStorage('shopID');
			if (type == 'product') {
				postData['Unit']= 1;
				postData['storeid']= 0;
			}
			//判断是否有过滤条件缓存
			if (typeof(filter) == 'undefined') {
				var dataArg = _basic.getDates();
				sDate = _basic.changeData(dataArg.sDate);
				eDate = _basic.changeData(dataArg.eDate);
			} else {
				sDate = filter.sDate;
				eDate = filter.eDate;
				var select = filter.select;
				//添加过滤输入参数
				for (var i = 0; i < select.length; i++) {
					if(select[i]._dom=='stock'){
						postData['storeid']=select[i].val;
					}else{
						postData['filterItems['+i+'].fieldtype'] = 'ft_ListStr';
						postData['filterItems['+i+'].fieldid'] = select[i]._id;
						postData['filterItems['+i+'].operate'] = select[i]._operate;
						postData['filterItems['+i+'].displayvalue'] = select[i].val;
						postData['filterItems['+i+'].realvalue'] = select[i].index;
						postData['filterItems['+i+'].itemno'] = 0;
						postData['filterItems['+i+'].fieldlabel'] = select[i].label;
					}
				};
			}
			postData['beginDate'] = sDate;
			postData['endDate'] = eDate;
			var Ajax_data= {
				url: 'http://'+ this.url_suffix + url,
				method: 'post',
				datatype: 'json',
				data: postData
			};
			_basic.Ajax(Ajax_data,backcall,err);
		},
		/*
		 * 加载过滤条件的数据
		 * pageType 过滤页面类型，bill单据页面；credit财务汇总；product库存汇总
		 * dom 该过滤条件select的id
		 * type 该过滤条件viewname值（每个过滤条件值固定）
		 * num 0表示获取仓库数据, 1表示获取货品名称数据，2表示获取供应商/客户数据,
		 * 		3表示获取货品类型/往来类型数据
		 * likeVal 搜索值
		 */
		selectPages:function(pageType,dom,type,num,likeVal) {
			alert(6767)
			var back = function(ret){
				if (ret.errNo) {
					_basic.closeToLogin(ret.errMsg);
					api.hideProgress();
				} else {
					var list = ret.listData;
					var str = '';
					if (list.length == 0) {
						str += '<div class="none-icon">'+
							'<img src="../../image/none.png">'+
							'<div class="tx-gray">暂无数据</div>'+
						'</div>'
					} else {
						var dataVal, dataName, dataCode;
						//判断是否获取仓库数据，加载不同的数据
						for (var i = 0; i < list.length; i++) {
							if (num == 0) {
								dataVal = list[i].storeid;
								dataName = list[i].name;
								dataCode = '';
							} else if (num == 1) {
								dataVal = list[i].name;
								dataName = list[i].name;
								dataCode = list[i].code;
							} else if (num == 2){
								dataVal = list[i].shortname;
								dataName = list[i].shortname;
								dataCode = list[i].code;
							}
							if (num == 3) {
								str += '<div class="listItem ub ub-ac h-65 marl-10 marr-10 line-b">'+
									'<div class="li-tips" data-name="'+ list[i].lcode +'" data-text="'+ list[i].name +'" data-value="'+ list[i].name +'"></div>'+
									'<div class="ub ub-ac ub-f1 marl-10">'+
										'<div class="tx-gra marr-10">'+ list[i].lcode +'</div>'+
										'<div class="ub-f1 tx-bla">'+ list[i].name +'</div>'+
									'</div>'+
								'</div>'
							} else {
								str += '<div class="listItem ub ub-ac h-65 marl-10 marr-10 line-b">'+
									'<div class="li-tips" data-name="'+ dataName +'" data-text="'+ dataName +'" data-value="'+ dataVal +'"></div>'+
									'<div class="ub ub-ac ub-f1 marl-10">'+
										'<div class="tx-gra marr-10">'+ dataCode +'</div>'+
										'<div class="ub-f1 tx-bla">'+ dataName +'</div>'+
									'</div>'+
								'</div>'
							}
						}
					}
					$('.listItem').remove();
					$('.none-icon').remove();
					$api.append($api.byId(dom), str);
					//元素选择事件
					$('.listItem').on('click',function(){
						if($(this).hasClass('active')){
							$(this).removeClass('active');
						}else{
							$('.listItem').removeClass('active');
							$(this).addClass('active');
						}
					});
					api.hideProgress();
				}
			};
			var err = function(ret){
				api.hideProgress();
				_basic.toastMsg(ret.msg);
			};
			//加载数据
			var Ajax_data={};
			Ajax_data['url']='http://'+this.url_suffix+'/lookupdm/lookupdata.action';
			//请求方式
			Ajax_data['method']='post';
			//返回的格式
			Ajax_data['datatype']='json';
			//参数
			if(type=='store_ds'){
				type='store1_ds';
				Ajax_data['url']='http://'+this.url_suffix+'/lookupdm/replookupdata.action';
			}
			Ajax_data['data']={
			  'viewname': type,
			  'likeValue':likeVal,
			  'pageSize': 100000,
			  'start': 0,
			};
			console.log(JSON.stringify(Ajax_data))
			if (num == 1) {
				if (pageType == 'product') {
					Ajax_data['data']['filter']="1=1 and  g.phoneapply='T' and kind=3";
				} else {
					Ajax_data['data']['filter']="1=1 and  g.phoneapply='T'";
				}
			} else if(num == 2){
				if (pageType == 'credit') {
					if (type == 'client_ds') {
						Ajax_data['data']['filter']="1=1 and (isdouble='F' or clientkind=1)";
					} else {
						Ajax_data['data']['filter']="1=1 and (isdouble='F' or clientkind=2)";
					}
				} else {
					Ajax_data['data']['filter']="1=1";
				}
			} else if (num == 3) {
				Ajax_data['data']['filter']="1=1";
			}
			_basic.Ajax(Ajax_data,back,err);
		},
		/*
		 * 获取筛选条件
		 * arg 筛选条件select 节点
		 * 返回值result 数组包含过滤条件值value、显示名称text
		 */
		values:function(arg){
			var result= [];
			var sel = [];
			var text = [];
			var val = [];
			var v,t,index,dom;
			var arry,filter;
			for (var i = 0; i < arg.length; i++) {
				dom = document.getElementById(arg[i]);
				v = dom.getAttribute('data-value');
				t = dom.value;
				index = dom.getAttribute('data-name');
				if (t != '') {
					if ((dom == 'stock')&&(t == '全部')) {
						return;
					}
					arry = {_operate:$('#'+arg[i]).attr('data-operate'),_id: $('#'+arg[i]).attr('data-id'), val: v, index: index, _text: t,_dom:arg[i]};
					sel.push(arry);
					text.push(t);
				}
			};
			result.push(sel);
			result.push(text);
			return result;
		},
		/*
		 *设置过滤条件默认值
		 */
		setDefault: function(){
			var f_data = $api.getStorage('filter');
			if (typeof(f_data) != 'undefined') {
				for (var i = 0; i < f_data.select.length; i++) {
					$('#'+f_data.select[i]._dom).val(f_data.select[i]._text);
					$('#'+f_data.select[i]._dom).attr('data-value', f_data.select[i].val);
					$('#'+f_data.select[i]._dom).attr('data-name', f_data.select[i].index);
				};
			}
		}
	}
		_report.prototype.constructor=_report;
		module.exports=new _report();
})