define(function(require, exports, module) {
	var mobShare = api.require('mobShare');
	var clipBoard = api.require('clipBoard');
	var share = api.require('sharePics');
	
		/**
	 *  接收参数
	 * textJson 对象(JSON) 分享的文本
	 * type     分享类型       朋友圈 还是 好友 之后可能还有qq
	 * imgArr   分享的图片数组    没图片可以不传或是传空数组 []
	 */
	
	function Wx() {}

	var downloadTask = function(imgs, callback) {
		var imgArr = [];
		var count = 0;
		for (var index in imgs) {
			(function(img){
				api.download({
					url: img,
					report: true,
					cache: true,
					allowResume: true
				}, function(ret, err) {
					if (ret.state == 1) {
						console.log('download success');
						imgArr.push(ret.savePath);
						count++;
						console.log('count number: ' + count);
						if (count == imgs.length) {
							console.log('save paths: ' + JSON.stringify(imgArr));
							callback && callback(imgArr);
						}
					} 
				});
			})(imgs[index]);
		}
	}

	Wx.prototype = {
		shareTo: function(opts) {
			var shareData = '';
			_.each(opts.textJson, function(val, key) {
				if (key === ' ') {
					shareData = shareData +'\n'
				} else {
					shareData = shareData + key + ':' + val + '\r\n'
				}
			});
			if (api.systemType == 'android') {
				if (!opts.imgArr || opts.imgArr.length == 0) { // 没有图片
					console.log('无图');
					mobShare.shareTo({
						target: opts.type,
						title: 'title',
						text: shareData
					}, function(ret, err) {
						if (ret) {
							opts.success && opts.success(ret);
						} else {
							opts.error && opts.error(err);
						}
					});
				} else {
					if (opts.type == 'wxSession') { // 有图 好友
						console.log('有图 好友');
						clipBoard.set({
							value: shareData
						}, function(ret, err) {
							if (ret) {
								_g.toastMsg({
									msg: '请把分享数据粘贴在微信中的输入框'
								});
								setTimeout(function() {
									mobShare.shareTo({
										target: opts.type,
										title: 'title',
										text: shareData,
										imgPaths: opts.imgArr
									}, function(ret, err) {
										if (ret.status) {
											opts.success && opts.success(ret);
										}
									});	
								}, 600);
							}
						});
					} else { // 有图 朋友圈
						downloadTask(opts.imgArr, function(imgArr) {
							share.shareToTimeLine({
								title: shareData,
								list: imgArr
							});
						});
					}
				}
			} else {
				// 纯文字  通过 actionsheet (opts.type) 决定分享好友还是朋友圈
				if (!opts.imgArr || opts.imgArr.length == 0) {
					mobShare.shareTo({
						target: opts.type,
						title: 'title',
						text: shareData
					}, function(ret, err) {
						if (ret.status) {
							opts.success && opts.success(ret);
						} else {
							opts.error && opts.error(err);
						}
					});
				} else if (opts.imgArr.length == 1) { // 单图 通过 actionsheet (opts.type) 决定分享好友还是朋友圈
					if (opts.type == 'wxSession') {  // 如果是好友 需要粘贴文本
						clipBoard.set({
							value: shareData
						}, function(ret, err) {
							if (ret) {
								_g.toastMsg({
									msg: '请把分享的数据粘贴到输入框中'
								});
								setTimeout(function() {
									mobShare.shareTo({
										target: opts.type,
										textJson: shareData,
										title: 'title',
										imgPaths: opts.imgArr
									}, function(ret, err) {
										if (ret.status) {
											opts.success && opts.success(ret);
										} else {
											opts.error && opts.error(err);
										}
									});
								}, 600);
							}
						});
					} else { // 朋友圈 不需要粘贴
						mobShare.shareTo({
							target: opts.type,
							textJson: shareData,
							title: 'title',
							imgPaths: opts.imgArr
						}, function(ret, err) {
							if (ret.status) {
								opts.success && opts.success(ret);
							} else {
								opts.error && opts.error(err);
							}
						});
					}
				} else {  // 多图 直接使用sharePics的弹出的系统菜单选择
					// 分享到朋友圈需要粘贴数据
					clipBoard.set({
						value: shareData
					}, function(ret, err) {
						if (ret) {
							_g.toastMsg({
								msg: '请把要分享的数据粘贴到输入框'
							});
							downloadTask(opts.imgArr, function(imgArr) {
								share.shareToTimeLine({
									title: shareData,
									list: imgArr
								});
							});
						}
					});
				}
			}
		}
	}

	Wx.prototype.constructor = Wx;
	module.exports = new Wx();
});