define(function(require, exports, module) {

	var HTTP = require('http');
	var _interface = require('interface')

	function _storage() {
		this.storageName = [];
	}

	_storage.prototype = {
		/*
		 * 统一入口
		 */
		init: function(sample, SUCCESS) {
			//var sample= [{listName:'dailytype', unlimit:false, name:['name'],submitArr:['name','id']},];
			console.log(1);
			var self = this;
			var one = sample[0];
			self.setStorageName(sample);
			//判断是否其中一个是否有缓存即可
			_g.rmLS(one.listName);
			if (!_g.getLS(one.listName)) {
				console.log('success:' + JSON.stringify(sample));
				self.getFilterData(sample, SUCCESS);
			}
		},
		/*
		 * 1.获取选择项的数据,并且设置缓存
		 */
		getFilterData: function(sample, SUCCESS) {
			var self = this;
			$.each(sample, function(key, value) {
				var url = _interface['base']['url'];
				console.log(url);
				console.log('base param:' + JSON.stringify(_interface['base'][value.listName]['param']));
				HTTP.ajax({
					url: url,
					data: _interface['base'][value.listName]['param'],
					success: function(ret) {
						value.sources = ret.listData;
						var storageData = self.sortSelectList(value);
						//					//设置缓存
						_g.setLS(value.listName, storageData);
						console.log('storage:' + JSON.stringify(_g.getLS(value.listName)));
						//console.log('key,sample:'+key+'*'+sample.length+'*'+JSON.stringify(sample));
						if (key == sample.length - 1) {
							//缓存完最后一条过滤数据后，执行回调函数
							SUCCESS();
						}
					}
				});
			});
		},
		/*  2.对选择项的数据进行处理
		 * listName：对应在interface.js里的名字
		 * sources:下拉列表数据，格式：json数组
		 * unlimit:是否有“不限”的选择项，true是表示有
		 * name:要显示的内容
		 * submitArr:选择项要提交的数据，例如：id,code等等。格式：数组
		 */
		sortSelectList: function(sample) {
			var sortData = [];
			var order = 0;
			var a = '';
			if (sample.unlimit) {
				var unlimitData = {};
				$.each(sample.submitArr, function(index, val) {
					unlimitData[val] = '不限';
				});
				unlimitData['order'] = 0;
				unlimitData['name'] = '不限';
				sortData.push(unlimitData);
				order++;
			}
			$.each(sample.sources, function(index, val) {
				var name = sample.name;
				val.order = order;
				a = '';
				//遍历name数组
				$.each(name, function(k, v) {
					a += val[v] + ' ';
				});
				val.name = a.substring(0, a.length - 1);
				val.sub = [{}]; //防止选择器点击确定按钮后，出现闪退问题
				sortData.push(val);
				order++;
			});
			return sortData;
		},
		setStorageName: function(sample) {
			var self = this;
			$.each(sample, function(index, value) {
				self.storageName.push(value.listName);
			});
		}
	}

	_storage.prototype.constructor = _storage;
	module.exports = new _storage();
});
